#include "tree_sitter/parser.h"

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 443
#define LARGE_STATE_COUNT 32
#define SYMBOL_COUNT 235
#define ALIAS_COUNT 0
#define TOKEN_COUNT 146
#define EXTERNAL_TOKEN_COUNT 1
#define FIELD_COUNT 15
#define MAX_ALIAS_SEQUENCE_LENGTH 9
#define PRODUCTION_ID_COUNT 26

enum ts_symbol_identifiers {
  sym_identifier = 1,
  sym_line_comment = 2,
  anon_sym_SEMI = 3,
  anon_sym_EQ = 4,
  anon_sym_let = 5,
  anon_sym_override = 6,
  anon_sym_type = 7,
  anon_sym_LPAREN = 8,
  anon_sym_COMMA = 9,
  anon_sym_RPAREN = 10,
  anon_sym_virtual = 11,
  anon_sym_fn = 12,
  anon_sym_DASH_GT = 13,
  anon_sym_struct = 14,
  anon_sym_LBRACE = 15,
  anon_sym_RBRACE = 16,
  anon_sym_enable = 17,
  anon_sym_AT = 18,
  anon_sym__ = 19,
  anon_sym_PLUS_EQ = 20,
  anon_sym_DASH_EQ = 21,
  anon_sym_STAR_EQ = 22,
  anon_sym_SLASH_EQ = 23,
  anon_sym_PERCENT_EQ = 24,
  anon_sym_AMP_EQ = 25,
  anon_sym_PIPE_EQ = 26,
  anon_sym_CARET_EQ = 27,
  anon_sym_if = 28,
  anon_sym_else = 29,
  anon_sym_switch = 30,
  anon_sym_case = 31,
  anon_sym_COLON = 32,
  anon_sym_default = 33,
  anon_sym_fallthrough = 34,
  anon_sym_loop = 35,
  anon_sym_for = 36,
  anon_sym_while = 37,
  anon_sym_break = 38,
  anon_sym_continue = 39,
  anon_sym_continuing = 40,
  anon_sym_return = 41,
  anon_sym_discard = 42,
  anon_sym_var = 43,
  anon_sym_LT = 44,
  anon_sym_GT = 45,
  anon_sym_PLUS_PLUS = 46,
  anon_sym_DASH_DASH = 47,
  sym_int_literal = 48,
  aux_sym_float_literal_token1 = 49,
  aux_sym_float_literal_token2 = 50,
  anon_sym_true = 51,
  anon_sym_false = 52,
  anon_sym_bool = 53,
  anon_sym_u32 = 54,
  anon_sym_i32 = 55,
  anon_sym_f32 = 56,
  anon_sym_f16 = 57,
  anon_sym_array = 58,
  anon_sym_ptr = 59,
  anon_sym_sampler = 60,
  anon_sym_sampler_comparison = 61,
  anon_sym_texture_depth_2d = 62,
  anon_sym_texture_depth_2d_array = 63,
  anon_sym_texture_depth_cube = 64,
  anon_sym_texture_depth_cube_array = 65,
  anon_sym_texture_depth_multisampled_2d = 66,
  anon_sym_texture_1d = 67,
  anon_sym_texture_2d = 68,
  anon_sym_texture_2d_array = 69,
  anon_sym_texture_3d = 70,
  anon_sym_texture_cube = 71,
  anon_sym_texture_cube_array = 72,
  anon_sym_texture_multisampled_2d = 73,
  anon_sym_texture_storage_1d = 74,
  anon_sym_texture_storage_2d = 75,
  anon_sym_texture_storage_2d_array = 76,
  anon_sym_texture_storage_3d = 77,
  anon_sym_vec2 = 78,
  anon_sym_vec3 = 79,
  anon_sym_vec4 = 80,
  anon_sym_mat2x2 = 81,
  anon_sym_mat2x3 = 82,
  anon_sym_mat2x4 = 83,
  anon_sym_mat3x2 = 84,
  anon_sym_mat3x3 = 85,
  anon_sym_mat3x4 = 86,
  anon_sym_mat4x2 = 87,
  anon_sym_mat4x3 = 88,
  anon_sym_mat4x4 = 89,
  anon_sym_rgba8unorm = 90,
  anon_sym_rgba8snorm = 91,
  anon_sym_rgba8uint = 92,
  anon_sym_rgba8sint = 93,
  anon_sym_rgba16uint = 94,
  anon_sym_rgba16sint = 95,
  anon_sym_rgba16float = 96,
  anon_sym_r32uint = 97,
  anon_sym_r32sint = 98,
  anon_sym_r32float = 99,
  anon_sym_rg32uint = 100,
  anon_sym_rg32sint = 101,
  anon_sym_rg32float = 102,
  anon_sym_rgba32uint = 103,
  anon_sym_rgba32sint = 104,
  anon_sym_rgba32float = 105,
  anon_sym_function = 106,
  anon_sym_private = 107,
  anon_sym_workgroup = 108,
  anon_sym_uniform = 109,
  anon_sym_storage = 110,
  anon_sym_read = 111,
  anon_sym_write = 112,
  anon_sym_read_write = 113,
  anon_sym_bitcast = 114,
  anon_sym_PIPE_PIPE = 115,
  anon_sym_AMP_AMP = 116,
  anon_sym_PIPE = 117,
  anon_sym_CARET = 118,
  anon_sym_AMP = 119,
  anon_sym_EQ_EQ = 120,
  anon_sym_BANG_EQ = 121,
  anon_sym_LT_EQ = 122,
  anon_sym_GT_EQ = 123,
  anon_sym_LT_LT = 124,
  anon_sym_GT_GT = 125,
  anon_sym_PLUS = 126,
  anon_sym_DASH = 127,
  anon_sym_STAR = 128,
  anon_sym_SLASH = 129,
  anon_sym_PERCENT = 130,
  anon_sym_BANG = 131,
  anon_sym_TILDE = 132,
  anon_sym_LBRACK = 133,
  anon_sym_RBRACK = 134,
  anon_sym_DOT = 135,
  aux_sym_preproc_import_token1 = 136,
  anon_sym_LF = 137,
  aux_sym_define_import_path_token1 = 138,
  anon_sym_COLON_COLON = 139,
  anon_sym_as = 140,
  aux_sym_preproc_ifdef_token1 = 141,
  aux_sym_preproc_ifdef_token2 = 142,
  aux_sym_preproc_ifdef_token3 = 143,
  aux_sym_preproc_else_token1 = 144,
  sym_block_comment = 145,
  sym_source_file = 146,
  sym__declaration = 147,
  sym_global_variable_declaration = 148,
  sym_global_constant_declaration = 149,
  sym_type_alias_declaration = 150,
  sym_const_expression = 151,
  sym_function_declaration = 152,
  sym_function_return_type_declaration = 153,
  sym_struct_declaration = 154,
  sym_struct_member = 155,
  sym_enable_directive = 156,
  sym_attribute = 157,
  sym__literal_or_identifier = 158,
  sym_parameter_list = 159,
  sym_parameter = 160,
  sym__statement = 161,
  sym_compound_statement = 162,
  sym_assignment_statement = 163,
  sym_compound_assignment_operator = 164,
  sym_if_statement = 165,
  sym_else_statement = 166,
  sym_switch_statement = 167,
  sym_switch_body = 168,
  sym_case_selectors = 169,
  sym_case_compound_statement = 170,
  sym_fallthrough_statement = 171,
  sym_loop_statement = 172,
  sym_for_statement = 173,
  sym_for_header = 174,
  sym_while_statement = 175,
  sym_break_statement = 176,
  sym_break_if_statement = 177,
  sym_continue_statement = 178,
  sym_continuing_statement = 179,
  sym_continuing_compound_statement = 180,
  sym_return_statement = 181,
  sym_discard_statement = 182,
  sym_variable_statement = 183,
  sym_variable_declaration = 184,
  sym_variable_qualifier = 185,
  sym_variable_identifier_declaration = 186,
  sym_increment_statement = 187,
  sym_decrement_statement = 188,
  sym__expression = 189,
  sym_const_literal = 190,
  sym_float_literal = 191,
  sym_bool_literal = 192,
  sym_parenthesized_expression = 193,
  sym_type_constructor_or_function_call_expression = 194,
  sym_type_declaration = 195,
  sym__vec_prefix = 196,
  sym__mat_prefix = 197,
  sym_texel_format = 198,
  sym_address_space = 199,
  sym_access_mode = 200,
  sym_argument_list_expression = 201,
  sym_bitcast_expression = 202,
  sym_binary_expression = 203,
  sym_unary_expression = 204,
  sym_postfix_expression = 205,
  sym_subscript_expression = 206,
  sym_lhs_expression = 207,
  sym_composite_value_decomposition_expression = 208,
  sym__struct_declaration_content = 209,
  sym_preproc_import = 210,
  sym_define_import_path = 211,
  sym_import_path = 212,
  sym_alias = 213,
  sym_preproc_ifdef = 214,
  sym_preproc_else = 215,
  sym_preproc_ifdef_in_statement = 216,
  sym_preproc_else_in_statement = 217,
  sym_preproc_ifdef_in_struct_declaration = 218,
  sym_preproc_else_in_struct_declaration = 219,
  aux_sym_source_file_repeat1 = 220,
  aux_sym_source_file_repeat2 = 221,
  aux_sym_global_variable_declaration_repeat1 = 222,
  aux_sym_const_expression_repeat1 = 223,
  aux_sym_attribute_repeat1 = 224,
  aux_sym_parameter_list_repeat1 = 225,
  aux_sym_compound_statement_repeat1 = 226,
  aux_sym_switch_statement_repeat1 = 227,
  aux_sym_case_selectors_repeat1 = 228,
  aux_sym_argument_list_expression_repeat1 = 229,
  aux_sym_lhs_expression_repeat1 = 230,
  aux_sym__struct_declaration_content_repeat1 = 231,
  aux_sym_preproc_import_repeat1 = 232,
  aux_sym_import_path_repeat1 = 233,
  aux_sym_preproc_ifdef_in_struct_declaration_repeat1 = 234,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [sym_line_comment] = "line_comment",
  [anon_sym_SEMI] = ";",
  [anon_sym_EQ] = "=",
  [anon_sym_let] = "let",
  [anon_sym_override] = "override",
  [anon_sym_type] = "type",
  [anon_sym_LPAREN] = "(",
  [anon_sym_COMMA] = ",",
  [anon_sym_RPAREN] = ")",
  [anon_sym_virtual] = "virtual",
  [anon_sym_fn] = "fn",
  [anon_sym_DASH_GT] = "->",
  [anon_sym_struct] = "struct",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_enable] = "enable",
  [anon_sym_AT] = "@",
  [anon_sym__] = "_",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_if] = "if",
  [anon_sym_else] = "else",
  [anon_sym_switch] = "switch",
  [anon_sym_case] = "case",
  [anon_sym_COLON] = ":",
  [anon_sym_default] = "default",
  [anon_sym_fallthrough] = "fallthrough",
  [anon_sym_loop] = "loop",
  [anon_sym_for] = "for",
  [anon_sym_while] = "while",
  [anon_sym_break] = "break",
  [anon_sym_continue] = "continue",
  [anon_sym_continuing] = "continuing",
  [anon_sym_return] = "return",
  [anon_sym_discard] = "discard",
  [anon_sym_var] = "var",
  [anon_sym_LT] = "<",
  [anon_sym_GT] = ">",
  [anon_sym_PLUS_PLUS] = "++",
  [anon_sym_DASH_DASH] = "--",
  [sym_int_literal] = "int_literal",
  [aux_sym_float_literal_token1] = "float_literal_token1",
  [aux_sym_float_literal_token2] = "float_literal_token2",
  [anon_sym_true] = "true",
  [anon_sym_false] = "false",
  [anon_sym_bool] = "bool",
  [anon_sym_u32] = "u32",
  [anon_sym_i32] = "i32",
  [anon_sym_f32] = "f32",
  [anon_sym_f16] = "f16",
  [anon_sym_array] = "array",
  [anon_sym_ptr] = "ptr",
  [anon_sym_sampler] = "sampler",
  [anon_sym_sampler_comparison] = "sampler_comparison",
  [anon_sym_texture_depth_2d] = "texture_depth_2d",
  [anon_sym_texture_depth_2d_array] = "texture_depth_2d_array",
  [anon_sym_texture_depth_cube] = "texture_depth_cube",
  [anon_sym_texture_depth_cube_array] = "texture_depth_cube_array",
  [anon_sym_texture_depth_multisampled_2d] = "texture_depth_multisampled_2d",
  [anon_sym_texture_1d] = "texture_1d",
  [anon_sym_texture_2d] = "texture_2d",
  [anon_sym_texture_2d_array] = "texture_2d_array",
  [anon_sym_texture_3d] = "texture_3d",
  [anon_sym_texture_cube] = "texture_cube",
  [anon_sym_texture_cube_array] = "texture_cube_array",
  [anon_sym_texture_multisampled_2d] = "texture_multisampled_2d",
  [anon_sym_texture_storage_1d] = "texture_storage_1d",
  [anon_sym_texture_storage_2d] = "texture_storage_2d",
  [anon_sym_texture_storage_2d_array] = "texture_storage_2d_array",
  [anon_sym_texture_storage_3d] = "texture_storage_3d",
  [anon_sym_vec2] = "vec2",
  [anon_sym_vec3] = "vec3",
  [anon_sym_vec4] = "vec4",
  [anon_sym_mat2x2] = "mat2x2",
  [anon_sym_mat2x3] = "mat2x3",
  [anon_sym_mat2x4] = "mat2x4",
  [anon_sym_mat3x2] = "mat3x2",
  [anon_sym_mat3x3] = "mat3x3",
  [anon_sym_mat3x4] = "mat3x4",
  [anon_sym_mat4x2] = "mat4x2",
  [anon_sym_mat4x3] = "mat4x3",
  [anon_sym_mat4x4] = "mat4x4",
  [anon_sym_rgba8unorm] = "rgba8unorm",
  [anon_sym_rgba8snorm] = "rgba8snorm",
  [anon_sym_rgba8uint] = "rgba8uint",
  [anon_sym_rgba8sint] = "rgba8sint",
  [anon_sym_rgba16uint] = "rgba16uint",
  [anon_sym_rgba16sint] = "rgba16sint",
  [anon_sym_rgba16float] = "rgba16float",
  [anon_sym_r32uint] = "r32uint",
  [anon_sym_r32sint] = "r32sint",
  [anon_sym_r32float] = "r32float",
  [anon_sym_rg32uint] = "rg32uint",
  [anon_sym_rg32sint] = "rg32sint",
  [anon_sym_rg32float] = "rg32float",
  [anon_sym_rgba32uint] = "rgba32uint",
  [anon_sym_rgba32sint] = "rgba32sint",
  [anon_sym_rgba32float] = "rgba32float",
  [anon_sym_function] = "function",
  [anon_sym_private] = "private",
  [anon_sym_workgroup] = "workgroup",
  [anon_sym_uniform] = "uniform",
  [anon_sym_storage] = "storage",
  [anon_sym_read] = "read",
  [anon_sym_write] = "write",
  [anon_sym_read_write] = "read_write",
  [anon_sym_bitcast] = "bitcast",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_PIPE] = "|",
  [anon_sym_CARET] = "^",
  [anon_sym_AMP] = "&",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [anon_sym_STAR] = "*",
  [anon_sym_SLASH] = "/",
  [anon_sym_PERCENT] = "%",
  [anon_sym_BANG] = "!",
  [anon_sym_TILDE] = "~",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_DOT] = ".",
  [aux_sym_preproc_import_token1] = "#import",
  [anon_sym_LF] = "\n",
  [aux_sym_define_import_path_token1] = "#define_import_path",
  [anon_sym_COLON_COLON] = "::",
  [anon_sym_as] = "as",
  [aux_sym_preproc_ifdef_token1] = "#ifdef",
  [aux_sym_preproc_ifdef_token2] = "#ifndef",
  [aux_sym_preproc_ifdef_token3] = "#endif",
  [aux_sym_preproc_else_token1] = "#else",
  [sym_block_comment] = "block_comment",
  [sym_source_file] = "source_file",
  [sym__declaration] = "_declaration",
  [sym_global_variable_declaration] = "global_variable_declaration",
  [sym_global_constant_declaration] = "global_constant_declaration",
  [sym_type_alias_declaration] = "type_alias_declaration",
  [sym_const_expression] = "const_expression",
  [sym_function_declaration] = "function_declaration",
  [sym_function_return_type_declaration] = "function_return_type_declaration",
  [sym_struct_declaration] = "struct_declaration",
  [sym_struct_member] = "struct_member",
  [sym_enable_directive] = "enable_directive",
  [sym_attribute] = "attribute",
  [sym__literal_or_identifier] = "_literal_or_identifier",
  [sym_parameter_list] = "parameter_list",
  [sym_parameter] = "parameter",
  [sym__statement] = "_statement",
  [sym_compound_statement] = "compound_statement",
  [sym_assignment_statement] = "assignment_statement",
  [sym_compound_assignment_operator] = "compound_assignment_operator",
  [sym_if_statement] = "if_statement",
  [sym_else_statement] = "else_statement",
  [sym_switch_statement] = "switch_statement",
  [sym_switch_body] = "switch_body",
  [sym_case_selectors] = "case_selectors",
  [sym_case_compound_statement] = "case_compound_statement",
  [sym_fallthrough_statement] = "fallthrough_statement",
  [sym_loop_statement] = "loop_statement",
  [sym_for_statement] = "for_statement",
  [sym_for_header] = "for_header",
  [sym_while_statement] = "while_statement",
  [sym_break_statement] = "break_statement",
  [sym_break_if_statement] = "break_if_statement",
  [sym_continue_statement] = "continue_statement",
  [sym_continuing_statement] = "continuing_statement",
  [sym_continuing_compound_statement] = "continuing_compound_statement",
  [sym_return_statement] = "return_statement",
  [sym_discard_statement] = "discard_statement",
  [sym_variable_statement] = "variable_statement",
  [sym_variable_declaration] = "variable_declaration",
  [sym_variable_qualifier] = "variable_qualifier",
  [sym_variable_identifier_declaration] = "variable_identifier_declaration",
  [sym_increment_statement] = "increment_statement",
  [sym_decrement_statement] = "decrement_statement",
  [sym__expression] = "_expression",
  [sym_const_literal] = "const_literal",
  [sym_float_literal] = "float_literal",
  [sym_bool_literal] = "bool_literal",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym_type_constructor_or_function_call_expression] = "type_constructor_or_function_call_expression",
  [sym_type_declaration] = "type_declaration",
  [sym__vec_prefix] = "_vec_prefix",
  [sym__mat_prefix] = "_mat_prefix",
  [sym_texel_format] = "texel_format",
  [sym_address_space] = "address_space",
  [sym_access_mode] = "access_mode",
  [sym_argument_list_expression] = "argument_list_expression",
  [sym_bitcast_expression] = "bitcast_expression",
  [sym_binary_expression] = "binary_expression",
  [sym_unary_expression] = "unary_expression",
  [sym_postfix_expression] = "postfix_expression",
  [sym_subscript_expression] = "subscript_expression",
  [sym_lhs_expression] = "lhs_expression",
  [sym_composite_value_decomposition_expression] = "composite_value_decomposition_expression",
  [sym__struct_declaration_content] = "_struct_declaration_content",
  [sym_preproc_import] = "preproc_import",
  [sym_define_import_path] = "define_import_path",
  [sym_import_path] = "import_path",
  [sym_alias] = "alias",
  [sym_preproc_ifdef] = "preproc_ifdef",
  [sym_preproc_else] = "preproc_else",
  [sym_preproc_ifdef_in_statement] = "preproc_ifdef",
  [sym_preproc_else_in_statement] = "preproc_else",
  [sym_preproc_ifdef_in_struct_declaration] = "preproc_ifdef",
  [sym_preproc_else_in_struct_declaration] = "preproc_else",
  [aux_sym_source_file_repeat1] = "source_file_repeat1",
  [aux_sym_source_file_repeat2] = "source_file_repeat2",
  [aux_sym_global_variable_declaration_repeat1] = "global_variable_declaration_repeat1",
  [aux_sym_const_expression_repeat1] = "const_expression_repeat1",
  [aux_sym_attribute_repeat1] = "attribute_repeat1",
  [aux_sym_parameter_list_repeat1] = "parameter_list_repeat1",
  [aux_sym_compound_statement_repeat1] = "compound_statement_repeat1",
  [aux_sym_switch_statement_repeat1] = "switch_statement_repeat1",
  [aux_sym_case_selectors_repeat1] = "case_selectors_repeat1",
  [aux_sym_argument_list_expression_repeat1] = "argument_list_expression_repeat1",
  [aux_sym_lhs_expression_repeat1] = "lhs_expression_repeat1",
  [aux_sym__struct_declaration_content_repeat1] = "_struct_declaration_content_repeat1",
  [aux_sym_preproc_import_repeat1] = "preproc_import_repeat1",
  [aux_sym_import_path_repeat1] = "import_path_repeat1",
  [aux_sym_preproc_ifdef_in_struct_declaration_repeat1] = "preproc_ifdef_in_struct_declaration_repeat1",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [sym_line_comment] = sym_line_comment,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_let] = anon_sym_let,
  [anon_sym_override] = anon_sym_override,
  [anon_sym_type] = anon_sym_type,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_virtual] = anon_sym_virtual,
  [anon_sym_fn] = anon_sym_fn,
  [anon_sym_DASH_GT] = anon_sym_DASH_GT,
  [anon_sym_struct] = anon_sym_struct,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_enable] = anon_sym_enable,
  [anon_sym_AT] = anon_sym_AT,
  [anon_sym__] = anon_sym__,
  [anon_sym_PLUS_EQ] = anon_sym_PLUS_EQ,
  [anon_sym_DASH_EQ] = anon_sym_DASH_EQ,
  [anon_sym_STAR_EQ] = anon_sym_STAR_EQ,
  [anon_sym_SLASH_EQ] = anon_sym_SLASH_EQ,
  [anon_sym_PERCENT_EQ] = anon_sym_PERCENT_EQ,
  [anon_sym_AMP_EQ] = anon_sym_AMP_EQ,
  [anon_sym_PIPE_EQ] = anon_sym_PIPE_EQ,
  [anon_sym_CARET_EQ] = anon_sym_CARET_EQ,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_switch] = anon_sym_switch,
  [anon_sym_case] = anon_sym_case,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_default] = anon_sym_default,
  [anon_sym_fallthrough] = anon_sym_fallthrough,
  [anon_sym_loop] = anon_sym_loop,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_while] = anon_sym_while,
  [anon_sym_break] = anon_sym_break,
  [anon_sym_continue] = anon_sym_continue,
  [anon_sym_continuing] = anon_sym_continuing,
  [anon_sym_return] = anon_sym_return,
  [anon_sym_discard] = anon_sym_discard,
  [anon_sym_var] = anon_sym_var,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_PLUS_PLUS] = anon_sym_PLUS_PLUS,
  [anon_sym_DASH_DASH] = anon_sym_DASH_DASH,
  [sym_int_literal] = sym_int_literal,
  [aux_sym_float_literal_token1] = aux_sym_float_literal_token1,
  [aux_sym_float_literal_token2] = aux_sym_float_literal_token2,
  [anon_sym_true] = anon_sym_true,
  [anon_sym_false] = anon_sym_false,
  [anon_sym_bool] = anon_sym_bool,
  [anon_sym_u32] = anon_sym_u32,
  [anon_sym_i32] = anon_sym_i32,
  [anon_sym_f32] = anon_sym_f32,
  [anon_sym_f16] = anon_sym_f16,
  [anon_sym_array] = anon_sym_array,
  [anon_sym_ptr] = anon_sym_ptr,
  [anon_sym_sampler] = anon_sym_sampler,
  [anon_sym_sampler_comparison] = anon_sym_sampler_comparison,
  [anon_sym_texture_depth_2d] = anon_sym_texture_depth_2d,
  [anon_sym_texture_depth_2d_array] = anon_sym_texture_depth_2d_array,
  [anon_sym_texture_depth_cube] = anon_sym_texture_depth_cube,
  [anon_sym_texture_depth_cube_array] = anon_sym_texture_depth_cube_array,
  [anon_sym_texture_depth_multisampled_2d] = anon_sym_texture_depth_multisampled_2d,
  [anon_sym_texture_1d] = anon_sym_texture_1d,
  [anon_sym_texture_2d] = anon_sym_texture_2d,
  [anon_sym_texture_2d_array] = anon_sym_texture_2d_array,
  [anon_sym_texture_3d] = anon_sym_texture_3d,
  [anon_sym_texture_cube] = anon_sym_texture_cube,
  [anon_sym_texture_cube_array] = anon_sym_texture_cube_array,
  [anon_sym_texture_multisampled_2d] = anon_sym_texture_multisampled_2d,
  [anon_sym_texture_storage_1d] = anon_sym_texture_storage_1d,
  [anon_sym_texture_storage_2d] = anon_sym_texture_storage_2d,
  [anon_sym_texture_storage_2d_array] = anon_sym_texture_storage_2d_array,
  [anon_sym_texture_storage_3d] = anon_sym_texture_storage_3d,
  [anon_sym_vec2] = anon_sym_vec2,
  [anon_sym_vec3] = anon_sym_vec3,
  [anon_sym_vec4] = anon_sym_vec4,
  [anon_sym_mat2x2] = anon_sym_mat2x2,
  [anon_sym_mat2x3] = anon_sym_mat2x3,
  [anon_sym_mat2x4] = anon_sym_mat2x4,
  [anon_sym_mat3x2] = anon_sym_mat3x2,
  [anon_sym_mat3x3] = anon_sym_mat3x3,
  [anon_sym_mat3x4] = anon_sym_mat3x4,
  [anon_sym_mat4x2] = anon_sym_mat4x2,
  [anon_sym_mat4x3] = anon_sym_mat4x3,
  [anon_sym_mat4x4] = anon_sym_mat4x4,
  [anon_sym_rgba8unorm] = anon_sym_rgba8unorm,
  [anon_sym_rgba8snorm] = anon_sym_rgba8snorm,
  [anon_sym_rgba8uint] = anon_sym_rgba8uint,
  [anon_sym_rgba8sint] = anon_sym_rgba8sint,
  [anon_sym_rgba16uint] = anon_sym_rgba16uint,
  [anon_sym_rgba16sint] = anon_sym_rgba16sint,
  [anon_sym_rgba16float] = anon_sym_rgba16float,
  [anon_sym_r32uint] = anon_sym_r32uint,
  [anon_sym_r32sint] = anon_sym_r32sint,
  [anon_sym_r32float] = anon_sym_r32float,
  [anon_sym_rg32uint] = anon_sym_rg32uint,
  [anon_sym_rg32sint] = anon_sym_rg32sint,
  [anon_sym_rg32float] = anon_sym_rg32float,
  [anon_sym_rgba32uint] = anon_sym_rgba32uint,
  [anon_sym_rgba32sint] = anon_sym_rgba32sint,
  [anon_sym_rgba32float] = anon_sym_rgba32float,
  [anon_sym_function] = anon_sym_function,
  [anon_sym_private] = anon_sym_private,
  [anon_sym_workgroup] = anon_sym_workgroup,
  [anon_sym_uniform] = anon_sym_uniform,
  [anon_sym_storage] = anon_sym_storage,
  [anon_sym_read] = anon_sym_read,
  [anon_sym_write] = anon_sym_write,
  [anon_sym_read_write] = anon_sym_read_write,
  [anon_sym_bitcast] = anon_sym_bitcast,
  [anon_sym_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [anon_sym_AMP_AMP] = anon_sym_AMP_AMP,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_LT_LT] = anon_sym_LT_LT,
  [anon_sym_GT_GT] = anon_sym_GT_GT,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_DOT] = anon_sym_DOT,
  [aux_sym_preproc_import_token1] = aux_sym_preproc_import_token1,
  [anon_sym_LF] = anon_sym_LF,
  [aux_sym_define_import_path_token1] = aux_sym_define_import_path_token1,
  [anon_sym_COLON_COLON] = anon_sym_COLON_COLON,
  [anon_sym_as] = anon_sym_as,
  [aux_sym_preproc_ifdef_token1] = aux_sym_preproc_ifdef_token1,
  [aux_sym_preproc_ifdef_token2] = aux_sym_preproc_ifdef_token2,
  [aux_sym_preproc_ifdef_token3] = aux_sym_preproc_ifdef_token3,
  [aux_sym_preproc_else_token1] = aux_sym_preproc_else_token1,
  [sym_block_comment] = sym_block_comment,
  [sym_source_file] = sym_source_file,
  [sym__declaration] = sym__declaration,
  [sym_global_variable_declaration] = sym_global_variable_declaration,
  [sym_global_constant_declaration] = sym_global_constant_declaration,
  [sym_type_alias_declaration] = sym_type_alias_declaration,
  [sym_const_expression] = sym_const_expression,
  [sym_function_declaration] = sym_function_declaration,
  [sym_function_return_type_declaration] = sym_function_return_type_declaration,
  [sym_struct_declaration] = sym_struct_declaration,
  [sym_struct_member] = sym_struct_member,
  [sym_enable_directive] = sym_enable_directive,
  [sym_attribute] = sym_attribute,
  [sym__literal_or_identifier] = sym__literal_or_identifier,
  [sym_parameter_list] = sym_parameter_list,
  [sym_parameter] = sym_parameter,
  [sym__statement] = sym__statement,
  [sym_compound_statement] = sym_compound_statement,
  [sym_assignment_statement] = sym_assignment_statement,
  [sym_compound_assignment_operator] = sym_compound_assignment_operator,
  [sym_if_statement] = sym_if_statement,
  [sym_else_statement] = sym_else_statement,
  [sym_switch_statement] = sym_switch_statement,
  [sym_switch_body] = sym_switch_body,
  [sym_case_selectors] = sym_case_selectors,
  [sym_case_compound_statement] = sym_case_compound_statement,
  [sym_fallthrough_statement] = sym_fallthrough_statement,
  [sym_loop_statement] = sym_loop_statement,
  [sym_for_statement] = sym_for_statement,
  [sym_for_header] = sym_for_header,
  [sym_while_statement] = sym_while_statement,
  [sym_break_statement] = sym_break_statement,
  [sym_break_if_statement] = sym_break_if_statement,
  [sym_continue_statement] = sym_continue_statement,
  [sym_continuing_statement] = sym_continuing_statement,
  [sym_continuing_compound_statement] = sym_continuing_compound_statement,
  [sym_return_statement] = sym_return_statement,
  [sym_discard_statement] = sym_discard_statement,
  [sym_variable_statement] = sym_variable_statement,
  [sym_variable_declaration] = sym_variable_declaration,
  [sym_variable_qualifier] = sym_variable_qualifier,
  [sym_variable_identifier_declaration] = sym_variable_identifier_declaration,
  [sym_increment_statement] = sym_increment_statement,
  [sym_decrement_statement] = sym_decrement_statement,
  [sym__expression] = sym__expression,
  [sym_const_literal] = sym_const_literal,
  [sym_float_literal] = sym_float_literal,
  [sym_bool_literal] = sym_bool_literal,
  [sym_parenthesized_expression] = sym_parenthesized_expression,
  [sym_type_constructor_or_function_call_expression] = sym_type_constructor_or_function_call_expression,
  [sym_type_declaration] = sym_type_declaration,
  [sym__vec_prefix] = sym__vec_prefix,
  [sym__mat_prefix] = sym__mat_prefix,
  [sym_texel_format] = sym_texel_format,
  [sym_address_space] = sym_address_space,
  [sym_access_mode] = sym_access_mode,
  [sym_argument_list_expression] = sym_argument_list_expression,
  [sym_bitcast_expression] = sym_bitcast_expression,
  [sym_binary_expression] = sym_binary_expression,
  [sym_unary_expression] = sym_unary_expression,
  [sym_postfix_expression] = sym_postfix_expression,
  [sym_subscript_expression] = sym_subscript_expression,
  [sym_lhs_expression] = sym_lhs_expression,
  [sym_composite_value_decomposition_expression] = sym_composite_value_decomposition_expression,
  [sym__struct_declaration_content] = sym__struct_declaration_content,
  [sym_preproc_import] = sym_preproc_import,
  [sym_define_import_path] = sym_define_import_path,
  [sym_import_path] = sym_import_path,
  [sym_alias] = sym_alias,
  [sym_preproc_ifdef] = sym_preproc_ifdef,
  [sym_preproc_else] = sym_preproc_else,
  [sym_preproc_ifdef_in_statement] = sym_preproc_ifdef,
  [sym_preproc_else_in_statement] = sym_preproc_else,
  [sym_preproc_ifdef_in_struct_declaration] = sym_preproc_ifdef,
  [sym_preproc_else_in_struct_declaration] = sym_preproc_else,
  [aux_sym_source_file_repeat1] = aux_sym_source_file_repeat1,
  [aux_sym_source_file_repeat2] = aux_sym_source_file_repeat2,
  [aux_sym_global_variable_declaration_repeat1] = aux_sym_global_variable_declaration_repeat1,
  [aux_sym_const_expression_repeat1] = aux_sym_const_expression_repeat1,
  [aux_sym_attribute_repeat1] = aux_sym_attribute_repeat1,
  [aux_sym_parameter_list_repeat1] = aux_sym_parameter_list_repeat1,
  [aux_sym_compound_statement_repeat1] = aux_sym_compound_statement_repeat1,
  [aux_sym_switch_statement_repeat1] = aux_sym_switch_statement_repeat1,
  [aux_sym_case_selectors_repeat1] = aux_sym_case_selectors_repeat1,
  [aux_sym_argument_list_expression_repeat1] = aux_sym_argument_list_expression_repeat1,
  [aux_sym_lhs_expression_repeat1] = aux_sym_lhs_expression_repeat1,
  [aux_sym__struct_declaration_content_repeat1] = aux_sym__struct_declaration_content_repeat1,
  [aux_sym_preproc_import_repeat1] = aux_sym_preproc_import_repeat1,
  [aux_sym_import_path_repeat1] = aux_sym_import_path_repeat1,
  [aux_sym_preproc_ifdef_in_struct_declaration_repeat1] = aux_sym_preproc_ifdef_in_struct_declaration_repeat1,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_line_comment] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_let] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_override] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_type] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_virtual] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_fn] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_struct] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_enable] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_switch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_default] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_fallthrough] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_loop] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_continue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_continuing] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_discard] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_var] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_DASH] = {
    .visible = true,
    .named = false,
  },
  [sym_int_literal] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_float_literal_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_float_literal_token2] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_true] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_false] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bool] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u32] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_i32] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_f32] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_f16] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_array] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ptr] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sampler] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sampler_comparison] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_texture_depth_2d] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_texture_depth_2d_array] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_texture_depth_cube] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_texture_depth_cube_array] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_texture_depth_multisampled_2d] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_texture_1d] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_texture_2d] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_texture_2d_array] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_texture_3d] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_texture_cube] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_texture_cube_array] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_texture_multisampled_2d] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_texture_storage_1d] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_texture_storage_2d] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_texture_storage_2d_array] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_texture_storage_3d] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_vec2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_vec3] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_vec4] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_mat2x2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_mat2x3] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_mat2x4] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_mat3x2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_mat3x3] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_mat3x4] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_mat4x2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_mat4x3] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_mat4x4] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_rgba8unorm] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_rgba8snorm] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_rgba8uint] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_rgba8sint] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_rgba16uint] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_rgba16sint] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_rgba16float] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_r32uint] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_r32sint] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_r32float] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_rg32uint] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_rg32sint] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_rg32float] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_rgba32uint] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_rgba32sint] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_rgba32float] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_function] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_private] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_workgroup] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uniform] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_storage] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_read] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_write] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_read_write] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bitcast] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_import_token1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LF] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_define_import_path_token1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_as] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_ifdef_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_ifdef_token2] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_ifdef_token3] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_else_token1] = {
    .visible = true,
    .named = false,
  },
  [sym_block_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_source_file] = {
    .visible = true,
    .named = true,
  },
  [sym__declaration] = {
    .visible = false,
    .named = true,
  },
  [sym_global_variable_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_global_constant_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_type_alias_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_const_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_function_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_function_return_type_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_struct_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_struct_member] = {
    .visible = true,
    .named = true,
  },
  [sym_enable_directive] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute] = {
    .visible = true,
    .named = true,
  },
  [sym__literal_or_identifier] = {
    .visible = false,
    .named = true,
  },
  [sym_parameter_list] = {
    .visible = true,
    .named = true,
  },
  [sym_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym__statement] = {
    .visible = false,
    .named = true,
  },
  [sym_compound_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_compound_assignment_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_else_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_body] = {
    .visible = true,
    .named = true,
  },
  [sym_case_selectors] = {
    .visible = true,
    .named = true,
  },
  [sym_case_compound_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_fallthrough_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_loop_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_header] = {
    .visible = true,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_break_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_break_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_continuing_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_continuing_compound_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_discard_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_qualifier] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_identifier_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_increment_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_decrement_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__expression] = {
    .visible = false,
    .named = true,
  },
  [sym_const_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_float_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_bool_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_type_constructor_or_function_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_type_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__vec_prefix] = {
    .visible = false,
    .named = true,
  },
  [sym__mat_prefix] = {
    .visible = false,
    .named = true,
  },
  [sym_texel_format] = {
    .visible = true,
    .named = true,
  },
  [sym_address_space] = {
    .visible = true,
    .named = true,
  },
  [sym_access_mode] = {
    .visible = true,
    .named = true,
  },
  [sym_argument_list_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_bitcast_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_postfix_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_lhs_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_composite_value_decomposition_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__struct_declaration_content] = {
    .visible = false,
    .named = true,
  },
  [sym_preproc_import] = {
    .visible = true,
    .named = true,
  },
  [sym_define_import_path] = {
    .visible = true,
    .named = true,
  },
  [sym_import_path] = {
    .visible = true,
    .named = true,
  },
  [sym_alias] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_ifdef] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_else] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_ifdef_in_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_else_in_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_ifdef_in_struct_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_else_in_struct_declaration] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_source_file_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_source_file_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_global_variable_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_const_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_attribute_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_parameter_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_compound_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_switch_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_case_selectors_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_argument_list_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_lhs_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__struct_declaration_content_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_import_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_import_path_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_ifdef_in_struct_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
};

enum ts_field_identifiers {
  field_accessor = 1,
  field_alias = 2,
  field_alternative = 3,
  field_argument = 4,
  field_body = 5,
  field_condition = 6,
  field_consequence = 7,
  field_left = 8,
  field_name = 9,
  field_parameters = 10,
  field_path = 11,
  field_right = 12,
  field_subscript = 13,
  field_type = 14,
  field_value = 15,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_accessor] = "accessor",
  [field_alias] = "alias",
  [field_alternative] = "alternative",
  [field_argument] = "argument",
  [field_body] = "body",
  [field_condition] = "condition",
  [field_consequence] = "consequence",
  [field_left] = "left",
  [field_name] = "name",
  [field_parameters] = "parameters",
  [field_path] = "path",
  [field_right] = "right",
  [field_subscript] = "subscript",
  [field_type] = "type",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [1] = {.index = 0, .length = 1},
  [2] = {.index = 1, .length = 1},
  [3] = {.index = 2, .length = 2},
  [4] = {.index = 4, .length = 2},
  [5] = {.index = 6, .length = 2},
  [6] = {.index = 8, .length = 1},
  [7] = {.index = 9, .length = 2},
  [8] = {.index = 11, .length = 2},
  [9] = {.index = 13, .length = 2},
  [10] = {.index = 15, .length = 2},
  [11] = {.index = 17, .length = 2},
  [12] = {.index = 19, .length = 3},
  [13] = {.index = 22, .length = 3},
  [14] = {.index = 25, .length = 3},
  [15] = {.index = 28, .length = 3},
  [16] = {.index = 31, .length = 2},
  [17] = {.index = 33, .length = 2},
  [18] = {.index = 35, .length = 4},
  [19] = {.index = 39, .length = 4},
  [20] = {.index = 43, .length = 3},
  [21] = {.index = 46, .length = 3},
  [22] = {.index = 49, .length = 2},
  [23] = {.index = 51, .length = 1},
  [24] = {.index = 52, .length = 4},
  [25] = {.index = 56, .length = 3},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_path, 1},
  [1] =
    {field_name, 1},
  [2] =
    {field_name, 0},
    {field_type, 2},
  [4] =
    {field_alias, 2},
    {field_path, 1},
  [6] =
    {field_alternative, 2},
    {field_name, 1},
  [8] =
    {field_argument, 1},
  [9] =
    {field_body, 4},
    {field_name, 1},
  [11] =
    {field_alternative, 3},
    {field_name, 1},
  [13] =
    {field_body, 5},
    {field_name, 2},
  [15] =
    {field_left, 0},
    {field_right, 2},
  [17] =
    {field_accessor, 2},
    {field_value, 0},
  [19] =
    {field_body, 5},
    {field_name, 1},
    {field_type, 4},
  [22] =
    {field_body, 5},
    {field_name, 1},
    {field_parameters, 3},
  [25] =
    {field_body, 6},
    {field_name, 2},
    {field_type, 5},
  [28] =
    {field_body, 6},
    {field_name, 2},
    {field_parameters, 4},
  [31] =
    {field_subscript, 2},
    {field_value, 0},
  [33] =
    {field_body, 6},
    {field_name, 3},
  [35] =
    {field_body, 6},
    {field_name, 1},
    {field_parameters, 3},
    {field_type, 5},
  [39] =
    {field_body, 7},
    {field_name, 2},
    {field_parameters, 4},
    {field_type, 6},
  [43] =
    {field_body, 7},
    {field_name, 3},
    {field_type, 6},
  [46] =
    {field_body, 7},
    {field_name, 3},
    {field_parameters, 5},
  [49] =
    {field_condition, 1},
    {field_consequence, 2},
  [51] =
    {field_condition, 1},
  [52] =
    {field_body, 8},
    {field_name, 3},
    {field_parameters, 5},
    {field_type, 7},
  [56] =
    {field_alternative, 4},
    {field_condition, 1},
    {field_consequence, 2},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
};

static const uint16_t ts_non_terminal_alias_map[] = {
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 3,
  [4] = 4,
  [5] = 5,
  [6] = 6,
  [7] = 7,
  [8] = 8,
  [9] = 9,
  [10] = 10,
  [11] = 11,
  [12] = 12,
  [13] = 13,
  [14] = 14,
  [15] = 15,
  [16] = 16,
  [17] = 17,
  [18] = 18,
  [19] = 19,
  [20] = 20,
  [21] = 21,
  [22] = 22,
  [23] = 23,
  [24] = 24,
  [25] = 8,
  [26] = 26,
  [27] = 27,
  [28] = 28,
  [29] = 29,
  [30] = 30,
  [31] = 31,
  [32] = 32,
  [33] = 33,
  [34] = 34,
  [35] = 35,
  [36] = 36,
  [37] = 37,
  [38] = 38,
  [39] = 39,
  [40] = 40,
  [41] = 41,
  [42] = 42,
  [43] = 43,
  [44] = 44,
  [45] = 45,
  [46] = 46,
  [47] = 47,
  [48] = 48,
  [49] = 49,
  [50] = 50,
  [51] = 51,
  [52] = 52,
  [53] = 53,
  [54] = 54,
  [55] = 55,
  [56] = 56,
  [57] = 57,
  [58] = 58,
  [59] = 59,
  [60] = 60,
  [61] = 61,
  [62] = 62,
  [63] = 63,
  [64] = 64,
  [65] = 65,
  [66] = 66,
  [67] = 67,
  [68] = 68,
  [69] = 69,
  [70] = 70,
  [71] = 71,
  [72] = 72,
  [73] = 73,
  [74] = 74,
  [75] = 75,
  [76] = 76,
  [77] = 77,
  [78] = 78,
  [79] = 79,
  [80] = 80,
  [81] = 81,
  [82] = 82,
  [83] = 83,
  [84] = 84,
  [85] = 85,
  [86] = 86,
  [87] = 87,
  [88] = 88,
  [89] = 89,
  [90] = 90,
  [91] = 91,
  [92] = 92,
  [93] = 93,
  [94] = 94,
  [95] = 95,
  [96] = 96,
  [97] = 97,
  [98] = 98,
  [99] = 99,
  [100] = 100,
  [101] = 101,
  [102] = 102,
  [103] = 103,
  [104] = 104,
  [105] = 105,
  [106] = 106,
  [107] = 107,
  [108] = 108,
  [109] = 109,
  [110] = 110,
  [111] = 111,
  [112] = 112,
  [113] = 113,
  [114] = 114,
  [115] = 115,
  [116] = 116,
  [117] = 117,
  [118] = 118,
  [119] = 119,
  [120] = 120,
  [121] = 121,
  [122] = 122,
  [123] = 123,
  [124] = 124,
  [125] = 125,
  [126] = 126,
  [127] = 127,
  [128] = 128,
  [129] = 129,
  [130] = 130,
  [131] = 131,
  [132] = 132,
  [133] = 133,
  [134] = 134,
  [135] = 135,
  [136] = 136,
  [137] = 137,
  [138] = 138,
  [139] = 139,
  [140] = 140,
  [141] = 141,
  [142] = 142,
  [143] = 143,
  [144] = 144,
  [145] = 145,
  [146] = 146,
  [147] = 147,
  [148] = 148,
  [149] = 149,
  [150] = 137,
  [151] = 151,
  [152] = 152,
  [153] = 153,
  [154] = 154,
  [155] = 155,
  [156] = 156,
  [157] = 157,
  [158] = 158,
  [159] = 159,
  [160] = 160,
  [161] = 161,
  [162] = 162,
  [163] = 163,
  [164] = 164,
  [165] = 165,
  [166] = 166,
  [167] = 167,
  [168] = 168,
  [169] = 169,
  [170] = 170,
  [171] = 171,
  [172] = 172,
  [173] = 173,
  [174] = 174,
  [175] = 175,
  [176] = 176,
  [177] = 177,
  [178] = 178,
  [179] = 179,
  [180] = 180,
  [181] = 181,
  [182] = 182,
  [183] = 183,
  [184] = 184,
  [185] = 185,
  [186] = 186,
  [187] = 186,
  [188] = 177,
  [189] = 178,
  [190] = 182,
  [191] = 191,
  [192] = 192,
  [193] = 193,
  [194] = 194,
  [195] = 195,
  [196] = 196,
  [197] = 197,
  [198] = 198,
  [199] = 199,
  [200] = 200,
  [201] = 201,
  [202] = 202,
  [203] = 203,
  [204] = 204,
  [205] = 205,
  [206] = 206,
  [207] = 207,
  [208] = 208,
  [209] = 209,
  [210] = 210,
  [211] = 211,
  [212] = 212,
  [213] = 213,
  [214] = 214,
  [215] = 215,
  [216] = 216,
  [217] = 217,
  [218] = 218,
  [219] = 219,
  [220] = 220,
  [221] = 221,
  [222] = 222,
  [223] = 223,
  [224] = 224,
  [225] = 225,
  [226] = 226,
  [227] = 227,
  [228] = 228,
  [229] = 229,
  [230] = 230,
  [231] = 231,
  [232] = 232,
  [233] = 233,
  [234] = 234,
  [235] = 235,
  [236] = 236,
  [237] = 237,
  [238] = 238,
  [239] = 239,
  [240] = 240,
  [241] = 241,
  [242] = 242,
  [243] = 243,
  [244] = 244,
  [245] = 245,
  [246] = 246,
  [247] = 247,
  [248] = 248,
  [249] = 249,
  [250] = 250,
  [251] = 251,
  [252] = 252,
  [253] = 253,
  [254] = 254,
  [255] = 255,
  [256] = 256,
  [257] = 257,
  [258] = 258,
  [259] = 259,
  [260] = 260,
  [261] = 261,
  [262] = 262,
  [263] = 263,
  [264] = 264,
  [265] = 265,
  [266] = 266,
  [267] = 267,
  [268] = 268,
  [269] = 269,
  [270] = 270,
  [271] = 271,
  [272] = 272,
  [273] = 273,
  [274] = 274,
  [275] = 275,
  [276] = 276,
  [277] = 277,
  [278] = 278,
  [279] = 279,
  [280] = 280,
  [281] = 281,
  [282] = 282,
  [283] = 283,
  [284] = 284,
  [285] = 285,
  [286] = 286,
  [287] = 287,
  [288] = 288,
  [289] = 289,
  [290] = 290,
  [291] = 291,
  [292] = 292,
  [293] = 248,
  [294] = 241,
  [295] = 238,
  [296] = 296,
  [297] = 297,
  [298] = 298,
  [299] = 299,
  [300] = 300,
  [301] = 301,
  [302] = 302,
  [303] = 303,
  [304] = 304,
  [305] = 305,
  [306] = 306,
  [307] = 307,
  [308] = 308,
  [309] = 309,
  [310] = 310,
  [311] = 311,
  [312] = 312,
  [313] = 313,
  [314] = 314,
  [315] = 315,
  [316] = 316,
  [317] = 317,
  [318] = 318,
  [319] = 319,
  [320] = 320,
  [321] = 321,
  [322] = 322,
  [323] = 323,
  [324] = 324,
  [325] = 325,
  [326] = 326,
  [327] = 327,
  [328] = 328,
  [329] = 329,
  [330] = 330,
  [331] = 331,
  [332] = 332,
  [333] = 333,
  [334] = 334,
  [335] = 335,
  [336] = 336,
  [337] = 337,
  [338] = 338,
  [339] = 261,
  [340] = 340,
  [341] = 341,
  [342] = 342,
  [343] = 343,
  [344] = 344,
  [345] = 345,
  [346] = 346,
  [347] = 347,
  [348] = 348,
  [349] = 349,
  [350] = 350,
  [351] = 351,
  [352] = 352,
  [353] = 353,
  [354] = 354,
  [355] = 355,
  [356] = 356,
  [357] = 357,
  [358] = 358,
  [359] = 359,
  [360] = 360,
  [361] = 361,
  [362] = 362,
  [363] = 363,
  [364] = 364,
  [365] = 365,
  [366] = 366,
  [367] = 367,
  [368] = 368,
  [369] = 369,
  [370] = 370,
  [371] = 371,
  [372] = 372,
  [373] = 373,
  [374] = 374,
  [375] = 375,
  [376] = 376,
  [377] = 377,
  [378] = 378,
  [379] = 379,
  [380] = 380,
  [381] = 381,
  [382] = 382,
  [383] = 383,
  [384] = 384,
  [385] = 385,
  [386] = 386,
  [387] = 387,
  [388] = 388,
  [389] = 389,
  [390] = 390,
  [391] = 391,
  [392] = 392,
  [393] = 393,
  [394] = 394,
  [395] = 395,
  [396] = 396,
  [397] = 397,
  [398] = 398,
  [399] = 399,
  [400] = 400,
  [401] = 401,
  [402] = 402,
  [403] = 403,
  [404] = 404,
  [405] = 405,
  [406] = 406,
  [407] = 407,
  [408] = 408,
  [409] = 409,
  [410] = 410,
  [411] = 411,
  [412] = 412,
  [413] = 413,
  [414] = 414,
  [415] = 415,
  [416] = 416,
  [417] = 417,
  [418] = 418,
  [419] = 419,
  [420] = 420,
  [421] = 421,
  [422] = 422,
  [423] = 423,
  [424] = 424,
  [425] = 425,
  [426] = 426,
  [427] = 427,
  [428] = 428,
  [429] = 429,
  [430] = 430,
  [431] = 431,
  [432] = 432,
  [433] = 433,
  [434] = 434,
  [435] = 435,
  [436] = 436,
  [437] = 437,
  [438] = 365,
  [439] = 392,
  [440] = 440,
  [441] = 441,
  [442] = 442,
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(65);
      ADVANCE_MAP(
        '!', 136,
        '#', 23,
        '%', 134,
        '&', 117,
        '(', 70,
        ')', 72,
        '*', 130,
        '+', 125,
        ',', 71,
        '-', 127,
        '.', 141,
        '/', 132,
        '0', 96,
        ':', 89,
        ';', 67,
        '<', 90,
        '=', 69,
        '>', 92,
        '@', 76,
        '[', 138,
        ']', 139,
        '^', 114,
        '_', 79,
        '{', 74,
        '|', 111,
        '}', 75,
        '~', 137,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(97);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(0);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(77);
      END_STATE();
    case 1:
      if (lookahead == '\n') ADVANCE(143);
      if (lookahead == ',') ADVANCE(71);
      if (lookahead == '/') ADVANCE(10);
      if (lookahead == ':') ADVANCE(12);
      if (lookahead == '_') ADVANCE(63);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(1);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(77);
      END_STATE();
    case 2:
      ADVANCE_MAP(
        '!', 13,
        '%', 133,
        '&', 116,
        '(', 70,
        ')', 72,
        '*', 129,
        '+', 124,
        ',', 71,
        '-', 126,
        '.', 140,
        '/', 131,
        ':', 88,
        ';', 67,
        '<', 90,
        '=', 17,
        '>', 92,
        '[', 138,
        ']', 139,
        '^', 113,
        '{', 74,
        '|', 112,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(2);
      END_STATE();
    case 3:
      ADVANCE_MAP(
        '%', 14,
        '&', 15,
        '(', 70,
        ')', 72,
        '*', 16,
        '+', 4,
        '-', 5,
        '.', 140,
        '/', 11,
        '0', 100,
        ':', 12,
        '=', 68,
        '[', 138,
        '^', 18,
        '_', 63,
        '{', 74,
        '|', 19,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(101);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(3);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(77);
      END_STATE();
    case 4:
      if (lookahead == '+') ADVANCE(93);
      if (lookahead == '=') ADVANCE(80);
      END_STATE();
    case 5:
      if (lookahead == '-') ADVANCE(94);
      if (lookahead == '0') ADVANCE(57);
      if (lookahead == '=') ADVANCE(81);
      if (lookahead == '>') ADVANCE(73);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(101);
      END_STATE();
    case 6:
      if (lookahead == '.') ADVANCE(104);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(55);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(6);
      END_STATE();
    case 7:
      if (lookahead == '.') ADVANCE(104);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(9);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(8);
      END_STATE();
    case 8:
      if (lookahead == '.') ADVANCE(104);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(8);
      END_STATE();
    case 9:
      if (lookahead == '.') ADVANCE(61);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(99);
      END_STATE();
    case 10:
      if (lookahead == '/') ADVANCE(66);
      END_STATE();
    case 11:
      if (lookahead == '/') ADVANCE(66);
      if (lookahead == '=') ADVANCE(83);
      END_STATE();
    case 12:
      if (lookahead == ':') ADVANCE(145);
      END_STATE();
    case 13:
      if (lookahead == '=') ADVANCE(119);
      END_STATE();
    case 14:
      if (lookahead == '=') ADVANCE(84);
      END_STATE();
    case 15:
      if (lookahead == '=') ADVANCE(85);
      END_STATE();
    case 16:
      if (lookahead == '=') ADVANCE(82);
      END_STATE();
    case 17:
      if (lookahead == '=') ADVANCE(118);
      END_STATE();
    case 18:
      if (lookahead == '=') ADVANCE(87);
      END_STATE();
    case 19:
      if (lookahead == '=') ADVANCE(86);
      END_STATE();
    case 20:
      if (lookahead == '_') ADVANCE(47);
      END_STATE();
    case 21:
      if (lookahead == '_') ADVANCE(39);
      END_STATE();
    case 22:
      if (lookahead == 'a') ADVANCE(53);
      END_STATE();
    case 23:
      if (lookahead == 'd') ADVANCE(27);
      if (lookahead == 'e') ADVANCE(41);
      if (lookahead == 'i') ADVANCE(32);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(23);
      END_STATE();
    case 24:
      if (lookahead == 'd') ADVANCE(40);
      END_STATE();
    case 25:
      if (lookahead == 'd') ADVANCE(30);
      if (lookahead == 'n') ADVANCE(26);
      END_STATE();
    case 26:
      if (lookahead == 'd') ADVANCE(31);
      END_STATE();
    case 27:
      if (lookahead == 'e') ADVANCE(33);
      END_STATE();
    case 28:
      if (lookahead == 'e') ADVANCE(149);
      END_STATE();
    case 29:
      if (lookahead == 'e') ADVANCE(21);
      END_STATE();
    case 30:
      if (lookahead == 'e') ADVANCE(35);
      END_STATE();
    case 31:
      if (lookahead == 'e') ADVANCE(36);
      END_STATE();
    case 32:
      if (lookahead == 'f') ADVANCE(25);
      if (lookahead == 'm') ADVANCE(46);
      END_STATE();
    case 33:
      if (lookahead == 'f') ADVANCE(38);
      END_STATE();
    case 34:
      if (lookahead == 'f') ADVANCE(148);
      END_STATE();
    case 35:
      if (lookahead == 'f') ADVANCE(146);
      END_STATE();
    case 36:
      if (lookahead == 'f') ADVANCE(147);
      END_STATE();
    case 37:
      if (lookahead == 'h') ADVANCE(144);
      END_STATE();
    case 38:
      if (lookahead == 'i') ADVANCE(43);
      END_STATE();
    case 39:
      if (lookahead == 'i') ADVANCE(42);
      END_STATE();
    case 40:
      if (lookahead == 'i') ADVANCE(34);
      END_STATE();
    case 41:
      if (lookahead == 'l') ADVANCE(51);
      if (lookahead == 'n') ADVANCE(24);
      END_STATE();
    case 42:
      if (lookahead == 'm') ADVANCE(48);
      END_STATE();
    case 43:
      if (lookahead == 'n') ADVANCE(29);
      END_STATE();
    case 44:
      if (lookahead == 'o') ADVANCE(49);
      END_STATE();
    case 45:
      if (lookahead == 'o') ADVANCE(50);
      END_STATE();
    case 46:
      if (lookahead == 'p') ADVANCE(44);
      END_STATE();
    case 47:
      if (lookahead == 'p') ADVANCE(22);
      END_STATE();
    case 48:
      if (lookahead == 'p') ADVANCE(45);
      END_STATE();
    case 49:
      if (lookahead == 'r') ADVANCE(52);
      END_STATE();
    case 50:
      if (lookahead == 'r') ADVANCE(54);
      END_STATE();
    case 51:
      if (lookahead == 's') ADVANCE(28);
      END_STATE();
    case 52:
      if (lookahead == 't') ADVANCE(142);
      END_STATE();
    case 53:
      if (lookahead == 't') ADVANCE(37);
      END_STATE();
    case 54:
      if (lookahead == 't') ADVANCE(20);
      END_STATE();
    case 55:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(59);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(105);
      END_STATE();
    case 56:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(60);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(107);
      END_STATE();
    case 57:
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(62);
      END_STATE();
    case 58:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(104);
      END_STATE();
    case 59:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(105);
      END_STATE();
    case 60:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(107);
      END_STATE();
    case 61:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(108);
      END_STATE();
    case 62:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(102);
      END_STATE();
    case 63:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(78);
      END_STATE();
    case 64:
      if (eof) ADVANCE(65);
      ADVANCE_MAP(
        '!', 135,
        '#', 23,
        '&', 115,
        '(', 70,
        ')', 72,
        '*', 129,
        ',', 71,
        '-', 128,
        '.', 58,
        '/', 10,
        '0', 96,
        ':', 88,
        ';', 67,
        '=', 68,
        '>', 91,
        '@', 76,
        '_', 79,
        '{', 74,
        '}', 75,
        '~', 137,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(97);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(64);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(77);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(sym_line_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(66);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(118);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '_') ADVANCE(78);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(78);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(sym_identifier);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(78);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(anon_sym__);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(78);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == ':') ADVANCE(145);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(122);
      if (lookahead == '=') ADVANCE(120);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(121);
      if (lookahead == '>') ADVANCE(123);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(anon_sym_PLUS_PLUS);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(sym_int_literal);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(sym_int_literal);
      ADVANCE_MAP(
        '.', 104,
        'f', 103,
        'E', 55,
        'e', 55,
        'X', 9,
        'x', 9,
        'i', 95,
        'u', 95,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(6);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(sym_int_literal);
      if (lookahead == '.') ADVANCE(104);
      if (lookahead == 'f') ADVANCE(103);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(55);
      if (lookahead == 'i' ||
          lookahead == 'u') ADVANCE(95);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(97);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(sym_int_literal);
      if (lookahead == '.') ADVANCE(104);
      if (lookahead == 'f') ADVANCE(103);
      if (lookahead == 'i' ||
          lookahead == 'u') ADVANCE(95);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(98);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(sym_int_literal);
      if (lookahead == '.') ADVANCE(108);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(56);
      if (lookahead == 'i' ||
          lookahead == 'u') ADVANCE(95);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(99);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(sym_int_literal);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(62);
      if (lookahead == 'i' ||
          lookahead == 'u') ADVANCE(95);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(sym_int_literal);
      if (lookahead == 'i' ||
          lookahead == 'u') ADVANCE(95);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(101);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(sym_int_literal);
      if (lookahead == 'i' ||
          lookahead == 'u') ADVANCE(95);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(102);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(aux_sym_float_literal_token1);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(aux_sym_float_literal_token1);
      if (lookahead == 'f') ADVANCE(103);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(55);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(104);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(aux_sym_float_literal_token1);
      if (lookahead == 'f') ADVANCE(103);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(105);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(aux_sym_float_literal_token2);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(aux_sym_float_literal_token2);
      if (lookahead == 'f') ADVANCE(106);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(107);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(aux_sym_float_literal_token2);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(56);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(108);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(86);
      if (lookahead == '|') ADVANCE(109);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|') ADVANCE(109);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=') ADVANCE(87);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(110);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(110);
      if (lookahead == '=') ADVANCE(85);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(93);
      if (lookahead == '=') ADVANCE(80);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '.') ADVANCE(58);
      if (lookahead == '0') ADVANCE(7);
      if (lookahead == '=') ADVANCE(81);
      if (lookahead == '>') ADVANCE(73);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(98);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '.') ADVANCE(58);
      if (lookahead == '0') ADVANCE(7);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(98);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '=') ADVANCE(82);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '/') ADVANCE(66);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '/') ADVANCE(66);
      if (lookahead == '=') ADVANCE(83);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=') ADVANCE(84);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=') ADVANCE(119);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(104);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(aux_sym_preproc_import_token1);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n') ADVANCE(143);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(aux_sym_define_import_path_token1);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(anon_sym_COLON_COLON);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(aux_sym_preproc_ifdef_token1);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(aux_sym_preproc_ifdef_token2);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(aux_sym_preproc_ifdef_token3);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(aux_sym_preproc_else_token1);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      ADVANCE_MAP(
        'a', 1,
        'b', 2,
        'c', 3,
        'd', 4,
        'e', 5,
        'f', 6,
        'i', 7,
        'l', 8,
        'm', 9,
        'o', 10,
        'p', 11,
        'r', 12,
        's', 13,
        't', 14,
        'u', 15,
        'v', 16,
        'w', 17,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(0);
      END_STATE();
    case 1:
      if (lookahead == 'r') ADVANCE(18);
      if (lookahead == 's') ADVANCE(19);
      END_STATE();
    case 2:
      if (lookahead == 'i') ADVANCE(20);
      if (lookahead == 'o') ADVANCE(21);
      if (lookahead == 'r') ADVANCE(22);
      END_STATE();
    case 3:
      if (lookahead == 'a') ADVANCE(23);
      if (lookahead == 'o') ADVANCE(24);
      END_STATE();
    case 4:
      if (lookahead == 'e') ADVANCE(25);
      if (lookahead == 'i') ADVANCE(26);
      END_STATE();
    case 5:
      if (lookahead == 'l') ADVANCE(27);
      if (lookahead == 'n') ADVANCE(28);
      END_STATE();
    case 6:
      if (lookahead == '1') ADVANCE(29);
      if (lookahead == '3') ADVANCE(30);
      if (lookahead == 'a') ADVANCE(31);
      if (lookahead == 'n') ADVANCE(32);
      if (lookahead == 'o') ADVANCE(33);
      if (lookahead == 'u') ADVANCE(34);
      END_STATE();
    case 7:
      if (lookahead == '3') ADVANCE(35);
      if (lookahead == 'f') ADVANCE(36);
      END_STATE();
    case 8:
      if (lookahead == 'e') ADVANCE(37);
      if (lookahead == 'o') ADVANCE(38);
      END_STATE();
    case 9:
      if (lookahead == 'a') ADVANCE(39);
      END_STATE();
    case 10:
      if (lookahead == 'v') ADVANCE(40);
      END_STATE();
    case 11:
      if (lookahead == 'r') ADVANCE(41);
      if (lookahead == 't') ADVANCE(42);
      END_STATE();
    case 12:
      if (lookahead == '3') ADVANCE(43);
      if (lookahead == 'e') ADVANCE(44);
      if (lookahead == 'g') ADVANCE(45);
      END_STATE();
    case 13:
      if (lookahead == 'a') ADVANCE(46);
      if (lookahead == 't') ADVANCE(47);
      if (lookahead == 'w') ADVANCE(48);
      END_STATE();
    case 14:
      if (lookahead == 'e') ADVANCE(49);
      if (lookahead == 'r') ADVANCE(50);
      if (lookahead == 'y') ADVANCE(51);
      END_STATE();
    case 15:
      if (lookahead == '3') ADVANCE(52);
      if (lookahead == 'n') ADVANCE(53);
      END_STATE();
    case 16:
      if (lookahead == 'a') ADVANCE(54);
      if (lookahead == 'e') ADVANCE(55);
      if (lookahead == 'i') ADVANCE(56);
      END_STATE();
    case 17:
      if (lookahead == 'h') ADVANCE(57);
      if (lookahead == 'o') ADVANCE(58);
      if (lookahead == 'r') ADVANCE(59);
      END_STATE();
    case 18:
      if (lookahead == 'r') ADVANCE(60);
      END_STATE();
    case 19:
      ACCEPT_TOKEN(anon_sym_as);
      END_STATE();
    case 20:
      if (lookahead == 't') ADVANCE(61);
      END_STATE();
    case 21:
      if (lookahead == 'o') ADVANCE(62);
      END_STATE();
    case 22:
      if (lookahead == 'e') ADVANCE(63);
      END_STATE();
    case 23:
      if (lookahead == 's') ADVANCE(64);
      END_STATE();
    case 24:
      if (lookahead == 'n') ADVANCE(65);
      END_STATE();
    case 25:
      if (lookahead == 'f') ADVANCE(66);
      END_STATE();
    case 26:
      if (lookahead == 's') ADVANCE(67);
      END_STATE();
    case 27:
      if (lookahead == 's') ADVANCE(68);
      END_STATE();
    case 28:
      if (lookahead == 'a') ADVANCE(69);
      END_STATE();
    case 29:
      if (lookahead == '6') ADVANCE(70);
      END_STATE();
    case 30:
      if (lookahead == '2') ADVANCE(71);
      END_STATE();
    case 31:
      if (lookahead == 'l') ADVANCE(72);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(anon_sym_fn);
      END_STATE();
    case 33:
      if (lookahead == 'r') ADVANCE(73);
      END_STATE();
    case 34:
      if (lookahead == 'n') ADVANCE(74);
      END_STATE();
    case 35:
      if (lookahead == '2') ADVANCE(75);
      END_STATE();
    case 36:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 37:
      if (lookahead == 't') ADVANCE(76);
      END_STATE();
    case 38:
      if (lookahead == 'o') ADVANCE(77);
      END_STATE();
    case 39:
      if (lookahead == 't') ADVANCE(78);
      END_STATE();
    case 40:
      if (lookahead == 'e') ADVANCE(79);
      END_STATE();
    case 41:
      if (lookahead == 'i') ADVANCE(80);
      END_STATE();
    case 42:
      if (lookahead == 'r') ADVANCE(81);
      END_STATE();
    case 43:
      if (lookahead == '2') ADVANCE(82);
      END_STATE();
    case 44:
      if (lookahead == 'a') ADVANCE(83);
      if (lookahead == 't') ADVANCE(84);
      END_STATE();
    case 45:
      if (lookahead == '3') ADVANCE(85);
      if (lookahead == 'b') ADVANCE(86);
      END_STATE();
    case 46:
      if (lookahead == 'm') ADVANCE(87);
      END_STATE();
    case 47:
      if (lookahead == 'o') ADVANCE(88);
      if (lookahead == 'r') ADVANCE(89);
      END_STATE();
    case 48:
      if (lookahead == 'i') ADVANCE(90);
      END_STATE();
    case 49:
      if (lookahead == 'x') ADVANCE(91);
      END_STATE();
    case 50:
      if (lookahead == 'u') ADVANCE(92);
      END_STATE();
    case 51:
      if (lookahead == 'p') ADVANCE(93);
      END_STATE();
    case 52:
      if (lookahead == '2') ADVANCE(94);
      END_STATE();
    case 53:
      if (lookahead == 'i') ADVANCE(95);
      END_STATE();
    case 54:
      if (lookahead == 'r') ADVANCE(96);
      END_STATE();
    case 55:
      if (lookahead == 'c') ADVANCE(97);
      END_STATE();
    case 56:
      if (lookahead == 'r') ADVANCE(98);
      END_STATE();
    case 57:
      if (lookahead == 'i') ADVANCE(99);
      END_STATE();
    case 58:
      if (lookahead == 'r') ADVANCE(100);
      END_STATE();
    case 59:
      if (lookahead == 'i') ADVANCE(101);
      END_STATE();
    case 60:
      if (lookahead == 'a') ADVANCE(102);
      END_STATE();
    case 61:
      if (lookahead == 'c') ADVANCE(103);
      END_STATE();
    case 62:
      if (lookahead == 'l') ADVANCE(104);
      END_STATE();
    case 63:
      if (lookahead == 'a') ADVANCE(105);
      END_STATE();
    case 64:
      if (lookahead == 'e') ADVANCE(106);
      END_STATE();
    case 65:
      if (lookahead == 't') ADVANCE(107);
      END_STATE();
    case 66:
      if (lookahead == 'a') ADVANCE(108);
      END_STATE();
    case 67:
      if (lookahead == 'c') ADVANCE(109);
      END_STATE();
    case 68:
      if (lookahead == 'e') ADVANCE(110);
      END_STATE();
    case 69:
      if (lookahead == 'b') ADVANCE(111);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(anon_sym_f16);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(anon_sym_f32);
      END_STATE();
    case 72:
      if (lookahead == 'l') ADVANCE(112);
      if (lookahead == 's') ADVANCE(113);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 74:
      if (lookahead == 'c') ADVANCE(114);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_i32);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(anon_sym_let);
      END_STATE();
    case 77:
      if (lookahead == 'p') ADVANCE(115);
      END_STATE();
    case 78:
      if (lookahead == '2') ADVANCE(116);
      if (lookahead == '3') ADVANCE(117);
      if (lookahead == '4') ADVANCE(118);
      END_STATE();
    case 79:
      if (lookahead == 'r') ADVANCE(119);
      END_STATE();
    case 80:
      if (lookahead == 'v') ADVANCE(120);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(anon_sym_ptr);
      END_STATE();
    case 82:
      if (lookahead == 'f') ADVANCE(121);
      if (lookahead == 's') ADVANCE(122);
      if (lookahead == 'u') ADVANCE(123);
      END_STATE();
    case 83:
      if (lookahead == 'd') ADVANCE(124);
      END_STATE();
    case 84:
      if (lookahead == 'u') ADVANCE(125);
      END_STATE();
    case 85:
      if (lookahead == '2') ADVANCE(126);
      END_STATE();
    case 86:
      if (lookahead == 'a') ADVANCE(127);
      END_STATE();
    case 87:
      if (lookahead == 'p') ADVANCE(128);
      END_STATE();
    case 88:
      if (lookahead == 'r') ADVANCE(129);
      END_STATE();
    case 89:
      if (lookahead == 'u') ADVANCE(130);
      END_STATE();
    case 90:
      if (lookahead == 't') ADVANCE(131);
      END_STATE();
    case 91:
      if (lookahead == 't') ADVANCE(132);
      END_STATE();
    case 92:
      if (lookahead == 'e') ADVANCE(133);
      END_STATE();
    case 93:
      if (lookahead == 'e') ADVANCE(134);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(anon_sym_u32);
      END_STATE();
    case 95:
      if (lookahead == 'f') ADVANCE(135);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_var);
      END_STATE();
    case 97:
      if (lookahead == '2') ADVANCE(136);
      if (lookahead == '3') ADVANCE(137);
      if (lookahead == '4') ADVANCE(138);
      END_STATE();
    case 98:
      if (lookahead == 't') ADVANCE(139);
      END_STATE();
    case 99:
      if (lookahead == 'l') ADVANCE(140);
      END_STATE();
    case 100:
      if (lookahead == 'k') ADVANCE(141);
      END_STATE();
    case 101:
      if (lookahead == 't') ADVANCE(142);
      END_STATE();
    case 102:
      if (lookahead == 'y') ADVANCE(143);
      END_STATE();
    case 103:
      if (lookahead == 'a') ADVANCE(144);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_bool);
      END_STATE();
    case 105:
      if (lookahead == 'k') ADVANCE(145);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_case);
      END_STATE();
    case 107:
      if (lookahead == 'i') ADVANCE(146);
      END_STATE();
    case 108:
      if (lookahead == 'u') ADVANCE(147);
      END_STATE();
    case 109:
      if (lookahead == 'a') ADVANCE(148);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 111:
      if (lookahead == 'l') ADVANCE(149);
      END_STATE();
    case 112:
      if (lookahead == 't') ADVANCE(150);
      END_STATE();
    case 113:
      if (lookahead == 'e') ADVANCE(151);
      END_STATE();
    case 114:
      if (lookahead == 't') ADVANCE(152);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_loop);
      END_STATE();
    case 116:
      if (lookahead == 'x') ADVANCE(153);
      END_STATE();
    case 117:
      if (lookahead == 'x') ADVANCE(154);
      END_STATE();
    case 118:
      if (lookahead == 'x') ADVANCE(155);
      END_STATE();
    case 119:
      if (lookahead == 'r') ADVANCE(156);
      END_STATE();
    case 120:
      if (lookahead == 'a') ADVANCE(157);
      END_STATE();
    case 121:
      if (lookahead == 'l') ADVANCE(158);
      END_STATE();
    case 122:
      if (lookahead == 'i') ADVANCE(159);
      END_STATE();
    case 123:
      if (lookahead == 'i') ADVANCE(160);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_read);
      if (lookahead == '_') ADVANCE(161);
      END_STATE();
    case 125:
      if (lookahead == 'r') ADVANCE(162);
      END_STATE();
    case 126:
      if (lookahead == 'f') ADVANCE(163);
      if (lookahead == 's') ADVANCE(164);
      if (lookahead == 'u') ADVANCE(165);
      END_STATE();
    case 127:
      if (lookahead == '1') ADVANCE(166);
      if (lookahead == '3') ADVANCE(167);
      if (lookahead == '8') ADVANCE(168);
      END_STATE();
    case 128:
      if (lookahead == 'l') ADVANCE(169);
      END_STATE();
    case 129:
      if (lookahead == 'a') ADVANCE(170);
      END_STATE();
    case 130:
      if (lookahead == 'c') ADVANCE(171);
      END_STATE();
    case 131:
      if (lookahead == 'c') ADVANCE(172);
      END_STATE();
    case 132:
      if (lookahead == 'u') ADVANCE(173);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_true);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(anon_sym_type);
      END_STATE();
    case 135:
      if (lookahead == 'o') ADVANCE(174);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_vec2);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_vec3);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_vec4);
      END_STATE();
    case 139:
      if (lookahead == 'u') ADVANCE(175);
      END_STATE();
    case 140:
      if (lookahead == 'e') ADVANCE(176);
      END_STATE();
    case 141:
      if (lookahead == 'g') ADVANCE(177);
      END_STATE();
    case 142:
      if (lookahead == 'e') ADVANCE(178);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(anon_sym_array);
      END_STATE();
    case 144:
      if (lookahead == 's') ADVANCE(179);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 146:
      if (lookahead == 'n') ADVANCE(180);
      END_STATE();
    case 147:
      if (lookahead == 'l') ADVANCE(181);
      END_STATE();
    case 148:
      if (lookahead == 'r') ADVANCE(182);
      END_STATE();
    case 149:
      if (lookahead == 'e') ADVANCE(183);
      END_STATE();
    case 150:
      if (lookahead == 'h') ADVANCE(184);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(anon_sym_false);
      END_STATE();
    case 152:
      if (lookahead == 'i') ADVANCE(185);
      END_STATE();
    case 153:
      if (lookahead == '2') ADVANCE(186);
      if (lookahead == '3') ADVANCE(187);
      if (lookahead == '4') ADVANCE(188);
      END_STATE();
    case 154:
      if (lookahead == '2') ADVANCE(189);
      if (lookahead == '3') ADVANCE(190);
      if (lookahead == '4') ADVANCE(191);
      END_STATE();
    case 155:
      if (lookahead == '2') ADVANCE(192);
      if (lookahead == '3') ADVANCE(193);
      if (lookahead == '4') ADVANCE(194);
      END_STATE();
    case 156:
      if (lookahead == 'i') ADVANCE(195);
      END_STATE();
    case 157:
      if (lookahead == 't') ADVANCE(196);
      END_STATE();
    case 158:
      if (lookahead == 'o') ADVANCE(197);
      END_STATE();
    case 159:
      if (lookahead == 'n') ADVANCE(198);
      END_STATE();
    case 160:
      if (lookahead == 'n') ADVANCE(199);
      END_STATE();
    case 161:
      if (lookahead == 'w') ADVANCE(200);
      END_STATE();
    case 162:
      if (lookahead == 'n') ADVANCE(201);
      END_STATE();
    case 163:
      if (lookahead == 'l') ADVANCE(202);
      END_STATE();
    case 164:
      if (lookahead == 'i') ADVANCE(203);
      END_STATE();
    case 165:
      if (lookahead == 'i') ADVANCE(204);
      END_STATE();
    case 166:
      if (lookahead == '6') ADVANCE(205);
      END_STATE();
    case 167:
      if (lookahead == '2') ADVANCE(206);
      END_STATE();
    case 168:
      if (lookahead == 's') ADVANCE(207);
      if (lookahead == 'u') ADVANCE(208);
      END_STATE();
    case 169:
      if (lookahead == 'e') ADVANCE(209);
      END_STATE();
    case 170:
      if (lookahead == 'g') ADVANCE(210);
      END_STATE();
    case 171:
      if (lookahead == 't') ADVANCE(211);
      END_STATE();
    case 172:
      if (lookahead == 'h') ADVANCE(212);
      END_STATE();
    case 173:
      if (lookahead == 'r') ADVANCE(213);
      END_STATE();
    case 174:
      if (lookahead == 'r') ADVANCE(214);
      END_STATE();
    case 175:
      if (lookahead == 'a') ADVANCE(215);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 177:
      if (lookahead == 'r') ADVANCE(216);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(anon_sym_write);
      END_STATE();
    case 179:
      if (lookahead == 't') ADVANCE(217);
      END_STATE();
    case 180:
      if (lookahead == 'u') ADVANCE(218);
      END_STATE();
    case 181:
      if (lookahead == 't') ADVANCE(219);
      END_STATE();
    case 182:
      if (lookahead == 'd') ADVANCE(220);
      END_STATE();
    case 183:
      ACCEPT_TOKEN(anon_sym_enable);
      END_STATE();
    case 184:
      if (lookahead == 'r') ADVANCE(221);
      END_STATE();
    case 185:
      if (lookahead == 'o') ADVANCE(222);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(anon_sym_mat2x2);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(anon_sym_mat2x3);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(anon_sym_mat2x4);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(anon_sym_mat3x2);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(anon_sym_mat3x3);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(anon_sym_mat3x4);
      END_STATE();
    case 192:
      ACCEPT_TOKEN(anon_sym_mat4x2);
      END_STATE();
    case 193:
      ACCEPT_TOKEN(anon_sym_mat4x3);
      END_STATE();
    case 194:
      ACCEPT_TOKEN(anon_sym_mat4x4);
      END_STATE();
    case 195:
      if (lookahead == 'd') ADVANCE(223);
      END_STATE();
    case 196:
      if (lookahead == 'e') ADVANCE(224);
      END_STATE();
    case 197:
      if (lookahead == 'a') ADVANCE(225);
      END_STATE();
    case 198:
      if (lookahead == 't') ADVANCE(226);
      END_STATE();
    case 199:
      if (lookahead == 't') ADVANCE(227);
      END_STATE();
    case 200:
      if (lookahead == 'r') ADVANCE(228);
      END_STATE();
    case 201:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 202:
      if (lookahead == 'o') ADVANCE(229);
      END_STATE();
    case 203:
      if (lookahead == 'n') ADVANCE(230);
      END_STATE();
    case 204:
      if (lookahead == 'n') ADVANCE(231);
      END_STATE();
    case 205:
      if (lookahead == 'f') ADVANCE(232);
      if (lookahead == 's') ADVANCE(233);
      if (lookahead == 'u') ADVANCE(234);
      END_STATE();
    case 206:
      if (lookahead == 'f') ADVANCE(235);
      if (lookahead == 's') ADVANCE(236);
      if (lookahead == 'u') ADVANCE(237);
      END_STATE();
    case 207:
      if (lookahead == 'i') ADVANCE(238);
      if (lookahead == 'n') ADVANCE(239);
      END_STATE();
    case 208:
      if (lookahead == 'i') ADVANCE(240);
      if (lookahead == 'n') ADVANCE(241);
      END_STATE();
    case 209:
      if (lookahead == 'r') ADVANCE(242);
      END_STATE();
    case 210:
      if (lookahead == 'e') ADVANCE(243);
      END_STATE();
    case 211:
      ACCEPT_TOKEN(anon_sym_struct);
      END_STATE();
    case 212:
      ACCEPT_TOKEN(anon_sym_switch);
      END_STATE();
    case 213:
      if (lookahead == 'e') ADVANCE(244);
      END_STATE();
    case 214:
      if (lookahead == 'm') ADVANCE(245);
      END_STATE();
    case 215:
      if (lookahead == 'l') ADVANCE(246);
      END_STATE();
    case 216:
      if (lookahead == 'o') ADVANCE(247);
      END_STATE();
    case 217:
      ACCEPT_TOKEN(anon_sym_bitcast);
      END_STATE();
    case 218:
      if (lookahead == 'e') ADVANCE(248);
      if (lookahead == 'i') ADVANCE(249);
      END_STATE();
    case 219:
      ACCEPT_TOKEN(anon_sym_default);
      END_STATE();
    case 220:
      ACCEPT_TOKEN(anon_sym_discard);
      END_STATE();
    case 221:
      if (lookahead == 'o') ADVANCE(250);
      END_STATE();
    case 222:
      if (lookahead == 'n') ADVANCE(251);
      END_STATE();
    case 223:
      if (lookahead == 'e') ADVANCE(252);
      END_STATE();
    case 224:
      ACCEPT_TOKEN(anon_sym_private);
      END_STATE();
    case 225:
      if (lookahead == 't') ADVANCE(253);
      END_STATE();
    case 226:
      ACCEPT_TOKEN(anon_sym_r32sint);
      END_STATE();
    case 227:
      ACCEPT_TOKEN(anon_sym_r32uint);
      END_STATE();
    case 228:
      if (lookahead == 'i') ADVANCE(254);
      END_STATE();
    case 229:
      if (lookahead == 'a') ADVANCE(255);
      END_STATE();
    case 230:
      if (lookahead == 't') ADVANCE(256);
      END_STATE();
    case 231:
      if (lookahead == 't') ADVANCE(257);
      END_STATE();
    case 232:
      if (lookahead == 'l') ADVANCE(258);
      END_STATE();
    case 233:
      if (lookahead == 'i') ADVANCE(259);
      END_STATE();
    case 234:
      if (lookahead == 'i') ADVANCE(260);
      END_STATE();
    case 235:
      if (lookahead == 'l') ADVANCE(261);
      END_STATE();
    case 236:
      if (lookahead == 'i') ADVANCE(262);
      END_STATE();
    case 237:
      if (lookahead == 'i') ADVANCE(263);
      END_STATE();
    case 238:
      if (lookahead == 'n') ADVANCE(264);
      END_STATE();
    case 239:
      if (lookahead == 'o') ADVANCE(265);
      END_STATE();
    case 240:
      if (lookahead == 'n') ADVANCE(266);
      END_STATE();
    case 241:
      if (lookahead == 'o') ADVANCE(267);
      END_STATE();
    case 242:
      ACCEPT_TOKEN(anon_sym_sampler);
      if (lookahead == '_') ADVANCE(268);
      END_STATE();
    case 243:
      ACCEPT_TOKEN(anon_sym_storage);
      END_STATE();
    case 244:
      if (lookahead == '_') ADVANCE(269);
      END_STATE();
    case 245:
      ACCEPT_TOKEN(anon_sym_uniform);
      END_STATE();
    case 246:
      ACCEPT_TOKEN(anon_sym_virtual);
      END_STATE();
    case 247:
      if (lookahead == 'u') ADVANCE(270);
      END_STATE();
    case 248:
      ACCEPT_TOKEN(anon_sym_continue);
      END_STATE();
    case 249:
      if (lookahead == 'n') ADVANCE(271);
      END_STATE();
    case 250:
      if (lookahead == 'u') ADVANCE(272);
      END_STATE();
    case 251:
      ACCEPT_TOKEN(anon_sym_function);
      END_STATE();
    case 252:
      ACCEPT_TOKEN(anon_sym_override);
      END_STATE();
    case 253:
      ACCEPT_TOKEN(anon_sym_r32float);
      END_STATE();
    case 254:
      if (lookahead == 't') ADVANCE(273);
      END_STATE();
    case 255:
      if (lookahead == 't') ADVANCE(274);
      END_STATE();
    case 256:
      ACCEPT_TOKEN(anon_sym_rg32sint);
      END_STATE();
    case 257:
      ACCEPT_TOKEN(anon_sym_rg32uint);
      END_STATE();
    case 258:
      if (lookahead == 'o') ADVANCE(275);
      END_STATE();
    case 259:
      if (lookahead == 'n') ADVANCE(276);
      END_STATE();
    case 260:
      if (lookahead == 'n') ADVANCE(277);
      END_STATE();
    case 261:
      if (lookahead == 'o') ADVANCE(278);
      END_STATE();
    case 262:
      if (lookahead == 'n') ADVANCE(279);
      END_STATE();
    case 263:
      if (lookahead == 'n') ADVANCE(280);
      END_STATE();
    case 264:
      if (lookahead == 't') ADVANCE(281);
      END_STATE();
    case 265:
      if (lookahead == 'r') ADVANCE(282);
      END_STATE();
    case 266:
      if (lookahead == 't') ADVANCE(283);
      END_STATE();
    case 267:
      if (lookahead == 'r') ADVANCE(284);
      END_STATE();
    case 268:
      if (lookahead == 'c') ADVANCE(285);
      END_STATE();
    case 269:
      if (lookahead == '1') ADVANCE(286);
      if (lookahead == '2') ADVANCE(287);
      if (lookahead == '3') ADVANCE(288);
      if (lookahead == 'c') ADVANCE(289);
      if (lookahead == 'd') ADVANCE(290);
      if (lookahead == 'm') ADVANCE(291);
      if (lookahead == 's') ADVANCE(292);
      END_STATE();
    case 270:
      if (lookahead == 'p') ADVANCE(293);
      END_STATE();
    case 271:
      if (lookahead == 'g') ADVANCE(294);
      END_STATE();
    case 272:
      if (lookahead == 'g') ADVANCE(295);
      END_STATE();
    case 273:
      if (lookahead == 'e') ADVANCE(296);
      END_STATE();
    case 274:
      ACCEPT_TOKEN(anon_sym_rg32float);
      END_STATE();
    case 275:
      if (lookahead == 'a') ADVANCE(297);
      END_STATE();
    case 276:
      if (lookahead == 't') ADVANCE(298);
      END_STATE();
    case 277:
      if (lookahead == 't') ADVANCE(299);
      END_STATE();
    case 278:
      if (lookahead == 'a') ADVANCE(300);
      END_STATE();
    case 279:
      if (lookahead == 't') ADVANCE(301);
      END_STATE();
    case 280:
      if (lookahead == 't') ADVANCE(302);
      END_STATE();
    case 281:
      ACCEPT_TOKEN(anon_sym_rgba8sint);
      END_STATE();
    case 282:
      if (lookahead == 'm') ADVANCE(303);
      END_STATE();
    case 283:
      ACCEPT_TOKEN(anon_sym_rgba8uint);
      END_STATE();
    case 284:
      if (lookahead == 'm') ADVANCE(304);
      END_STATE();
    case 285:
      if (lookahead == 'o') ADVANCE(305);
      END_STATE();
    case 286:
      if (lookahead == 'd') ADVANCE(306);
      END_STATE();
    case 287:
      if (lookahead == 'd') ADVANCE(307);
      END_STATE();
    case 288:
      if (lookahead == 'd') ADVANCE(308);
      END_STATE();
    case 289:
      if (lookahead == 'u') ADVANCE(309);
      END_STATE();
    case 290:
      if (lookahead == 'e') ADVANCE(310);
      END_STATE();
    case 291:
      if (lookahead == 'u') ADVANCE(311);
      END_STATE();
    case 292:
      if (lookahead == 't') ADVANCE(312);
      END_STATE();
    case 293:
      ACCEPT_TOKEN(anon_sym_workgroup);
      END_STATE();
    case 294:
      ACCEPT_TOKEN(anon_sym_continuing);
      END_STATE();
    case 295:
      if (lookahead == 'h') ADVANCE(313);
      END_STATE();
    case 296:
      ACCEPT_TOKEN(anon_sym_read_write);
      END_STATE();
    case 297:
      if (lookahead == 't') ADVANCE(314);
      END_STATE();
    case 298:
      ACCEPT_TOKEN(anon_sym_rgba16sint);
      END_STATE();
    case 299:
      ACCEPT_TOKEN(anon_sym_rgba16uint);
      END_STATE();
    case 300:
      if (lookahead == 't') ADVANCE(315);
      END_STATE();
    case 301:
      ACCEPT_TOKEN(anon_sym_rgba32sint);
      END_STATE();
    case 302:
      ACCEPT_TOKEN(anon_sym_rgba32uint);
      END_STATE();
    case 303:
      ACCEPT_TOKEN(anon_sym_rgba8snorm);
      END_STATE();
    case 304:
      ACCEPT_TOKEN(anon_sym_rgba8unorm);
      END_STATE();
    case 305:
      if (lookahead == 'm') ADVANCE(316);
      END_STATE();
    case 306:
      ACCEPT_TOKEN(anon_sym_texture_1d);
      END_STATE();
    case 307:
      ACCEPT_TOKEN(anon_sym_texture_2d);
      if (lookahead == '_') ADVANCE(317);
      END_STATE();
    case 308:
      ACCEPT_TOKEN(anon_sym_texture_3d);
      END_STATE();
    case 309:
      if (lookahead == 'b') ADVANCE(318);
      END_STATE();
    case 310:
      if (lookahead == 'p') ADVANCE(319);
      END_STATE();
    case 311:
      if (lookahead == 'l') ADVANCE(320);
      END_STATE();
    case 312:
      if (lookahead == 'o') ADVANCE(321);
      END_STATE();
    case 313:
      ACCEPT_TOKEN(anon_sym_fallthrough);
      END_STATE();
    case 314:
      ACCEPT_TOKEN(anon_sym_rgba16float);
      END_STATE();
    case 315:
      ACCEPT_TOKEN(anon_sym_rgba32float);
      END_STATE();
    case 316:
      if (lookahead == 'p') ADVANCE(322);
      END_STATE();
    case 317:
      if (lookahead == 'a') ADVANCE(323);
      END_STATE();
    case 318:
      if (lookahead == 'e') ADVANCE(324);
      END_STATE();
    case 319:
      if (lookahead == 't') ADVANCE(325);
      END_STATE();
    case 320:
      if (lookahead == 't') ADVANCE(326);
      END_STATE();
    case 321:
      if (lookahead == 'r') ADVANCE(327);
      END_STATE();
    case 322:
      if (lookahead == 'a') ADVANCE(328);
      END_STATE();
    case 323:
      if (lookahead == 'r') ADVANCE(329);
      END_STATE();
    case 324:
      ACCEPT_TOKEN(anon_sym_texture_cube);
      if (lookahead == '_') ADVANCE(330);
      END_STATE();
    case 325:
      if (lookahead == 'h') ADVANCE(331);
      END_STATE();
    case 326:
      if (lookahead == 'i') ADVANCE(332);
      END_STATE();
    case 327:
      if (lookahead == 'a') ADVANCE(333);
      END_STATE();
    case 328:
      if (lookahead == 'r') ADVANCE(334);
      END_STATE();
    case 329:
      if (lookahead == 'r') ADVANCE(335);
      END_STATE();
    case 330:
      if (lookahead == 'a') ADVANCE(336);
      END_STATE();
    case 331:
      if (lookahead == '_') ADVANCE(337);
      END_STATE();
    case 332:
      if (lookahead == 's') ADVANCE(338);
      END_STATE();
    case 333:
      if (lookahead == 'g') ADVANCE(339);
      END_STATE();
    case 334:
      if (lookahead == 'i') ADVANCE(340);
      END_STATE();
    case 335:
      if (lookahead == 'a') ADVANCE(341);
      END_STATE();
    case 336:
      if (lookahead == 'r') ADVANCE(342);
      END_STATE();
    case 337:
      if (lookahead == '2') ADVANCE(343);
      if (lookahead == 'c') ADVANCE(344);
      if (lookahead == 'm') ADVANCE(345);
      END_STATE();
    case 338:
      if (lookahead == 'a') ADVANCE(346);
      END_STATE();
    case 339:
      if (lookahead == 'e') ADVANCE(347);
      END_STATE();
    case 340:
      if (lookahead == 's') ADVANCE(348);
      END_STATE();
    case 341:
      if (lookahead == 'y') ADVANCE(349);
      END_STATE();
    case 342:
      if (lookahead == 'r') ADVANCE(350);
      END_STATE();
    case 343:
      if (lookahead == 'd') ADVANCE(351);
      END_STATE();
    case 344:
      if (lookahead == 'u') ADVANCE(352);
      END_STATE();
    case 345:
      if (lookahead == 'u') ADVANCE(353);
      END_STATE();
    case 346:
      if (lookahead == 'm') ADVANCE(354);
      END_STATE();
    case 347:
      if (lookahead == '_') ADVANCE(355);
      END_STATE();
    case 348:
      if (lookahead == 'o') ADVANCE(356);
      END_STATE();
    case 349:
      ACCEPT_TOKEN(anon_sym_texture_2d_array);
      END_STATE();
    case 350:
      if (lookahead == 'a') ADVANCE(357);
      END_STATE();
    case 351:
      ACCEPT_TOKEN(anon_sym_texture_depth_2d);
      if (lookahead == '_') ADVANCE(358);
      END_STATE();
    case 352:
      if (lookahead == 'b') ADVANCE(359);
      END_STATE();
    case 353:
      if (lookahead == 'l') ADVANCE(360);
      END_STATE();
    case 354:
      if (lookahead == 'p') ADVANCE(361);
      END_STATE();
    case 355:
      if (lookahead == '1') ADVANCE(362);
      if (lookahead == '2') ADVANCE(363);
      if (lookahead == '3') ADVANCE(364);
      END_STATE();
    case 356:
      if (lookahead == 'n') ADVANCE(365);
      END_STATE();
    case 357:
      if (lookahead == 'y') ADVANCE(366);
      END_STATE();
    case 358:
      if (lookahead == 'a') ADVANCE(367);
      END_STATE();
    case 359:
      if (lookahead == 'e') ADVANCE(368);
      END_STATE();
    case 360:
      if (lookahead == 't') ADVANCE(369);
      END_STATE();
    case 361:
      if (lookahead == 'l') ADVANCE(370);
      END_STATE();
    case 362:
      if (lookahead == 'd') ADVANCE(371);
      END_STATE();
    case 363:
      if (lookahead == 'd') ADVANCE(372);
      END_STATE();
    case 364:
      if (lookahead == 'd') ADVANCE(373);
      END_STATE();
    case 365:
      ACCEPT_TOKEN(anon_sym_sampler_comparison);
      END_STATE();
    case 366:
      ACCEPT_TOKEN(anon_sym_texture_cube_array);
      END_STATE();
    case 367:
      if (lookahead == 'r') ADVANCE(374);
      END_STATE();
    case 368:
      ACCEPT_TOKEN(anon_sym_texture_depth_cube);
      if (lookahead == '_') ADVANCE(375);
      END_STATE();
    case 369:
      if (lookahead == 'i') ADVANCE(376);
      END_STATE();
    case 370:
      if (lookahead == 'e') ADVANCE(377);
      END_STATE();
    case 371:
      ACCEPT_TOKEN(anon_sym_texture_storage_1d);
      END_STATE();
    case 372:
      ACCEPT_TOKEN(anon_sym_texture_storage_2d);
      if (lookahead == '_') ADVANCE(378);
      END_STATE();
    case 373:
      ACCEPT_TOKEN(anon_sym_texture_storage_3d);
      END_STATE();
    case 374:
      if (lookahead == 'r') ADVANCE(379);
      END_STATE();
    case 375:
      if (lookahead == 'a') ADVANCE(380);
      END_STATE();
    case 376:
      if (lookahead == 's') ADVANCE(381);
      END_STATE();
    case 377:
      if (lookahead == 'd') ADVANCE(382);
      END_STATE();
    case 378:
      if (lookahead == 'a') ADVANCE(383);
      END_STATE();
    case 379:
      if (lookahead == 'a') ADVANCE(384);
      END_STATE();
    case 380:
      if (lookahead == 'r') ADVANCE(385);
      END_STATE();
    case 381:
      if (lookahead == 'a') ADVANCE(386);
      END_STATE();
    case 382:
      if (lookahead == '_') ADVANCE(387);
      END_STATE();
    case 383:
      if (lookahead == 'r') ADVANCE(388);
      END_STATE();
    case 384:
      if (lookahead == 'y') ADVANCE(389);
      END_STATE();
    case 385:
      if (lookahead == 'r') ADVANCE(390);
      END_STATE();
    case 386:
      if (lookahead == 'm') ADVANCE(391);
      END_STATE();
    case 387:
      if (lookahead == '2') ADVANCE(392);
      END_STATE();
    case 388:
      if (lookahead == 'r') ADVANCE(393);
      END_STATE();
    case 389:
      ACCEPT_TOKEN(anon_sym_texture_depth_2d_array);
      END_STATE();
    case 390:
      if (lookahead == 'a') ADVANCE(394);
      END_STATE();
    case 391:
      if (lookahead == 'p') ADVANCE(395);
      END_STATE();
    case 392:
      if (lookahead == 'd') ADVANCE(396);
      END_STATE();
    case 393:
      if (lookahead == 'a') ADVANCE(397);
      END_STATE();
    case 394:
      if (lookahead == 'y') ADVANCE(398);
      END_STATE();
    case 395:
      if (lookahead == 'l') ADVANCE(399);
      END_STATE();
    case 396:
      ACCEPT_TOKEN(anon_sym_texture_multisampled_2d);
      END_STATE();
    case 397:
      if (lookahead == 'y') ADVANCE(400);
      END_STATE();
    case 398:
      ACCEPT_TOKEN(anon_sym_texture_depth_cube_array);
      END_STATE();
    case 399:
      if (lookahead == 'e') ADVANCE(401);
      END_STATE();
    case 400:
      ACCEPT_TOKEN(anon_sym_texture_storage_2d_array);
      END_STATE();
    case 401:
      if (lookahead == 'd') ADVANCE(402);
      END_STATE();
    case 402:
      if (lookahead == '_') ADVANCE(403);
      END_STATE();
    case 403:
      if (lookahead == '2') ADVANCE(404);
      END_STATE();
    case 404:
      if (lookahead == 'd') ADVANCE(405);
      END_STATE();
    case 405:
      ACCEPT_TOKEN(anon_sym_texture_depth_multisampled_2d);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 0, .external_lex_state = 1},
  [2] = {.lex_state = 64, .external_lex_state = 1},
  [3] = {.lex_state = 64, .external_lex_state = 1},
  [4] = {.lex_state = 64, .external_lex_state = 1},
  [5] = {.lex_state = 64, .external_lex_state = 1},
  [6] = {.lex_state = 64, .external_lex_state = 1},
  [7] = {.lex_state = 64, .external_lex_state = 1},
  [8] = {.lex_state = 64, .external_lex_state = 1},
  [9] = {.lex_state = 64, .external_lex_state = 1},
  [10] = {.lex_state = 64, .external_lex_state = 1},
  [11] = {.lex_state = 64, .external_lex_state = 1},
  [12] = {.lex_state = 64, .external_lex_state = 1},
  [13] = {.lex_state = 64, .external_lex_state = 1},
  [14] = {.lex_state = 64, .external_lex_state = 1},
  [15] = {.lex_state = 64, .external_lex_state = 1},
  [16] = {.lex_state = 64, .external_lex_state = 1},
  [17] = {.lex_state = 64, .external_lex_state = 1},
  [18] = {.lex_state = 64, .external_lex_state = 1},
  [19] = {.lex_state = 64, .external_lex_state = 1},
  [20] = {.lex_state = 64, .external_lex_state = 1},
  [21] = {.lex_state = 64, .external_lex_state = 1},
  [22] = {.lex_state = 64, .external_lex_state = 1},
  [23] = {.lex_state = 64, .external_lex_state = 1},
  [24] = {.lex_state = 64, .external_lex_state = 1},
  [25] = {.lex_state = 64, .external_lex_state = 1},
  [26] = {.lex_state = 64, .external_lex_state = 1},
  [27] = {.lex_state = 64, .external_lex_state = 1},
  [28] = {.lex_state = 64, .external_lex_state = 1},
  [29] = {.lex_state = 64, .external_lex_state = 1},
  [30] = {.lex_state = 64, .external_lex_state = 1},
  [31] = {.lex_state = 64, .external_lex_state = 1},
  [32] = {.lex_state = 64, .external_lex_state = 1},
  [33] = {.lex_state = 64, .external_lex_state = 1},
  [34] = {.lex_state = 64, .external_lex_state = 1},
  [35] = {.lex_state = 64, .external_lex_state = 1},
  [36] = {.lex_state = 64, .external_lex_state = 1},
  [37] = {.lex_state = 64, .external_lex_state = 1},
  [38] = {.lex_state = 64, .external_lex_state = 1},
  [39] = {.lex_state = 64, .external_lex_state = 1},
  [40] = {.lex_state = 64, .external_lex_state = 1},
  [41] = {.lex_state = 64, .external_lex_state = 1},
  [42] = {.lex_state = 64, .external_lex_state = 1},
  [43] = {.lex_state = 64, .external_lex_state = 1},
  [44] = {.lex_state = 64, .external_lex_state = 1},
  [45] = {.lex_state = 64, .external_lex_state = 1},
  [46] = {.lex_state = 64, .external_lex_state = 1},
  [47] = {.lex_state = 64, .external_lex_state = 1},
  [48] = {.lex_state = 0, .external_lex_state = 1},
  [49] = {.lex_state = 0, .external_lex_state = 1},
  [50] = {.lex_state = 0, .external_lex_state = 1},
  [51] = {.lex_state = 64, .external_lex_state = 1},
  [52] = {.lex_state = 64, .external_lex_state = 1},
  [53] = {.lex_state = 64, .external_lex_state = 1},
  [54] = {.lex_state = 64, .external_lex_state = 1},
  [55] = {.lex_state = 64, .external_lex_state = 1},
  [56] = {.lex_state = 64, .external_lex_state = 1},
  [57] = {.lex_state = 64, .external_lex_state = 1},
  [58] = {.lex_state = 64, .external_lex_state = 1},
  [59] = {.lex_state = 0, .external_lex_state = 1},
  [60] = {.lex_state = 64, .external_lex_state = 1},
  [61] = {.lex_state = 64, .external_lex_state = 1},
  [62] = {.lex_state = 64, .external_lex_state = 1},
  [63] = {.lex_state = 0, .external_lex_state = 1},
  [64] = {.lex_state = 64, .external_lex_state = 1},
  [65] = {.lex_state = 0, .external_lex_state = 1},
  [66] = {.lex_state = 0, .external_lex_state = 1},
  [67] = {.lex_state = 64, .external_lex_state = 1},
  [68] = {.lex_state = 64, .external_lex_state = 1},
  [69] = {.lex_state = 0, .external_lex_state = 1},
  [70] = {.lex_state = 0, .external_lex_state = 1},
  [71] = {.lex_state = 0, .external_lex_state = 1},
  [72] = {.lex_state = 0, .external_lex_state = 1},
  [73] = {.lex_state = 0, .external_lex_state = 1},
  [74] = {.lex_state = 0, .external_lex_state = 1},
  [75] = {.lex_state = 64, .external_lex_state = 1},
  [76] = {.lex_state = 64, .external_lex_state = 1},
  [77] = {.lex_state = 64, .external_lex_state = 1},
  [78] = {.lex_state = 64, .external_lex_state = 1},
  [79] = {.lex_state = 64, .external_lex_state = 1},
  [80] = {.lex_state = 64, .external_lex_state = 1},
  [81] = {.lex_state = 0, .external_lex_state = 1},
  [82] = {.lex_state = 0, .external_lex_state = 1},
  [83] = {.lex_state = 0, .external_lex_state = 1},
  [84] = {.lex_state = 0, .external_lex_state = 1},
  [85] = {.lex_state = 0, .external_lex_state = 1},
  [86] = {.lex_state = 64, .external_lex_state = 1},
  [87] = {.lex_state = 0, .external_lex_state = 1},
  [88] = {.lex_state = 0, .external_lex_state = 1},
  [89] = {.lex_state = 0, .external_lex_state = 1},
  [90] = {.lex_state = 64, .external_lex_state = 1},
  [91] = {.lex_state = 2, .external_lex_state = 1},
  [92] = {.lex_state = 2, .external_lex_state = 1},
  [93] = {.lex_state = 2, .external_lex_state = 1},
  [94] = {.lex_state = 64, .external_lex_state = 1},
  [95] = {.lex_state = 2, .external_lex_state = 1},
  [96] = {.lex_state = 2, .external_lex_state = 1},
  [97] = {.lex_state = 2, .external_lex_state = 1},
  [98] = {.lex_state = 2, .external_lex_state = 1},
  [99] = {.lex_state = 2, .external_lex_state = 1},
  [100] = {.lex_state = 2, .external_lex_state = 1},
  [101] = {.lex_state = 2, .external_lex_state = 1},
  [102] = {.lex_state = 64, .external_lex_state = 1},
  [103] = {.lex_state = 64, .external_lex_state = 1},
  [104] = {.lex_state = 64, .external_lex_state = 1},
  [105] = {.lex_state = 64, .external_lex_state = 1},
  [106] = {.lex_state = 2, .external_lex_state = 1},
  [107] = {.lex_state = 2, .external_lex_state = 1},
  [108] = {.lex_state = 2, .external_lex_state = 1},
  [109] = {.lex_state = 2, .external_lex_state = 1},
  [110] = {.lex_state = 2, .external_lex_state = 1},
  [111] = {.lex_state = 2, .external_lex_state = 1},
  [112] = {.lex_state = 2, .external_lex_state = 1},
  [113] = {.lex_state = 2, .external_lex_state = 1},
  [114] = {.lex_state = 64, .external_lex_state = 1},
  [115] = {.lex_state = 2, .external_lex_state = 1},
  [116] = {.lex_state = 64, .external_lex_state = 1},
  [117] = {.lex_state = 64, .external_lex_state = 1},
  [118] = {.lex_state = 2, .external_lex_state = 1},
  [119] = {.lex_state = 2, .external_lex_state = 1},
  [120] = {.lex_state = 2, .external_lex_state = 1},
  [121] = {.lex_state = 64, .external_lex_state = 1},
  [122] = {.lex_state = 64, .external_lex_state = 1},
  [123] = {.lex_state = 64, .external_lex_state = 1},
  [124] = {.lex_state = 64, .external_lex_state = 1},
  [125] = {.lex_state = 64, .external_lex_state = 1},
  [126] = {.lex_state = 64, .external_lex_state = 1},
  [127] = {.lex_state = 64, .external_lex_state = 1},
  [128] = {.lex_state = 64, .external_lex_state = 1},
  [129] = {.lex_state = 64, .external_lex_state = 1},
  [130] = {.lex_state = 2, .external_lex_state = 1},
  [131] = {.lex_state = 2, .external_lex_state = 1},
  [132] = {.lex_state = 2, .external_lex_state = 1},
  [133] = {.lex_state = 2, .external_lex_state = 1},
  [134] = {.lex_state = 2, .external_lex_state = 1},
  [135] = {.lex_state = 2, .external_lex_state = 1},
  [136] = {.lex_state = 2, .external_lex_state = 1},
  [137] = {.lex_state = 2, .external_lex_state = 1},
  [138] = {.lex_state = 2, .external_lex_state = 1},
  [139] = {.lex_state = 2, .external_lex_state = 1},
  [140] = {.lex_state = 2, .external_lex_state = 1},
  [141] = {.lex_state = 2, .external_lex_state = 1},
  [142] = {.lex_state = 2, .external_lex_state = 1},
  [143] = {.lex_state = 2, .external_lex_state = 1},
  [144] = {.lex_state = 2, .external_lex_state = 1},
  [145] = {.lex_state = 2, .external_lex_state = 1},
  [146] = {.lex_state = 2, .external_lex_state = 1},
  [147] = {.lex_state = 2, .external_lex_state = 1},
  [148] = {.lex_state = 2, .external_lex_state = 1},
  [149] = {.lex_state = 2, .external_lex_state = 1},
  [150] = {.lex_state = 2, .external_lex_state = 1},
  [151] = {.lex_state = 0, .external_lex_state = 1},
  [152] = {.lex_state = 0, .external_lex_state = 1},
  [153] = {.lex_state = 0, .external_lex_state = 1},
  [154] = {.lex_state = 0, .external_lex_state = 1},
  [155] = {.lex_state = 0, .external_lex_state = 1},
  [156] = {.lex_state = 0, .external_lex_state = 1},
  [157] = {.lex_state = 0, .external_lex_state = 1},
  [158] = {.lex_state = 0, .external_lex_state = 1},
  [159] = {.lex_state = 0, .external_lex_state = 1},
  [160] = {.lex_state = 0, .external_lex_state = 1},
  [161] = {.lex_state = 0, .external_lex_state = 1},
  [162] = {.lex_state = 0, .external_lex_state = 1},
  [163] = {.lex_state = 0, .external_lex_state = 1},
  [164] = {.lex_state = 0, .external_lex_state = 1},
  [165] = {.lex_state = 0, .external_lex_state = 1},
  [166] = {.lex_state = 0, .external_lex_state = 1},
  [167] = {.lex_state = 0, .external_lex_state = 1},
  [168] = {.lex_state = 0, .external_lex_state = 1},
  [169] = {.lex_state = 0, .external_lex_state = 1},
  [170] = {.lex_state = 0, .external_lex_state = 1},
  [171] = {.lex_state = 0, .external_lex_state = 1},
  [172] = {.lex_state = 0, .external_lex_state = 1},
  [173] = {.lex_state = 64, .external_lex_state = 1},
  [174] = {.lex_state = 64, .external_lex_state = 1},
  [175] = {.lex_state = 3, .external_lex_state = 1},
  [176] = {.lex_state = 64, .external_lex_state = 1},
  [177] = {.lex_state = 3, .external_lex_state = 1},
  [178] = {.lex_state = 3, .external_lex_state = 1},
  [179] = {.lex_state = 3, .external_lex_state = 1},
  [180] = {.lex_state = 3, .external_lex_state = 1},
  [181] = {.lex_state = 3, .external_lex_state = 1},
  [182] = {.lex_state = 3, .external_lex_state = 1},
  [183] = {.lex_state = 0, .external_lex_state = 1},
  [184] = {.lex_state = 3, .external_lex_state = 1},
  [185] = {.lex_state = 64, .external_lex_state = 1},
  [186] = {.lex_state = 3, .external_lex_state = 1},
  [187] = {.lex_state = 3, .external_lex_state = 1},
  [188] = {.lex_state = 3, .external_lex_state = 1},
  [189] = {.lex_state = 3, .external_lex_state = 1},
  [190] = {.lex_state = 3, .external_lex_state = 1},
  [191] = {.lex_state = 0, .external_lex_state = 1},
  [192] = {.lex_state = 0, .external_lex_state = 1},
  [193] = {.lex_state = 3, .external_lex_state = 1},
  [194] = {.lex_state = 3, .external_lex_state = 1},
  [195] = {.lex_state = 0, .external_lex_state = 1},
  [196] = {.lex_state = 0, .external_lex_state = 1},
  [197] = {.lex_state = 0, .external_lex_state = 1},
  [198] = {.lex_state = 64, .external_lex_state = 1},
  [199] = {.lex_state = 3, .external_lex_state = 1},
  [200] = {.lex_state = 3, .external_lex_state = 1},
  [201] = {.lex_state = 3, .external_lex_state = 1},
  [202] = {.lex_state = 3, .external_lex_state = 1},
  [203] = {.lex_state = 0, .external_lex_state = 1},
  [204] = {.lex_state = 3, .external_lex_state = 1},
  [205] = {.lex_state = 0, .external_lex_state = 1},
  [206] = {.lex_state = 64, .external_lex_state = 1},
  [207] = {.lex_state = 64, .external_lex_state = 1},
  [208] = {.lex_state = 0, .external_lex_state = 1},
  [209] = {.lex_state = 0, .external_lex_state = 1},
  [210] = {.lex_state = 0, .external_lex_state = 1},
  [211] = {.lex_state = 0, .external_lex_state = 1},
  [212] = {.lex_state = 0, .external_lex_state = 1},
  [213] = {.lex_state = 64, .external_lex_state = 1},
  [214] = {.lex_state = 0, .external_lex_state = 1},
  [215] = {.lex_state = 0, .external_lex_state = 1},
  [216] = {.lex_state = 0, .external_lex_state = 1},
  [217] = {.lex_state = 0, .external_lex_state = 1},
  [218] = {.lex_state = 64, .external_lex_state = 1},
  [219] = {.lex_state = 0, .external_lex_state = 1},
  [220] = {.lex_state = 0, .external_lex_state = 1},
  [221] = {.lex_state = 64, .external_lex_state = 1},
  [222] = {.lex_state = 64, .external_lex_state = 1},
  [223] = {.lex_state = 0, .external_lex_state = 1},
  [224] = {.lex_state = 0, .external_lex_state = 1},
  [225] = {.lex_state = 0, .external_lex_state = 1},
  [226] = {.lex_state = 0, .external_lex_state = 1},
  [227] = {.lex_state = 64, .external_lex_state = 1},
  [228] = {.lex_state = 0, .external_lex_state = 1},
  [229] = {.lex_state = 64, .external_lex_state = 1},
  [230] = {.lex_state = 0, .external_lex_state = 1},
  [231] = {.lex_state = 0, .external_lex_state = 1},
  [232] = {.lex_state = 64, .external_lex_state = 1},
  [233] = {.lex_state = 0, .external_lex_state = 1},
  [234] = {.lex_state = 0, .external_lex_state = 1},
  [235] = {.lex_state = 0, .external_lex_state = 1},
  [236] = {.lex_state = 0, .external_lex_state = 1},
  [237] = {.lex_state = 0, .external_lex_state = 1},
  [238] = {.lex_state = 1, .external_lex_state = 1},
  [239] = {.lex_state = 64, .external_lex_state = 1},
  [240] = {.lex_state = 64, .external_lex_state = 1},
  [241] = {.lex_state = 1, .external_lex_state = 1},
  [242] = {.lex_state = 64, .external_lex_state = 1},
  [243] = {.lex_state = 0, .external_lex_state = 1},
  [244] = {.lex_state = 0, .external_lex_state = 1},
  [245] = {.lex_state = 0, .external_lex_state = 1},
  [246] = {.lex_state = 0, .external_lex_state = 1},
  [247] = {.lex_state = 64, .external_lex_state = 1},
  [248] = {.lex_state = 1, .external_lex_state = 1},
  [249] = {.lex_state = 3, .external_lex_state = 1},
  [250] = {.lex_state = 3, .external_lex_state = 1},
  [251] = {.lex_state = 0, .external_lex_state = 1},
  [252] = {.lex_state = 3, .external_lex_state = 1},
  [253] = {.lex_state = 1, .external_lex_state = 1},
  [254] = {.lex_state = 0, .external_lex_state = 1},
  [255] = {.lex_state = 64, .external_lex_state = 1},
  [256] = {.lex_state = 3, .external_lex_state = 1},
  [257] = {.lex_state = 0, .external_lex_state = 1},
  [258] = {.lex_state = 0, .external_lex_state = 1},
  [259] = {.lex_state = 0, .external_lex_state = 1},
  [260] = {.lex_state = 0, .external_lex_state = 1},
  [261] = {.lex_state = 1, .external_lex_state = 1},
  [262] = {.lex_state = 0, .external_lex_state = 1},
  [263] = {.lex_state = 3, .external_lex_state = 1},
  [264] = {.lex_state = 64, .external_lex_state = 1},
  [265] = {.lex_state = 0, .external_lex_state = 1},
  [266] = {.lex_state = 3, .external_lex_state = 1},
  [267] = {.lex_state = 0, .external_lex_state = 1},
  [268] = {.lex_state = 64, .external_lex_state = 1},
  [269] = {.lex_state = 64, .external_lex_state = 1},
  [270] = {.lex_state = 0, .external_lex_state = 1},
  [271] = {.lex_state = 0, .external_lex_state = 1},
  [272] = {.lex_state = 0, .external_lex_state = 1},
  [273] = {.lex_state = 64, .external_lex_state = 1},
  [274] = {.lex_state = 0, .external_lex_state = 1},
  [275] = {.lex_state = 0, .external_lex_state = 1},
  [276] = {.lex_state = 64, .external_lex_state = 1},
  [277] = {.lex_state = 64, .external_lex_state = 1},
  [278] = {.lex_state = 64, .external_lex_state = 1},
  [279] = {.lex_state = 64, .external_lex_state = 1},
  [280] = {.lex_state = 0, .external_lex_state = 1},
  [281] = {.lex_state = 64, .external_lex_state = 1},
  [282] = {.lex_state = 0, .external_lex_state = 1},
  [283] = {.lex_state = 0, .external_lex_state = 1},
  [284] = {.lex_state = 0, .external_lex_state = 1},
  [285] = {.lex_state = 1, .external_lex_state = 1},
  [286] = {.lex_state = 0, .external_lex_state = 1},
  [287] = {.lex_state = 0, .external_lex_state = 1},
  [288] = {.lex_state = 0, .external_lex_state = 1},
  [289] = {.lex_state = 64, .external_lex_state = 1},
  [290] = {.lex_state = 1, .external_lex_state = 1},
  [291] = {.lex_state = 0, .external_lex_state = 1},
  [292] = {.lex_state = 0, .external_lex_state = 1},
  [293] = {.lex_state = 3, .external_lex_state = 1},
  [294] = {.lex_state = 3, .external_lex_state = 1},
  [295] = {.lex_state = 3, .external_lex_state = 1},
  [296] = {.lex_state = 1, .external_lex_state = 1},
  [297] = {.lex_state = 0, .external_lex_state = 1},
  [298] = {.lex_state = 0, .external_lex_state = 1},
  [299] = {.lex_state = 64, .external_lex_state = 1},
  [300] = {.lex_state = 64, .external_lex_state = 1},
  [301] = {.lex_state = 0, .external_lex_state = 1},
  [302] = {.lex_state = 64, .external_lex_state = 1},
  [303] = {.lex_state = 0, .external_lex_state = 1},
  [304] = {.lex_state = 3, .external_lex_state = 1},
  [305] = {.lex_state = 0, .external_lex_state = 1},
  [306] = {.lex_state = 0, .external_lex_state = 1},
  [307] = {.lex_state = 64, .external_lex_state = 1},
  [308] = {.lex_state = 0, .external_lex_state = 1},
  [309] = {.lex_state = 0, .external_lex_state = 1},
  [310] = {.lex_state = 0, .external_lex_state = 1},
  [311] = {.lex_state = 64, .external_lex_state = 1},
  [312] = {.lex_state = 64, .external_lex_state = 1},
  [313] = {.lex_state = 0, .external_lex_state = 1},
  [314] = {.lex_state = 0, .external_lex_state = 1},
  [315] = {.lex_state = 0, .external_lex_state = 1},
  [316] = {.lex_state = 0, .external_lex_state = 1},
  [317] = {.lex_state = 64, .external_lex_state = 1},
  [318] = {.lex_state = 0, .external_lex_state = 1},
  [319] = {.lex_state = 0, .external_lex_state = 1},
  [320] = {.lex_state = 0, .external_lex_state = 1},
  [321] = {.lex_state = 0, .external_lex_state = 1},
  [322] = {.lex_state = 64, .external_lex_state = 1},
  [323] = {.lex_state = 0, .external_lex_state = 1},
  [324] = {.lex_state = 64, .external_lex_state = 1},
  [325] = {.lex_state = 0, .external_lex_state = 1},
  [326] = {.lex_state = 0, .external_lex_state = 1},
  [327] = {.lex_state = 0, .external_lex_state = 1},
  [328] = {.lex_state = 0, .external_lex_state = 1},
  [329] = {.lex_state = 64, .external_lex_state = 1},
  [330] = {.lex_state = 64, .external_lex_state = 1},
  [331] = {.lex_state = 0, .external_lex_state = 1},
  [332] = {.lex_state = 0, .external_lex_state = 1},
  [333] = {.lex_state = 0, .external_lex_state = 1},
  [334] = {.lex_state = 64, .external_lex_state = 1},
  [335] = {.lex_state = 0, .external_lex_state = 1},
  [336] = {.lex_state = 0, .external_lex_state = 1},
  [337] = {.lex_state = 64, .external_lex_state = 1},
  [338] = {.lex_state = 0, .external_lex_state = 1},
  [339] = {.lex_state = 3, .external_lex_state = 1},
  [340] = {.lex_state = 0, .external_lex_state = 1},
  [341] = {.lex_state = 0, .external_lex_state = 1},
  [342] = {.lex_state = 0, .external_lex_state = 1},
  [343] = {.lex_state = 1, .external_lex_state = 1},
  [344] = {.lex_state = 0, .external_lex_state = 1},
  [345] = {.lex_state = 0, .external_lex_state = 1},
  [346] = {.lex_state = 0, .external_lex_state = 1},
  [347] = {.lex_state = 64, .external_lex_state = 1},
  [348] = {.lex_state = 0, .external_lex_state = 1},
  [349] = {.lex_state = 64, .external_lex_state = 1},
  [350] = {.lex_state = 0, .external_lex_state = 1},
  [351] = {.lex_state = 0, .external_lex_state = 1},
  [352] = {.lex_state = 0, .external_lex_state = 1},
  [353] = {.lex_state = 0, .external_lex_state = 1},
  [354] = {.lex_state = 1, .external_lex_state = 1},
  [355] = {.lex_state = 0, .external_lex_state = 1},
  [356] = {.lex_state = 0, .external_lex_state = 1},
  [357] = {.lex_state = 0, .external_lex_state = 1},
  [358] = {.lex_state = 64, .external_lex_state = 1},
  [359] = {.lex_state = 0, .external_lex_state = 1},
  [360] = {.lex_state = 0, .external_lex_state = 1},
  [361] = {.lex_state = 0, .external_lex_state = 1},
  [362] = {.lex_state = 0, .external_lex_state = 1},
  [363] = {.lex_state = 0, .external_lex_state = 1},
  [364] = {.lex_state = 0, .external_lex_state = 1},
  [365] = {.lex_state = 0, .external_lex_state = 1},
  [366] = {.lex_state = 0, .external_lex_state = 1},
  [367] = {.lex_state = 0, .external_lex_state = 1},
  [368] = {.lex_state = 0, .external_lex_state = 1},
  [369] = {.lex_state = 0, .external_lex_state = 1},
  [370] = {.lex_state = 0, .external_lex_state = 1},
  [371] = {.lex_state = 0, .external_lex_state = 1},
  [372] = {.lex_state = 0, .external_lex_state = 1},
  [373] = {.lex_state = 0, .external_lex_state = 1},
  [374] = {.lex_state = 0, .external_lex_state = 1},
  [375] = {.lex_state = 64, .external_lex_state = 1},
  [376] = {.lex_state = 0, .external_lex_state = 1},
  [377] = {.lex_state = 0, .external_lex_state = 1},
  [378] = {.lex_state = 0, .external_lex_state = 1},
  [379] = {.lex_state = 64, .external_lex_state = 1},
  [380] = {.lex_state = 64, .external_lex_state = 1},
  [381] = {.lex_state = 0, .external_lex_state = 1},
  [382] = {.lex_state = 0, .external_lex_state = 1},
  [383] = {.lex_state = 0, .external_lex_state = 1},
  [384] = {.lex_state = 64, .external_lex_state = 1},
  [385] = {.lex_state = 64, .external_lex_state = 1},
  [386] = {.lex_state = 0, .external_lex_state = 1},
  [387] = {.lex_state = 0, .external_lex_state = 1},
  [388] = {.lex_state = 0, .external_lex_state = 1},
  [389] = {.lex_state = 0, .external_lex_state = 1},
  [390] = {.lex_state = 1, .external_lex_state = 1},
  [391] = {.lex_state = 0, .external_lex_state = 1},
  [392] = {.lex_state = 0, .external_lex_state = 1},
  [393] = {.lex_state = 0, .external_lex_state = 1},
  [394] = {.lex_state = 0, .external_lex_state = 1},
  [395] = {.lex_state = 0, .external_lex_state = 1},
  [396] = {.lex_state = 0, .external_lex_state = 1},
  [397] = {.lex_state = 0, .external_lex_state = 1},
  [398] = {.lex_state = 0, .external_lex_state = 1},
  [399] = {.lex_state = 0, .external_lex_state = 1},
  [400] = {.lex_state = 0, .external_lex_state = 1},
  [401] = {.lex_state = 0, .external_lex_state = 1},
  [402] = {.lex_state = 0, .external_lex_state = 1},
  [403] = {.lex_state = 0, .external_lex_state = 1},
  [404] = {.lex_state = 0, .external_lex_state = 1},
  [405] = {.lex_state = 0, .external_lex_state = 1},
  [406] = {.lex_state = 0, .external_lex_state = 1},
  [407] = {.lex_state = 0, .external_lex_state = 1},
  [408] = {.lex_state = 0, .external_lex_state = 1},
  [409] = {.lex_state = 0, .external_lex_state = 1},
  [410] = {.lex_state = 0, .external_lex_state = 1},
  [411] = {.lex_state = 0, .external_lex_state = 1},
  [412] = {.lex_state = 0, .external_lex_state = 1},
  [413] = {.lex_state = 0, .external_lex_state = 1},
  [414] = {.lex_state = 0, .external_lex_state = 1},
  [415] = {.lex_state = 0, .external_lex_state = 1},
  [416] = {.lex_state = 0, .external_lex_state = 1},
  [417] = {.lex_state = 0, .external_lex_state = 1},
  [418] = {.lex_state = 64, .external_lex_state = 1},
  [419] = {.lex_state = 64, .external_lex_state = 1},
  [420] = {.lex_state = 0, .external_lex_state = 1},
  [421] = {.lex_state = 0, .external_lex_state = 1},
  [422] = {.lex_state = 0, .external_lex_state = 1},
  [423] = {.lex_state = 0, .external_lex_state = 1},
  [424] = {.lex_state = 0, .external_lex_state = 1},
  [425] = {.lex_state = 0, .external_lex_state = 1},
  [426] = {.lex_state = 0, .external_lex_state = 1},
  [427] = {.lex_state = 64, .external_lex_state = 1},
  [428] = {.lex_state = 0, .external_lex_state = 1},
  [429] = {.lex_state = 0, .external_lex_state = 1},
  [430] = {.lex_state = 0, .external_lex_state = 1},
  [431] = {.lex_state = 0, .external_lex_state = 1},
  [432] = {.lex_state = 0, .external_lex_state = 1},
  [433] = {.lex_state = 0, .external_lex_state = 1},
  [434] = {.lex_state = 0, .external_lex_state = 1},
  [435] = {.lex_state = 0, .external_lex_state = 1},
  [436] = {.lex_state = 0, .external_lex_state = 1},
  [437] = {.lex_state = 0, .external_lex_state = 1},
  [438] = {.lex_state = 0, .external_lex_state = 1},
  [439] = {.lex_state = 0, .external_lex_state = 1},
  [440] = {.lex_state = 0, .external_lex_state = 1},
  [441] = {.lex_state = 0, .external_lex_state = 1},
  [442] = {.lex_state = 1, .external_lex_state = 1},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_let] = ACTIONS(1),
    [anon_sym_override] = ACTIONS(1),
    [anon_sym_type] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_virtual] = ACTIONS(1),
    [anon_sym_fn] = ACTIONS(1),
    [anon_sym_DASH_GT] = ACTIONS(1),
    [anon_sym_struct] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_enable] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym__] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_SLASH_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_switch] = ACTIONS(1),
    [anon_sym_case] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_default] = ACTIONS(1),
    [anon_sym_fallthrough] = ACTIONS(1),
    [anon_sym_loop] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_break] = ACTIONS(1),
    [anon_sym_continue] = ACTIONS(1),
    [anon_sym_continuing] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_discard] = ACTIONS(1),
    [anon_sym_var] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_PLUS_PLUS] = ACTIONS(1),
    [sym_int_literal] = ACTIONS(1),
    [aux_sym_float_literal_token1] = ACTIONS(1),
    [aux_sym_float_literal_token2] = ACTIONS(1),
    [anon_sym_true] = ACTIONS(1),
    [anon_sym_false] = ACTIONS(1),
    [anon_sym_bool] = ACTIONS(1),
    [anon_sym_u32] = ACTIONS(1),
    [anon_sym_i32] = ACTIONS(1),
    [anon_sym_f32] = ACTIONS(1),
    [anon_sym_f16] = ACTIONS(1),
    [anon_sym_array] = ACTIONS(1),
    [anon_sym_ptr] = ACTIONS(1),
    [anon_sym_sampler] = ACTIONS(1),
    [anon_sym_sampler_comparison] = ACTIONS(1),
    [anon_sym_texture_depth_2d] = ACTIONS(1),
    [anon_sym_texture_depth_2d_array] = ACTIONS(1),
    [anon_sym_texture_depth_cube] = ACTIONS(1),
    [anon_sym_texture_depth_cube_array] = ACTIONS(1),
    [anon_sym_texture_depth_multisampled_2d] = ACTIONS(1),
    [anon_sym_texture_1d] = ACTIONS(1),
    [anon_sym_texture_2d] = ACTIONS(1),
    [anon_sym_texture_2d_array] = ACTIONS(1),
    [anon_sym_texture_3d] = ACTIONS(1),
    [anon_sym_texture_cube] = ACTIONS(1),
    [anon_sym_texture_cube_array] = ACTIONS(1),
    [anon_sym_texture_multisampled_2d] = ACTIONS(1),
    [anon_sym_texture_storage_1d] = ACTIONS(1),
    [anon_sym_texture_storage_2d] = ACTIONS(1),
    [anon_sym_texture_storage_2d_array] = ACTIONS(1),
    [anon_sym_texture_storage_3d] = ACTIONS(1),
    [anon_sym_vec2] = ACTIONS(1),
    [anon_sym_vec3] = ACTIONS(1),
    [anon_sym_vec4] = ACTIONS(1),
    [anon_sym_mat2x2] = ACTIONS(1),
    [anon_sym_mat2x3] = ACTIONS(1),
    [anon_sym_mat2x4] = ACTIONS(1),
    [anon_sym_mat3x2] = ACTIONS(1),
    [anon_sym_mat3x3] = ACTIONS(1),
    [anon_sym_mat3x4] = ACTIONS(1),
    [anon_sym_mat4x2] = ACTIONS(1),
    [anon_sym_mat4x3] = ACTIONS(1),
    [anon_sym_mat4x4] = ACTIONS(1),
    [anon_sym_rgba8unorm] = ACTIONS(1),
    [anon_sym_rgba8snorm] = ACTIONS(1),
    [anon_sym_rgba8uint] = ACTIONS(1),
    [anon_sym_rgba8sint] = ACTIONS(1),
    [anon_sym_rgba16uint] = ACTIONS(1),
    [anon_sym_rgba16sint] = ACTIONS(1),
    [anon_sym_rgba16float] = ACTIONS(1),
    [anon_sym_r32uint] = ACTIONS(1),
    [anon_sym_r32sint] = ACTIONS(1),
    [anon_sym_r32float] = ACTIONS(1),
    [anon_sym_rg32uint] = ACTIONS(1),
    [anon_sym_rg32sint] = ACTIONS(1),
    [anon_sym_rg32float] = ACTIONS(1),
    [anon_sym_rgba32uint] = ACTIONS(1),
    [anon_sym_rgba32sint] = ACTIONS(1),
    [anon_sym_rgba32float] = ACTIONS(1),
    [anon_sym_function] = ACTIONS(1),
    [anon_sym_private] = ACTIONS(1),
    [anon_sym_workgroup] = ACTIONS(1),
    [anon_sym_uniform] = ACTIONS(1),
    [anon_sym_storage] = ACTIONS(1),
    [anon_sym_read] = ACTIONS(1),
    [anon_sym_write] = ACTIONS(1),
    [anon_sym_read_write] = ACTIONS(1),
    [anon_sym_bitcast] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [aux_sym_preproc_import_token1] = ACTIONS(1),
    [aux_sym_define_import_path_token1] = ACTIONS(1),
    [anon_sym_COLON_COLON] = ACTIONS(1),
    [anon_sym_as] = ACTIONS(1),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1),
    [aux_sym_preproc_ifdef_token3] = ACTIONS(1),
    [aux_sym_preproc_else_token1] = ACTIONS(1),
    [sym_block_comment] = ACTIONS(3),
  },
  [1] = {
    [sym_source_file] = STATE(402),
    [sym__declaration] = STATE(88),
    [sym_global_variable_declaration] = STATE(417),
    [sym_global_constant_declaration] = STATE(417),
    [sym_type_alias_declaration] = STATE(417),
    [sym_function_declaration] = STATE(88),
    [sym_struct_declaration] = STATE(88),
    [sym_enable_directive] = STATE(81),
    [sym_attribute] = STATE(226),
    [sym_variable_declaration] = STATE(324),
    [sym_preproc_import] = STATE(88),
    [sym_define_import_path] = STATE(88),
    [sym_preproc_ifdef] = STATE(88),
    [aux_sym_source_file_repeat1] = STATE(81),
    [aux_sym_source_file_repeat2] = STATE(88),
    [aux_sym_global_variable_declaration_repeat1] = STATE(226),
    [ts_builtin_sym_end] = ACTIONS(5),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(7),
    [anon_sym_let] = ACTIONS(9),
    [anon_sym_override] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_virtual] = ACTIONS(15),
    [anon_sym_fn] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_enable] = ACTIONS(21),
    [anon_sym_AT] = ACTIONS(23),
    [anon_sym_var] = ACTIONS(25),
    [aux_sym_preproc_import_token1] = ACTIONS(27),
    [aux_sym_define_import_path_token1] = ACTIONS(29),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(31),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(31),
    [sym_block_comment] = ACTIONS(3),
  },
  [2] = {
    [sym__expression] = STATE(132),
    [sym_const_literal] = STATE(132),
    [sym_float_literal] = STATE(93),
    [sym_bool_literal] = STATE(93),
    [sym_parenthesized_expression] = STATE(132),
    [sym_type_constructor_or_function_call_expression] = STATE(132),
    [sym_type_declaration] = STATE(323),
    [sym__vec_prefix] = STATE(283),
    [sym__mat_prefix] = STATE(283),
    [sym_bitcast_expression] = STATE(132),
    [sym_binary_expression] = STATE(132),
    [sym_unary_expression] = STATE(132),
    [sym_subscript_expression] = STATE(132),
    [sym_composite_value_decomposition_expression] = STATE(132),
    [aux_sym_argument_list_expression_repeat1] = STATE(3),
    [sym_identifier] = ACTIONS(33),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_RPAREN] = ACTIONS(37),
    [sym_int_literal] = ACTIONS(39),
    [aux_sym_float_literal_token1] = ACTIONS(41),
    [aux_sym_float_literal_token2] = ACTIONS(41),
    [anon_sym_true] = ACTIONS(43),
    [anon_sym_false] = ACTIONS(43),
    [anon_sym_bool] = ACTIONS(45),
    [anon_sym_u32] = ACTIONS(45),
    [anon_sym_i32] = ACTIONS(45),
    [anon_sym_f32] = ACTIONS(45),
    [anon_sym_f16] = ACTIONS(45),
    [anon_sym_array] = ACTIONS(47),
    [anon_sym_ptr] = ACTIONS(49),
    [anon_sym_sampler] = ACTIONS(45),
    [anon_sym_sampler_comparison] = ACTIONS(45),
    [anon_sym_texture_depth_2d] = ACTIONS(45),
    [anon_sym_texture_depth_2d_array] = ACTIONS(45),
    [anon_sym_texture_depth_cube] = ACTIONS(45),
    [anon_sym_texture_depth_cube_array] = ACTIONS(45),
    [anon_sym_texture_depth_multisampled_2d] = ACTIONS(45),
    [anon_sym_texture_1d] = ACTIONS(51),
    [anon_sym_texture_2d] = ACTIONS(51),
    [anon_sym_texture_2d_array] = ACTIONS(51),
    [anon_sym_texture_3d] = ACTIONS(51),
    [anon_sym_texture_cube] = ACTIONS(51),
    [anon_sym_texture_cube_array] = ACTIONS(51),
    [anon_sym_texture_multisampled_2d] = ACTIONS(51),
    [anon_sym_texture_storage_1d] = ACTIONS(53),
    [anon_sym_texture_storage_2d] = ACTIONS(53),
    [anon_sym_texture_storage_2d_array] = ACTIONS(53),
    [anon_sym_texture_storage_3d] = ACTIONS(53),
    [anon_sym_vec2] = ACTIONS(55),
    [anon_sym_vec3] = ACTIONS(55),
    [anon_sym_vec4] = ACTIONS(55),
    [anon_sym_mat2x2] = ACTIONS(55),
    [anon_sym_mat2x3] = ACTIONS(55),
    [anon_sym_mat2x4] = ACTIONS(55),
    [anon_sym_mat3x2] = ACTIONS(55),
    [anon_sym_mat3x3] = ACTIONS(55),
    [anon_sym_mat3x4] = ACTIONS(55),
    [anon_sym_mat4x2] = ACTIONS(55),
    [anon_sym_mat4x3] = ACTIONS(55),
    [anon_sym_mat4x4] = ACTIONS(55),
    [anon_sym_bitcast] = ACTIONS(57),
    [anon_sym_AMP] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(61),
    [anon_sym_STAR] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_TILDE] = ACTIONS(59),
    [sym_block_comment] = ACTIONS(3),
  },
  [3] = {
    [sym__expression] = STATE(136),
    [sym_const_literal] = STATE(136),
    [sym_float_literal] = STATE(93),
    [sym_bool_literal] = STATE(93),
    [sym_parenthesized_expression] = STATE(136),
    [sym_type_constructor_or_function_call_expression] = STATE(136),
    [sym_type_declaration] = STATE(323),
    [sym__vec_prefix] = STATE(283),
    [sym__mat_prefix] = STATE(283),
    [sym_bitcast_expression] = STATE(136),
    [sym_binary_expression] = STATE(136),
    [sym_unary_expression] = STATE(136),
    [sym_subscript_expression] = STATE(136),
    [sym_composite_value_decomposition_expression] = STATE(136),
    [aux_sym_argument_list_expression_repeat1] = STATE(5),
    [sym_identifier] = ACTIONS(33),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(35),
    [sym_int_literal] = ACTIONS(39),
    [aux_sym_float_literal_token1] = ACTIONS(41),
    [aux_sym_float_literal_token2] = ACTIONS(41),
    [anon_sym_true] = ACTIONS(43),
    [anon_sym_false] = ACTIONS(43),
    [anon_sym_bool] = ACTIONS(45),
    [anon_sym_u32] = ACTIONS(45),
    [anon_sym_i32] = ACTIONS(45),
    [anon_sym_f32] = ACTIONS(45),
    [anon_sym_f16] = ACTIONS(45),
    [anon_sym_array] = ACTIONS(47),
    [anon_sym_ptr] = ACTIONS(49),
    [anon_sym_sampler] = ACTIONS(45),
    [anon_sym_sampler_comparison] = ACTIONS(45),
    [anon_sym_texture_depth_2d] = ACTIONS(45),
    [anon_sym_texture_depth_2d_array] = ACTIONS(45),
    [anon_sym_texture_depth_cube] = ACTIONS(45),
    [anon_sym_texture_depth_cube_array] = ACTIONS(45),
    [anon_sym_texture_depth_multisampled_2d] = ACTIONS(45),
    [anon_sym_texture_1d] = ACTIONS(51),
    [anon_sym_texture_2d] = ACTIONS(51),
    [anon_sym_texture_2d_array] = ACTIONS(51),
    [anon_sym_texture_3d] = ACTIONS(51),
    [anon_sym_texture_cube] = ACTIONS(51),
    [anon_sym_texture_cube_array] = ACTIONS(51),
    [anon_sym_texture_multisampled_2d] = ACTIONS(51),
    [anon_sym_texture_storage_1d] = ACTIONS(53),
    [anon_sym_texture_storage_2d] = ACTIONS(53),
    [anon_sym_texture_storage_2d_array] = ACTIONS(53),
    [anon_sym_texture_storage_3d] = ACTIONS(53),
    [anon_sym_vec2] = ACTIONS(55),
    [anon_sym_vec3] = ACTIONS(55),
    [anon_sym_vec4] = ACTIONS(55),
    [anon_sym_mat2x2] = ACTIONS(55),
    [anon_sym_mat2x3] = ACTIONS(55),
    [anon_sym_mat2x4] = ACTIONS(55),
    [anon_sym_mat3x2] = ACTIONS(55),
    [anon_sym_mat3x3] = ACTIONS(55),
    [anon_sym_mat3x4] = ACTIONS(55),
    [anon_sym_mat4x2] = ACTIONS(55),
    [anon_sym_mat4x3] = ACTIONS(55),
    [anon_sym_mat4x4] = ACTIONS(55),
    [anon_sym_bitcast] = ACTIONS(57),
    [anon_sym_AMP] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(61),
    [anon_sym_STAR] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_TILDE] = ACTIONS(59),
    [sym_block_comment] = ACTIONS(3),
  },
  [4] = {
    [sym__expression] = STATE(141),
    [sym_const_literal] = STATE(141),
    [sym_float_literal] = STATE(93),
    [sym_bool_literal] = STATE(93),
    [sym_parenthesized_expression] = STATE(141),
    [sym_type_constructor_or_function_call_expression] = STATE(141),
    [sym_type_declaration] = STATE(323),
    [sym__vec_prefix] = STATE(283),
    [sym__mat_prefix] = STATE(283),
    [sym_bitcast_expression] = STATE(141),
    [sym_binary_expression] = STATE(141),
    [sym_unary_expression] = STATE(141),
    [sym_subscript_expression] = STATE(141),
    [sym_composite_value_decomposition_expression] = STATE(141),
    [sym_identifier] = ACTIONS(33),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(35),
    [sym_int_literal] = ACTIONS(39),
    [aux_sym_float_literal_token1] = ACTIONS(41),
    [aux_sym_float_literal_token2] = ACTIONS(41),
    [anon_sym_true] = ACTIONS(43),
    [anon_sym_false] = ACTIONS(43),
    [anon_sym_bool] = ACTIONS(45),
    [anon_sym_u32] = ACTIONS(45),
    [anon_sym_i32] = ACTIONS(45),
    [anon_sym_f32] = ACTIONS(45),
    [anon_sym_f16] = ACTIONS(45),
    [anon_sym_array] = ACTIONS(47),
    [anon_sym_ptr] = ACTIONS(49),
    [anon_sym_sampler] = ACTIONS(45),
    [anon_sym_sampler_comparison] = ACTIONS(45),
    [anon_sym_texture_depth_2d] = ACTIONS(45),
    [anon_sym_texture_depth_2d_array] = ACTIONS(45),
    [anon_sym_texture_depth_cube] = ACTIONS(45),
    [anon_sym_texture_depth_cube_array] = ACTIONS(45),
    [anon_sym_texture_depth_multisampled_2d] = ACTIONS(45),
    [anon_sym_texture_1d] = ACTIONS(51),
    [anon_sym_texture_2d] = ACTIONS(51),
    [anon_sym_texture_2d_array] = ACTIONS(51),
    [anon_sym_texture_3d] = ACTIONS(51),
    [anon_sym_texture_cube] = ACTIONS(51),
    [anon_sym_texture_cube_array] = ACTIONS(51),
    [anon_sym_texture_multisampled_2d] = ACTIONS(51),
    [anon_sym_texture_storage_1d] = ACTIONS(53),
    [anon_sym_texture_storage_2d] = ACTIONS(53),
    [anon_sym_texture_storage_2d_array] = ACTIONS(53),
    [anon_sym_texture_storage_3d] = ACTIONS(53),
    [anon_sym_vec2] = ACTIONS(55),
    [anon_sym_vec3] = ACTIONS(55),
    [anon_sym_vec4] = ACTIONS(55),
    [anon_sym_mat2x2] = ACTIONS(55),
    [anon_sym_mat2x3] = ACTIONS(55),
    [anon_sym_mat2x4] = ACTIONS(55),
    [anon_sym_mat3x2] = ACTIONS(55),
    [anon_sym_mat3x3] = ACTIONS(55),
    [anon_sym_mat3x4] = ACTIONS(55),
    [anon_sym_mat4x2] = ACTIONS(55),
    [anon_sym_mat4x3] = ACTIONS(55),
    [anon_sym_mat4x4] = ACTIONS(55),
    [anon_sym_bitcast] = ACTIONS(57),
    [anon_sym_AMP] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(61),
    [anon_sym_STAR] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_TILDE] = ACTIONS(59),
    [sym_block_comment] = ACTIONS(3),
  },
  [5] = {
    [sym__expression] = STATE(145),
    [sym_const_literal] = STATE(145),
    [sym_float_literal] = STATE(93),
    [sym_bool_literal] = STATE(93),
    [sym_parenthesized_expression] = STATE(145),
    [sym_type_constructor_or_function_call_expression] = STATE(145),
    [sym_type_declaration] = STATE(323),
    [sym__vec_prefix] = STATE(283),
    [sym__mat_prefix] = STATE(283),
    [sym_bitcast_expression] = STATE(145),
    [sym_binary_expression] = STATE(145),
    [sym_unary_expression] = STATE(145),
    [sym_subscript_expression] = STATE(145),
    [sym_composite_value_decomposition_expression] = STATE(145),
    [aux_sym_argument_list_expression_repeat1] = STATE(5),
    [sym_identifier] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(68),
    [sym_int_literal] = ACTIONS(71),
    [aux_sym_float_literal_token1] = ACTIONS(74),
    [aux_sym_float_literal_token2] = ACTIONS(74),
    [anon_sym_true] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(77),
    [anon_sym_bool] = ACTIONS(80),
    [anon_sym_u32] = ACTIONS(80),
    [anon_sym_i32] = ACTIONS(80),
    [anon_sym_f32] = ACTIONS(80),
    [anon_sym_f16] = ACTIONS(80),
    [anon_sym_array] = ACTIONS(83),
    [anon_sym_ptr] = ACTIONS(86),
    [anon_sym_sampler] = ACTIONS(80),
    [anon_sym_sampler_comparison] = ACTIONS(80),
    [anon_sym_texture_depth_2d] = ACTIONS(80),
    [anon_sym_texture_depth_2d_array] = ACTIONS(80),
    [anon_sym_texture_depth_cube] = ACTIONS(80),
    [anon_sym_texture_depth_cube_array] = ACTIONS(80),
    [anon_sym_texture_depth_multisampled_2d] = ACTIONS(80),
    [anon_sym_texture_1d] = ACTIONS(89),
    [anon_sym_texture_2d] = ACTIONS(89),
    [anon_sym_texture_2d_array] = ACTIONS(89),
    [anon_sym_texture_3d] = ACTIONS(89),
    [anon_sym_texture_cube] = ACTIONS(89),
    [anon_sym_texture_cube_array] = ACTIONS(89),
    [anon_sym_texture_multisampled_2d] = ACTIONS(89),
    [anon_sym_texture_storage_1d] = ACTIONS(92),
    [anon_sym_texture_storage_2d] = ACTIONS(92),
    [anon_sym_texture_storage_2d_array] = ACTIONS(92),
    [anon_sym_texture_storage_3d] = ACTIONS(92),
    [anon_sym_vec2] = ACTIONS(95),
    [anon_sym_vec3] = ACTIONS(95),
    [anon_sym_vec4] = ACTIONS(95),
    [anon_sym_mat2x2] = ACTIONS(95),
    [anon_sym_mat2x3] = ACTIONS(95),
    [anon_sym_mat2x4] = ACTIONS(95),
    [anon_sym_mat3x2] = ACTIONS(95),
    [anon_sym_mat3x3] = ACTIONS(95),
    [anon_sym_mat3x4] = ACTIONS(95),
    [anon_sym_mat4x2] = ACTIONS(95),
    [anon_sym_mat4x3] = ACTIONS(95),
    [anon_sym_mat4x4] = ACTIONS(95),
    [anon_sym_bitcast] = ACTIONS(98),
    [anon_sym_AMP] = ACTIONS(101),
    [anon_sym_DASH] = ACTIONS(104),
    [anon_sym_STAR] = ACTIONS(101),
    [anon_sym_BANG] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_block_comment] = ACTIONS(3),
  },
  [6] = {
    [sym__expression] = STATE(142),
    [sym_const_literal] = STATE(142),
    [sym_float_literal] = STATE(93),
    [sym_bool_literal] = STATE(93),
    [sym_parenthesized_expression] = STATE(142),
    [sym_type_constructor_or_function_call_expression] = STATE(142),
    [sym_type_declaration] = STATE(323),
    [sym__vec_prefix] = STATE(283),
    [sym__mat_prefix] = STATE(283),
    [sym_bitcast_expression] = STATE(142),
    [sym_binary_expression] = STATE(142),
    [sym_unary_expression] = STATE(142),
    [sym_subscript_expression] = STATE(142),
    [sym_composite_value_decomposition_expression] = STATE(142),
    [sym_identifier] = ACTIONS(33),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(107),
    [anon_sym_LPAREN] = ACTIONS(35),
    [sym_int_literal] = ACTIONS(39),
    [aux_sym_float_literal_token1] = ACTIONS(41),
    [aux_sym_float_literal_token2] = ACTIONS(41),
    [anon_sym_true] = ACTIONS(43),
    [anon_sym_false] = ACTIONS(43),
    [anon_sym_bool] = ACTIONS(45),
    [anon_sym_u32] = ACTIONS(45),
    [anon_sym_i32] = ACTIONS(45),
    [anon_sym_f32] = ACTIONS(45),
    [anon_sym_f16] = ACTIONS(45),
    [anon_sym_array] = ACTIONS(47),
    [anon_sym_ptr] = ACTIONS(49),
    [anon_sym_sampler] = ACTIONS(45),
    [anon_sym_sampler_comparison] = ACTIONS(45),
    [anon_sym_texture_depth_2d] = ACTIONS(45),
    [anon_sym_texture_depth_2d_array] = ACTIONS(45),
    [anon_sym_texture_depth_cube] = ACTIONS(45),
    [anon_sym_texture_depth_cube_array] = ACTIONS(45),
    [anon_sym_texture_depth_multisampled_2d] = ACTIONS(45),
    [anon_sym_texture_1d] = ACTIONS(51),
    [anon_sym_texture_2d] = ACTIONS(51),
    [anon_sym_texture_2d_array] = ACTIONS(51),
    [anon_sym_texture_3d] = ACTIONS(51),
    [anon_sym_texture_cube] = ACTIONS(51),
    [anon_sym_texture_cube_array] = ACTIONS(51),
    [anon_sym_texture_multisampled_2d] = ACTIONS(51),
    [anon_sym_texture_storage_1d] = ACTIONS(53),
    [anon_sym_texture_storage_2d] = ACTIONS(53),
    [anon_sym_texture_storage_2d_array] = ACTIONS(53),
    [anon_sym_texture_storage_3d] = ACTIONS(53),
    [anon_sym_vec2] = ACTIONS(55),
    [anon_sym_vec3] = ACTIONS(55),
    [anon_sym_vec4] = ACTIONS(55),
    [anon_sym_mat2x2] = ACTIONS(55),
    [anon_sym_mat2x3] = ACTIONS(55),
    [anon_sym_mat2x4] = ACTIONS(55),
    [anon_sym_mat3x2] = ACTIONS(55),
    [anon_sym_mat3x3] = ACTIONS(55),
    [anon_sym_mat3x4] = ACTIONS(55),
    [anon_sym_mat4x2] = ACTIONS(55),
    [anon_sym_mat4x3] = ACTIONS(55),
    [anon_sym_mat4x4] = ACTIONS(55),
    [anon_sym_bitcast] = ACTIONS(57),
    [anon_sym_AMP] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(61),
    [anon_sym_STAR] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_TILDE] = ACTIONS(59),
    [sym_block_comment] = ACTIONS(3),
  },
  [7] = {
    [sym__expression] = STATE(147),
    [sym_const_literal] = STATE(147),
    [sym_float_literal] = STATE(93),
    [sym_bool_literal] = STATE(93),
    [sym_parenthesized_expression] = STATE(147),
    [sym_type_constructor_or_function_call_expression] = STATE(147),
    [sym_type_declaration] = STATE(323),
    [sym__vec_prefix] = STATE(283),
    [sym__mat_prefix] = STATE(283),
    [sym_bitcast_expression] = STATE(147),
    [sym_binary_expression] = STATE(147),
    [sym_unary_expression] = STATE(147),
    [sym_subscript_expression] = STATE(147),
    [sym_composite_value_decomposition_expression] = STATE(147),
    [sym_identifier] = ACTIONS(33),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(35),
    [sym_int_literal] = ACTIONS(39),
    [aux_sym_float_literal_token1] = ACTIONS(41),
    [aux_sym_float_literal_token2] = ACTIONS(41),
    [anon_sym_true] = ACTIONS(43),
    [anon_sym_false] = ACTIONS(43),
    [anon_sym_bool] = ACTIONS(45),
    [anon_sym_u32] = ACTIONS(45),
    [anon_sym_i32] = ACTIONS(45),
    [anon_sym_f32] = ACTIONS(45),
    [anon_sym_f16] = ACTIONS(45),
    [anon_sym_array] = ACTIONS(47),
    [anon_sym_ptr] = ACTIONS(49),
    [anon_sym_sampler] = ACTIONS(45),
    [anon_sym_sampler_comparison] = ACTIONS(45),
    [anon_sym_texture_depth_2d] = ACTIONS(45),
    [anon_sym_texture_depth_2d_array] = ACTIONS(45),
    [anon_sym_texture_depth_cube] = ACTIONS(45),
    [anon_sym_texture_depth_cube_array] = ACTIONS(45),
    [anon_sym_texture_depth_multisampled_2d] = ACTIONS(45),
    [anon_sym_texture_1d] = ACTIONS(51),
    [anon_sym_texture_2d] = ACTIONS(51),
    [anon_sym_texture_2d_array] = ACTIONS(51),
    [anon_sym_texture_3d] = ACTIONS(51),
    [anon_sym_texture_cube] = ACTIONS(51),
    [anon_sym_texture_cube_array] = ACTIONS(51),
    [anon_sym_texture_multisampled_2d] = ACTIONS(51),
    [anon_sym_texture_storage_1d] = ACTIONS(53),
    [anon_sym_texture_storage_2d] = ACTIONS(53),
    [anon_sym_texture_storage_2d_array] = ACTIONS(53),
    [anon_sym_texture_storage_3d] = ACTIONS(53),
    [anon_sym_vec2] = ACTIONS(55),
    [anon_sym_vec3] = ACTIONS(55),
    [anon_sym_vec4] = ACTIONS(55),
    [anon_sym_mat2x2] = ACTIONS(55),
    [anon_sym_mat2x3] = ACTIONS(55),
    [anon_sym_mat2x4] = ACTIONS(55),
    [anon_sym_mat3x2] = ACTIONS(55),
    [anon_sym_mat3x3] = ACTIONS(55),
    [anon_sym_mat3x4] = ACTIONS(55),
    [anon_sym_mat4x2] = ACTIONS(55),
    [anon_sym_mat4x3] = ACTIONS(55),
    [anon_sym_mat4x4] = ACTIONS(55),
    [anon_sym_bitcast] = ACTIONS(57),
    [anon_sym_AMP] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(61),
    [anon_sym_STAR] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_TILDE] = ACTIONS(59),
    [sym_block_comment] = ACTIONS(3),
  },
  [8] = {
    [sym__expression] = STATE(150),
    [sym_const_literal] = STATE(150),
    [sym_float_literal] = STATE(93),
    [sym_bool_literal] = STATE(93),
    [sym_parenthesized_expression] = STATE(150),
    [sym_type_constructor_or_function_call_expression] = STATE(150),
    [sym_type_declaration] = STATE(323),
    [sym__vec_prefix] = STATE(283),
    [sym__mat_prefix] = STATE(283),
    [sym_bitcast_expression] = STATE(150),
    [sym_binary_expression] = STATE(150),
    [sym_unary_expression] = STATE(150),
    [sym_subscript_expression] = STATE(150),
    [sym_composite_value_decomposition_expression] = STATE(150),
    [sym_identifier] = ACTIONS(33),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(35),
    [sym_int_literal] = ACTIONS(39),
    [aux_sym_float_literal_token1] = ACTIONS(41),
    [aux_sym_float_literal_token2] = ACTIONS(41),
    [anon_sym_true] = ACTIONS(43),
    [anon_sym_false] = ACTIONS(43),
    [anon_sym_bool] = ACTIONS(45),
    [anon_sym_u32] = ACTIONS(45),
    [anon_sym_i32] = ACTIONS(45),
    [anon_sym_f32] = ACTIONS(45),
    [anon_sym_f16] = ACTIONS(45),
    [anon_sym_array] = ACTIONS(47),
    [anon_sym_ptr] = ACTIONS(49),
    [anon_sym_sampler] = ACTIONS(45),
    [anon_sym_sampler_comparison] = ACTIONS(45),
    [anon_sym_texture_depth_2d] = ACTIONS(45),
    [anon_sym_texture_depth_2d_array] = ACTIONS(45),
    [anon_sym_texture_depth_cube] = ACTIONS(45),
    [anon_sym_texture_depth_cube_array] = ACTIONS(45),
    [anon_sym_texture_depth_multisampled_2d] = ACTIONS(45),
    [anon_sym_texture_1d] = ACTIONS(51),
    [anon_sym_texture_2d] = ACTIONS(51),
    [anon_sym_texture_2d_array] = ACTIONS(51),
    [anon_sym_texture_3d] = ACTIONS(51),
    [anon_sym_texture_cube] = ACTIONS(51),
    [anon_sym_texture_cube_array] = ACTIONS(51),
    [anon_sym_texture_multisampled_2d] = ACTIONS(51),
    [anon_sym_texture_storage_1d] = ACTIONS(53),
    [anon_sym_texture_storage_2d] = ACTIONS(53),
    [anon_sym_texture_storage_2d_array] = ACTIONS(53),
    [anon_sym_texture_storage_3d] = ACTIONS(53),
    [anon_sym_vec2] = ACTIONS(55),
    [anon_sym_vec3] = ACTIONS(55),
    [anon_sym_vec4] = ACTIONS(55),
    [anon_sym_mat2x2] = ACTIONS(55),
    [anon_sym_mat2x3] = ACTIONS(55),
    [anon_sym_mat2x4] = ACTIONS(55),
    [anon_sym_mat3x2] = ACTIONS(55),
    [anon_sym_mat3x3] = ACTIONS(55),
    [anon_sym_mat3x4] = ACTIONS(55),
    [anon_sym_mat4x2] = ACTIONS(55),
    [anon_sym_mat4x3] = ACTIONS(55),
    [anon_sym_mat4x4] = ACTIONS(55),
    [anon_sym_bitcast] = ACTIONS(57),
    [anon_sym_AMP] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(61),
    [anon_sym_STAR] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_TILDE] = ACTIONS(59),
    [sym_block_comment] = ACTIONS(3),
  },
  [9] = {
    [sym__expression] = STATE(108),
    [sym_const_literal] = STATE(108),
    [sym_float_literal] = STATE(93),
    [sym_bool_literal] = STATE(93),
    [sym_parenthesized_expression] = STATE(108),
    [sym_type_constructor_or_function_call_expression] = STATE(108),
    [sym_type_declaration] = STATE(323),
    [sym__vec_prefix] = STATE(283),
    [sym__mat_prefix] = STATE(283),
    [sym_bitcast_expression] = STATE(108),
    [sym_binary_expression] = STATE(108),
    [sym_unary_expression] = STATE(108),
    [sym_subscript_expression] = STATE(108),
    [sym_composite_value_decomposition_expression] = STATE(108),
    [sym_identifier] = ACTIONS(33),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(35),
    [sym_int_literal] = ACTIONS(39),
    [aux_sym_float_literal_token1] = ACTIONS(41),
    [aux_sym_float_literal_token2] = ACTIONS(41),
    [anon_sym_true] = ACTIONS(43),
    [anon_sym_false] = ACTIONS(43),
    [anon_sym_bool] = ACTIONS(45),
    [anon_sym_u32] = ACTIONS(45),
    [anon_sym_i32] = ACTIONS(45),
    [anon_sym_f32] = ACTIONS(45),
    [anon_sym_f16] = ACTIONS(45),
    [anon_sym_array] = ACTIONS(47),
    [anon_sym_ptr] = ACTIONS(49),
    [anon_sym_sampler] = ACTIONS(45),
    [anon_sym_sampler_comparison] = ACTIONS(45),
    [anon_sym_texture_depth_2d] = ACTIONS(45),
    [anon_sym_texture_depth_2d_array] = ACTIONS(45),
    [anon_sym_texture_depth_cube] = ACTIONS(45),
    [anon_sym_texture_depth_cube_array] = ACTIONS(45),
    [anon_sym_texture_depth_multisampled_2d] = ACTIONS(45),
    [anon_sym_texture_1d] = ACTIONS(51),
    [anon_sym_texture_2d] = ACTIONS(51),
    [anon_sym_texture_2d_array] = ACTIONS(51),
    [anon_sym_texture_3d] = ACTIONS(51),
    [anon_sym_texture_cube] = ACTIONS(51),
    [anon_sym_texture_cube_array] = ACTIONS(51),
    [anon_sym_texture_multisampled_2d] = ACTIONS(51),
    [anon_sym_texture_storage_1d] = ACTIONS(53),
    [anon_sym_texture_storage_2d] = ACTIONS(53),
    [anon_sym_texture_storage_2d_array] = ACTIONS(53),
    [anon_sym_texture_storage_3d] = ACTIONS(53),
    [anon_sym_vec2] = ACTIONS(55),
    [anon_sym_vec3] = ACTIONS(55),
    [anon_sym_vec4] = ACTIONS(55),
    [anon_sym_mat2x2] = ACTIONS(55),
    [anon_sym_mat2x3] = ACTIONS(55),
    [anon_sym_mat2x4] = ACTIONS(55),
    [anon_sym_mat3x2] = ACTIONS(55),
    [anon_sym_mat3x3] = ACTIONS(55),
    [anon_sym_mat3x4] = ACTIONS(55),
    [anon_sym_mat4x2] = ACTIONS(55),
    [anon_sym_mat4x3] = ACTIONS(55),
    [anon_sym_mat4x4] = ACTIONS(55),
    [anon_sym_bitcast] = ACTIONS(57),
    [anon_sym_AMP] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(61),
    [anon_sym_STAR] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_TILDE] = ACTIONS(59),
    [sym_block_comment] = ACTIONS(3),
  },
  [10] = {
    [sym__expression] = STATE(109),
    [sym_const_literal] = STATE(109),
    [sym_float_literal] = STATE(93),
    [sym_bool_literal] = STATE(93),
    [sym_parenthesized_expression] = STATE(109),
    [sym_type_constructor_or_function_call_expression] = STATE(109),
    [sym_type_declaration] = STATE(323),
    [sym__vec_prefix] = STATE(283),
    [sym__mat_prefix] = STATE(283),
    [sym_bitcast_expression] = STATE(109),
    [sym_binary_expression] = STATE(109),
    [sym_unary_expression] = STATE(109),
    [sym_subscript_expression] = STATE(109),
    [sym_composite_value_decomposition_expression] = STATE(109),
    [sym_identifier] = ACTIONS(33),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(35),
    [sym_int_literal] = ACTIONS(39),
    [aux_sym_float_literal_token1] = ACTIONS(41),
    [aux_sym_float_literal_token2] = ACTIONS(41),
    [anon_sym_true] = ACTIONS(43),
    [anon_sym_false] = ACTIONS(43),
    [anon_sym_bool] = ACTIONS(45),
    [anon_sym_u32] = ACTIONS(45),
    [anon_sym_i32] = ACTIONS(45),
    [anon_sym_f32] = ACTIONS(45),
    [anon_sym_f16] = ACTIONS(45),
    [anon_sym_array] = ACTIONS(47),
    [anon_sym_ptr] = ACTIONS(49),
    [anon_sym_sampler] = ACTIONS(45),
    [anon_sym_sampler_comparison] = ACTIONS(45),
    [anon_sym_texture_depth_2d] = ACTIONS(45),
    [anon_sym_texture_depth_2d_array] = ACTIONS(45),
    [anon_sym_texture_depth_cube] = ACTIONS(45),
    [anon_sym_texture_depth_cube_array] = ACTIONS(45),
    [anon_sym_texture_depth_multisampled_2d] = ACTIONS(45),
    [anon_sym_texture_1d] = ACTIONS(51),
    [anon_sym_texture_2d] = ACTIONS(51),
    [anon_sym_texture_2d_array] = ACTIONS(51),
    [anon_sym_texture_3d] = ACTIONS(51),
    [anon_sym_texture_cube] = ACTIONS(51),
    [anon_sym_texture_cube_array] = ACTIONS(51),
    [anon_sym_texture_multisampled_2d] = ACTIONS(51),
    [anon_sym_texture_storage_1d] = ACTIONS(53),
    [anon_sym_texture_storage_2d] = ACTIONS(53),
    [anon_sym_texture_storage_2d_array] = ACTIONS(53),
    [anon_sym_texture_storage_3d] = ACTIONS(53),
    [anon_sym_vec2] = ACTIONS(55),
    [anon_sym_vec3] = ACTIONS(55),
    [anon_sym_vec4] = ACTIONS(55),
    [anon_sym_mat2x2] = ACTIONS(55),
    [anon_sym_mat2x3] = ACTIONS(55),
    [anon_sym_mat2x4] = ACTIONS(55),
    [anon_sym_mat3x2] = ACTIONS(55),
    [anon_sym_mat3x3] = ACTIONS(55),
    [anon_sym_mat3x4] = ACTIONS(55),
    [anon_sym_mat4x2] = ACTIONS(55),
    [anon_sym_mat4x3] = ACTIONS(55),
    [anon_sym_mat4x4] = ACTIONS(55),
    [anon_sym_bitcast] = ACTIONS(57),
    [anon_sym_AMP] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(61),
    [anon_sym_STAR] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_TILDE] = ACTIONS(59),
    [sym_block_comment] = ACTIONS(3),
  },
  [11] = {
    [sym__expression] = STATE(113),
    [sym_const_literal] = STATE(113),
    [sym_float_literal] = STATE(93),
    [sym_bool_literal] = STATE(93),
    [sym_parenthesized_expression] = STATE(113),
    [sym_type_constructor_or_function_call_expression] = STATE(113),
    [sym_type_declaration] = STATE(323),
    [sym__vec_prefix] = STATE(283),
    [sym__mat_prefix] = STATE(283),
    [sym_bitcast_expression] = STATE(113),
    [sym_binary_expression] = STATE(113),
    [sym_unary_expression] = STATE(113),
    [sym_subscript_expression] = STATE(113),
    [sym_composite_value_decomposition_expression] = STATE(113),
    [sym_identifier] = ACTIONS(33),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(35),
    [sym_int_literal] = ACTIONS(39),
    [aux_sym_float_literal_token1] = ACTIONS(41),
    [aux_sym_float_literal_token2] = ACTIONS(41),
    [anon_sym_true] = ACTIONS(43),
    [anon_sym_false] = ACTIONS(43),
    [anon_sym_bool] = ACTIONS(45),
    [anon_sym_u32] = ACTIONS(45),
    [anon_sym_i32] = ACTIONS(45),
    [anon_sym_f32] = ACTIONS(45),
    [anon_sym_f16] = ACTIONS(45),
    [anon_sym_array] = ACTIONS(47),
    [anon_sym_ptr] = ACTIONS(49),
    [anon_sym_sampler] = ACTIONS(45),
    [anon_sym_sampler_comparison] = ACTIONS(45),
    [anon_sym_texture_depth_2d] = ACTIONS(45),
    [anon_sym_texture_depth_2d_array] = ACTIONS(45),
    [anon_sym_texture_depth_cube] = ACTIONS(45),
    [anon_sym_texture_depth_cube_array] = ACTIONS(45),
    [anon_sym_texture_depth_multisampled_2d] = ACTIONS(45),
    [anon_sym_texture_1d] = ACTIONS(51),
    [anon_sym_texture_2d] = ACTIONS(51),
    [anon_sym_texture_2d_array] = ACTIONS(51),
    [anon_sym_texture_3d] = ACTIONS(51),
    [anon_sym_texture_cube] = ACTIONS(51),
    [anon_sym_texture_cube_array] = ACTIONS(51),
    [anon_sym_texture_multisampled_2d] = ACTIONS(51),
    [anon_sym_texture_storage_1d] = ACTIONS(53),
    [anon_sym_texture_storage_2d] = ACTIONS(53),
    [anon_sym_texture_storage_2d_array] = ACTIONS(53),
    [anon_sym_texture_storage_3d] = ACTIONS(53),
    [anon_sym_vec2] = ACTIONS(55),
    [anon_sym_vec3] = ACTIONS(55),
    [anon_sym_vec4] = ACTIONS(55),
    [anon_sym_mat2x2] = ACTIONS(55),
    [anon_sym_mat2x3] = ACTIONS(55),
    [anon_sym_mat2x4] = ACTIONS(55),
    [anon_sym_mat3x2] = ACTIONS(55),
    [anon_sym_mat3x3] = ACTIONS(55),
    [anon_sym_mat3x4] = ACTIONS(55),
    [anon_sym_mat4x2] = ACTIONS(55),
    [anon_sym_mat4x3] = ACTIONS(55),
    [anon_sym_mat4x4] = ACTIONS(55),
    [anon_sym_bitcast] = ACTIONS(57),
    [anon_sym_AMP] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(61),
    [anon_sym_STAR] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_TILDE] = ACTIONS(59),
    [sym_block_comment] = ACTIONS(3),
  },
  [12] = {
    [sym__expression] = STATE(115),
    [sym_const_literal] = STATE(115),
    [sym_float_literal] = STATE(93),
    [sym_bool_literal] = STATE(93),
    [sym_parenthesized_expression] = STATE(115),
    [sym_type_constructor_or_function_call_expression] = STATE(115),
    [sym_type_declaration] = STATE(323),
    [sym__vec_prefix] = STATE(283),
    [sym__mat_prefix] = STATE(283),
    [sym_bitcast_expression] = STATE(115),
    [sym_binary_expression] = STATE(115),
    [sym_unary_expression] = STATE(115),
    [sym_subscript_expression] = STATE(115),
    [sym_composite_value_decomposition_expression] = STATE(115),
    [sym_identifier] = ACTIONS(33),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(35),
    [sym_int_literal] = ACTIONS(39),
    [aux_sym_float_literal_token1] = ACTIONS(41),
    [aux_sym_float_literal_token2] = ACTIONS(41),
    [anon_sym_true] = ACTIONS(43),
    [anon_sym_false] = ACTIONS(43),
    [anon_sym_bool] = ACTIONS(45),
    [anon_sym_u32] = ACTIONS(45),
    [anon_sym_i32] = ACTIONS(45),
    [anon_sym_f32] = ACTIONS(45),
    [anon_sym_f16] = ACTIONS(45),
    [anon_sym_array] = ACTIONS(47),
    [anon_sym_ptr] = ACTIONS(49),
    [anon_sym_sampler] = ACTIONS(45),
    [anon_sym_sampler_comparison] = ACTIONS(45),
    [anon_sym_texture_depth_2d] = ACTIONS(45),
    [anon_sym_texture_depth_2d_array] = ACTIONS(45),
    [anon_sym_texture_depth_cube] = ACTIONS(45),
    [anon_sym_texture_depth_cube_array] = ACTIONS(45),
    [anon_sym_texture_depth_multisampled_2d] = ACTIONS(45),
    [anon_sym_texture_1d] = ACTIONS(51),
    [anon_sym_texture_2d] = ACTIONS(51),
    [anon_sym_texture_2d_array] = ACTIONS(51),
    [anon_sym_texture_3d] = ACTIONS(51),
    [anon_sym_texture_cube] = ACTIONS(51),
    [anon_sym_texture_cube_array] = ACTIONS(51),
    [anon_sym_texture_multisampled_2d] = ACTIONS(51),
    [anon_sym_texture_storage_1d] = ACTIONS(53),
    [anon_sym_texture_storage_2d] = ACTIONS(53),
    [anon_sym_texture_storage_2d_array] = ACTIONS(53),
    [anon_sym_texture_storage_3d] = ACTIONS(53),
    [anon_sym_vec2] = ACTIONS(55),
    [anon_sym_vec3] = ACTIONS(55),
    [anon_sym_vec4] = ACTIONS(55),
    [anon_sym_mat2x2] = ACTIONS(55),
    [anon_sym_mat2x3] = ACTIONS(55),
    [anon_sym_mat2x4] = ACTIONS(55),
    [anon_sym_mat3x2] = ACTIONS(55),
    [anon_sym_mat3x3] = ACTIONS(55),
    [anon_sym_mat3x4] = ACTIONS(55),
    [anon_sym_mat4x2] = ACTIONS(55),
    [anon_sym_mat4x3] = ACTIONS(55),
    [anon_sym_mat4x4] = ACTIONS(55),
    [anon_sym_bitcast] = ACTIONS(57),
    [anon_sym_AMP] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(61),
    [anon_sym_STAR] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_TILDE] = ACTIONS(59),
    [sym_block_comment] = ACTIONS(3),
  },
  [13] = {
    [sym__expression] = STATE(119),
    [sym_const_literal] = STATE(119),
    [sym_float_literal] = STATE(93),
    [sym_bool_literal] = STATE(93),
    [sym_parenthesized_expression] = STATE(119),
    [sym_type_constructor_or_function_call_expression] = STATE(119),
    [sym_type_declaration] = STATE(323),
    [sym__vec_prefix] = STATE(283),
    [sym__mat_prefix] = STATE(283),
    [sym_bitcast_expression] = STATE(119),
    [sym_binary_expression] = STATE(119),
    [sym_unary_expression] = STATE(119),
    [sym_subscript_expression] = STATE(119),
    [sym_composite_value_decomposition_expression] = STATE(119),
    [sym_identifier] = ACTIONS(33),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(35),
    [sym_int_literal] = ACTIONS(39),
    [aux_sym_float_literal_token1] = ACTIONS(41),
    [aux_sym_float_literal_token2] = ACTIONS(41),
    [anon_sym_true] = ACTIONS(43),
    [anon_sym_false] = ACTIONS(43),
    [anon_sym_bool] = ACTIONS(45),
    [anon_sym_u32] = ACTIONS(45),
    [anon_sym_i32] = ACTIONS(45),
    [anon_sym_f32] = ACTIONS(45),
    [anon_sym_f16] = ACTIONS(45),
    [anon_sym_array] = ACTIONS(47),
    [anon_sym_ptr] = ACTIONS(49),
    [anon_sym_sampler] = ACTIONS(45),
    [anon_sym_sampler_comparison] = ACTIONS(45),
    [anon_sym_texture_depth_2d] = ACTIONS(45),
    [anon_sym_texture_depth_2d_array] = ACTIONS(45),
    [anon_sym_texture_depth_cube] = ACTIONS(45),
    [anon_sym_texture_depth_cube_array] = ACTIONS(45),
    [anon_sym_texture_depth_multisampled_2d] = ACTIONS(45),
    [anon_sym_texture_1d] = ACTIONS(51),
    [anon_sym_texture_2d] = ACTIONS(51),
    [anon_sym_texture_2d_array] = ACTIONS(51),
    [anon_sym_texture_3d] = ACTIONS(51),
    [anon_sym_texture_cube] = ACTIONS(51),
    [anon_sym_texture_cube_array] = ACTIONS(51),
    [anon_sym_texture_multisampled_2d] = ACTIONS(51),
    [anon_sym_texture_storage_1d] = ACTIONS(53),
    [anon_sym_texture_storage_2d] = ACTIONS(53),
    [anon_sym_texture_storage_2d_array] = ACTIONS(53),
    [anon_sym_texture_storage_3d] = ACTIONS(53),
    [anon_sym_vec2] = ACTIONS(55),
    [anon_sym_vec3] = ACTIONS(55),
    [anon_sym_vec4] = ACTIONS(55),
    [anon_sym_mat2x2] = ACTIONS(55),
    [anon_sym_mat2x3] = ACTIONS(55),
    [anon_sym_mat2x4] = ACTIONS(55),
    [anon_sym_mat3x2] = ACTIONS(55),
    [anon_sym_mat3x3] = ACTIONS(55),
    [anon_sym_mat3x4] = ACTIONS(55),
    [anon_sym_mat4x2] = ACTIONS(55),
    [anon_sym_mat4x3] = ACTIONS(55),
    [anon_sym_mat4x4] = ACTIONS(55),
    [anon_sym_bitcast] = ACTIONS(57),
    [anon_sym_AMP] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(61),
    [anon_sym_STAR] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_TILDE] = ACTIONS(59),
    [sym_block_comment] = ACTIONS(3),
  },
  [14] = {
    [sym__expression] = STATE(120),
    [sym_const_literal] = STATE(120),
    [sym_float_literal] = STATE(93),
    [sym_bool_literal] = STATE(93),
    [sym_parenthesized_expression] = STATE(120),
    [sym_type_constructor_or_function_call_expression] = STATE(120),
    [sym_type_declaration] = STATE(323),
    [sym__vec_prefix] = STATE(283),
    [sym__mat_prefix] = STATE(283),
    [sym_bitcast_expression] = STATE(120),
    [sym_binary_expression] = STATE(120),
    [sym_unary_expression] = STATE(120),
    [sym_subscript_expression] = STATE(120),
    [sym_composite_value_decomposition_expression] = STATE(120),
    [sym_identifier] = ACTIONS(33),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(35),
    [sym_int_literal] = ACTIONS(39),
    [aux_sym_float_literal_token1] = ACTIONS(41),
    [aux_sym_float_literal_token2] = ACTIONS(41),
    [anon_sym_true] = ACTIONS(43),
    [anon_sym_false] = ACTIONS(43),
    [anon_sym_bool] = ACTIONS(45),
    [anon_sym_u32] = ACTIONS(45),
    [anon_sym_i32] = ACTIONS(45),
    [anon_sym_f32] = ACTIONS(45),
    [anon_sym_f16] = ACTIONS(45),
    [anon_sym_array] = ACTIONS(47),
    [anon_sym_ptr] = ACTIONS(49),
    [anon_sym_sampler] = ACTIONS(45),
    [anon_sym_sampler_comparison] = ACTIONS(45),
    [anon_sym_texture_depth_2d] = ACTIONS(45),
    [anon_sym_texture_depth_2d_array] = ACTIONS(45),
    [anon_sym_texture_depth_cube] = ACTIONS(45),
    [anon_sym_texture_depth_cube_array] = ACTIONS(45),
    [anon_sym_texture_depth_multisampled_2d] = ACTIONS(45),
    [anon_sym_texture_1d] = ACTIONS(51),
    [anon_sym_texture_2d] = ACTIONS(51),
    [anon_sym_texture_2d_array] = ACTIONS(51),
    [anon_sym_texture_3d] = ACTIONS(51),
    [anon_sym_texture_cube] = ACTIONS(51),
    [anon_sym_texture_cube_array] = ACTIONS(51),
    [anon_sym_texture_multisampled_2d] = ACTIONS(51),
    [anon_sym_texture_storage_1d] = ACTIONS(53),
    [anon_sym_texture_storage_2d] = ACTIONS(53),
    [anon_sym_texture_storage_2d_array] = ACTIONS(53),
    [anon_sym_texture_storage_3d] = ACTIONS(53),
    [anon_sym_vec2] = ACTIONS(55),
    [anon_sym_vec3] = ACTIONS(55),
    [anon_sym_vec4] = ACTIONS(55),
    [anon_sym_mat2x2] = ACTIONS(55),
    [anon_sym_mat2x3] = ACTIONS(55),
    [anon_sym_mat2x4] = ACTIONS(55),
    [anon_sym_mat3x2] = ACTIONS(55),
    [anon_sym_mat3x3] = ACTIONS(55),
    [anon_sym_mat3x4] = ACTIONS(55),
    [anon_sym_mat4x2] = ACTIONS(55),
    [anon_sym_mat4x3] = ACTIONS(55),
    [anon_sym_mat4x4] = ACTIONS(55),
    [anon_sym_bitcast] = ACTIONS(57),
    [anon_sym_AMP] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(61),
    [anon_sym_STAR] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_TILDE] = ACTIONS(59),
    [sym_block_comment] = ACTIONS(3),
  },
  [15] = {
    [sym__expression] = STATE(130),
    [sym_const_literal] = STATE(130),
    [sym_float_literal] = STATE(93),
    [sym_bool_literal] = STATE(93),
    [sym_parenthesized_expression] = STATE(130),
    [sym_type_constructor_or_function_call_expression] = STATE(130),
    [sym_type_declaration] = STATE(323),
    [sym__vec_prefix] = STATE(283),
    [sym__mat_prefix] = STATE(283),
    [sym_bitcast_expression] = STATE(130),
    [sym_binary_expression] = STATE(130),
    [sym_unary_expression] = STATE(130),
    [sym_subscript_expression] = STATE(130),
    [sym_composite_value_decomposition_expression] = STATE(130),
    [sym_identifier] = ACTIONS(33),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(35),
    [sym_int_literal] = ACTIONS(39),
    [aux_sym_float_literal_token1] = ACTIONS(41),
    [aux_sym_float_literal_token2] = ACTIONS(41),
    [anon_sym_true] = ACTIONS(43),
    [anon_sym_false] = ACTIONS(43),
    [anon_sym_bool] = ACTIONS(45),
    [anon_sym_u32] = ACTIONS(45),
    [anon_sym_i32] = ACTIONS(45),
    [anon_sym_f32] = ACTIONS(45),
    [anon_sym_f16] = ACTIONS(45),
    [anon_sym_array] = ACTIONS(47),
    [anon_sym_ptr] = ACTIONS(49),
    [anon_sym_sampler] = ACTIONS(45),
    [anon_sym_sampler_comparison] = ACTIONS(45),
    [anon_sym_texture_depth_2d] = ACTIONS(45),
    [anon_sym_texture_depth_2d_array] = ACTIONS(45),
    [anon_sym_texture_depth_cube] = ACTIONS(45),
    [anon_sym_texture_depth_cube_array] = ACTIONS(45),
    [anon_sym_texture_depth_multisampled_2d] = ACTIONS(45),
    [anon_sym_texture_1d] = ACTIONS(51),
    [anon_sym_texture_2d] = ACTIONS(51),
    [anon_sym_texture_2d_array] = ACTIONS(51),
    [anon_sym_texture_3d] = ACTIONS(51),
    [anon_sym_texture_cube] = ACTIONS(51),
    [anon_sym_texture_cube_array] = ACTIONS(51),
    [anon_sym_texture_multisampled_2d] = ACTIONS(51),
    [anon_sym_texture_storage_1d] = ACTIONS(53),
    [anon_sym_texture_storage_2d] = ACTIONS(53),
    [anon_sym_texture_storage_2d_array] = ACTIONS(53),
    [anon_sym_texture_storage_3d] = ACTIONS(53),
    [anon_sym_vec2] = ACTIONS(55),
    [anon_sym_vec3] = ACTIONS(55),
    [anon_sym_vec4] = ACTIONS(55),
    [anon_sym_mat2x2] = ACTIONS(55),
    [anon_sym_mat2x3] = ACTIONS(55),
    [anon_sym_mat2x4] = ACTIONS(55),
    [anon_sym_mat3x2] = ACTIONS(55),
    [anon_sym_mat3x3] = ACTIONS(55),
    [anon_sym_mat3x4] = ACTIONS(55),
    [anon_sym_mat4x2] = ACTIONS(55),
    [anon_sym_mat4x3] = ACTIONS(55),
    [anon_sym_mat4x4] = ACTIONS(55),
    [anon_sym_bitcast] = ACTIONS(57),
    [anon_sym_AMP] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(61),
    [anon_sym_STAR] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_TILDE] = ACTIONS(59),
    [sym_block_comment] = ACTIONS(3),
  },
  [16] = {
    [sym__expression] = STATE(112),
    [sym_const_literal] = STATE(112),
    [sym_float_literal] = STATE(93),
    [sym_bool_literal] = STATE(93),
    [sym_parenthesized_expression] = STATE(112),
    [sym_type_constructor_or_function_call_expression] = STATE(112),
    [sym_type_declaration] = STATE(323),
    [sym__vec_prefix] = STATE(283),
    [sym__mat_prefix] = STATE(283),
    [sym_bitcast_expression] = STATE(112),
    [sym_binary_expression] = STATE(112),
    [sym_unary_expression] = STATE(112),
    [sym_subscript_expression] = STATE(112),
    [sym_composite_value_decomposition_expression] = STATE(112),
    [sym_identifier] = ACTIONS(33),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(35),
    [sym_int_literal] = ACTIONS(39),
    [aux_sym_float_literal_token1] = ACTIONS(41),
    [aux_sym_float_literal_token2] = ACTIONS(41),
    [anon_sym_true] = ACTIONS(43),
    [anon_sym_false] = ACTIONS(43),
    [anon_sym_bool] = ACTIONS(45),
    [anon_sym_u32] = ACTIONS(45),
    [anon_sym_i32] = ACTIONS(45),
    [anon_sym_f32] = ACTIONS(45),
    [anon_sym_f16] = ACTIONS(45),
    [anon_sym_array] = ACTIONS(47),
    [anon_sym_ptr] = ACTIONS(49),
    [anon_sym_sampler] = ACTIONS(45),
    [anon_sym_sampler_comparison] = ACTIONS(45),
    [anon_sym_texture_depth_2d] = ACTIONS(45),
    [anon_sym_texture_depth_2d_array] = ACTIONS(45),
    [anon_sym_texture_depth_cube] = ACTIONS(45),
    [anon_sym_texture_depth_cube_array] = ACTIONS(45),
    [anon_sym_texture_depth_multisampled_2d] = ACTIONS(45),
    [anon_sym_texture_1d] = ACTIONS(51),
    [anon_sym_texture_2d] = ACTIONS(51),
    [anon_sym_texture_2d_array] = ACTIONS(51),
    [anon_sym_texture_3d] = ACTIONS(51),
    [anon_sym_texture_cube] = ACTIONS(51),
    [anon_sym_texture_cube_array] = ACTIONS(51),
    [anon_sym_texture_multisampled_2d] = ACTIONS(51),
    [anon_sym_texture_storage_1d] = ACTIONS(53),
    [anon_sym_texture_storage_2d] = ACTIONS(53),
    [anon_sym_texture_storage_2d_array] = ACTIONS(53),
    [anon_sym_texture_storage_3d] = ACTIONS(53),
    [anon_sym_vec2] = ACTIONS(55),
    [anon_sym_vec3] = ACTIONS(55),
    [anon_sym_vec4] = ACTIONS(55),
    [anon_sym_mat2x2] = ACTIONS(55),
    [anon_sym_mat2x3] = ACTIONS(55),
    [anon_sym_mat2x4] = ACTIONS(55),
    [anon_sym_mat3x2] = ACTIONS(55),
    [anon_sym_mat3x3] = ACTIONS(55),
    [anon_sym_mat3x4] = ACTIONS(55),
    [anon_sym_mat4x2] = ACTIONS(55),
    [anon_sym_mat4x3] = ACTIONS(55),
    [anon_sym_mat4x4] = ACTIONS(55),
    [anon_sym_bitcast] = ACTIONS(57),
    [anon_sym_AMP] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(61),
    [anon_sym_STAR] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_TILDE] = ACTIONS(59),
    [sym_block_comment] = ACTIONS(3),
  },
  [17] = {
    [sym__expression] = STATE(97),
    [sym_const_literal] = STATE(97),
    [sym_float_literal] = STATE(93),
    [sym_bool_literal] = STATE(93),
    [sym_parenthesized_expression] = STATE(97),
    [sym_type_constructor_or_function_call_expression] = STATE(97),
    [sym_type_declaration] = STATE(323),
    [sym__vec_prefix] = STATE(283),
    [sym__mat_prefix] = STATE(283),
    [sym_bitcast_expression] = STATE(97),
    [sym_binary_expression] = STATE(97),
    [sym_unary_expression] = STATE(97),
    [sym_subscript_expression] = STATE(97),
    [sym_composite_value_decomposition_expression] = STATE(97),
    [sym_identifier] = ACTIONS(33),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(35),
    [sym_int_literal] = ACTIONS(39),
    [aux_sym_float_literal_token1] = ACTIONS(41),
    [aux_sym_float_literal_token2] = ACTIONS(41),
    [anon_sym_true] = ACTIONS(43),
    [anon_sym_false] = ACTIONS(43),
    [anon_sym_bool] = ACTIONS(45),
    [anon_sym_u32] = ACTIONS(45),
    [anon_sym_i32] = ACTIONS(45),
    [anon_sym_f32] = ACTIONS(45),
    [anon_sym_f16] = ACTIONS(45),
    [anon_sym_array] = ACTIONS(47),
    [anon_sym_ptr] = ACTIONS(49),
    [anon_sym_sampler] = ACTIONS(45),
    [anon_sym_sampler_comparison] = ACTIONS(45),
    [anon_sym_texture_depth_2d] = ACTIONS(45),
    [anon_sym_texture_depth_2d_array] = ACTIONS(45),
    [anon_sym_texture_depth_cube] = ACTIONS(45),
    [anon_sym_texture_depth_cube_array] = ACTIONS(45),
    [anon_sym_texture_depth_multisampled_2d] = ACTIONS(45),
    [anon_sym_texture_1d] = ACTIONS(51),
    [anon_sym_texture_2d] = ACTIONS(51),
    [anon_sym_texture_2d_array] = ACTIONS(51),
    [anon_sym_texture_3d] = ACTIONS(51),
    [anon_sym_texture_cube] = ACTIONS(51),
    [anon_sym_texture_cube_array] = ACTIONS(51),
    [anon_sym_texture_multisampled_2d] = ACTIONS(51),
    [anon_sym_texture_storage_1d] = ACTIONS(53),
    [anon_sym_texture_storage_2d] = ACTIONS(53),
    [anon_sym_texture_storage_2d_array] = ACTIONS(53),
    [anon_sym_texture_storage_3d] = ACTIONS(53),
    [anon_sym_vec2] = ACTIONS(55),
    [anon_sym_vec3] = ACTIONS(55),
    [anon_sym_vec4] = ACTIONS(55),
    [anon_sym_mat2x2] = ACTIONS(55),
    [anon_sym_mat2x3] = ACTIONS(55),
    [anon_sym_mat2x4] = ACTIONS(55),
    [anon_sym_mat3x2] = ACTIONS(55),
    [anon_sym_mat3x3] = ACTIONS(55),
    [anon_sym_mat3x4] = ACTIONS(55),
    [anon_sym_mat4x2] = ACTIONS(55),
    [anon_sym_mat4x3] = ACTIONS(55),
    [anon_sym_mat4x4] = ACTIONS(55),
    [anon_sym_bitcast] = ACTIONS(57),
    [anon_sym_AMP] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(61),
    [anon_sym_STAR] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_TILDE] = ACTIONS(59),
    [sym_block_comment] = ACTIONS(3),
  },
  [18] = {
    [sym__expression] = STATE(144),
    [sym_const_literal] = STATE(144),
    [sym_float_literal] = STATE(93),
    [sym_bool_literal] = STATE(93),
    [sym_parenthesized_expression] = STATE(144),
    [sym_type_constructor_or_function_call_expression] = STATE(144),
    [sym_type_declaration] = STATE(323),
    [sym__vec_prefix] = STATE(283),
    [sym__mat_prefix] = STATE(283),
    [sym_bitcast_expression] = STATE(144),
    [sym_binary_expression] = STATE(144),
    [sym_unary_expression] = STATE(144),
    [sym_subscript_expression] = STATE(144),
    [sym_composite_value_decomposition_expression] = STATE(144),
    [sym_identifier] = ACTIONS(33),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(35),
    [sym_int_literal] = ACTIONS(39),
    [aux_sym_float_literal_token1] = ACTIONS(41),
    [aux_sym_float_literal_token2] = ACTIONS(41),
    [anon_sym_true] = ACTIONS(43),
    [anon_sym_false] = ACTIONS(43),
    [anon_sym_bool] = ACTIONS(45),
    [anon_sym_u32] = ACTIONS(45),
    [anon_sym_i32] = ACTIONS(45),
    [anon_sym_f32] = ACTIONS(45),
    [anon_sym_f16] = ACTIONS(45),
    [anon_sym_array] = ACTIONS(47),
    [anon_sym_ptr] = ACTIONS(49),
    [anon_sym_sampler] = ACTIONS(45),
    [anon_sym_sampler_comparison] = ACTIONS(45),
    [anon_sym_texture_depth_2d] = ACTIONS(45),
    [anon_sym_texture_depth_2d_array] = ACTIONS(45),
    [anon_sym_texture_depth_cube] = ACTIONS(45),
    [anon_sym_texture_depth_cube_array] = ACTIONS(45),
    [anon_sym_texture_depth_multisampled_2d] = ACTIONS(45),
    [anon_sym_texture_1d] = ACTIONS(51),
    [anon_sym_texture_2d] = ACTIONS(51),
    [anon_sym_texture_2d_array] = ACTIONS(51),
    [anon_sym_texture_3d] = ACTIONS(51),
    [anon_sym_texture_cube] = ACTIONS(51),
    [anon_sym_texture_cube_array] = ACTIONS(51),
    [anon_sym_texture_multisampled_2d] = ACTIONS(51),
    [anon_sym_texture_storage_1d] = ACTIONS(53),
    [anon_sym_texture_storage_2d] = ACTIONS(53),
    [anon_sym_texture_storage_2d_array] = ACTIONS(53),
    [anon_sym_texture_storage_3d] = ACTIONS(53),
    [anon_sym_vec2] = ACTIONS(55),
    [anon_sym_vec3] = ACTIONS(55),
    [anon_sym_vec4] = ACTIONS(55),
    [anon_sym_mat2x2] = ACTIONS(55),
    [anon_sym_mat2x3] = ACTIONS(55),
    [anon_sym_mat2x4] = ACTIONS(55),
    [anon_sym_mat3x2] = ACTIONS(55),
    [anon_sym_mat3x3] = ACTIONS(55),
    [anon_sym_mat3x4] = ACTIONS(55),
    [anon_sym_mat4x2] = ACTIONS(55),
    [anon_sym_mat4x3] = ACTIONS(55),
    [anon_sym_mat4x4] = ACTIONS(55),
    [anon_sym_bitcast] = ACTIONS(57),
    [anon_sym_AMP] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(61),
    [anon_sym_STAR] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_TILDE] = ACTIONS(59),
    [sym_block_comment] = ACTIONS(3),
  },
  [19] = {
    [sym__expression] = STATE(148),
    [sym_const_literal] = STATE(148),
    [sym_float_literal] = STATE(93),
    [sym_bool_literal] = STATE(93),
    [sym_parenthesized_expression] = STATE(148),
    [sym_type_constructor_or_function_call_expression] = STATE(148),
    [sym_type_declaration] = STATE(323),
    [sym__vec_prefix] = STATE(283),
    [sym__mat_prefix] = STATE(283),
    [sym_bitcast_expression] = STATE(148),
    [sym_binary_expression] = STATE(148),
    [sym_unary_expression] = STATE(148),
    [sym_subscript_expression] = STATE(148),
    [sym_composite_value_decomposition_expression] = STATE(148),
    [sym_identifier] = ACTIONS(33),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(35),
    [sym_int_literal] = ACTIONS(39),
    [aux_sym_float_literal_token1] = ACTIONS(41),
    [aux_sym_float_literal_token2] = ACTIONS(41),
    [anon_sym_true] = ACTIONS(43),
    [anon_sym_false] = ACTIONS(43),
    [anon_sym_bool] = ACTIONS(45),
    [anon_sym_u32] = ACTIONS(45),
    [anon_sym_i32] = ACTIONS(45),
    [anon_sym_f32] = ACTIONS(45),
    [anon_sym_f16] = ACTIONS(45),
    [anon_sym_array] = ACTIONS(47),
    [anon_sym_ptr] = ACTIONS(49),
    [anon_sym_sampler] = ACTIONS(45),
    [anon_sym_sampler_comparison] = ACTIONS(45),
    [anon_sym_texture_depth_2d] = ACTIONS(45),
    [anon_sym_texture_depth_2d_array] = ACTIONS(45),
    [anon_sym_texture_depth_cube] = ACTIONS(45),
    [anon_sym_texture_depth_cube_array] = ACTIONS(45),
    [anon_sym_texture_depth_multisampled_2d] = ACTIONS(45),
    [anon_sym_texture_1d] = ACTIONS(51),
    [anon_sym_texture_2d] = ACTIONS(51),
    [anon_sym_texture_2d_array] = ACTIONS(51),
    [anon_sym_texture_3d] = ACTIONS(51),
    [anon_sym_texture_cube] = ACTIONS(51),
    [anon_sym_texture_cube_array] = ACTIONS(51),
    [anon_sym_texture_multisampled_2d] = ACTIONS(51),
    [anon_sym_texture_storage_1d] = ACTIONS(53),
    [anon_sym_texture_storage_2d] = ACTIONS(53),
    [anon_sym_texture_storage_2d_array] = ACTIONS(53),
    [anon_sym_texture_storage_3d] = ACTIONS(53),
    [anon_sym_vec2] = ACTIONS(55),
    [anon_sym_vec3] = ACTIONS(55),
    [anon_sym_vec4] = ACTIONS(55),
    [anon_sym_mat2x2] = ACTIONS(55),
    [anon_sym_mat2x3] = ACTIONS(55),
    [anon_sym_mat2x4] = ACTIONS(55),
    [anon_sym_mat3x2] = ACTIONS(55),
    [anon_sym_mat3x3] = ACTIONS(55),
    [anon_sym_mat3x4] = ACTIONS(55),
    [anon_sym_mat4x2] = ACTIONS(55),
    [anon_sym_mat4x3] = ACTIONS(55),
    [anon_sym_mat4x4] = ACTIONS(55),
    [anon_sym_bitcast] = ACTIONS(57),
    [anon_sym_AMP] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(61),
    [anon_sym_STAR] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_TILDE] = ACTIONS(59),
    [sym_block_comment] = ACTIONS(3),
  },
  [20] = {
    [sym__expression] = STATE(135),
    [sym_const_literal] = STATE(135),
    [sym_float_literal] = STATE(93),
    [sym_bool_literal] = STATE(93),
    [sym_parenthesized_expression] = STATE(135),
    [sym_type_constructor_or_function_call_expression] = STATE(135),
    [sym_type_declaration] = STATE(323),
    [sym__vec_prefix] = STATE(283),
    [sym__mat_prefix] = STATE(283),
    [sym_bitcast_expression] = STATE(135),
    [sym_binary_expression] = STATE(135),
    [sym_unary_expression] = STATE(135),
    [sym_subscript_expression] = STATE(135),
    [sym_composite_value_decomposition_expression] = STATE(135),
    [sym_identifier] = ACTIONS(33),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(35),
    [sym_int_literal] = ACTIONS(39),
    [aux_sym_float_literal_token1] = ACTIONS(41),
    [aux_sym_float_literal_token2] = ACTIONS(41),
    [anon_sym_true] = ACTIONS(43),
    [anon_sym_false] = ACTIONS(43),
    [anon_sym_bool] = ACTIONS(45),
    [anon_sym_u32] = ACTIONS(45),
    [anon_sym_i32] = ACTIONS(45),
    [anon_sym_f32] = ACTIONS(45),
    [anon_sym_f16] = ACTIONS(45),
    [anon_sym_array] = ACTIONS(47),
    [anon_sym_ptr] = ACTIONS(49),
    [anon_sym_sampler] = ACTIONS(45),
    [anon_sym_sampler_comparison] = ACTIONS(45),
    [anon_sym_texture_depth_2d] = ACTIONS(45),
    [anon_sym_texture_depth_2d_array] = ACTIONS(45),
    [anon_sym_texture_depth_cube] = ACTIONS(45),
    [anon_sym_texture_depth_cube_array] = ACTIONS(45),
    [anon_sym_texture_depth_multisampled_2d] = ACTIONS(45),
    [anon_sym_texture_1d] = ACTIONS(51),
    [anon_sym_texture_2d] = ACTIONS(51),
    [anon_sym_texture_2d_array] = ACTIONS(51),
    [anon_sym_texture_3d] = ACTIONS(51),
    [anon_sym_texture_cube] = ACTIONS(51),
    [anon_sym_texture_cube_array] = ACTIONS(51),
    [anon_sym_texture_multisampled_2d] = ACTIONS(51),
    [anon_sym_texture_storage_1d] = ACTIONS(53),
    [anon_sym_texture_storage_2d] = ACTIONS(53),
    [anon_sym_texture_storage_2d_array] = ACTIONS(53),
    [anon_sym_texture_storage_3d] = ACTIONS(53),
    [anon_sym_vec2] = ACTIONS(55),
    [anon_sym_vec3] = ACTIONS(55),
    [anon_sym_vec4] = ACTIONS(55),
    [anon_sym_mat2x2] = ACTIONS(55),
    [anon_sym_mat2x3] = ACTIONS(55),
    [anon_sym_mat2x4] = ACTIONS(55),
    [anon_sym_mat3x2] = ACTIONS(55),
    [anon_sym_mat3x3] = ACTIONS(55),
    [anon_sym_mat3x4] = ACTIONS(55),
    [anon_sym_mat4x2] = ACTIONS(55),
    [anon_sym_mat4x3] = ACTIONS(55),
    [anon_sym_mat4x4] = ACTIONS(55),
    [anon_sym_bitcast] = ACTIONS(57),
    [anon_sym_AMP] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(61),
    [anon_sym_STAR] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_TILDE] = ACTIONS(59),
    [sym_block_comment] = ACTIONS(3),
  },
  [21] = {
    [sym__expression] = STATE(143),
    [sym_const_literal] = STATE(143),
    [sym_float_literal] = STATE(93),
    [sym_bool_literal] = STATE(93),
    [sym_parenthesized_expression] = STATE(143),
    [sym_type_constructor_or_function_call_expression] = STATE(143),
    [sym_type_declaration] = STATE(323),
    [sym__vec_prefix] = STATE(283),
    [sym__mat_prefix] = STATE(283),
    [sym_bitcast_expression] = STATE(143),
    [sym_binary_expression] = STATE(143),
    [sym_unary_expression] = STATE(143),
    [sym_subscript_expression] = STATE(143),
    [sym_composite_value_decomposition_expression] = STATE(143),
    [sym_identifier] = ACTIONS(33),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(35),
    [sym_int_literal] = ACTIONS(39),
    [aux_sym_float_literal_token1] = ACTIONS(41),
    [aux_sym_float_literal_token2] = ACTIONS(41),
    [anon_sym_true] = ACTIONS(43),
    [anon_sym_false] = ACTIONS(43),
    [anon_sym_bool] = ACTIONS(45),
    [anon_sym_u32] = ACTIONS(45),
    [anon_sym_i32] = ACTIONS(45),
    [anon_sym_f32] = ACTIONS(45),
    [anon_sym_f16] = ACTIONS(45),
    [anon_sym_array] = ACTIONS(47),
    [anon_sym_ptr] = ACTIONS(49),
    [anon_sym_sampler] = ACTIONS(45),
    [anon_sym_sampler_comparison] = ACTIONS(45),
    [anon_sym_texture_depth_2d] = ACTIONS(45),
    [anon_sym_texture_depth_2d_array] = ACTIONS(45),
    [anon_sym_texture_depth_cube] = ACTIONS(45),
    [anon_sym_texture_depth_cube_array] = ACTIONS(45),
    [anon_sym_texture_depth_multisampled_2d] = ACTIONS(45),
    [anon_sym_texture_1d] = ACTIONS(51),
    [anon_sym_texture_2d] = ACTIONS(51),
    [anon_sym_texture_2d_array] = ACTIONS(51),
    [anon_sym_texture_3d] = ACTIONS(51),
    [anon_sym_texture_cube] = ACTIONS(51),
    [anon_sym_texture_cube_array] = ACTIONS(51),
    [anon_sym_texture_multisampled_2d] = ACTIONS(51),
    [anon_sym_texture_storage_1d] = ACTIONS(53),
    [anon_sym_texture_storage_2d] = ACTIONS(53),
    [anon_sym_texture_storage_2d_array] = ACTIONS(53),
    [anon_sym_texture_storage_3d] = ACTIONS(53),
    [anon_sym_vec2] = ACTIONS(55),
    [anon_sym_vec3] = ACTIONS(55),
    [anon_sym_vec4] = ACTIONS(55),
    [anon_sym_mat2x2] = ACTIONS(55),
    [anon_sym_mat2x3] = ACTIONS(55),
    [anon_sym_mat2x4] = ACTIONS(55),
    [anon_sym_mat3x2] = ACTIONS(55),
    [anon_sym_mat3x3] = ACTIONS(55),
    [anon_sym_mat3x4] = ACTIONS(55),
    [anon_sym_mat4x2] = ACTIONS(55),
    [anon_sym_mat4x3] = ACTIONS(55),
    [anon_sym_mat4x4] = ACTIONS(55),
    [anon_sym_bitcast] = ACTIONS(57),
    [anon_sym_AMP] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(61),
    [anon_sym_STAR] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_TILDE] = ACTIONS(59),
    [sym_block_comment] = ACTIONS(3),
  },
  [22] = {
    [sym__expression] = STATE(134),
    [sym_const_literal] = STATE(134),
    [sym_float_literal] = STATE(93),
    [sym_bool_literal] = STATE(93),
    [sym_parenthesized_expression] = STATE(134),
    [sym_type_constructor_or_function_call_expression] = STATE(134),
    [sym_type_declaration] = STATE(323),
    [sym__vec_prefix] = STATE(283),
    [sym__mat_prefix] = STATE(283),
    [sym_bitcast_expression] = STATE(134),
    [sym_binary_expression] = STATE(134),
    [sym_unary_expression] = STATE(134),
    [sym_subscript_expression] = STATE(134),
    [sym_composite_value_decomposition_expression] = STATE(134),
    [sym_identifier] = ACTIONS(33),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(35),
    [sym_int_literal] = ACTIONS(39),
    [aux_sym_float_literal_token1] = ACTIONS(41),
    [aux_sym_float_literal_token2] = ACTIONS(41),
    [anon_sym_true] = ACTIONS(43),
    [anon_sym_false] = ACTIONS(43),
    [anon_sym_bool] = ACTIONS(45),
    [anon_sym_u32] = ACTIONS(45),
    [anon_sym_i32] = ACTIONS(45),
    [anon_sym_f32] = ACTIONS(45),
    [anon_sym_f16] = ACTIONS(45),
    [anon_sym_array] = ACTIONS(47),
    [anon_sym_ptr] = ACTIONS(49),
    [anon_sym_sampler] = ACTIONS(45),
    [anon_sym_sampler_comparison] = ACTIONS(45),
    [anon_sym_texture_depth_2d] = ACTIONS(45),
    [anon_sym_texture_depth_2d_array] = ACTIONS(45),
    [anon_sym_texture_depth_cube] = ACTIONS(45),
    [anon_sym_texture_depth_cube_array] = ACTIONS(45),
    [anon_sym_texture_depth_multisampled_2d] = ACTIONS(45),
    [anon_sym_texture_1d] = ACTIONS(51),
    [anon_sym_texture_2d] = ACTIONS(51),
    [anon_sym_texture_2d_array] = ACTIONS(51),
    [anon_sym_texture_3d] = ACTIONS(51),
    [anon_sym_texture_cube] = ACTIONS(51),
    [anon_sym_texture_cube_array] = ACTIONS(51),
    [anon_sym_texture_multisampled_2d] = ACTIONS(51),
    [anon_sym_texture_storage_1d] = ACTIONS(53),
    [anon_sym_texture_storage_2d] = ACTIONS(53),
    [anon_sym_texture_storage_2d_array] = ACTIONS(53),
    [anon_sym_texture_storage_3d] = ACTIONS(53),
    [anon_sym_vec2] = ACTIONS(55),
    [anon_sym_vec3] = ACTIONS(55),
    [anon_sym_vec4] = ACTIONS(55),
    [anon_sym_mat2x2] = ACTIONS(55),
    [anon_sym_mat2x3] = ACTIONS(55),
    [anon_sym_mat2x4] = ACTIONS(55),
    [anon_sym_mat3x2] = ACTIONS(55),
    [anon_sym_mat3x3] = ACTIONS(55),
    [anon_sym_mat3x4] = ACTIONS(55),
    [anon_sym_mat4x2] = ACTIONS(55),
    [anon_sym_mat4x3] = ACTIONS(55),
    [anon_sym_mat4x4] = ACTIONS(55),
    [anon_sym_bitcast] = ACTIONS(57),
    [anon_sym_AMP] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(61),
    [anon_sym_STAR] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_TILDE] = ACTIONS(59),
    [sym_block_comment] = ACTIONS(3),
  },
  [23] = {
    [sym__expression] = STATE(140),
    [sym_const_literal] = STATE(140),
    [sym_float_literal] = STATE(93),
    [sym_bool_literal] = STATE(93),
    [sym_parenthesized_expression] = STATE(140),
    [sym_type_constructor_or_function_call_expression] = STATE(140),
    [sym_type_declaration] = STATE(323),
    [sym__vec_prefix] = STATE(283),
    [sym__mat_prefix] = STATE(283),
    [sym_bitcast_expression] = STATE(140),
    [sym_binary_expression] = STATE(140),
    [sym_unary_expression] = STATE(140),
    [sym_subscript_expression] = STATE(140),
    [sym_composite_value_decomposition_expression] = STATE(140),
    [sym_identifier] = ACTIONS(33),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(35),
    [sym_int_literal] = ACTIONS(39),
    [aux_sym_float_literal_token1] = ACTIONS(41),
    [aux_sym_float_literal_token2] = ACTIONS(41),
    [anon_sym_true] = ACTIONS(43),
    [anon_sym_false] = ACTIONS(43),
    [anon_sym_bool] = ACTIONS(45),
    [anon_sym_u32] = ACTIONS(45),
    [anon_sym_i32] = ACTIONS(45),
    [anon_sym_f32] = ACTIONS(45),
    [anon_sym_f16] = ACTIONS(45),
    [anon_sym_array] = ACTIONS(47),
    [anon_sym_ptr] = ACTIONS(49),
    [anon_sym_sampler] = ACTIONS(45),
    [anon_sym_sampler_comparison] = ACTIONS(45),
    [anon_sym_texture_depth_2d] = ACTIONS(45),
    [anon_sym_texture_depth_2d_array] = ACTIONS(45),
    [anon_sym_texture_depth_cube] = ACTIONS(45),
    [anon_sym_texture_depth_cube_array] = ACTIONS(45),
    [anon_sym_texture_depth_multisampled_2d] = ACTIONS(45),
    [anon_sym_texture_1d] = ACTIONS(51),
    [anon_sym_texture_2d] = ACTIONS(51),
    [anon_sym_texture_2d_array] = ACTIONS(51),
    [anon_sym_texture_3d] = ACTIONS(51),
    [anon_sym_texture_cube] = ACTIONS(51),
    [anon_sym_texture_cube_array] = ACTIONS(51),
    [anon_sym_texture_multisampled_2d] = ACTIONS(51),
    [anon_sym_texture_storage_1d] = ACTIONS(53),
    [anon_sym_texture_storage_2d] = ACTIONS(53),
    [anon_sym_texture_storage_2d_array] = ACTIONS(53),
    [anon_sym_texture_storage_3d] = ACTIONS(53),
    [anon_sym_vec2] = ACTIONS(55),
    [anon_sym_vec3] = ACTIONS(55),
    [anon_sym_vec4] = ACTIONS(55),
    [anon_sym_mat2x2] = ACTIONS(55),
    [anon_sym_mat2x3] = ACTIONS(55),
    [anon_sym_mat2x4] = ACTIONS(55),
    [anon_sym_mat3x2] = ACTIONS(55),
    [anon_sym_mat3x3] = ACTIONS(55),
    [anon_sym_mat3x4] = ACTIONS(55),
    [anon_sym_mat4x2] = ACTIONS(55),
    [anon_sym_mat4x3] = ACTIONS(55),
    [anon_sym_mat4x4] = ACTIONS(55),
    [anon_sym_bitcast] = ACTIONS(57),
    [anon_sym_AMP] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(61),
    [anon_sym_STAR] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_TILDE] = ACTIONS(59),
    [sym_block_comment] = ACTIONS(3),
  },
  [24] = {
    [sym__expression] = STATE(110),
    [sym_const_literal] = STATE(110),
    [sym_float_literal] = STATE(93),
    [sym_bool_literal] = STATE(93),
    [sym_parenthesized_expression] = STATE(110),
    [sym_type_constructor_or_function_call_expression] = STATE(110),
    [sym_type_declaration] = STATE(323),
    [sym__vec_prefix] = STATE(283),
    [sym__mat_prefix] = STATE(283),
    [sym_bitcast_expression] = STATE(110),
    [sym_binary_expression] = STATE(110),
    [sym_unary_expression] = STATE(110),
    [sym_subscript_expression] = STATE(110),
    [sym_composite_value_decomposition_expression] = STATE(110),
    [sym_identifier] = ACTIONS(33),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(35),
    [sym_int_literal] = ACTIONS(39),
    [aux_sym_float_literal_token1] = ACTIONS(41),
    [aux_sym_float_literal_token2] = ACTIONS(41),
    [anon_sym_true] = ACTIONS(43),
    [anon_sym_false] = ACTIONS(43),
    [anon_sym_bool] = ACTIONS(45),
    [anon_sym_u32] = ACTIONS(45),
    [anon_sym_i32] = ACTIONS(45),
    [anon_sym_f32] = ACTIONS(45),
    [anon_sym_f16] = ACTIONS(45),
    [anon_sym_array] = ACTIONS(47),
    [anon_sym_ptr] = ACTIONS(49),
    [anon_sym_sampler] = ACTIONS(45),
    [anon_sym_sampler_comparison] = ACTIONS(45),
    [anon_sym_texture_depth_2d] = ACTIONS(45),
    [anon_sym_texture_depth_2d_array] = ACTIONS(45),
    [anon_sym_texture_depth_cube] = ACTIONS(45),
    [anon_sym_texture_depth_cube_array] = ACTIONS(45),
    [anon_sym_texture_depth_multisampled_2d] = ACTIONS(45),
    [anon_sym_texture_1d] = ACTIONS(51),
    [anon_sym_texture_2d] = ACTIONS(51),
    [anon_sym_texture_2d_array] = ACTIONS(51),
    [anon_sym_texture_3d] = ACTIONS(51),
    [anon_sym_texture_cube] = ACTIONS(51),
    [anon_sym_texture_cube_array] = ACTIONS(51),
    [anon_sym_texture_multisampled_2d] = ACTIONS(51),
    [anon_sym_texture_storage_1d] = ACTIONS(53),
    [anon_sym_texture_storage_2d] = ACTIONS(53),
    [anon_sym_texture_storage_2d_array] = ACTIONS(53),
    [anon_sym_texture_storage_3d] = ACTIONS(53),
    [anon_sym_vec2] = ACTIONS(55),
    [anon_sym_vec3] = ACTIONS(55),
    [anon_sym_vec4] = ACTIONS(55),
    [anon_sym_mat2x2] = ACTIONS(55),
    [anon_sym_mat2x3] = ACTIONS(55),
    [anon_sym_mat2x4] = ACTIONS(55),
    [anon_sym_mat3x2] = ACTIONS(55),
    [anon_sym_mat3x3] = ACTIONS(55),
    [anon_sym_mat3x4] = ACTIONS(55),
    [anon_sym_mat4x2] = ACTIONS(55),
    [anon_sym_mat4x3] = ACTIONS(55),
    [anon_sym_mat4x4] = ACTIONS(55),
    [anon_sym_bitcast] = ACTIONS(57),
    [anon_sym_AMP] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(61),
    [anon_sym_STAR] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_TILDE] = ACTIONS(59),
    [sym_block_comment] = ACTIONS(3),
  },
  [25] = {
    [sym__expression] = STATE(137),
    [sym_const_literal] = STATE(137),
    [sym_float_literal] = STATE(93),
    [sym_bool_literal] = STATE(93),
    [sym_parenthesized_expression] = STATE(137),
    [sym_type_constructor_or_function_call_expression] = STATE(137),
    [sym_type_declaration] = STATE(323),
    [sym__vec_prefix] = STATE(283),
    [sym__mat_prefix] = STATE(283),
    [sym_bitcast_expression] = STATE(137),
    [sym_binary_expression] = STATE(137),
    [sym_unary_expression] = STATE(137),
    [sym_subscript_expression] = STATE(137),
    [sym_composite_value_decomposition_expression] = STATE(137),
    [sym_identifier] = ACTIONS(33),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(35),
    [sym_int_literal] = ACTIONS(39),
    [aux_sym_float_literal_token1] = ACTIONS(41),
    [aux_sym_float_literal_token2] = ACTIONS(41),
    [anon_sym_true] = ACTIONS(43),
    [anon_sym_false] = ACTIONS(43),
    [anon_sym_bool] = ACTIONS(45),
    [anon_sym_u32] = ACTIONS(45),
    [anon_sym_i32] = ACTIONS(45),
    [anon_sym_f32] = ACTIONS(45),
    [anon_sym_f16] = ACTIONS(45),
    [anon_sym_array] = ACTIONS(47),
    [anon_sym_ptr] = ACTIONS(49),
    [anon_sym_sampler] = ACTIONS(45),
    [anon_sym_sampler_comparison] = ACTIONS(45),
    [anon_sym_texture_depth_2d] = ACTIONS(45),
    [anon_sym_texture_depth_2d_array] = ACTIONS(45),
    [anon_sym_texture_depth_cube] = ACTIONS(45),
    [anon_sym_texture_depth_cube_array] = ACTIONS(45),
    [anon_sym_texture_depth_multisampled_2d] = ACTIONS(45),
    [anon_sym_texture_1d] = ACTIONS(51),
    [anon_sym_texture_2d] = ACTIONS(51),
    [anon_sym_texture_2d_array] = ACTIONS(51),
    [anon_sym_texture_3d] = ACTIONS(51),
    [anon_sym_texture_cube] = ACTIONS(51),
    [anon_sym_texture_cube_array] = ACTIONS(51),
    [anon_sym_texture_multisampled_2d] = ACTIONS(51),
    [anon_sym_texture_storage_1d] = ACTIONS(53),
    [anon_sym_texture_storage_2d] = ACTIONS(53),
    [anon_sym_texture_storage_2d_array] = ACTIONS(53),
    [anon_sym_texture_storage_3d] = ACTIONS(53),
    [anon_sym_vec2] = ACTIONS(55),
    [anon_sym_vec3] = ACTIONS(55),
    [anon_sym_vec4] = ACTIONS(55),
    [anon_sym_mat2x2] = ACTIONS(55),
    [anon_sym_mat2x3] = ACTIONS(55),
    [anon_sym_mat2x4] = ACTIONS(55),
    [anon_sym_mat3x2] = ACTIONS(55),
    [anon_sym_mat3x3] = ACTIONS(55),
    [anon_sym_mat3x4] = ACTIONS(55),
    [anon_sym_mat4x2] = ACTIONS(55),
    [anon_sym_mat4x3] = ACTIONS(55),
    [anon_sym_mat4x4] = ACTIONS(55),
    [anon_sym_bitcast] = ACTIONS(57),
    [anon_sym_AMP] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(61),
    [anon_sym_STAR] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_TILDE] = ACTIONS(59),
    [sym_block_comment] = ACTIONS(3),
  },
  [26] = {
    [sym__expression] = STATE(133),
    [sym_const_literal] = STATE(133),
    [sym_float_literal] = STATE(93),
    [sym_bool_literal] = STATE(93),
    [sym_parenthesized_expression] = STATE(133),
    [sym_type_constructor_or_function_call_expression] = STATE(133),
    [sym_type_declaration] = STATE(323),
    [sym__vec_prefix] = STATE(283),
    [sym__mat_prefix] = STATE(283),
    [sym_bitcast_expression] = STATE(133),
    [sym_binary_expression] = STATE(133),
    [sym_unary_expression] = STATE(133),
    [sym_subscript_expression] = STATE(133),
    [sym_composite_value_decomposition_expression] = STATE(133),
    [sym_identifier] = ACTIONS(33),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(35),
    [sym_int_literal] = ACTIONS(39),
    [aux_sym_float_literal_token1] = ACTIONS(41),
    [aux_sym_float_literal_token2] = ACTIONS(41),
    [anon_sym_true] = ACTIONS(43),
    [anon_sym_false] = ACTIONS(43),
    [anon_sym_bool] = ACTIONS(45),
    [anon_sym_u32] = ACTIONS(45),
    [anon_sym_i32] = ACTIONS(45),
    [anon_sym_f32] = ACTIONS(45),
    [anon_sym_f16] = ACTIONS(45),
    [anon_sym_array] = ACTIONS(47),
    [anon_sym_ptr] = ACTIONS(49),
    [anon_sym_sampler] = ACTIONS(45),
    [anon_sym_sampler_comparison] = ACTIONS(45),
    [anon_sym_texture_depth_2d] = ACTIONS(45),
    [anon_sym_texture_depth_2d_array] = ACTIONS(45),
    [anon_sym_texture_depth_cube] = ACTIONS(45),
    [anon_sym_texture_depth_cube_array] = ACTIONS(45),
    [anon_sym_texture_depth_multisampled_2d] = ACTIONS(45),
    [anon_sym_texture_1d] = ACTIONS(51),
    [anon_sym_texture_2d] = ACTIONS(51),
    [anon_sym_texture_2d_array] = ACTIONS(51),
    [anon_sym_texture_3d] = ACTIONS(51),
    [anon_sym_texture_cube] = ACTIONS(51),
    [anon_sym_texture_cube_array] = ACTIONS(51),
    [anon_sym_texture_multisampled_2d] = ACTIONS(51),
    [anon_sym_texture_storage_1d] = ACTIONS(53),
    [anon_sym_texture_storage_2d] = ACTIONS(53),
    [anon_sym_texture_storage_2d_array] = ACTIONS(53),
    [anon_sym_texture_storage_3d] = ACTIONS(53),
    [anon_sym_vec2] = ACTIONS(55),
    [anon_sym_vec3] = ACTIONS(55),
    [anon_sym_vec4] = ACTIONS(55),
    [anon_sym_mat2x2] = ACTIONS(55),
    [anon_sym_mat2x3] = ACTIONS(55),
    [anon_sym_mat2x4] = ACTIONS(55),
    [anon_sym_mat3x2] = ACTIONS(55),
    [anon_sym_mat3x3] = ACTIONS(55),
    [anon_sym_mat3x4] = ACTIONS(55),
    [anon_sym_mat4x2] = ACTIONS(55),
    [anon_sym_mat4x3] = ACTIONS(55),
    [anon_sym_mat4x4] = ACTIONS(55),
    [anon_sym_bitcast] = ACTIONS(57),
    [anon_sym_AMP] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(61),
    [anon_sym_STAR] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_TILDE] = ACTIONS(59),
    [sym_block_comment] = ACTIONS(3),
  },
  [27] = {
    [sym__expression] = STATE(107),
    [sym_const_literal] = STATE(107),
    [sym_float_literal] = STATE(93),
    [sym_bool_literal] = STATE(93),
    [sym_parenthesized_expression] = STATE(107),
    [sym_type_constructor_or_function_call_expression] = STATE(107),
    [sym_type_declaration] = STATE(323),
    [sym__vec_prefix] = STATE(283),
    [sym__mat_prefix] = STATE(283),
    [sym_bitcast_expression] = STATE(107),
    [sym_binary_expression] = STATE(107),
    [sym_unary_expression] = STATE(107),
    [sym_subscript_expression] = STATE(107),
    [sym_composite_value_decomposition_expression] = STATE(107),
    [sym_identifier] = ACTIONS(33),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(35),
    [sym_int_literal] = ACTIONS(39),
    [aux_sym_float_literal_token1] = ACTIONS(41),
    [aux_sym_float_literal_token2] = ACTIONS(41),
    [anon_sym_true] = ACTIONS(43),
    [anon_sym_false] = ACTIONS(43),
    [anon_sym_bool] = ACTIONS(45),
    [anon_sym_u32] = ACTIONS(45),
    [anon_sym_i32] = ACTIONS(45),
    [anon_sym_f32] = ACTIONS(45),
    [anon_sym_f16] = ACTIONS(45),
    [anon_sym_array] = ACTIONS(47),
    [anon_sym_ptr] = ACTIONS(49),
    [anon_sym_sampler] = ACTIONS(45),
    [anon_sym_sampler_comparison] = ACTIONS(45),
    [anon_sym_texture_depth_2d] = ACTIONS(45),
    [anon_sym_texture_depth_2d_array] = ACTIONS(45),
    [anon_sym_texture_depth_cube] = ACTIONS(45),
    [anon_sym_texture_depth_cube_array] = ACTIONS(45),
    [anon_sym_texture_depth_multisampled_2d] = ACTIONS(45),
    [anon_sym_texture_1d] = ACTIONS(51),
    [anon_sym_texture_2d] = ACTIONS(51),
    [anon_sym_texture_2d_array] = ACTIONS(51),
    [anon_sym_texture_3d] = ACTIONS(51),
    [anon_sym_texture_cube] = ACTIONS(51),
    [anon_sym_texture_cube_array] = ACTIONS(51),
    [anon_sym_texture_multisampled_2d] = ACTIONS(51),
    [anon_sym_texture_storage_1d] = ACTIONS(53),
    [anon_sym_texture_storage_2d] = ACTIONS(53),
    [anon_sym_texture_storage_2d_array] = ACTIONS(53),
    [anon_sym_texture_storage_3d] = ACTIONS(53),
    [anon_sym_vec2] = ACTIONS(55),
    [anon_sym_vec3] = ACTIONS(55),
    [anon_sym_vec4] = ACTIONS(55),
    [anon_sym_mat2x2] = ACTIONS(55),
    [anon_sym_mat2x3] = ACTIONS(55),
    [anon_sym_mat2x4] = ACTIONS(55),
    [anon_sym_mat3x2] = ACTIONS(55),
    [anon_sym_mat3x3] = ACTIONS(55),
    [anon_sym_mat3x4] = ACTIONS(55),
    [anon_sym_mat4x2] = ACTIONS(55),
    [anon_sym_mat4x3] = ACTIONS(55),
    [anon_sym_mat4x4] = ACTIONS(55),
    [anon_sym_bitcast] = ACTIONS(57),
    [anon_sym_AMP] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(61),
    [anon_sym_STAR] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_TILDE] = ACTIONS(59),
    [sym_block_comment] = ACTIONS(3),
  },
  [28] = {
    [sym__expression] = STATE(139),
    [sym_const_literal] = STATE(139),
    [sym_float_literal] = STATE(93),
    [sym_bool_literal] = STATE(93),
    [sym_parenthesized_expression] = STATE(139),
    [sym_type_constructor_or_function_call_expression] = STATE(139),
    [sym_type_declaration] = STATE(323),
    [sym__vec_prefix] = STATE(283),
    [sym__mat_prefix] = STATE(283),
    [sym_bitcast_expression] = STATE(139),
    [sym_binary_expression] = STATE(139),
    [sym_unary_expression] = STATE(139),
    [sym_subscript_expression] = STATE(139),
    [sym_composite_value_decomposition_expression] = STATE(139),
    [sym_identifier] = ACTIONS(33),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(35),
    [sym_int_literal] = ACTIONS(39),
    [aux_sym_float_literal_token1] = ACTIONS(41),
    [aux_sym_float_literal_token2] = ACTIONS(41),
    [anon_sym_true] = ACTIONS(43),
    [anon_sym_false] = ACTIONS(43),
    [anon_sym_bool] = ACTIONS(45),
    [anon_sym_u32] = ACTIONS(45),
    [anon_sym_i32] = ACTIONS(45),
    [anon_sym_f32] = ACTIONS(45),
    [anon_sym_f16] = ACTIONS(45),
    [anon_sym_array] = ACTIONS(47),
    [anon_sym_ptr] = ACTIONS(49),
    [anon_sym_sampler] = ACTIONS(45),
    [anon_sym_sampler_comparison] = ACTIONS(45),
    [anon_sym_texture_depth_2d] = ACTIONS(45),
    [anon_sym_texture_depth_2d_array] = ACTIONS(45),
    [anon_sym_texture_depth_cube] = ACTIONS(45),
    [anon_sym_texture_depth_cube_array] = ACTIONS(45),
    [anon_sym_texture_depth_multisampled_2d] = ACTIONS(45),
    [anon_sym_texture_1d] = ACTIONS(51),
    [anon_sym_texture_2d] = ACTIONS(51),
    [anon_sym_texture_2d_array] = ACTIONS(51),
    [anon_sym_texture_3d] = ACTIONS(51),
    [anon_sym_texture_cube] = ACTIONS(51),
    [anon_sym_texture_cube_array] = ACTIONS(51),
    [anon_sym_texture_multisampled_2d] = ACTIONS(51),
    [anon_sym_texture_storage_1d] = ACTIONS(53),
    [anon_sym_texture_storage_2d] = ACTIONS(53),
    [anon_sym_texture_storage_2d_array] = ACTIONS(53),
    [anon_sym_texture_storage_3d] = ACTIONS(53),
    [anon_sym_vec2] = ACTIONS(55),
    [anon_sym_vec3] = ACTIONS(55),
    [anon_sym_vec4] = ACTIONS(55),
    [anon_sym_mat2x2] = ACTIONS(55),
    [anon_sym_mat2x3] = ACTIONS(55),
    [anon_sym_mat2x4] = ACTIONS(55),
    [anon_sym_mat3x2] = ACTIONS(55),
    [anon_sym_mat3x3] = ACTIONS(55),
    [anon_sym_mat3x4] = ACTIONS(55),
    [anon_sym_mat4x2] = ACTIONS(55),
    [anon_sym_mat4x3] = ACTIONS(55),
    [anon_sym_mat4x4] = ACTIONS(55),
    [anon_sym_bitcast] = ACTIONS(57),
    [anon_sym_AMP] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(61),
    [anon_sym_STAR] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_TILDE] = ACTIONS(59),
    [sym_block_comment] = ACTIONS(3),
  },
  [29] = {
    [sym__expression] = STATE(138),
    [sym_const_literal] = STATE(138),
    [sym_float_literal] = STATE(93),
    [sym_bool_literal] = STATE(93),
    [sym_parenthesized_expression] = STATE(138),
    [sym_type_constructor_or_function_call_expression] = STATE(138),
    [sym_type_declaration] = STATE(323),
    [sym__vec_prefix] = STATE(283),
    [sym__mat_prefix] = STATE(283),
    [sym_bitcast_expression] = STATE(138),
    [sym_binary_expression] = STATE(138),
    [sym_unary_expression] = STATE(138),
    [sym_subscript_expression] = STATE(138),
    [sym_composite_value_decomposition_expression] = STATE(138),
    [sym_identifier] = ACTIONS(33),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(35),
    [sym_int_literal] = ACTIONS(39),
    [aux_sym_float_literal_token1] = ACTIONS(41),
    [aux_sym_float_literal_token2] = ACTIONS(41),
    [anon_sym_true] = ACTIONS(43),
    [anon_sym_false] = ACTIONS(43),
    [anon_sym_bool] = ACTIONS(45),
    [anon_sym_u32] = ACTIONS(45),
    [anon_sym_i32] = ACTIONS(45),
    [anon_sym_f32] = ACTIONS(45),
    [anon_sym_f16] = ACTIONS(45),
    [anon_sym_array] = ACTIONS(47),
    [anon_sym_ptr] = ACTIONS(49),
    [anon_sym_sampler] = ACTIONS(45),
    [anon_sym_sampler_comparison] = ACTIONS(45),
    [anon_sym_texture_depth_2d] = ACTIONS(45),
    [anon_sym_texture_depth_2d_array] = ACTIONS(45),
    [anon_sym_texture_depth_cube] = ACTIONS(45),
    [anon_sym_texture_depth_cube_array] = ACTIONS(45),
    [anon_sym_texture_depth_multisampled_2d] = ACTIONS(45),
    [anon_sym_texture_1d] = ACTIONS(51),
    [anon_sym_texture_2d] = ACTIONS(51),
    [anon_sym_texture_2d_array] = ACTIONS(51),
    [anon_sym_texture_3d] = ACTIONS(51),
    [anon_sym_texture_cube] = ACTIONS(51),
    [anon_sym_texture_cube_array] = ACTIONS(51),
    [anon_sym_texture_multisampled_2d] = ACTIONS(51),
    [anon_sym_texture_storage_1d] = ACTIONS(53),
    [anon_sym_texture_storage_2d] = ACTIONS(53),
    [anon_sym_texture_storage_2d_array] = ACTIONS(53),
    [anon_sym_texture_storage_3d] = ACTIONS(53),
    [anon_sym_vec2] = ACTIONS(55),
    [anon_sym_vec3] = ACTIONS(55),
    [anon_sym_vec4] = ACTIONS(55),
    [anon_sym_mat2x2] = ACTIONS(55),
    [anon_sym_mat2x3] = ACTIONS(55),
    [anon_sym_mat2x4] = ACTIONS(55),
    [anon_sym_mat3x2] = ACTIONS(55),
    [anon_sym_mat3x3] = ACTIONS(55),
    [anon_sym_mat3x4] = ACTIONS(55),
    [anon_sym_mat4x2] = ACTIONS(55),
    [anon_sym_mat4x3] = ACTIONS(55),
    [anon_sym_mat4x4] = ACTIONS(55),
    [anon_sym_bitcast] = ACTIONS(57),
    [anon_sym_AMP] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(61),
    [anon_sym_STAR] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_TILDE] = ACTIONS(59),
    [sym_block_comment] = ACTIONS(3),
  },
  [30] = {
    [sym__expression] = STATE(146),
    [sym_const_literal] = STATE(146),
    [sym_float_literal] = STATE(93),
    [sym_bool_literal] = STATE(93),
    [sym_parenthesized_expression] = STATE(146),
    [sym_type_constructor_or_function_call_expression] = STATE(146),
    [sym_type_declaration] = STATE(323),
    [sym__vec_prefix] = STATE(283),
    [sym__mat_prefix] = STATE(283),
    [sym_bitcast_expression] = STATE(146),
    [sym_binary_expression] = STATE(146),
    [sym_unary_expression] = STATE(146),
    [sym_subscript_expression] = STATE(146),
    [sym_composite_value_decomposition_expression] = STATE(146),
    [sym_identifier] = ACTIONS(33),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(35),
    [sym_int_literal] = ACTIONS(39),
    [aux_sym_float_literal_token1] = ACTIONS(41),
    [aux_sym_float_literal_token2] = ACTIONS(41),
    [anon_sym_true] = ACTIONS(43),
    [anon_sym_false] = ACTIONS(43),
    [anon_sym_bool] = ACTIONS(45),
    [anon_sym_u32] = ACTIONS(45),
    [anon_sym_i32] = ACTIONS(45),
    [anon_sym_f32] = ACTIONS(45),
    [anon_sym_f16] = ACTIONS(45),
    [anon_sym_array] = ACTIONS(47),
    [anon_sym_ptr] = ACTIONS(49),
    [anon_sym_sampler] = ACTIONS(45),
    [anon_sym_sampler_comparison] = ACTIONS(45),
    [anon_sym_texture_depth_2d] = ACTIONS(45),
    [anon_sym_texture_depth_2d_array] = ACTIONS(45),
    [anon_sym_texture_depth_cube] = ACTIONS(45),
    [anon_sym_texture_depth_cube_array] = ACTIONS(45),
    [anon_sym_texture_depth_multisampled_2d] = ACTIONS(45),
    [anon_sym_texture_1d] = ACTIONS(51),
    [anon_sym_texture_2d] = ACTIONS(51),
    [anon_sym_texture_2d_array] = ACTIONS(51),
    [anon_sym_texture_3d] = ACTIONS(51),
    [anon_sym_texture_cube] = ACTIONS(51),
    [anon_sym_texture_cube_array] = ACTIONS(51),
    [anon_sym_texture_multisampled_2d] = ACTIONS(51),
    [anon_sym_texture_storage_1d] = ACTIONS(53),
    [anon_sym_texture_storage_2d] = ACTIONS(53),
    [anon_sym_texture_storage_2d_array] = ACTIONS(53),
    [anon_sym_texture_storage_3d] = ACTIONS(53),
    [anon_sym_vec2] = ACTIONS(55),
    [anon_sym_vec3] = ACTIONS(55),
    [anon_sym_vec4] = ACTIONS(55),
    [anon_sym_mat2x2] = ACTIONS(55),
    [anon_sym_mat2x3] = ACTIONS(55),
    [anon_sym_mat2x4] = ACTIONS(55),
    [anon_sym_mat3x2] = ACTIONS(55),
    [anon_sym_mat3x3] = ACTIONS(55),
    [anon_sym_mat3x4] = ACTIONS(55),
    [anon_sym_mat4x2] = ACTIONS(55),
    [anon_sym_mat4x3] = ACTIONS(55),
    [anon_sym_mat4x4] = ACTIONS(55),
    [anon_sym_bitcast] = ACTIONS(57),
    [anon_sym_AMP] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(61),
    [anon_sym_STAR] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_TILDE] = ACTIONS(59),
    [sym_block_comment] = ACTIONS(3),
  },
  [31] = {
    [sym__expression] = STATE(149),
    [sym_const_literal] = STATE(149),
    [sym_float_literal] = STATE(93),
    [sym_bool_literal] = STATE(93),
    [sym_parenthesized_expression] = STATE(149),
    [sym_type_constructor_or_function_call_expression] = STATE(149),
    [sym_type_declaration] = STATE(323),
    [sym__vec_prefix] = STATE(283),
    [sym__mat_prefix] = STATE(283),
    [sym_bitcast_expression] = STATE(149),
    [sym_binary_expression] = STATE(149),
    [sym_unary_expression] = STATE(149),
    [sym_subscript_expression] = STATE(149),
    [sym_composite_value_decomposition_expression] = STATE(149),
    [sym_identifier] = ACTIONS(33),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(35),
    [sym_int_literal] = ACTIONS(39),
    [aux_sym_float_literal_token1] = ACTIONS(41),
    [aux_sym_float_literal_token2] = ACTIONS(41),
    [anon_sym_true] = ACTIONS(43),
    [anon_sym_false] = ACTIONS(43),
    [anon_sym_bool] = ACTIONS(45),
    [anon_sym_u32] = ACTIONS(45),
    [anon_sym_i32] = ACTIONS(45),
    [anon_sym_f32] = ACTIONS(45),
    [anon_sym_f16] = ACTIONS(45),
    [anon_sym_array] = ACTIONS(47),
    [anon_sym_ptr] = ACTIONS(49),
    [anon_sym_sampler] = ACTIONS(45),
    [anon_sym_sampler_comparison] = ACTIONS(45),
    [anon_sym_texture_depth_2d] = ACTIONS(45),
    [anon_sym_texture_depth_2d_array] = ACTIONS(45),
    [anon_sym_texture_depth_cube] = ACTIONS(45),
    [anon_sym_texture_depth_cube_array] = ACTIONS(45),
    [anon_sym_texture_depth_multisampled_2d] = ACTIONS(45),
    [anon_sym_texture_1d] = ACTIONS(51),
    [anon_sym_texture_2d] = ACTIONS(51),
    [anon_sym_texture_2d_array] = ACTIONS(51),
    [anon_sym_texture_3d] = ACTIONS(51),
    [anon_sym_texture_cube] = ACTIONS(51),
    [anon_sym_texture_cube_array] = ACTIONS(51),
    [anon_sym_texture_multisampled_2d] = ACTIONS(51),
    [anon_sym_texture_storage_1d] = ACTIONS(53),
    [anon_sym_texture_storage_2d] = ACTIONS(53),
    [anon_sym_texture_storage_2d_array] = ACTIONS(53),
    [anon_sym_texture_storage_3d] = ACTIONS(53),
    [anon_sym_vec2] = ACTIONS(55),
    [anon_sym_vec3] = ACTIONS(55),
    [anon_sym_vec4] = ACTIONS(55),
    [anon_sym_mat2x2] = ACTIONS(55),
    [anon_sym_mat2x3] = ACTIONS(55),
    [anon_sym_mat2x4] = ACTIONS(55),
    [anon_sym_mat3x2] = ACTIONS(55),
    [anon_sym_mat3x3] = ACTIONS(55),
    [anon_sym_mat3x4] = ACTIONS(55),
    [anon_sym_mat4x2] = ACTIONS(55),
    [anon_sym_mat4x3] = ACTIONS(55),
    [anon_sym_mat4x4] = ACTIONS(55),
    [anon_sym_bitcast] = ACTIONS(57),
    [anon_sym_AMP] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(61),
    [anon_sym_STAR] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_TILDE] = ACTIONS(59),
    [sym_block_comment] = ACTIONS(3),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 21,
    ACTIONS(47), 1,
      anon_sym_array,
    ACTIONS(49), 1,
      anon_sym_ptr,
    ACTIONS(111), 1,
      sym_identifier,
    ACTIONS(113), 1,
      anon_sym_SEMI,
    ACTIONS(115), 1,
      anon_sym_let,
    ACTIONS(117), 1,
      anon_sym_LPAREN,
    ACTIONS(119), 1,
      anon_sym__,
    ACTIONS(121), 1,
      anon_sym_var,
    STATE(201), 1,
      sym_lhs_expression,
    STATE(239), 1,
      aux_sym_lhs_expression_repeat1,
    STATE(323), 1,
      sym_type_declaration,
    STATE(330), 1,
      sym_variable_declaration,
    STATE(433), 1,
      sym_for_header,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(123), 2,
      anon_sym_AMP,
      anon_sym_STAR,
    STATE(283), 2,
      sym__vec_prefix,
      sym__mat_prefix,
    ACTIONS(53), 4,
      anon_sym_texture_storage_1d,
      anon_sym_texture_storage_2d,
      anon_sym_texture_storage_2d_array,
      anon_sym_texture_storage_3d,
    STATE(432), 5,
      sym_assignment_statement,
      sym_variable_statement,
      sym_increment_statement,
      sym_decrement_statement,
      sym_type_constructor_or_function_call_expression,
    ACTIONS(51), 7,
      anon_sym_texture_1d,
      anon_sym_texture_2d,
      anon_sym_texture_2d_array,
      anon_sym_texture_3d,
      anon_sym_texture_cube,
      anon_sym_texture_cube_array,
      anon_sym_texture_multisampled_2d,
    ACTIONS(45), 12,
      anon_sym_bool,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_f32,
      anon_sym_f16,
      anon_sym_sampler,
      anon_sym_sampler_comparison,
      anon_sym_texture_depth_2d,
      anon_sym_texture_depth_2d_array,
      anon_sym_texture_depth_cube,
      anon_sym_texture_depth_cube_array,
      anon_sym_texture_depth_multisampled_2d,
    ACTIONS(55), 12,
      anon_sym_vec2,
      anon_sym_vec3,
      anon_sym_vec4,
      anon_sym_mat2x2,
      anon_sym_mat2x3,
      anon_sym_mat2x4,
      anon_sym_mat3x2,
      anon_sym_mat3x3,
      anon_sym_mat3x4,
      anon_sym_mat4x2,
      anon_sym_mat4x3,
      anon_sym_mat4x4,
  [102] = 17,
    ACTIONS(39), 1,
      sym_int_literal,
    ACTIONS(47), 1,
      anon_sym_array,
    ACTIONS(49), 1,
      anon_sym_ptr,
    ACTIONS(125), 1,
      anon_sym_RPAREN,
    STATE(38), 1,
      aux_sym_const_expression_repeat1,
    STATE(274), 1,
      sym_const_literal,
    STATE(303), 1,
      sym_const_expression,
    STATE(374), 1,
      sym_type_declaration,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(41), 2,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token2,
    ACTIONS(43), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(93), 2,
      sym_float_literal,
      sym_bool_literal,
    STATE(376), 2,
      sym__vec_prefix,
      sym__mat_prefix,
    ACTIONS(53), 4,
      anon_sym_texture_storage_1d,
      anon_sym_texture_storage_2d,
      anon_sym_texture_storage_2d_array,
      anon_sym_texture_storage_3d,
    ACTIONS(51), 7,
      anon_sym_texture_1d,
      anon_sym_texture_2d,
      anon_sym_texture_2d_array,
      anon_sym_texture_3d,
      anon_sym_texture_cube,
      anon_sym_texture_cube_array,
      anon_sym_texture_multisampled_2d,
    ACTIONS(127), 12,
      anon_sym_vec2,
      anon_sym_vec3,
      anon_sym_vec4,
      anon_sym_mat2x2,
      anon_sym_mat2x3,
      anon_sym_mat2x4,
      anon_sym_mat3x2,
      anon_sym_mat3x3,
      anon_sym_mat3x4,
      anon_sym_mat4x2,
      anon_sym_mat4x3,
      anon_sym_mat4x4,
    ACTIONS(45), 13,
      sym_identifier,
      anon_sym_bool,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_f32,
      anon_sym_f16,
      anon_sym_sampler,
      anon_sym_sampler_comparison,
      anon_sym_texture_depth_2d,
      anon_sym_texture_depth_2d_array,
      anon_sym_texture_depth_cube,
      anon_sym_texture_depth_cube_array,
      anon_sym_texture_depth_multisampled_2d,
  [191] = 17,
    ACTIONS(47), 1,
      anon_sym_array,
    ACTIONS(49), 1,
      anon_sym_ptr,
    ACTIONS(111), 1,
      sym_identifier,
    ACTIONS(117), 1,
      anon_sym_LPAREN,
    ACTIONS(119), 1,
      anon_sym__,
    ACTIONS(129), 1,
      anon_sym_RPAREN,
    STATE(201), 1,
      sym_lhs_expression,
    STATE(239), 1,
      aux_sym_lhs_expression_repeat1,
    STATE(323), 1,
      sym_type_declaration,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(123), 2,
      anon_sym_AMP,
      anon_sym_STAR,
    STATE(283), 2,
      sym__vec_prefix,
      sym__mat_prefix,
    ACTIONS(53), 4,
      anon_sym_texture_storage_1d,
      anon_sym_texture_storage_2d,
      anon_sym_texture_storage_2d_array,
      anon_sym_texture_storage_3d,
    STATE(396), 4,
      sym_assignment_statement,
      sym_increment_statement,
      sym_decrement_statement,
      sym_type_constructor_or_function_call_expression,
    ACTIONS(51), 7,
      anon_sym_texture_1d,
      anon_sym_texture_2d,
      anon_sym_texture_2d_array,
      anon_sym_texture_3d,
      anon_sym_texture_cube,
      anon_sym_texture_cube_array,
      anon_sym_texture_multisampled_2d,
    ACTIONS(45), 12,
      anon_sym_bool,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_f32,
      anon_sym_f16,
      anon_sym_sampler,
      anon_sym_sampler_comparison,
      anon_sym_texture_depth_2d,
      anon_sym_texture_depth_2d_array,
      anon_sym_texture_depth_cube,
      anon_sym_texture_depth_cube_array,
      anon_sym_texture_depth_multisampled_2d,
    ACTIONS(55), 12,
      anon_sym_vec2,
      anon_sym_vec3,
      anon_sym_vec4,
      anon_sym_mat2x2,
      anon_sym_mat2x3,
      anon_sym_mat2x4,
      anon_sym_mat3x2,
      anon_sym_mat3x3,
      anon_sym_mat3x4,
      anon_sym_mat4x2,
      anon_sym_mat4x3,
      anon_sym_mat4x4,
  [280] = 17,
    ACTIONS(47), 1,
      anon_sym_array,
    ACTIONS(49), 1,
      anon_sym_ptr,
    ACTIONS(111), 1,
      sym_identifier,
    ACTIONS(117), 1,
      anon_sym_LPAREN,
    ACTIONS(119), 1,
      anon_sym__,
    ACTIONS(131), 1,
      anon_sym_RPAREN,
    STATE(201), 1,
      sym_lhs_expression,
    STATE(239), 1,
      aux_sym_lhs_expression_repeat1,
    STATE(323), 1,
      sym_type_declaration,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(123), 2,
      anon_sym_AMP,
      anon_sym_STAR,
    STATE(283), 2,
      sym__vec_prefix,
      sym__mat_prefix,
    ACTIONS(53), 4,
      anon_sym_texture_storage_1d,
      anon_sym_texture_storage_2d,
      anon_sym_texture_storage_2d_array,
      anon_sym_texture_storage_3d,
    STATE(415), 4,
      sym_assignment_statement,
      sym_increment_statement,
      sym_decrement_statement,
      sym_type_constructor_or_function_call_expression,
    ACTIONS(51), 7,
      anon_sym_texture_1d,
      anon_sym_texture_2d,
      anon_sym_texture_2d_array,
      anon_sym_texture_3d,
      anon_sym_texture_cube,
      anon_sym_texture_cube_array,
      anon_sym_texture_multisampled_2d,
    ACTIONS(45), 12,
      anon_sym_bool,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_f32,
      anon_sym_f16,
      anon_sym_sampler,
      anon_sym_sampler_comparison,
      anon_sym_texture_depth_2d,
      anon_sym_texture_depth_2d_array,
      anon_sym_texture_depth_cube,
      anon_sym_texture_depth_cube_array,
      anon_sym_texture_depth_multisampled_2d,
    ACTIONS(55), 12,
      anon_sym_vec2,
      anon_sym_vec3,
      anon_sym_vec4,
      anon_sym_mat2x2,
      anon_sym_mat2x3,
      anon_sym_mat2x4,
      anon_sym_mat3x2,
      anon_sym_mat3x3,
      anon_sym_mat3x4,
      anon_sym_mat4x2,
      anon_sym_mat4x3,
      anon_sym_mat4x4,
  [369] = 17,
    ACTIONS(47), 1,
      anon_sym_array,
    ACTIONS(49), 1,
      anon_sym_ptr,
    ACTIONS(111), 1,
      sym_identifier,
    ACTIONS(117), 1,
      anon_sym_LPAREN,
    ACTIONS(119), 1,
      anon_sym__,
    ACTIONS(133), 1,
      anon_sym_RPAREN,
    STATE(201), 1,
      sym_lhs_expression,
    STATE(239), 1,
      aux_sym_lhs_expression_repeat1,
    STATE(323), 1,
      sym_type_declaration,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(123), 2,
      anon_sym_AMP,
      anon_sym_STAR,
    STATE(283), 2,
      sym__vec_prefix,
      sym__mat_prefix,
    ACTIONS(53), 4,
      anon_sym_texture_storage_1d,
      anon_sym_texture_storage_2d,
      anon_sym_texture_storage_2d_array,
      anon_sym_texture_storage_3d,
    STATE(426), 4,
      sym_assignment_statement,
      sym_increment_statement,
      sym_decrement_statement,
      sym_type_constructor_or_function_call_expression,
    ACTIONS(51), 7,
      anon_sym_texture_1d,
      anon_sym_texture_2d,
      anon_sym_texture_2d_array,
      anon_sym_texture_3d,
      anon_sym_texture_cube,
      anon_sym_texture_cube_array,
      anon_sym_texture_multisampled_2d,
    ACTIONS(45), 12,
      anon_sym_bool,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_f32,
      anon_sym_f16,
      anon_sym_sampler,
      anon_sym_sampler_comparison,
      anon_sym_texture_depth_2d,
      anon_sym_texture_depth_2d_array,
      anon_sym_texture_depth_cube,
      anon_sym_texture_depth_cube_array,
      anon_sym_texture_depth_multisampled_2d,
    ACTIONS(55), 12,
      anon_sym_vec2,
      anon_sym_vec3,
      anon_sym_vec4,
      anon_sym_mat2x2,
      anon_sym_mat2x3,
      anon_sym_mat2x4,
      anon_sym_mat3x2,
      anon_sym_mat3x3,
      anon_sym_mat3x4,
      anon_sym_mat4x2,
      anon_sym_mat4x3,
      anon_sym_mat4x4,
  [458] = 4,
    ACTIONS(139), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(137), 7,
      anon_sym_LPAREN,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token2,
      anon_sym_AMP,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(135), 43,
      sym_identifier,
      sym_int_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_bool,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_f32,
      anon_sym_f16,
      anon_sym_array,
      anon_sym_ptr,
      anon_sym_sampler,
      anon_sym_sampler_comparison,
      anon_sym_texture_depth_2d,
      anon_sym_texture_depth_2d_array,
      anon_sym_texture_depth_cube,
      anon_sym_texture_depth_cube_array,
      anon_sym_texture_depth_multisampled_2d,
      anon_sym_texture_1d,
      anon_sym_texture_2d,
      anon_sym_texture_2d_array,
      anon_sym_texture_3d,
      anon_sym_texture_cube,
      anon_sym_texture_cube_array,
      anon_sym_texture_multisampled_2d,
      anon_sym_texture_storage_1d,
      anon_sym_texture_storage_2d,
      anon_sym_texture_storage_2d_array,
      anon_sym_texture_storage_3d,
      anon_sym_vec2,
      anon_sym_vec3,
      anon_sym_vec4,
      anon_sym_mat2x2,
      anon_sym_mat2x3,
      anon_sym_mat2x4,
      anon_sym_mat3x2,
      anon_sym_mat3x3,
      anon_sym_mat3x4,
      anon_sym_mat4x2,
      anon_sym_mat4x3,
      anon_sym_mat4x4,
      anon_sym_bitcast,
      anon_sym_DASH,
  [520] = 16,
    ACTIONS(39), 1,
      sym_int_literal,
    ACTIONS(47), 1,
      anon_sym_array,
    ACTIONS(49), 1,
      anon_sym_ptr,
    STATE(39), 1,
      aux_sym_const_expression_repeat1,
    STATE(274), 1,
      sym_const_literal,
    STATE(305), 1,
      sym_const_expression,
    STATE(374), 1,
      sym_type_declaration,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(41), 2,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token2,
    ACTIONS(43), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(93), 2,
      sym_float_literal,
      sym_bool_literal,
    STATE(376), 2,
      sym__vec_prefix,
      sym__mat_prefix,
    ACTIONS(53), 4,
      anon_sym_texture_storage_1d,
      anon_sym_texture_storage_2d,
      anon_sym_texture_storage_2d_array,
      anon_sym_texture_storage_3d,
    ACTIONS(51), 7,
      anon_sym_texture_1d,
      anon_sym_texture_2d,
      anon_sym_texture_2d_array,
      anon_sym_texture_3d,
      anon_sym_texture_cube,
      anon_sym_texture_cube_array,
      anon_sym_texture_multisampled_2d,
    ACTIONS(127), 12,
      anon_sym_vec2,
      anon_sym_vec3,
      anon_sym_vec4,
      anon_sym_mat2x2,
      anon_sym_mat2x3,
      anon_sym_mat2x4,
      anon_sym_mat3x2,
      anon_sym_mat3x3,
      anon_sym_mat3x4,
      anon_sym_mat4x2,
      anon_sym_mat4x3,
      anon_sym_mat4x4,
    ACTIONS(45), 13,
      sym_identifier,
      anon_sym_bool,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_f32,
      anon_sym_f16,
      anon_sym_sampler,
      anon_sym_sampler_comparison,
      anon_sym_texture_depth_2d,
      anon_sym_texture_depth_2d_array,
      anon_sym_texture_depth_cube,
      anon_sym_texture_depth_cube_array,
      anon_sym_texture_depth_multisampled_2d,
  [606] = 16,
    ACTIONS(144), 1,
      sym_int_literal,
    ACTIONS(153), 1,
      anon_sym_array,
    ACTIONS(156), 1,
      anon_sym_ptr,
    STATE(39), 1,
      aux_sym_const_expression_repeat1,
    STATE(274), 1,
      sym_const_literal,
    STATE(374), 1,
      sym_type_declaration,
    STATE(389), 1,
      sym_const_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(147), 2,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token2,
    ACTIONS(150), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(93), 2,
      sym_float_literal,
      sym_bool_literal,
    STATE(376), 2,
      sym__vec_prefix,
      sym__mat_prefix,
    ACTIONS(162), 4,
      anon_sym_texture_storage_1d,
      anon_sym_texture_storage_2d,
      anon_sym_texture_storage_2d_array,
      anon_sym_texture_storage_3d,
    ACTIONS(159), 7,
      anon_sym_texture_1d,
      anon_sym_texture_2d,
      anon_sym_texture_2d_array,
      anon_sym_texture_3d,
      anon_sym_texture_cube,
      anon_sym_texture_cube_array,
      anon_sym_texture_multisampled_2d,
    ACTIONS(165), 12,
      anon_sym_vec2,
      anon_sym_vec3,
      anon_sym_vec4,
      anon_sym_mat2x2,
      anon_sym_mat2x3,
      anon_sym_mat2x4,
      anon_sym_mat3x2,
      anon_sym_mat3x3,
      anon_sym_mat3x4,
      anon_sym_mat4x2,
      anon_sym_mat4x3,
      anon_sym_mat4x4,
    ACTIONS(141), 13,
      sym_identifier,
      anon_sym_bool,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_f32,
      anon_sym_f16,
      anon_sym_sampler,
      anon_sym_sampler_comparison,
      anon_sym_texture_depth_2d,
      anon_sym_texture_depth_2d_array,
      anon_sym_texture_depth_cube,
      anon_sym_texture_depth_cube_array,
      anon_sym_texture_depth_multisampled_2d,
  [692] = 4,
    ACTIONS(168), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(137), 7,
      anon_sym_LPAREN,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token2,
      anon_sym_AMP,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(135), 43,
      sym_identifier,
      sym_int_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_bool,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_f32,
      anon_sym_f16,
      anon_sym_array,
      anon_sym_ptr,
      anon_sym_sampler,
      anon_sym_sampler_comparison,
      anon_sym_texture_depth_2d,
      anon_sym_texture_depth_2d_array,
      anon_sym_texture_depth_cube,
      anon_sym_texture_depth_cube_array,
      anon_sym_texture_depth_multisampled_2d,
      anon_sym_texture_1d,
      anon_sym_texture_2d,
      anon_sym_texture_2d_array,
      anon_sym_texture_3d,
      anon_sym_texture_cube,
      anon_sym_texture_cube_array,
      anon_sym_texture_multisampled_2d,
      anon_sym_texture_storage_1d,
      anon_sym_texture_storage_2d,
      anon_sym_texture_storage_2d_array,
      anon_sym_texture_storage_3d,
      anon_sym_vec2,
      anon_sym_vec3,
      anon_sym_vec4,
      anon_sym_mat2x2,
      anon_sym_mat2x3,
      anon_sym_mat2x4,
      anon_sym_mat3x2,
      anon_sym_mat3x3,
      anon_sym_mat3x4,
      anon_sym_mat4x2,
      anon_sym_mat4x3,
      anon_sym_mat4x4,
      anon_sym_bitcast,
      anon_sym_DASH,
  [754] = 15,
    ACTIONS(39), 1,
      sym_int_literal,
    ACTIONS(47), 1,
      anon_sym_array,
    ACTIONS(49), 1,
      anon_sym_ptr,
    STATE(274), 1,
      sym_const_literal,
    STATE(374), 1,
      sym_type_declaration,
    STATE(382), 1,
      sym_const_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(41), 2,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token2,
    ACTIONS(43), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(93), 2,
      sym_float_literal,
      sym_bool_literal,
    STATE(376), 2,
      sym__vec_prefix,
      sym__mat_prefix,
    ACTIONS(53), 4,
      anon_sym_texture_storage_1d,
      anon_sym_texture_storage_2d,
      anon_sym_texture_storage_2d_array,
      anon_sym_texture_storage_3d,
    ACTIONS(51), 7,
      anon_sym_texture_1d,
      anon_sym_texture_2d,
      anon_sym_texture_2d_array,
      anon_sym_texture_3d,
      anon_sym_texture_cube,
      anon_sym_texture_cube_array,
      anon_sym_texture_multisampled_2d,
    ACTIONS(127), 12,
      anon_sym_vec2,
      anon_sym_vec3,
      anon_sym_vec4,
      anon_sym_mat2x2,
      anon_sym_mat2x3,
      anon_sym_mat2x4,
      anon_sym_mat3x2,
      anon_sym_mat3x3,
      anon_sym_mat3x4,
      anon_sym_mat4x2,
      anon_sym_mat4x3,
      anon_sym_mat4x4,
    ACTIONS(45), 13,
      sym_identifier,
      anon_sym_bool,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_f32,
      anon_sym_f16,
      anon_sym_sampler,
      anon_sym_sampler_comparison,
      anon_sym_texture_depth_2d,
      anon_sym_texture_depth_2d_array,
      anon_sym_texture_depth_cube,
      anon_sym_texture_depth_cube_array,
      anon_sym_texture_depth_multisampled_2d,
  [837] = 15,
    ACTIONS(39), 1,
      sym_int_literal,
    ACTIONS(47), 1,
      anon_sym_array,
    ACTIONS(49), 1,
      anon_sym_ptr,
    STATE(274), 1,
      sym_const_literal,
    STATE(374), 1,
      sym_type_declaration,
    STATE(405), 1,
      sym_const_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(41), 2,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token2,
    ACTIONS(43), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(93), 2,
      sym_float_literal,
      sym_bool_literal,
    STATE(376), 2,
      sym__vec_prefix,
      sym__mat_prefix,
    ACTIONS(53), 4,
      anon_sym_texture_storage_1d,
      anon_sym_texture_storage_2d,
      anon_sym_texture_storage_2d_array,
      anon_sym_texture_storage_3d,
    ACTIONS(51), 7,
      anon_sym_texture_1d,
      anon_sym_texture_2d,
      anon_sym_texture_2d_array,
      anon_sym_texture_3d,
      anon_sym_texture_cube,
      anon_sym_texture_cube_array,
      anon_sym_texture_multisampled_2d,
    ACTIONS(127), 12,
      anon_sym_vec2,
      anon_sym_vec3,
      anon_sym_vec4,
      anon_sym_mat2x2,
      anon_sym_mat2x3,
      anon_sym_mat2x4,
      anon_sym_mat3x2,
      anon_sym_mat3x3,
      anon_sym_mat3x4,
      anon_sym_mat4x2,
      anon_sym_mat4x3,
      anon_sym_mat4x4,
    ACTIONS(45), 13,
      sym_identifier,
      anon_sym_bool,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_f32,
      anon_sym_f16,
      anon_sym_sampler,
      anon_sym_sampler_comparison,
      anon_sym_texture_depth_2d,
      anon_sym_texture_depth_2d_array,
      anon_sym_texture_depth_cube,
      anon_sym_texture_depth_cube_array,
      anon_sym_texture_depth_multisampled_2d,
  [920] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(137), 7,
      anon_sym_LPAREN,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token2,
      anon_sym_AMP,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(135), 43,
      sym_identifier,
      sym_int_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_bool,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_f32,
      anon_sym_f16,
      anon_sym_array,
      anon_sym_ptr,
      anon_sym_sampler,
      anon_sym_sampler_comparison,
      anon_sym_texture_depth_2d,
      anon_sym_texture_depth_2d_array,
      anon_sym_texture_depth_cube,
      anon_sym_texture_depth_cube_array,
      anon_sym_texture_depth_multisampled_2d,
      anon_sym_texture_1d,
      anon_sym_texture_2d,
      anon_sym_texture_2d_array,
      anon_sym_texture_3d,
      anon_sym_texture_cube,
      anon_sym_texture_cube_array,
      anon_sym_texture_multisampled_2d,
      anon_sym_texture_storage_1d,
      anon_sym_texture_storage_2d,
      anon_sym_texture_storage_2d_array,
      anon_sym_texture_storage_3d,
      anon_sym_vec2,
      anon_sym_vec3,
      anon_sym_vec4,
      anon_sym_mat2x2,
      anon_sym_mat2x3,
      anon_sym_mat2x4,
      anon_sym_mat3x2,
      anon_sym_mat3x3,
      anon_sym_mat3x4,
      anon_sym_mat4x2,
      anon_sym_mat4x3,
      anon_sym_mat4x4,
      anon_sym_bitcast,
      anon_sym_DASH,
  [979] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(172), 7,
      anon_sym_LPAREN,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token2,
      anon_sym_AMP,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(170), 43,
      sym_identifier,
      sym_int_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_bool,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_f32,
      anon_sym_f16,
      anon_sym_array,
      anon_sym_ptr,
      anon_sym_sampler,
      anon_sym_sampler_comparison,
      anon_sym_texture_depth_2d,
      anon_sym_texture_depth_2d_array,
      anon_sym_texture_depth_cube,
      anon_sym_texture_depth_cube_array,
      anon_sym_texture_depth_multisampled_2d,
      anon_sym_texture_1d,
      anon_sym_texture_2d,
      anon_sym_texture_2d_array,
      anon_sym_texture_3d,
      anon_sym_texture_cube,
      anon_sym_texture_cube_array,
      anon_sym_texture_multisampled_2d,
      anon_sym_texture_storage_1d,
      anon_sym_texture_storage_2d,
      anon_sym_texture_storage_2d_array,
      anon_sym_texture_storage_3d,
      anon_sym_vec2,
      anon_sym_vec3,
      anon_sym_vec4,
      anon_sym_mat2x2,
      anon_sym_mat2x3,
      anon_sym_mat2x4,
      anon_sym_mat3x2,
      anon_sym_mat3x3,
      anon_sym_mat3x4,
      anon_sym_mat4x2,
      anon_sym_mat4x3,
      anon_sym_mat4x4,
      anon_sym_bitcast,
      anon_sym_DASH,
  [1038] = 15,
    ACTIONS(39), 1,
      sym_int_literal,
    ACTIONS(47), 1,
      anon_sym_array,
    ACTIONS(49), 1,
      anon_sym_ptr,
    STATE(274), 1,
      sym_const_literal,
    STATE(368), 1,
      sym_const_expression,
    STATE(374), 1,
      sym_type_declaration,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(41), 2,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token2,
    ACTIONS(43), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(93), 2,
      sym_float_literal,
      sym_bool_literal,
    STATE(376), 2,
      sym__vec_prefix,
      sym__mat_prefix,
    ACTIONS(53), 4,
      anon_sym_texture_storage_1d,
      anon_sym_texture_storage_2d,
      anon_sym_texture_storage_2d_array,
      anon_sym_texture_storage_3d,
    ACTIONS(51), 7,
      anon_sym_texture_1d,
      anon_sym_texture_2d,
      anon_sym_texture_2d_array,
      anon_sym_texture_3d,
      anon_sym_texture_cube,
      anon_sym_texture_cube_array,
      anon_sym_texture_multisampled_2d,
    ACTIONS(127), 12,
      anon_sym_vec2,
      anon_sym_vec3,
      anon_sym_vec4,
      anon_sym_mat2x2,
      anon_sym_mat2x3,
      anon_sym_mat2x4,
      anon_sym_mat3x2,
      anon_sym_mat3x3,
      anon_sym_mat3x4,
      anon_sym_mat4x2,
      anon_sym_mat4x3,
      anon_sym_mat4x4,
    ACTIONS(45), 13,
      sym_identifier,
      anon_sym_bool,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_f32,
      anon_sym_f16,
      anon_sym_sampler,
      anon_sym_sampler_comparison,
      anon_sym_texture_depth_2d,
      anon_sym_texture_depth_2d_array,
      anon_sym_texture_depth_cube,
      anon_sym_texture_depth_cube_array,
      anon_sym_texture_depth_multisampled_2d,
  [1121] = 26,
    ACTIONS(174), 1,
      sym_identifier,
    ACTIONS(177), 1,
      anon_sym_let,
    ACTIONS(180), 1,
      anon_sym_LPAREN,
    ACTIONS(183), 1,
      anon_sym_LBRACE,
    ACTIONS(188), 1,
      anon_sym__,
    ACTIONS(191), 1,
      anon_sym_if,
    ACTIONS(194), 1,
      anon_sym_switch,
    ACTIONS(199), 1,
      anon_sym_loop,
    ACTIONS(202), 1,
      anon_sym_for,
    ACTIONS(205), 1,
      anon_sym_while,
    ACTIONS(208), 1,
      anon_sym_break,
    ACTIONS(211), 1,
      anon_sym_continue,
    ACTIONS(214), 1,
      anon_sym_return,
    ACTIONS(217), 1,
      anon_sym_discard,
    ACTIONS(220), 1,
      anon_sym_var,
    ACTIONS(226), 1,
      aux_sym_preproc_import_token1,
    STATE(201), 1,
      sym_lhs_expression,
    STATE(239), 1,
      aux_sym_lhs_expression_repeat1,
    STATE(330), 1,
      sym_variable_declaration,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(197), 2,
      anon_sym_fallthrough,
      anon_sym_continuing,
    ACTIONS(223), 2,
      anon_sym_AMP,
      anon_sym_STAR,
    ACTIONS(229), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    ACTIONS(186), 3,
      anon_sym_RBRACE,
      aux_sym_preproc_ifdef_token3,
      aux_sym_preproc_else_token1,
    STATE(398), 3,
      sym_assignment_statement,
      sym_return_statement,
      sym_variable_statement,
    STATE(46), 15,
      sym__statement,
      sym_compound_statement,
      sym_if_statement,
      sym_switch_statement,
      sym_loop_statement,
      sym_for_statement,
      sym_while_statement,
      sym_break_statement,
      sym_continue_statement,
      sym_discard_statement,
      sym_increment_statement,
      sym_decrement_statement,
      sym_preproc_import,
      sym_preproc_ifdef_in_statement,
      aux_sym_compound_statement_repeat1,
  [1222] = 27,
    ACTIONS(27), 1,
      aux_sym_preproc_import_token1,
    ACTIONS(115), 1,
      anon_sym_let,
    ACTIONS(117), 1,
      anon_sym_LPAREN,
    ACTIONS(119), 1,
      anon_sym__,
    ACTIONS(121), 1,
      anon_sym_var,
    ACTIONS(232), 1,
      sym_identifier,
    ACTIONS(234), 1,
      anon_sym_LBRACE,
    ACTIONS(236), 1,
      anon_sym_RBRACE,
    ACTIONS(238), 1,
      anon_sym_if,
    ACTIONS(240), 1,
      anon_sym_switch,
    ACTIONS(242), 1,
      anon_sym_fallthrough,
    ACTIONS(244), 1,
      anon_sym_loop,
    ACTIONS(246), 1,
      anon_sym_for,
    ACTIONS(248), 1,
      anon_sym_while,
    ACTIONS(250), 1,
      anon_sym_break,
    ACTIONS(252), 1,
      anon_sym_continue,
    ACTIONS(254), 1,
      anon_sym_return,
    ACTIONS(256), 1,
      anon_sym_discard,
    STATE(201), 1,
      sym_lhs_expression,
    STATE(239), 1,
      aux_sym_lhs_expression_repeat1,
    STATE(330), 1,
      sym_variable_declaration,
    STATE(345), 1,
      sym_fallthrough_statement,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(123), 2,
      anon_sym_AMP,
      anon_sym_STAR,
    ACTIONS(258), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(398), 3,
      sym_assignment_statement,
      sym_return_statement,
      sym_variable_statement,
    STATE(46), 15,
      sym__statement,
      sym_compound_statement,
      sym_if_statement,
      sym_switch_statement,
      sym_loop_statement,
      sym_for_statement,
      sym_while_statement,
      sym_break_statement,
      sym_continue_statement,
      sym_discard_statement,
      sym_increment_statement,
      sym_decrement_statement,
      sym_preproc_import,
      sym_preproc_ifdef_in_statement,
      aux_sym_compound_statement_repeat1,
  [1323] = 11,
    ACTIONS(23), 1,
      anon_sym_AT,
    ACTIONS(47), 1,
      anon_sym_array,
    ACTIONS(49), 1,
      anon_sym_ptr,
    STATE(406), 1,
      sym_type_declaration,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(50), 2,
      sym_attribute,
      aux_sym_global_variable_declaration_repeat1,
    STATE(376), 2,
      sym__vec_prefix,
      sym__mat_prefix,
    ACTIONS(53), 4,
      anon_sym_texture_storage_1d,
      anon_sym_texture_storage_2d,
      anon_sym_texture_storage_2d_array,
      anon_sym_texture_storage_3d,
    ACTIONS(51), 7,
      anon_sym_texture_1d,
      anon_sym_texture_2d,
      anon_sym_texture_2d_array,
      anon_sym_texture_3d,
      anon_sym_texture_cube,
      anon_sym_texture_cube_array,
      anon_sym_texture_multisampled_2d,
    ACTIONS(127), 12,
      anon_sym_vec2,
      anon_sym_vec3,
      anon_sym_vec4,
      anon_sym_mat2x2,
      anon_sym_mat2x3,
      anon_sym_mat2x4,
      anon_sym_mat3x2,
      anon_sym_mat3x3,
      anon_sym_mat3x4,
      anon_sym_mat4x2,
      anon_sym_mat4x3,
      anon_sym_mat4x4,
    ACTIONS(45), 13,
      sym_identifier,
      anon_sym_bool,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_f32,
      anon_sym_f16,
      anon_sym_sampler,
      anon_sym_sampler_comparison,
      anon_sym_texture_depth_2d,
      anon_sym_texture_depth_2d_array,
      anon_sym_texture_depth_cube,
      anon_sym_texture_depth_cube_array,
      anon_sym_texture_depth_multisampled_2d,
  [1392] = 4,
    ACTIONS(262), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(49), 2,
      sym_attribute,
      aux_sym_global_variable_declaration_repeat1,
    ACTIONS(260), 41,
      anon_sym_override,
      anon_sym_fn,
      sym_identifier,
      anon_sym_var,
      anon_sym_bool,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_f32,
      anon_sym_f16,
      anon_sym_array,
      anon_sym_ptr,
      anon_sym_sampler,
      anon_sym_sampler_comparison,
      anon_sym_texture_depth_2d,
      anon_sym_texture_depth_2d_array,
      anon_sym_texture_depth_cube,
      anon_sym_texture_depth_cube_array,
      anon_sym_texture_depth_multisampled_2d,
      anon_sym_texture_1d,
      anon_sym_texture_2d,
      anon_sym_texture_2d_array,
      anon_sym_texture_3d,
      anon_sym_texture_cube,
      anon_sym_texture_cube_array,
      anon_sym_texture_multisampled_2d,
      anon_sym_texture_storage_1d,
      anon_sym_texture_storage_2d,
      anon_sym_texture_storage_2d_array,
      anon_sym_texture_storage_3d,
      anon_sym_vec2,
      anon_sym_vec3,
      anon_sym_vec4,
      anon_sym_mat2x2,
      anon_sym_mat2x3,
      anon_sym_mat2x4,
      anon_sym_mat3x2,
      anon_sym_mat3x3,
      anon_sym_mat3x4,
      anon_sym_mat4x2,
      anon_sym_mat4x3,
      anon_sym_mat4x4,
  [1447] = 11,
    ACTIONS(23), 1,
      anon_sym_AT,
    ACTIONS(47), 1,
      anon_sym_array,
    ACTIONS(49), 1,
      anon_sym_ptr,
    STATE(373), 1,
      sym_type_declaration,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(49), 2,
      sym_attribute,
      aux_sym_global_variable_declaration_repeat1,
    STATE(376), 2,
      sym__vec_prefix,
      sym__mat_prefix,
    ACTIONS(53), 4,
      anon_sym_texture_storage_1d,
      anon_sym_texture_storage_2d,
      anon_sym_texture_storage_2d_array,
      anon_sym_texture_storage_3d,
    ACTIONS(51), 7,
      anon_sym_texture_1d,
      anon_sym_texture_2d,
      anon_sym_texture_2d_array,
      anon_sym_texture_3d,
      anon_sym_texture_cube,
      anon_sym_texture_cube_array,
      anon_sym_texture_multisampled_2d,
    ACTIONS(127), 12,
      anon_sym_vec2,
      anon_sym_vec3,
      anon_sym_vec4,
      anon_sym_mat2x2,
      anon_sym_mat2x3,
      anon_sym_mat2x4,
      anon_sym_mat3x2,
      anon_sym_mat3x3,
      anon_sym_mat3x4,
      anon_sym_mat4x2,
      anon_sym_mat4x3,
      anon_sym_mat4x4,
    ACTIONS(45), 13,
      sym_identifier,
      anon_sym_bool,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_f32,
      anon_sym_f16,
      anon_sym_sampler,
      anon_sym_sampler_comparison,
      anon_sym_texture_depth_2d,
      anon_sym_texture_depth_2d_array,
      anon_sym_texture_depth_cube,
      anon_sym_texture_depth_cube_array,
      anon_sym_texture_depth_multisampled_2d,
  [1516] = 4,
    ACTIONS(267), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(269), 2,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token2,
    ACTIONS(265), 41,
      sym_identifier,
      sym_int_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_bool,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_f32,
      anon_sym_f16,
      anon_sym_array,
      anon_sym_ptr,
      anon_sym_sampler,
      anon_sym_sampler_comparison,
      anon_sym_texture_depth_2d,
      anon_sym_texture_depth_2d_array,
      anon_sym_texture_depth_cube,
      anon_sym_texture_depth_cube_array,
      anon_sym_texture_depth_multisampled_2d,
      anon_sym_texture_1d,
      anon_sym_texture_2d,
      anon_sym_texture_2d_array,
      anon_sym_texture_3d,
      anon_sym_texture_cube,
      anon_sym_texture_cube_array,
      anon_sym_texture_multisampled_2d,
      anon_sym_texture_storage_1d,
      anon_sym_texture_storage_2d,
      anon_sym_texture_storage_2d_array,
      anon_sym_texture_storage_3d,
      anon_sym_vec2,
      anon_sym_vec3,
      anon_sym_vec4,
      anon_sym_mat2x2,
      anon_sym_mat2x3,
      anon_sym_mat2x4,
      anon_sym_mat3x2,
      anon_sym_mat3x3,
      anon_sym_mat3x4,
      anon_sym_mat4x2,
      anon_sym_mat4x3,
      anon_sym_mat4x4,
  [1571] = 27,
    ACTIONS(27), 1,
      aux_sym_preproc_import_token1,
    ACTIONS(115), 1,
      anon_sym_let,
    ACTIONS(117), 1,
      anon_sym_LPAREN,
    ACTIONS(119), 1,
      anon_sym__,
    ACTIONS(121), 1,
      anon_sym_var,
    ACTIONS(232), 1,
      sym_identifier,
    ACTIONS(234), 1,
      anon_sym_LBRACE,
    ACTIONS(238), 1,
      anon_sym_if,
    ACTIONS(240), 1,
      anon_sym_switch,
    ACTIONS(244), 1,
      anon_sym_loop,
    ACTIONS(246), 1,
      anon_sym_for,
    ACTIONS(248), 1,
      anon_sym_while,
    ACTIONS(250), 1,
      anon_sym_break,
    ACTIONS(252), 1,
      anon_sym_continue,
    ACTIONS(254), 1,
      anon_sym_return,
    ACTIONS(256), 1,
      anon_sym_discard,
    ACTIONS(271), 1,
      anon_sym_RBRACE,
    ACTIONS(273), 1,
      anon_sym_continuing,
    STATE(201), 1,
      sym_lhs_expression,
    STATE(239), 1,
      aux_sym_lhs_expression_repeat1,
    STATE(330), 1,
      sym_variable_declaration,
    STATE(422), 1,
      sym_continuing_statement,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(123), 2,
      anon_sym_AMP,
      anon_sym_STAR,
    ACTIONS(258), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(398), 3,
      sym_assignment_statement,
      sym_return_statement,
      sym_variable_statement,
    STATE(54), 15,
      sym__statement,
      sym_compound_statement,
      sym_if_statement,
      sym_switch_statement,
      sym_loop_statement,
      sym_for_statement,
      sym_while_statement,
      sym_break_statement,
      sym_continue_statement,
      sym_discard_statement,
      sym_increment_statement,
      sym_decrement_statement,
      sym_preproc_import,
      sym_preproc_ifdef_in_statement,
      aux_sym_compound_statement_repeat1,
  [1672] = 27,
    ACTIONS(27), 1,
      aux_sym_preproc_import_token1,
    ACTIONS(115), 1,
      anon_sym_let,
    ACTIONS(117), 1,
      anon_sym_LPAREN,
    ACTIONS(119), 1,
      anon_sym__,
    ACTIONS(121), 1,
      anon_sym_var,
    ACTIONS(232), 1,
      sym_identifier,
    ACTIONS(234), 1,
      anon_sym_LBRACE,
    ACTIONS(238), 1,
      anon_sym_if,
    ACTIONS(240), 1,
      anon_sym_switch,
    ACTIONS(244), 1,
      anon_sym_loop,
    ACTIONS(246), 1,
      anon_sym_for,
    ACTIONS(248), 1,
      anon_sym_while,
    ACTIONS(250), 1,
      anon_sym_break,
    ACTIONS(252), 1,
      anon_sym_continue,
    ACTIONS(254), 1,
      anon_sym_return,
    ACTIONS(256), 1,
      anon_sym_discard,
    ACTIONS(275), 1,
      aux_sym_preproc_ifdef_token3,
    ACTIONS(277), 1,
      aux_sym_preproc_else_token1,
    STATE(201), 1,
      sym_lhs_expression,
    STATE(239), 1,
      aux_sym_lhs_expression_repeat1,
    STATE(330), 1,
      sym_variable_declaration,
    STATE(397), 1,
      sym_preproc_else_in_statement,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(123), 2,
      anon_sym_AMP,
      anon_sym_STAR,
    ACTIONS(258), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(398), 3,
      sym_assignment_statement,
      sym_return_statement,
      sym_variable_statement,
    STATE(56), 15,
      sym__statement,
      sym_compound_statement,
      sym_if_statement,
      sym_switch_statement,
      sym_loop_statement,
      sym_for_statement,
      sym_while_statement,
      sym_break_statement,
      sym_continue_statement,
      sym_discard_statement,
      sym_increment_statement,
      sym_decrement_statement,
      sym_preproc_import,
      sym_preproc_ifdef_in_statement,
      aux_sym_compound_statement_repeat1,
  [1773] = 27,
    ACTIONS(27), 1,
      aux_sym_preproc_import_token1,
    ACTIONS(115), 1,
      anon_sym_let,
    ACTIONS(117), 1,
      anon_sym_LPAREN,
    ACTIONS(119), 1,
      anon_sym__,
    ACTIONS(121), 1,
      anon_sym_var,
    ACTIONS(232), 1,
      sym_identifier,
    ACTIONS(234), 1,
      anon_sym_LBRACE,
    ACTIONS(238), 1,
      anon_sym_if,
    ACTIONS(240), 1,
      anon_sym_switch,
    ACTIONS(244), 1,
      anon_sym_loop,
    ACTIONS(246), 1,
      anon_sym_for,
    ACTIONS(248), 1,
      anon_sym_while,
    ACTIONS(250), 1,
      anon_sym_break,
    ACTIONS(252), 1,
      anon_sym_continue,
    ACTIONS(254), 1,
      anon_sym_return,
    ACTIONS(256), 1,
      anon_sym_discard,
    ACTIONS(273), 1,
      anon_sym_continuing,
    ACTIONS(279), 1,
      anon_sym_RBRACE,
    STATE(201), 1,
      sym_lhs_expression,
    STATE(239), 1,
      aux_sym_lhs_expression_repeat1,
    STATE(330), 1,
      sym_variable_declaration,
    STATE(369), 1,
      sym_continuing_statement,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(123), 2,
      anon_sym_AMP,
      anon_sym_STAR,
    ACTIONS(258), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(398), 3,
      sym_assignment_statement,
      sym_return_statement,
      sym_variable_statement,
    STATE(46), 15,
      sym__statement,
      sym_compound_statement,
      sym_if_statement,
      sym_switch_statement,
      sym_loop_statement,
      sym_for_statement,
      sym_while_statement,
      sym_break_statement,
      sym_continue_statement,
      sym_discard_statement,
      sym_increment_statement,
      sym_decrement_statement,
      sym_preproc_import,
      sym_preproc_ifdef_in_statement,
      aux_sym_compound_statement_repeat1,
  [1874] = 4,
    ACTIONS(281), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(269), 2,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token2,
    ACTIONS(265), 41,
      sym_identifier,
      sym_int_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_bool,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_f32,
      anon_sym_f16,
      anon_sym_array,
      anon_sym_ptr,
      anon_sym_sampler,
      anon_sym_sampler_comparison,
      anon_sym_texture_depth_2d,
      anon_sym_texture_depth_2d_array,
      anon_sym_texture_depth_cube,
      anon_sym_texture_depth_cube_array,
      anon_sym_texture_depth_multisampled_2d,
      anon_sym_texture_1d,
      anon_sym_texture_2d,
      anon_sym_texture_2d_array,
      anon_sym_texture_3d,
      anon_sym_texture_cube,
      anon_sym_texture_cube_array,
      anon_sym_texture_multisampled_2d,
      anon_sym_texture_storage_1d,
      anon_sym_texture_storage_2d,
      anon_sym_texture_storage_2d_array,
      anon_sym_texture_storage_3d,
      anon_sym_vec2,
      anon_sym_vec3,
      anon_sym_vec4,
      anon_sym_mat2x2,
      anon_sym_mat2x3,
      anon_sym_mat2x4,
      anon_sym_mat3x2,
      anon_sym_mat3x3,
      anon_sym_mat3x4,
      anon_sym_mat4x2,
      anon_sym_mat4x3,
      anon_sym_mat4x4,
  [1929] = 27,
    ACTIONS(27), 1,
      aux_sym_preproc_import_token1,
    ACTIONS(115), 1,
      anon_sym_let,
    ACTIONS(117), 1,
      anon_sym_LPAREN,
    ACTIONS(119), 1,
      anon_sym__,
    ACTIONS(121), 1,
      anon_sym_var,
    ACTIONS(232), 1,
      sym_identifier,
    ACTIONS(234), 1,
      anon_sym_LBRACE,
    ACTIONS(238), 1,
      anon_sym_if,
    ACTIONS(240), 1,
      anon_sym_switch,
    ACTIONS(244), 1,
      anon_sym_loop,
    ACTIONS(246), 1,
      anon_sym_for,
    ACTIONS(248), 1,
      anon_sym_while,
    ACTIONS(250), 1,
      anon_sym_break,
    ACTIONS(252), 1,
      anon_sym_continue,
    ACTIONS(254), 1,
      anon_sym_return,
    ACTIONS(256), 1,
      anon_sym_discard,
    ACTIONS(277), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(283), 1,
      aux_sym_preproc_ifdef_token3,
    STATE(201), 1,
      sym_lhs_expression,
    STATE(239), 1,
      aux_sym_lhs_expression_repeat1,
    STATE(330), 1,
      sym_variable_declaration,
    STATE(377), 1,
      sym_preproc_else_in_statement,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(123), 2,
      anon_sym_AMP,
      anon_sym_STAR,
    ACTIONS(258), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(398), 3,
      sym_assignment_statement,
      sym_return_statement,
      sym_variable_statement,
    STATE(46), 15,
      sym__statement,
      sym_compound_statement,
      sym_if_statement,
      sym_switch_statement,
      sym_loop_statement,
      sym_for_statement,
      sym_while_statement,
      sym_break_statement,
      sym_continue_statement,
      sym_discard_statement,
      sym_increment_statement,
      sym_decrement_statement,
      sym_preproc_import,
      sym_preproc_ifdef_in_statement,
      aux_sym_compound_statement_repeat1,
  [2030] = 27,
    ACTIONS(27), 1,
      aux_sym_preproc_import_token1,
    ACTIONS(115), 1,
      anon_sym_let,
    ACTIONS(117), 1,
      anon_sym_LPAREN,
    ACTIONS(119), 1,
      anon_sym__,
    ACTIONS(121), 1,
      anon_sym_var,
    ACTIONS(232), 1,
      sym_identifier,
    ACTIONS(234), 1,
      anon_sym_LBRACE,
    ACTIONS(238), 1,
      anon_sym_if,
    ACTIONS(240), 1,
      anon_sym_switch,
    ACTIONS(242), 1,
      anon_sym_fallthrough,
    ACTIONS(244), 1,
      anon_sym_loop,
    ACTIONS(246), 1,
      anon_sym_for,
    ACTIONS(248), 1,
      anon_sym_while,
    ACTIONS(250), 1,
      anon_sym_break,
    ACTIONS(252), 1,
      anon_sym_continue,
    ACTIONS(254), 1,
      anon_sym_return,
    ACTIONS(256), 1,
      anon_sym_discard,
    ACTIONS(285), 1,
      anon_sym_RBRACE,
    STATE(201), 1,
      sym_lhs_expression,
    STATE(239), 1,
      aux_sym_lhs_expression_repeat1,
    STATE(330), 1,
      sym_variable_declaration,
    STATE(410), 1,
      sym_fallthrough_statement,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(123), 2,
      anon_sym_AMP,
      anon_sym_STAR,
    ACTIONS(258), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(398), 3,
      sym_assignment_statement,
      sym_return_statement,
      sym_variable_statement,
    STATE(47), 15,
      sym__statement,
      sym_compound_statement,
      sym_if_statement,
      sym_switch_statement,
      sym_loop_statement,
      sym_for_statement,
      sym_while_statement,
      sym_break_statement,
      sym_continue_statement,
      sym_discard_statement,
      sym_increment_statement,
      sym_decrement_statement,
      sym_preproc_import,
      sym_preproc_ifdef_in_statement,
      aux_sym_compound_statement_repeat1,
  [2131] = 26,
    ACTIONS(27), 1,
      aux_sym_preproc_import_token1,
    ACTIONS(115), 1,
      anon_sym_let,
    ACTIONS(117), 1,
      anon_sym_LPAREN,
    ACTIONS(119), 1,
      anon_sym__,
    ACTIONS(121), 1,
      anon_sym_var,
    ACTIONS(232), 1,
      sym_identifier,
    ACTIONS(234), 1,
      anon_sym_LBRACE,
    ACTIONS(238), 1,
      anon_sym_if,
    ACTIONS(240), 1,
      anon_sym_switch,
    ACTIONS(244), 1,
      anon_sym_loop,
    ACTIONS(246), 1,
      anon_sym_for,
    ACTIONS(248), 1,
      anon_sym_while,
    ACTIONS(252), 1,
      anon_sym_continue,
    ACTIONS(254), 1,
      anon_sym_return,
    ACTIONS(256), 1,
      anon_sym_discard,
    ACTIONS(287), 1,
      anon_sym_RBRACE,
    ACTIONS(289), 1,
      anon_sym_break,
    STATE(201), 1,
      sym_lhs_expression,
    STATE(239), 1,
      aux_sym_lhs_expression_repeat1,
    STATE(330), 1,
      sym_variable_declaration,
    STATE(414), 1,
      sym_break_if_statement,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(123), 2,
      anon_sym_AMP,
      anon_sym_STAR,
    ACTIONS(258), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(398), 3,
      sym_assignment_statement,
      sym_return_statement,
      sym_variable_statement,
    STATE(46), 15,
      sym__statement,
      sym_compound_statement,
      sym_if_statement,
      sym_switch_statement,
      sym_loop_statement,
      sym_for_statement,
      sym_while_statement,
      sym_break_statement,
      sym_continue_statement,
      sym_discard_statement,
      sym_increment_statement,
      sym_decrement_statement,
      sym_preproc_import,
      sym_preproc_ifdef_in_statement,
      aux_sym_compound_statement_repeat1,
  [2229] = 4,
    ACTIONS(293), 1,
      anon_sym_LPAREN,
    ACTIONS(295), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(291), 41,
      anon_sym_override,
      anon_sym_fn,
      sym_identifier,
      anon_sym_var,
      anon_sym_bool,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_f32,
      anon_sym_f16,
      anon_sym_array,
      anon_sym_ptr,
      anon_sym_sampler,
      anon_sym_sampler_comparison,
      anon_sym_texture_depth_2d,
      anon_sym_texture_depth_2d_array,
      anon_sym_texture_depth_cube,
      anon_sym_texture_depth_cube_array,
      anon_sym_texture_depth_multisampled_2d,
      anon_sym_texture_1d,
      anon_sym_texture_2d,
      anon_sym_texture_2d_array,
      anon_sym_texture_3d,
      anon_sym_texture_cube,
      anon_sym_texture_cube_array,
      anon_sym_texture_multisampled_2d,
      anon_sym_texture_storage_1d,
      anon_sym_texture_storage_2d,
      anon_sym_texture_storage_2d_array,
      anon_sym_texture_storage_3d,
      anon_sym_vec2,
      anon_sym_vec3,
      anon_sym_vec4,
      anon_sym_mat2x2,
      anon_sym_mat2x3,
      anon_sym_mat2x4,
      anon_sym_mat3x2,
      anon_sym_mat3x3,
      anon_sym_mat3x4,
      anon_sym_mat4x2,
      anon_sym_mat4x3,
      anon_sym_mat4x4,
  [2283] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(269), 2,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token2,
    ACTIONS(265), 41,
      sym_identifier,
      sym_int_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_bool,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_f32,
      anon_sym_f16,
      anon_sym_array,
      anon_sym_ptr,
      anon_sym_sampler,
      anon_sym_sampler_comparison,
      anon_sym_texture_depth_2d,
      anon_sym_texture_depth_2d_array,
      anon_sym_texture_depth_cube,
      anon_sym_texture_depth_cube_array,
      anon_sym_texture_depth_multisampled_2d,
      anon_sym_texture_1d,
      anon_sym_texture_2d,
      anon_sym_texture_2d_array,
      anon_sym_texture_3d,
      anon_sym_texture_cube,
      anon_sym_texture_cube_array,
      anon_sym_texture_multisampled_2d,
      anon_sym_texture_storage_1d,
      anon_sym_texture_storage_2d,
      anon_sym_texture_storage_2d_array,
      anon_sym_texture_storage_3d,
      anon_sym_vec2,
      anon_sym_vec3,
      anon_sym_vec4,
      anon_sym_mat2x2,
      anon_sym_mat2x3,
      anon_sym_mat2x4,
      anon_sym_mat3x2,
      anon_sym_mat3x3,
      anon_sym_mat3x4,
      anon_sym_mat4x2,
      anon_sym_mat4x3,
      anon_sym_mat4x4,
  [2335] = 26,
    ACTIONS(27), 1,
      aux_sym_preproc_import_token1,
    ACTIONS(115), 1,
      anon_sym_let,
    ACTIONS(117), 1,
      anon_sym_LPAREN,
    ACTIONS(119), 1,
      anon_sym__,
    ACTIONS(121), 1,
      anon_sym_var,
    ACTIONS(232), 1,
      sym_identifier,
    ACTIONS(234), 1,
      anon_sym_LBRACE,
    ACTIONS(238), 1,
      anon_sym_if,
    ACTIONS(240), 1,
      anon_sym_switch,
    ACTIONS(244), 1,
      anon_sym_loop,
    ACTIONS(246), 1,
      anon_sym_for,
    ACTIONS(248), 1,
      anon_sym_while,
    ACTIONS(252), 1,
      anon_sym_continue,
    ACTIONS(254), 1,
      anon_sym_return,
    ACTIONS(256), 1,
      anon_sym_discard,
    ACTIONS(289), 1,
      anon_sym_break,
    ACTIONS(297), 1,
      anon_sym_RBRACE,
    STATE(201), 1,
      sym_lhs_expression,
    STATE(239), 1,
      aux_sym_lhs_expression_repeat1,
    STATE(330), 1,
      sym_variable_declaration,
    STATE(393), 1,
      sym_break_if_statement,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(123), 2,
      anon_sym_AMP,
      anon_sym_STAR,
    ACTIONS(258), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(398), 3,
      sym_assignment_statement,
      sym_return_statement,
      sym_variable_statement,
    STATE(58), 15,
      sym__statement,
      sym_compound_statement,
      sym_if_statement,
      sym_switch_statement,
      sym_loop_statement,
      sym_for_statement,
      sym_while_statement,
      sym_break_statement,
      sym_continue_statement,
      sym_discard_statement,
      sym_increment_statement,
      sym_decrement_statement,
      sym_preproc_import,
      sym_preproc_ifdef_in_statement,
      aux_sym_compound_statement_repeat1,
  [2433] = 25,
    ACTIONS(27), 1,
      aux_sym_preproc_import_token1,
    ACTIONS(115), 1,
      anon_sym_let,
    ACTIONS(117), 1,
      anon_sym_LPAREN,
    ACTIONS(119), 1,
      anon_sym__,
    ACTIONS(121), 1,
      anon_sym_var,
    ACTIONS(232), 1,
      sym_identifier,
    ACTIONS(234), 1,
      anon_sym_LBRACE,
    ACTIONS(238), 1,
      anon_sym_if,
    ACTIONS(240), 1,
      anon_sym_switch,
    ACTIONS(244), 1,
      anon_sym_loop,
    ACTIONS(246), 1,
      anon_sym_for,
    ACTIONS(248), 1,
      anon_sym_while,
    ACTIONS(250), 1,
      anon_sym_break,
    ACTIONS(252), 1,
      anon_sym_continue,
    ACTIONS(254), 1,
      anon_sym_return,
    ACTIONS(256), 1,
      anon_sym_discard,
    ACTIONS(299), 1,
      anon_sym_RBRACE,
    STATE(201), 1,
      sym_lhs_expression,
    STATE(239), 1,
      aux_sym_lhs_expression_repeat1,
    STATE(330), 1,
      sym_variable_declaration,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(123), 2,
      anon_sym_AMP,
      anon_sym_STAR,
    ACTIONS(258), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(398), 3,
      sym_assignment_statement,
      sym_return_statement,
      sym_variable_statement,
    STATE(64), 15,
      sym__statement,
      sym_compound_statement,
      sym_if_statement,
      sym_switch_statement,
      sym_loop_statement,
      sym_for_statement,
      sym_while_statement,
      sym_break_statement,
      sym_continue_statement,
      sym_discard_statement,
      sym_increment_statement,
      sym_decrement_statement,
      sym_preproc_import,
      sym_preproc_ifdef_in_statement,
      aux_sym_compound_statement_repeat1,
  [2528] = 3,
    ACTIONS(303), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(301), 41,
      anon_sym_override,
      anon_sym_fn,
      sym_identifier,
      anon_sym_var,
      anon_sym_bool,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_f32,
      anon_sym_f16,
      anon_sym_array,
      anon_sym_ptr,
      anon_sym_sampler,
      anon_sym_sampler_comparison,
      anon_sym_texture_depth_2d,
      anon_sym_texture_depth_2d_array,
      anon_sym_texture_depth_cube,
      anon_sym_texture_depth_cube_array,
      anon_sym_texture_depth_multisampled_2d,
      anon_sym_texture_1d,
      anon_sym_texture_2d,
      anon_sym_texture_2d_array,
      anon_sym_texture_3d,
      anon_sym_texture_cube,
      anon_sym_texture_cube_array,
      anon_sym_texture_multisampled_2d,
      anon_sym_texture_storage_1d,
      anon_sym_texture_storage_2d,
      anon_sym_texture_storage_2d_array,
      anon_sym_texture_storage_3d,
      anon_sym_vec2,
      anon_sym_vec3,
      anon_sym_vec4,
      anon_sym_mat2x2,
      anon_sym_mat2x3,
      anon_sym_mat2x4,
      anon_sym_mat3x2,
      anon_sym_mat3x3,
      anon_sym_mat3x4,
      anon_sym_mat4x2,
      anon_sym_mat4x3,
      anon_sym_mat4x4,
  [2579] = 25,
    ACTIONS(27), 1,
      aux_sym_preproc_import_token1,
    ACTIONS(115), 1,
      anon_sym_let,
    ACTIONS(117), 1,
      anon_sym_LPAREN,
    ACTIONS(119), 1,
      anon_sym__,
    ACTIONS(121), 1,
      anon_sym_var,
    ACTIONS(232), 1,
      sym_identifier,
    ACTIONS(234), 1,
      anon_sym_LBRACE,
    ACTIONS(238), 1,
      anon_sym_if,
    ACTIONS(240), 1,
      anon_sym_switch,
    ACTIONS(244), 1,
      anon_sym_loop,
    ACTIONS(246), 1,
      anon_sym_for,
    ACTIONS(248), 1,
      anon_sym_while,
    ACTIONS(250), 1,
      anon_sym_break,
    ACTIONS(252), 1,
      anon_sym_continue,
    ACTIONS(254), 1,
      anon_sym_return,
    ACTIONS(256), 1,
      anon_sym_discard,
    ACTIONS(305), 1,
      anon_sym_RBRACE,
    STATE(201), 1,
      sym_lhs_expression,
    STATE(239), 1,
      aux_sym_lhs_expression_repeat1,
    STATE(330), 1,
      sym_variable_declaration,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(123), 2,
      anon_sym_AMP,
      anon_sym_STAR,
    ACTIONS(258), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(398), 3,
      sym_assignment_statement,
      sym_return_statement,
      sym_variable_statement,
    STATE(46), 15,
      sym__statement,
      sym_compound_statement,
      sym_if_statement,
      sym_switch_statement,
      sym_loop_statement,
      sym_for_statement,
      sym_while_statement,
      sym_break_statement,
      sym_continue_statement,
      sym_discard_statement,
      sym_increment_statement,
      sym_decrement_statement,
      sym_preproc_import,
      sym_preproc_ifdef_in_statement,
      aux_sym_compound_statement_repeat1,
  [2674] = 3,
    ACTIONS(309), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(307), 41,
      anon_sym_override,
      anon_sym_fn,
      sym_identifier,
      anon_sym_var,
      anon_sym_bool,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_f32,
      anon_sym_f16,
      anon_sym_array,
      anon_sym_ptr,
      anon_sym_sampler,
      anon_sym_sampler_comparison,
      anon_sym_texture_depth_2d,
      anon_sym_texture_depth_2d_array,
      anon_sym_texture_depth_cube,
      anon_sym_texture_depth_cube_array,
      anon_sym_texture_depth_multisampled_2d,
      anon_sym_texture_1d,
      anon_sym_texture_2d,
      anon_sym_texture_2d_array,
      anon_sym_texture_3d,
      anon_sym_texture_cube,
      anon_sym_texture_cube_array,
      anon_sym_texture_multisampled_2d,
      anon_sym_texture_storage_1d,
      anon_sym_texture_storage_2d,
      anon_sym_texture_storage_2d_array,
      anon_sym_texture_storage_3d,
      anon_sym_vec2,
      anon_sym_vec3,
      anon_sym_vec4,
      anon_sym_mat2x2,
      anon_sym_mat2x3,
      anon_sym_mat2x4,
      anon_sym_mat3x2,
      anon_sym_mat3x3,
      anon_sym_mat3x4,
      anon_sym_mat4x2,
      anon_sym_mat4x3,
      anon_sym_mat4x4,
  [2725] = 3,
    ACTIONS(313), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(311), 41,
      anon_sym_override,
      anon_sym_fn,
      sym_identifier,
      anon_sym_var,
      anon_sym_bool,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_f32,
      anon_sym_f16,
      anon_sym_array,
      anon_sym_ptr,
      anon_sym_sampler,
      anon_sym_sampler_comparison,
      anon_sym_texture_depth_2d,
      anon_sym_texture_depth_2d_array,
      anon_sym_texture_depth_cube,
      anon_sym_texture_depth_cube_array,
      anon_sym_texture_depth_multisampled_2d,
      anon_sym_texture_1d,
      anon_sym_texture_2d,
      anon_sym_texture_2d_array,
      anon_sym_texture_3d,
      anon_sym_texture_cube,
      anon_sym_texture_cube_array,
      anon_sym_texture_multisampled_2d,
      anon_sym_texture_storage_1d,
      anon_sym_texture_storage_2d,
      anon_sym_texture_storage_2d_array,
      anon_sym_texture_storage_3d,
      anon_sym_vec2,
      anon_sym_vec3,
      anon_sym_vec4,
      anon_sym_mat2x2,
      anon_sym_mat2x3,
      anon_sym_mat2x4,
      anon_sym_mat3x2,
      anon_sym_mat3x3,
      anon_sym_mat3x4,
      anon_sym_mat4x2,
      anon_sym_mat4x3,
      anon_sym_mat4x4,
  [2776] = 25,
    ACTIONS(27), 1,
      aux_sym_preproc_import_token1,
    ACTIONS(115), 1,
      anon_sym_let,
    ACTIONS(117), 1,
      anon_sym_LPAREN,
    ACTIONS(119), 1,
      anon_sym__,
    ACTIONS(121), 1,
      anon_sym_var,
    ACTIONS(232), 1,
      sym_identifier,
    ACTIONS(234), 1,
      anon_sym_LBRACE,
    ACTIONS(238), 1,
      anon_sym_if,
    ACTIONS(240), 1,
      anon_sym_switch,
    ACTIONS(244), 1,
      anon_sym_loop,
    ACTIONS(246), 1,
      anon_sym_for,
    ACTIONS(248), 1,
      anon_sym_while,
    ACTIONS(250), 1,
      anon_sym_break,
    ACTIONS(252), 1,
      anon_sym_continue,
    ACTIONS(254), 1,
      anon_sym_return,
    ACTIONS(256), 1,
      anon_sym_discard,
    ACTIONS(315), 1,
      aux_sym_preproc_ifdef_token3,
    STATE(201), 1,
      sym_lhs_expression,
    STATE(239), 1,
      aux_sym_lhs_expression_repeat1,
    STATE(330), 1,
      sym_variable_declaration,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(123), 2,
      anon_sym_AMP,
      anon_sym_STAR,
    ACTIONS(258), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(398), 3,
      sym_assignment_statement,
      sym_return_statement,
      sym_variable_statement,
    STATE(68), 15,
      sym__statement,
      sym_compound_statement,
      sym_if_statement,
      sym_switch_statement,
      sym_loop_statement,
      sym_for_statement,
      sym_while_statement,
      sym_break_statement,
      sym_continue_statement,
      sym_discard_statement,
      sym_increment_statement,
      sym_decrement_statement,
      sym_preproc_import,
      sym_preproc_ifdef_in_statement,
      aux_sym_compound_statement_repeat1,
  [2871] = 25,
    ACTIONS(27), 1,
      aux_sym_preproc_import_token1,
    ACTIONS(115), 1,
      anon_sym_let,
    ACTIONS(117), 1,
      anon_sym_LPAREN,
    ACTIONS(119), 1,
      anon_sym__,
    ACTIONS(121), 1,
      anon_sym_var,
    ACTIONS(232), 1,
      sym_identifier,
    ACTIONS(234), 1,
      anon_sym_LBRACE,
    ACTIONS(238), 1,
      anon_sym_if,
    ACTIONS(240), 1,
      anon_sym_switch,
    ACTIONS(244), 1,
      anon_sym_loop,
    ACTIONS(246), 1,
      anon_sym_for,
    ACTIONS(248), 1,
      anon_sym_while,
    ACTIONS(250), 1,
      anon_sym_break,
    ACTIONS(252), 1,
      anon_sym_continue,
    ACTIONS(254), 1,
      anon_sym_return,
    ACTIONS(256), 1,
      anon_sym_discard,
    ACTIONS(317), 1,
      aux_sym_preproc_ifdef_token3,
    STATE(201), 1,
      sym_lhs_expression,
    STATE(239), 1,
      aux_sym_lhs_expression_repeat1,
    STATE(330), 1,
      sym_variable_declaration,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(123), 2,
      anon_sym_AMP,
      anon_sym_STAR,
    ACTIONS(258), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(398), 3,
      sym_assignment_statement,
      sym_return_statement,
      sym_variable_statement,
    STATE(46), 15,
      sym__statement,
      sym_compound_statement,
      sym_if_statement,
      sym_switch_statement,
      sym_loop_statement,
      sym_for_statement,
      sym_while_statement,
      sym_break_statement,
      sym_continue_statement,
      sym_discard_statement,
      sym_increment_statement,
      sym_decrement_statement,
      sym_preproc_import,
      sym_preproc_ifdef_in_statement,
      aux_sym_compound_statement_repeat1,
  [2966] = 9,
    ACTIONS(47), 1,
      anon_sym_array,
    ACTIONS(49), 1,
      anon_sym_ptr,
    STATE(358), 1,
      sym_type_declaration,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(376), 2,
      sym__vec_prefix,
      sym__mat_prefix,
    ACTIONS(53), 4,
      anon_sym_texture_storage_1d,
      anon_sym_texture_storage_2d,
      anon_sym_texture_storage_2d_array,
      anon_sym_texture_storage_3d,
    ACTIONS(51), 7,
      anon_sym_texture_1d,
      anon_sym_texture_2d,
      anon_sym_texture_2d_array,
      anon_sym_texture_3d,
      anon_sym_texture_cube,
      anon_sym_texture_cube_array,
      anon_sym_texture_multisampled_2d,
    ACTIONS(127), 12,
      anon_sym_vec2,
      anon_sym_vec3,
      anon_sym_vec4,
      anon_sym_mat2x2,
      anon_sym_mat2x3,
      anon_sym_mat2x4,
      anon_sym_mat3x2,
      anon_sym_mat3x3,
      anon_sym_mat3x4,
      anon_sym_mat4x2,
      anon_sym_mat4x3,
      anon_sym_mat4x4,
    ACTIONS(45), 13,
      sym_identifier,
      anon_sym_bool,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_f32,
      anon_sym_f16,
      anon_sym_sampler,
      anon_sym_sampler_comparison,
      anon_sym_texture_depth_2d,
      anon_sym_texture_depth_2d_array,
      anon_sym_texture_depth_cube,
      anon_sym_texture_depth_cube_array,
      anon_sym_texture_depth_multisampled_2d,
  [3028] = 9,
    ACTIONS(47), 1,
      anon_sym_array,
    ACTIONS(49), 1,
      anon_sym_ptr,
    STATE(300), 1,
      sym_type_declaration,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(376), 2,
      sym__vec_prefix,
      sym__mat_prefix,
    ACTIONS(53), 4,
      anon_sym_texture_storage_1d,
      anon_sym_texture_storage_2d,
      anon_sym_texture_storage_2d_array,
      anon_sym_texture_storage_3d,
    ACTIONS(51), 7,
      anon_sym_texture_1d,
      anon_sym_texture_2d,
      anon_sym_texture_2d_array,
      anon_sym_texture_3d,
      anon_sym_texture_cube,
      anon_sym_texture_cube_array,
      anon_sym_texture_multisampled_2d,
    ACTIONS(127), 12,
      anon_sym_vec2,
      anon_sym_vec3,
      anon_sym_vec4,
      anon_sym_mat2x2,
      anon_sym_mat2x3,
      anon_sym_mat2x4,
      anon_sym_mat3x2,
      anon_sym_mat3x3,
      anon_sym_mat3x4,
      anon_sym_mat4x2,
      anon_sym_mat4x3,
      anon_sym_mat4x4,
    ACTIONS(45), 13,
      sym_identifier,
      anon_sym_bool,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_f32,
      anon_sym_f16,
      anon_sym_sampler,
      anon_sym_sampler_comparison,
      anon_sym_texture_depth_2d,
      anon_sym_texture_depth_2d_array,
      anon_sym_texture_depth_cube,
      anon_sym_texture_depth_cube_array,
      anon_sym_texture_depth_multisampled_2d,
  [3090] = 9,
    ACTIONS(47), 1,
      anon_sym_array,
    ACTIONS(49), 1,
      anon_sym_ptr,
    STATE(312), 1,
      sym_type_declaration,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(376), 2,
      sym__vec_prefix,
      sym__mat_prefix,
    ACTIONS(53), 4,
      anon_sym_texture_storage_1d,
      anon_sym_texture_storage_2d,
      anon_sym_texture_storage_2d_array,
      anon_sym_texture_storage_3d,
    ACTIONS(51), 7,
      anon_sym_texture_1d,
      anon_sym_texture_2d,
      anon_sym_texture_2d_array,
      anon_sym_texture_3d,
      anon_sym_texture_cube,
      anon_sym_texture_cube_array,
      anon_sym_texture_multisampled_2d,
    ACTIONS(127), 12,
      anon_sym_vec2,
      anon_sym_vec3,
      anon_sym_vec4,
      anon_sym_mat2x2,
      anon_sym_mat2x3,
      anon_sym_mat2x4,
      anon_sym_mat3x2,
      anon_sym_mat3x3,
      anon_sym_mat3x4,
      anon_sym_mat4x2,
      anon_sym_mat4x3,
      anon_sym_mat4x4,
    ACTIONS(45), 13,
      sym_identifier,
      anon_sym_bool,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_f32,
      anon_sym_f16,
      anon_sym_sampler,
      anon_sym_sampler_comparison,
      anon_sym_texture_depth_2d,
      anon_sym_texture_depth_2d_array,
      anon_sym_texture_depth_cube,
      anon_sym_texture_depth_cube_array,
      anon_sym_texture_depth_multisampled_2d,
  [3152] = 9,
    ACTIONS(47), 1,
      anon_sym_array,
    ACTIONS(49), 1,
      anon_sym_ptr,
    STATE(198), 1,
      sym_type_declaration,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(376), 2,
      sym__vec_prefix,
      sym__mat_prefix,
    ACTIONS(53), 4,
      anon_sym_texture_storage_1d,
      anon_sym_texture_storage_2d,
      anon_sym_texture_storage_2d_array,
      anon_sym_texture_storage_3d,
    ACTIONS(51), 7,
      anon_sym_texture_1d,
      anon_sym_texture_2d,
      anon_sym_texture_2d_array,
      anon_sym_texture_3d,
      anon_sym_texture_cube,
      anon_sym_texture_cube_array,
      anon_sym_texture_multisampled_2d,
    ACTIONS(127), 12,
      anon_sym_vec2,
      anon_sym_vec3,
      anon_sym_vec4,
      anon_sym_mat2x2,
      anon_sym_mat2x3,
      anon_sym_mat2x4,
      anon_sym_mat3x2,
      anon_sym_mat3x3,
      anon_sym_mat3x4,
      anon_sym_mat4x2,
      anon_sym_mat4x3,
      anon_sym_mat4x4,
    ACTIONS(45), 13,
      sym_identifier,
      anon_sym_bool,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_f32,
      anon_sym_f16,
      anon_sym_sampler,
      anon_sym_sampler_comparison,
      anon_sym_texture_depth_2d,
      anon_sym_texture_depth_2d_array,
      anon_sym_texture_depth_cube,
      anon_sym_texture_depth_cube_array,
      anon_sym_texture_depth_multisampled_2d,
  [3214] = 9,
    ACTIONS(47), 1,
      anon_sym_array,
    ACTIONS(49), 1,
      anon_sym_ptr,
    STATE(375), 1,
      sym_type_declaration,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(376), 2,
      sym__vec_prefix,
      sym__mat_prefix,
    ACTIONS(53), 4,
      anon_sym_texture_storage_1d,
      anon_sym_texture_storage_2d,
      anon_sym_texture_storage_2d_array,
      anon_sym_texture_storage_3d,
    ACTIONS(51), 7,
      anon_sym_texture_1d,
      anon_sym_texture_2d,
      anon_sym_texture_2d_array,
      anon_sym_texture_3d,
      anon_sym_texture_cube,
      anon_sym_texture_cube_array,
      anon_sym_texture_multisampled_2d,
    ACTIONS(127), 12,
      anon_sym_vec2,
      anon_sym_vec3,
      anon_sym_vec4,
      anon_sym_mat2x2,
      anon_sym_mat2x3,
      anon_sym_mat2x4,
      anon_sym_mat3x2,
      anon_sym_mat3x3,
      anon_sym_mat3x4,
      anon_sym_mat4x2,
      anon_sym_mat4x3,
      anon_sym_mat4x4,
    ACTIONS(45), 13,
      sym_identifier,
      anon_sym_bool,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_f32,
      anon_sym_f16,
      anon_sym_sampler,
      anon_sym_sampler_comparison,
      anon_sym_texture_depth_2d,
      anon_sym_texture_depth_2d_array,
      anon_sym_texture_depth_cube,
      anon_sym_texture_depth_cube_array,
      anon_sym_texture_depth_multisampled_2d,
  [3276] = 9,
    ACTIONS(47), 1,
      anon_sym_array,
    ACTIONS(49), 1,
      anon_sym_ptr,
    STATE(411), 1,
      sym_type_declaration,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(376), 2,
      sym__vec_prefix,
      sym__mat_prefix,
    ACTIONS(53), 4,
      anon_sym_texture_storage_1d,
      anon_sym_texture_storage_2d,
      anon_sym_texture_storage_2d_array,
      anon_sym_texture_storage_3d,
    ACTIONS(51), 7,
      anon_sym_texture_1d,
      anon_sym_texture_2d,
      anon_sym_texture_2d_array,
      anon_sym_texture_3d,
      anon_sym_texture_cube,
      anon_sym_texture_cube_array,
      anon_sym_texture_multisampled_2d,
    ACTIONS(127), 12,
      anon_sym_vec2,
      anon_sym_vec3,
      anon_sym_vec4,
      anon_sym_mat2x2,
      anon_sym_mat2x3,
      anon_sym_mat2x4,
      anon_sym_mat3x2,
      anon_sym_mat3x3,
      anon_sym_mat3x4,
      anon_sym_mat4x2,
      anon_sym_mat4x3,
      anon_sym_mat4x4,
    ACTIONS(45), 13,
      sym_identifier,
      anon_sym_bool,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_f32,
      anon_sym_f16,
      anon_sym_sampler,
      anon_sym_sampler_comparison,
      anon_sym_texture_depth_2d,
      anon_sym_texture_depth_2d_array,
      anon_sym_texture_depth_cube,
      anon_sym_texture_depth_cube_array,
      anon_sym_texture_depth_multisampled_2d,
  [3338] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(319), 14,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_AMP,
      anon_sym_STAR,
      aux_sym_preproc_import_token1,
      aux_sym_define_import_path_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_ifdef_token3,
      aux_sym_preproc_else_token1,
    ACTIONS(321), 21,
      anon_sym_let,
      anon_sym_override,
      anon_sym_type,
      anon_sym_virtual,
      anon_sym_fn,
      anon_sym_struct,
      sym_identifier,
      anon_sym__,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_fallthrough,
      anon_sym_loop,
      anon_sym_for,
      anon_sym_while,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_continuing,
      anon_sym_return,
      anon_sym_discard,
      anon_sym_var,
  [3382] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(323), 15,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_AMP,
      anon_sym_STAR,
      aux_sym_preproc_import_token1,
      aux_sym_define_import_path_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_ifdef_token3,
      aux_sym_preproc_else_token1,
    ACTIONS(325), 20,
      anon_sym_let,
      anon_sym_override,
      anon_sym_type,
      anon_sym_virtual,
      anon_sym_fn,
      anon_sym_struct,
      sym_identifier,
      anon_sym__,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_fallthrough,
      anon_sym_loop,
      anon_sym_for,
      anon_sym_while,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_continuing,
      anon_sym_return,
      anon_sym_discard,
      anon_sym_var,
  [3426] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(327), 15,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_AMP,
      anon_sym_STAR,
      aux_sym_preproc_import_token1,
      aux_sym_define_import_path_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_ifdef_token3,
      aux_sym_preproc_else_token1,
    ACTIONS(329), 20,
      anon_sym_let,
      anon_sym_override,
      anon_sym_type,
      anon_sym_virtual,
      anon_sym_fn,
      anon_sym_struct,
      sym_identifier,
      anon_sym__,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_fallthrough,
      anon_sym_loop,
      anon_sym_for,
      anon_sym_while,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_continuing,
      anon_sym_return,
      anon_sym_discard,
      anon_sym_var,
  [3470] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(331), 15,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_AMP,
      anon_sym_STAR,
      aux_sym_preproc_import_token1,
      aux_sym_define_import_path_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_ifdef_token3,
      aux_sym_preproc_else_token1,
    ACTIONS(333), 20,
      anon_sym_let,
      anon_sym_override,
      anon_sym_type,
      anon_sym_virtual,
      anon_sym_fn,
      anon_sym_struct,
      sym_identifier,
      anon_sym__,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_fallthrough,
      anon_sym_loop,
      anon_sym_for,
      anon_sym_while,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_continuing,
      anon_sym_return,
      anon_sym_discard,
      anon_sym_var,
  [3514] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(335), 15,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_AMP,
      anon_sym_STAR,
      aux_sym_preproc_import_token1,
      aux_sym_define_import_path_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_ifdef_token3,
      aux_sym_preproc_else_token1,
    ACTIONS(337), 20,
      anon_sym_let,
      anon_sym_override,
      anon_sym_type,
      anon_sym_virtual,
      anon_sym_fn,
      anon_sym_struct,
      sym_identifier,
      anon_sym__,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_fallthrough,
      anon_sym_loop,
      anon_sym_for,
      anon_sym_while,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_continuing,
      anon_sym_return,
      anon_sym_discard,
      anon_sym_var,
  [3558] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(339), 14,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_AMP,
      anon_sym_STAR,
      aux_sym_preproc_import_token1,
      aux_sym_define_import_path_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_ifdef_token3,
      aux_sym_preproc_else_token1,
    ACTIONS(341), 21,
      anon_sym_let,
      anon_sym_override,
      anon_sym_type,
      anon_sym_virtual,
      anon_sym_fn,
      anon_sym_struct,
      sym_identifier,
      anon_sym__,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_fallthrough,
      anon_sym_loop,
      anon_sym_for,
      anon_sym_while,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_continuing,
      anon_sym_return,
      anon_sym_discard,
      anon_sym_var,
  [3602] = 20,
    ACTIONS(9), 1,
      anon_sym_let,
    ACTIONS(11), 1,
      anon_sym_override,
    ACTIONS(13), 1,
      anon_sym_type,
    ACTIONS(15), 1,
      anon_sym_virtual,
    ACTIONS(17), 1,
      anon_sym_fn,
    ACTIONS(19), 1,
      anon_sym_struct,
    ACTIONS(21), 1,
      anon_sym_enable,
    ACTIONS(23), 1,
      anon_sym_AT,
    ACTIONS(25), 1,
      anon_sym_var,
    ACTIONS(27), 1,
      aux_sym_preproc_import_token1,
    ACTIONS(29), 1,
      aux_sym_define_import_path_token1,
    ACTIONS(343), 1,
      ts_builtin_sym_end,
    ACTIONS(345), 1,
      anon_sym_SEMI,
    STATE(324), 1,
      sym_variable_declaration,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(31), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(151), 2,
      sym_enable_directive,
      aux_sym_source_file_repeat1,
    STATE(226), 2,
      sym_attribute,
      aux_sym_global_variable_declaration_repeat1,
    STATE(417), 3,
      sym_global_variable_declaration,
      sym_global_constant_declaration,
      sym_type_alias_declaration,
    STATE(89), 7,
      sym__declaration,
      sym_function_declaration,
      sym_struct_declaration,
      sym_preproc_import,
      sym_define_import_path,
      sym_preproc_ifdef,
      aux_sym_source_file_repeat2,
  [3675] = 20,
    ACTIONS(9), 1,
      anon_sym_let,
    ACTIONS(11), 1,
      anon_sym_override,
    ACTIONS(13), 1,
      anon_sym_type,
    ACTIONS(15), 1,
      anon_sym_virtual,
    ACTIONS(17), 1,
      anon_sym_fn,
    ACTIONS(19), 1,
      anon_sym_struct,
    ACTIONS(23), 1,
      anon_sym_AT,
    ACTIONS(25), 1,
      anon_sym_var,
    ACTIONS(27), 1,
      aux_sym_preproc_import_token1,
    ACTIONS(29), 1,
      aux_sym_define_import_path_token1,
    ACTIONS(347), 1,
      anon_sym_SEMI,
    ACTIONS(349), 1,
      aux_sym_preproc_ifdef_token3,
    ACTIONS(351), 1,
      aux_sym_preproc_else_token1,
    STATE(324), 1,
      sym_variable_declaration,
    STATE(387), 1,
      sym_preproc_else,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(31), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(226), 2,
      sym_attribute,
      aux_sym_global_variable_declaration_repeat1,
    STATE(417), 3,
      sym_global_variable_declaration,
      sym_global_constant_declaration,
      sym_type_alias_declaration,
    STATE(84), 7,
      sym__declaration,
      sym_function_declaration,
      sym_struct_declaration,
      sym_preproc_import,
      sym_define_import_path,
      sym_preproc_ifdef,
      aux_sym_source_file_repeat2,
  [3747] = 20,
    ACTIONS(9), 1,
      anon_sym_let,
    ACTIONS(11), 1,
      anon_sym_override,
    ACTIONS(13), 1,
      anon_sym_type,
    ACTIONS(15), 1,
      anon_sym_virtual,
    ACTIONS(17), 1,
      anon_sym_fn,
    ACTIONS(19), 1,
      anon_sym_struct,
    ACTIONS(23), 1,
      anon_sym_AT,
    ACTIONS(25), 1,
      anon_sym_var,
    ACTIONS(27), 1,
      aux_sym_preproc_import_token1,
    ACTIONS(29), 1,
      aux_sym_define_import_path_token1,
    ACTIONS(351), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(353), 1,
      anon_sym_SEMI,
    ACTIONS(355), 1,
      aux_sym_preproc_ifdef_token3,
    STATE(324), 1,
      sym_variable_declaration,
    STATE(407), 1,
      sym_preproc_else,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(31), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(226), 2,
      sym_attribute,
      aux_sym_global_variable_declaration_repeat1,
    STATE(417), 3,
      sym_global_variable_declaration,
      sym_global_constant_declaration,
      sym_type_alias_declaration,
    STATE(82), 7,
      sym__declaration,
      sym_function_declaration,
      sym_struct_declaration,
      sym_preproc_import,
      sym_define_import_path,
      sym_preproc_ifdef,
      aux_sym_source_file_repeat2,
  [3819] = 18,
    ACTIONS(359), 1,
      anon_sym_SEMI,
    ACTIONS(362), 1,
      anon_sym_let,
    ACTIONS(365), 1,
      anon_sym_override,
    ACTIONS(368), 1,
      anon_sym_type,
    ACTIONS(371), 1,
      anon_sym_virtual,
    ACTIONS(374), 1,
      anon_sym_fn,
    ACTIONS(377), 1,
      anon_sym_struct,
    ACTIONS(380), 1,
      anon_sym_AT,
    ACTIONS(383), 1,
      anon_sym_var,
    ACTIONS(386), 1,
      aux_sym_preproc_import_token1,
    ACTIONS(389), 1,
      aux_sym_define_import_path_token1,
    STATE(324), 1,
      sym_variable_declaration,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(392), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(226), 2,
      sym_attribute,
      aux_sym_global_variable_declaration_repeat1,
    ACTIONS(357), 3,
      ts_builtin_sym_end,
      aux_sym_preproc_ifdef_token3,
      aux_sym_preproc_else_token1,
    STATE(417), 3,
      sym_global_variable_declaration,
      sym_global_constant_declaration,
      sym_type_alias_declaration,
    STATE(84), 7,
      sym__declaration,
      sym_function_declaration,
      sym_struct_declaration,
      sym_preproc_import,
      sym_define_import_path,
      sym_preproc_ifdef,
      aux_sym_source_file_repeat2,
  [3887] = 18,
    ACTIONS(9), 1,
      anon_sym_let,
    ACTIONS(11), 1,
      anon_sym_override,
    ACTIONS(13), 1,
      anon_sym_type,
    ACTIONS(15), 1,
      anon_sym_virtual,
    ACTIONS(17), 1,
      anon_sym_fn,
    ACTIONS(19), 1,
      anon_sym_struct,
    ACTIONS(23), 1,
      anon_sym_AT,
    ACTIONS(25), 1,
      anon_sym_var,
    ACTIONS(27), 1,
      aux_sym_preproc_import_token1,
    ACTIONS(29), 1,
      aux_sym_define_import_path_token1,
    ACTIONS(395), 1,
      anon_sym_SEMI,
    ACTIONS(397), 1,
      aux_sym_preproc_ifdef_token3,
    STATE(324), 1,
      sym_variable_declaration,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(31), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(226), 2,
      sym_attribute,
      aux_sym_global_variable_declaration_repeat1,
    STATE(417), 3,
      sym_global_variable_declaration,
      sym_global_constant_declaration,
      sym_type_alias_declaration,
    STATE(87), 7,
      sym__declaration,
      sym_function_declaration,
      sym_struct_declaration,
      sym_preproc_import,
      sym_define_import_path,
      sym_preproc_ifdef,
      aux_sym_source_file_repeat2,
  [3953] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(401), 12,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AMP,
      anon_sym_STAR,
      aux_sym_preproc_import_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_ifdef_token3,
      aux_sym_preproc_else_token1,
    ACTIONS(399), 15,
      anon_sym_let,
      sym_identifier,
      anon_sym__,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_fallthrough,
      anon_sym_loop,
      anon_sym_for,
      anon_sym_while,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_continuing,
      anon_sym_return,
      anon_sym_discard,
      anon_sym_var,
  [3989] = 18,
    ACTIONS(9), 1,
      anon_sym_let,
    ACTIONS(11), 1,
      anon_sym_override,
    ACTIONS(13), 1,
      anon_sym_type,
    ACTIONS(15), 1,
      anon_sym_virtual,
    ACTIONS(17), 1,
      anon_sym_fn,
    ACTIONS(19), 1,
      anon_sym_struct,
    ACTIONS(23), 1,
      anon_sym_AT,
    ACTIONS(25), 1,
      anon_sym_var,
    ACTIONS(27), 1,
      aux_sym_preproc_import_token1,
    ACTIONS(29), 1,
      aux_sym_define_import_path_token1,
    ACTIONS(347), 1,
      anon_sym_SEMI,
    ACTIONS(403), 1,
      aux_sym_preproc_ifdef_token3,
    STATE(324), 1,
      sym_variable_declaration,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(31), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(226), 2,
      sym_attribute,
      aux_sym_global_variable_declaration_repeat1,
    STATE(417), 3,
      sym_global_variable_declaration,
      sym_global_constant_declaration,
      sym_type_alias_declaration,
    STATE(84), 7,
      sym__declaration,
      sym_function_declaration,
      sym_struct_declaration,
      sym_preproc_import,
      sym_define_import_path,
      sym_preproc_ifdef,
      aux_sym_source_file_repeat2,
  [4055] = 18,
    ACTIONS(9), 1,
      anon_sym_let,
    ACTIONS(11), 1,
      anon_sym_override,
    ACTIONS(13), 1,
      anon_sym_type,
    ACTIONS(15), 1,
      anon_sym_virtual,
    ACTIONS(17), 1,
      anon_sym_fn,
    ACTIONS(19), 1,
      anon_sym_struct,
    ACTIONS(23), 1,
      anon_sym_AT,
    ACTIONS(25), 1,
      anon_sym_var,
    ACTIONS(27), 1,
      aux_sym_preproc_import_token1,
    ACTIONS(29), 1,
      aux_sym_define_import_path_token1,
    ACTIONS(343), 1,
      ts_builtin_sym_end,
    ACTIONS(347), 1,
      anon_sym_SEMI,
    STATE(324), 1,
      sym_variable_declaration,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(31), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(226), 2,
      sym_attribute,
      aux_sym_global_variable_declaration_repeat1,
    STATE(417), 3,
      sym_global_variable_declaration,
      sym_global_constant_declaration,
      sym_type_alias_declaration,
    STATE(84), 7,
      sym__declaration,
      sym_function_declaration,
      sym_struct_declaration,
      sym_preproc_import,
      sym_define_import_path,
      sym_preproc_ifdef,
      aux_sym_source_file_repeat2,
  [4121] = 18,
    ACTIONS(9), 1,
      anon_sym_let,
    ACTIONS(11), 1,
      anon_sym_override,
    ACTIONS(13), 1,
      anon_sym_type,
    ACTIONS(15), 1,
      anon_sym_virtual,
    ACTIONS(17), 1,
      anon_sym_fn,
    ACTIONS(19), 1,
      anon_sym_struct,
    ACTIONS(23), 1,
      anon_sym_AT,
    ACTIONS(25), 1,
      anon_sym_var,
    ACTIONS(27), 1,
      aux_sym_preproc_import_token1,
    ACTIONS(29), 1,
      aux_sym_define_import_path_token1,
    ACTIONS(347), 1,
      anon_sym_SEMI,
    ACTIONS(405), 1,
      ts_builtin_sym_end,
    STATE(324), 1,
      sym_variable_declaration,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(31), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(226), 2,
      sym_attribute,
      aux_sym_global_variable_declaration_repeat1,
    STATE(417), 3,
      sym_global_variable_declaration,
      sym_global_constant_declaration,
      sym_type_alias_declaration,
    STATE(84), 7,
      sym__declaration,
      sym_function_declaration,
      sym_struct_declaration,
      sym_preproc_import,
      sym_define_import_path,
      sym_preproc_ifdef,
      aux_sym_source_file_repeat2,
  [4187] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(409), 12,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AMP,
      anon_sym_STAR,
      aux_sym_preproc_import_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_ifdef_token3,
      aux_sym_preproc_else_token1,
    ACTIONS(407), 15,
      anon_sym_let,
      sym_identifier,
      anon_sym__,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_fallthrough,
      anon_sym_loop,
      anon_sym_for,
      anon_sym_while,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_continuing,
      anon_sym_return,
      anon_sym_discard,
      anon_sym_var,
  [4223] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(413), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(411), 21,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
  [4258] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(417), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(415), 21,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
  [4293] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(421), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(419), 21,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
  [4328] = 4,
    ACTIONS(427), 1,
      anon_sym_else,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(425), 10,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AMP,
      anon_sym_STAR,
      aux_sym_preproc_import_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_ifdef_token3,
      aux_sym_preproc_else_token1,
    ACTIONS(423), 15,
      anon_sym_let,
      sym_identifier,
      anon_sym__,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_fallthrough,
      anon_sym_loop,
      anon_sym_for,
      anon_sym_while,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_continuing,
      anon_sym_return,
      anon_sym_discard,
      anon_sym_var,
  [4365] = 4,
    ACTIONS(431), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(433), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(429), 20,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
  [4402] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(437), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(435), 20,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
  [4436] = 5,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(445), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(441), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(439), 18,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_RBRACK,
  [4474] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(449), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(447), 20,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
  [4508] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(453), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(451), 20,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
  [4542] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(457), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(455), 20,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
  [4576] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(461), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(459), 20,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
  [4610] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(465), 10,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AMP,
      anon_sym_STAR,
      aux_sym_preproc_import_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_ifdef_token3,
      aux_sym_preproc_else_token1,
    ACTIONS(463), 15,
      anon_sym_let,
      sym_identifier,
      anon_sym__,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_fallthrough,
      anon_sym_loop,
      anon_sym_for,
      anon_sym_while,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_continuing,
      anon_sym_return,
      anon_sym_discard,
      anon_sym_var,
  [4644] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(469), 10,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AMP,
      anon_sym_STAR,
      aux_sym_preproc_import_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_ifdef_token3,
      aux_sym_preproc_else_token1,
    ACTIONS(467), 15,
      anon_sym_let,
      sym_identifier,
      anon_sym__,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_fallthrough,
      anon_sym_loop,
      anon_sym_for,
      anon_sym_while,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_continuing,
      anon_sym_return,
      anon_sym_discard,
      anon_sym_var,
  [4678] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(473), 10,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AMP,
      anon_sym_STAR,
      aux_sym_preproc_import_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_ifdef_token3,
      aux_sym_preproc_else_token1,
    ACTIONS(471), 15,
      anon_sym_let,
      sym_identifier,
      anon_sym__,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_fallthrough,
      anon_sym_loop,
      anon_sym_for,
      anon_sym_while,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_continuing,
      anon_sym_return,
      anon_sym_discard,
      anon_sym_var,
  [4712] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(477), 10,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AMP,
      anon_sym_STAR,
      aux_sym_preproc_import_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_ifdef_token3,
      aux_sym_preproc_else_token1,
    ACTIONS(475), 15,
      anon_sym_let,
      sym_identifier,
      anon_sym__,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_fallthrough,
      anon_sym_loop,
      anon_sym_for,
      anon_sym_while,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_continuing,
      anon_sym_return,
      anon_sym_discard,
      anon_sym_var,
  [4746] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(481), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(479), 20,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
  [4780] = 9,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(445), 1,
      anon_sym_DOT,
    ACTIONS(489), 1,
      anon_sym_SLASH,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(483), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(485), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(487), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(441), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(439), 12,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_RBRACK,
  [4826] = 15,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(445), 1,
      anon_sym_DOT,
    ACTIONS(489), 1,
      anon_sym_SLASH,
    ACTIONS(493), 1,
      anon_sym_AMP_AMP,
    ACTIONS(495), 1,
      anon_sym_PIPE,
    ACTIONS(497), 1,
      anon_sym_CARET,
    ACTIONS(499), 1,
      anon_sym_AMP,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(483), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(485), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(487), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(491), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(501), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(503), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(439), 6,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_PIPE,
      anon_sym_RBRACK,
  [4884] = 14,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(445), 1,
      anon_sym_DOT,
    ACTIONS(489), 1,
      anon_sym_SLASH,
    ACTIONS(495), 1,
      anon_sym_PIPE,
    ACTIONS(497), 1,
      anon_sym_CARET,
    ACTIONS(499), 1,
      anon_sym_AMP,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(483), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(485), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(487), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(491), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(501), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(503), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(439), 7,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_RBRACK,
  [4940] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(507), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(505), 20,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
  [4974] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(511), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(509), 20,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
  [5008] = 7,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(445), 1,
      anon_sym_DOT,
    ACTIONS(489), 1,
      anon_sym_SLASH,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(487), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(441), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(439), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
  [5050] = 14,
    ACTIONS(441), 1,
      anon_sym_PIPE,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(445), 1,
      anon_sym_DOT,
    ACTIONS(489), 1,
      anon_sym_SLASH,
    ACTIONS(497), 1,
      anon_sym_CARET,
    ACTIONS(499), 1,
      anon_sym_AMP,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(483), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(485), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(487), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(491), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(501), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(503), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(439), 7,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_RBRACK,
  [5106] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(515), 10,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AMP,
      anon_sym_STAR,
      aux_sym_preproc_import_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_ifdef_token3,
      aux_sym_preproc_else_token1,
    ACTIONS(513), 15,
      anon_sym_let,
      sym_identifier,
      anon_sym__,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_fallthrough,
      anon_sym_loop,
      anon_sym_for,
      anon_sym_while,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_continuing,
      anon_sym_return,
      anon_sym_discard,
      anon_sym_var,
  [5140] = 13,
    ACTIONS(441), 1,
      anon_sym_PIPE,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(445), 1,
      anon_sym_DOT,
    ACTIONS(489), 1,
      anon_sym_SLASH,
    ACTIONS(499), 1,
      anon_sym_AMP,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(483), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(485), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(487), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(491), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(501), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(503), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(439), 8,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_RBRACK,
  [5194] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(519), 10,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AMP,
      anon_sym_STAR,
      aux_sym_preproc_import_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_ifdef_token3,
      aux_sym_preproc_else_token1,
    ACTIONS(517), 15,
      anon_sym_let,
      sym_identifier,
      anon_sym__,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_fallthrough,
      anon_sym_loop,
      anon_sym_for,
      anon_sym_while,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_continuing,
      anon_sym_return,
      anon_sym_discard,
      anon_sym_var,
  [5228] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(523), 10,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AMP,
      anon_sym_STAR,
      aux_sym_preproc_import_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_ifdef_token3,
      aux_sym_preproc_else_token1,
    ACTIONS(521), 15,
      anon_sym_let,
      sym_identifier,
      anon_sym__,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_fallthrough,
      anon_sym_loop,
      anon_sym_for,
      anon_sym_while,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_continuing,
      anon_sym_return,
      anon_sym_discard,
      anon_sym_var,
  [5262] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(527), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(525), 20,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
  [5296] = 12,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(445), 1,
      anon_sym_DOT,
    ACTIONS(489), 1,
      anon_sym_SLASH,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(441), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(483), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(485), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(487), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(491), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(501), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(503), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(439), 8,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_RBRACK,
  [5348] = 11,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(445), 1,
      anon_sym_DOT,
    ACTIONS(489), 1,
      anon_sym_SLASH,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(441), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(483), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(485), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(487), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(491), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(503), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(439), 10,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RBRACK,
  [5398] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(531), 10,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AMP,
      anon_sym_STAR,
      aux_sym_preproc_import_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_ifdef_token3,
      aux_sym_preproc_else_token1,
    ACTIONS(529), 15,
      anon_sym_let,
      sym_identifier,
      anon_sym__,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_fallthrough,
      anon_sym_loop,
      anon_sym_for,
      anon_sym_while,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_continuing,
      anon_sym_return,
      anon_sym_discard,
      anon_sym_var,
  [5432] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(535), 10,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AMP,
      anon_sym_STAR,
      aux_sym_preproc_import_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_ifdef_token3,
      aux_sym_preproc_else_token1,
    ACTIONS(533), 15,
      anon_sym_let,
      sym_identifier,
      anon_sym__,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_fallthrough,
      anon_sym_loop,
      anon_sym_for,
      anon_sym_while,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_continuing,
      anon_sym_return,
      anon_sym_discard,
      anon_sym_var,
  [5466] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(539), 10,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AMP,
      anon_sym_STAR,
      aux_sym_preproc_import_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_ifdef_token3,
      aux_sym_preproc_else_token1,
    ACTIONS(537), 15,
      anon_sym_let,
      sym_identifier,
      anon_sym__,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_fallthrough,
      anon_sym_loop,
      anon_sym_for,
      anon_sym_while,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_continuing,
      anon_sym_return,
      anon_sym_discard,
      anon_sym_var,
  [5500] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(543), 10,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AMP,
      anon_sym_STAR,
      aux_sym_preproc_import_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_ifdef_token3,
      aux_sym_preproc_else_token1,
    ACTIONS(541), 15,
      anon_sym_let,
      sym_identifier,
      anon_sym__,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_fallthrough,
      anon_sym_loop,
      anon_sym_for,
      anon_sym_while,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_continuing,
      anon_sym_return,
      anon_sym_discard,
      anon_sym_var,
  [5534] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(547), 10,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AMP,
      anon_sym_STAR,
      aux_sym_preproc_import_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_ifdef_token3,
      aux_sym_preproc_else_token1,
    ACTIONS(545), 15,
      anon_sym_let,
      sym_identifier,
      anon_sym__,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_fallthrough,
      anon_sym_loop,
      anon_sym_for,
      anon_sym_while,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_continuing,
      anon_sym_return,
      anon_sym_discard,
      anon_sym_var,
  [5568] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(551), 10,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AMP,
      anon_sym_STAR,
      aux_sym_preproc_import_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_ifdef_token3,
      aux_sym_preproc_else_token1,
    ACTIONS(549), 15,
      anon_sym_let,
      sym_identifier,
      anon_sym__,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_fallthrough,
      anon_sym_loop,
      anon_sym_for,
      anon_sym_while,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_continuing,
      anon_sym_return,
      anon_sym_discard,
      anon_sym_var,
  [5602] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(555), 10,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AMP,
      anon_sym_STAR,
      aux_sym_preproc_import_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_ifdef_token3,
      aux_sym_preproc_else_token1,
    ACTIONS(553), 15,
      anon_sym_let,
      sym_identifier,
      anon_sym__,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_fallthrough,
      anon_sym_loop,
      anon_sym_for,
      anon_sym_while,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_continuing,
      anon_sym_return,
      anon_sym_discard,
      anon_sym_var,
  [5636] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(559), 10,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AMP,
      anon_sym_STAR,
      aux_sym_preproc_import_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_ifdef_token3,
      aux_sym_preproc_else_token1,
    ACTIONS(557), 15,
      anon_sym_let,
      sym_identifier,
      anon_sym__,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_fallthrough,
      anon_sym_loop,
      anon_sym_for,
      anon_sym_while,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_continuing,
      anon_sym_return,
      anon_sym_discard,
      anon_sym_var,
  [5670] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(563), 10,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AMP,
      anon_sym_STAR,
      aux_sym_preproc_import_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_ifdef_token3,
      aux_sym_preproc_else_token1,
    ACTIONS(561), 15,
      anon_sym_let,
      sym_identifier,
      anon_sym__,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_fallthrough,
      anon_sym_loop,
      anon_sym_for,
      anon_sym_while,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_continuing,
      anon_sym_return,
      anon_sym_discard,
      anon_sym_var,
  [5704] = 8,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(445), 1,
      anon_sym_DOT,
    ACTIONS(489), 1,
      anon_sym_SLASH,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(485), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(487), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(441), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(439), 14,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_RBRACK,
  [5748] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(567), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(565), 20,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
  [5782] = 17,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(445), 1,
      anon_sym_DOT,
    ACTIONS(489), 1,
      anon_sym_SLASH,
    ACTIONS(493), 1,
      anon_sym_AMP_AMP,
    ACTIONS(495), 1,
      anon_sym_PIPE,
    ACTIONS(497), 1,
      anon_sym_CARET,
    ACTIONS(499), 1,
      anon_sym_AMP,
    ACTIONS(569), 1,
      anon_sym_COMMA,
    ACTIONS(571), 1,
      anon_sym_RPAREN,
    ACTIONS(573), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(483), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(485), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(487), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(491), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(501), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(503), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [5841] = 16,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(445), 1,
      anon_sym_DOT,
    ACTIONS(489), 1,
      anon_sym_SLASH,
    ACTIONS(493), 1,
      anon_sym_AMP_AMP,
    ACTIONS(495), 1,
      anon_sym_PIPE,
    ACTIONS(497), 1,
      anon_sym_CARET,
    ACTIONS(499), 1,
      anon_sym_AMP,
    ACTIONS(573), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(483), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(485), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(487), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(491), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(501), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(503), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(575), 2,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [5898] = 17,
    ACTIONS(234), 1,
      anon_sym_LBRACE,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(445), 1,
      anon_sym_DOT,
    ACTIONS(489), 1,
      anon_sym_SLASH,
    ACTIONS(493), 1,
      anon_sym_AMP_AMP,
    ACTIONS(495), 1,
      anon_sym_PIPE,
    ACTIONS(497), 1,
      anon_sym_CARET,
    ACTIONS(499), 1,
      anon_sym_AMP,
    ACTIONS(573), 1,
      anon_sym_PIPE_PIPE,
    STATE(116), 1,
      sym_compound_statement,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(483), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(485), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(487), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(491), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(501), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(503), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [5957] = 17,
    ACTIONS(234), 1,
      anon_sym_LBRACE,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(445), 1,
      anon_sym_DOT,
    ACTIONS(489), 1,
      anon_sym_SLASH,
    ACTIONS(493), 1,
      anon_sym_AMP_AMP,
    ACTIONS(495), 1,
      anon_sym_PIPE,
    ACTIONS(497), 1,
      anon_sym_CARET,
    ACTIONS(499), 1,
      anon_sym_AMP,
    ACTIONS(573), 1,
      anon_sym_PIPE_PIPE,
    STATE(94), 1,
      sym_compound_statement,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(483), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(485), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(487), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(491), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(501), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(503), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [6016] = 17,
    ACTIONS(168), 1,
      anon_sym_RPAREN,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(445), 1,
      anon_sym_DOT,
    ACTIONS(489), 1,
      anon_sym_SLASH,
    ACTIONS(493), 1,
      anon_sym_AMP_AMP,
    ACTIONS(495), 1,
      anon_sym_PIPE,
    ACTIONS(497), 1,
      anon_sym_CARET,
    ACTIONS(499), 1,
      anon_sym_AMP,
    ACTIONS(573), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(577), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(483), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(485), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(487), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(491), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(501), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(503), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [6075] = 16,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(445), 1,
      anon_sym_DOT,
    ACTIONS(489), 1,
      anon_sym_SLASH,
    ACTIONS(493), 1,
      anon_sym_AMP_AMP,
    ACTIONS(495), 1,
      anon_sym_PIPE,
    ACTIONS(497), 1,
      anon_sym_CARET,
    ACTIONS(499), 1,
      anon_sym_AMP,
    ACTIONS(573), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(579), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(483), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(485), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(487), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(491), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(501), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(503), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [6131] = 16,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(445), 1,
      anon_sym_DOT,
    ACTIONS(489), 1,
      anon_sym_SLASH,
    ACTIONS(493), 1,
      anon_sym_AMP_AMP,
    ACTIONS(495), 1,
      anon_sym_PIPE,
    ACTIONS(497), 1,
      anon_sym_CARET,
    ACTIONS(499), 1,
      anon_sym_AMP,
    ACTIONS(573), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(581), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(483), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(485), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(487), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(491), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(501), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(503), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [6187] = 16,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(445), 1,
      anon_sym_DOT,
    ACTIONS(489), 1,
      anon_sym_SLASH,
    ACTIONS(493), 1,
      anon_sym_AMP_AMP,
    ACTIONS(495), 1,
      anon_sym_PIPE,
    ACTIONS(497), 1,
      anon_sym_CARET,
    ACTIONS(499), 1,
      anon_sym_AMP,
    ACTIONS(573), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(583), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(483), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(485), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(487), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(491), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(501), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(503), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [6243] = 16,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(445), 1,
      anon_sym_DOT,
    ACTIONS(489), 1,
      anon_sym_SLASH,
    ACTIONS(493), 1,
      anon_sym_AMP_AMP,
    ACTIONS(495), 1,
      anon_sym_PIPE,
    ACTIONS(497), 1,
      anon_sym_CARET,
    ACTIONS(499), 1,
      anon_sym_AMP,
    ACTIONS(573), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(585), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(483), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(485), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(487), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(491), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(501), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(503), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [6299] = 16,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(445), 1,
      anon_sym_DOT,
    ACTIONS(489), 1,
      anon_sym_SLASH,
    ACTIONS(493), 1,
      anon_sym_AMP_AMP,
    ACTIONS(495), 1,
      anon_sym_PIPE,
    ACTIONS(497), 1,
      anon_sym_CARET,
    ACTIONS(499), 1,
      anon_sym_AMP,
    ACTIONS(573), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(587), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(483), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(485), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(487), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(491), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(501), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(503), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [6355] = 16,
    ACTIONS(109), 1,
      anon_sym_SEMI,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(445), 1,
      anon_sym_DOT,
    ACTIONS(489), 1,
      anon_sym_SLASH,
    ACTIONS(493), 1,
      anon_sym_AMP_AMP,
    ACTIONS(495), 1,
      anon_sym_PIPE,
    ACTIONS(497), 1,
      anon_sym_CARET,
    ACTIONS(499), 1,
      anon_sym_AMP,
    ACTIONS(573), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(483), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(485), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(487), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(491), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(501), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(503), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [6411] = 16,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(445), 1,
      anon_sym_DOT,
    ACTIONS(489), 1,
      anon_sym_SLASH,
    ACTIONS(493), 1,
      anon_sym_AMP_AMP,
    ACTIONS(495), 1,
      anon_sym_PIPE,
    ACTIONS(497), 1,
      anon_sym_CARET,
    ACTIONS(499), 1,
      anon_sym_AMP,
    ACTIONS(573), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(589), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(483), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(485), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(487), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(491), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(501), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(503), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [6467] = 16,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(445), 1,
      anon_sym_DOT,
    ACTIONS(489), 1,
      anon_sym_SLASH,
    ACTIONS(493), 1,
      anon_sym_AMP_AMP,
    ACTIONS(495), 1,
      anon_sym_PIPE,
    ACTIONS(497), 1,
      anon_sym_CARET,
    ACTIONS(499), 1,
      anon_sym_AMP,
    ACTIONS(573), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(591), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(483), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(485), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(487), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(491), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(501), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(503), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [6523] = 16,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(445), 1,
      anon_sym_DOT,
    ACTIONS(489), 1,
      anon_sym_SLASH,
    ACTIONS(493), 1,
      anon_sym_AMP_AMP,
    ACTIONS(495), 1,
      anon_sym_PIPE,
    ACTIONS(497), 1,
      anon_sym_CARET,
    ACTIONS(499), 1,
      anon_sym_AMP,
    ACTIONS(573), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(593), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(483), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(485), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(487), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(491), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(501), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(503), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [6579] = 16,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(445), 1,
      anon_sym_DOT,
    ACTIONS(489), 1,
      anon_sym_SLASH,
    ACTIONS(493), 1,
      anon_sym_AMP_AMP,
    ACTIONS(495), 1,
      anon_sym_PIPE,
    ACTIONS(497), 1,
      anon_sym_CARET,
    ACTIONS(499), 1,
      anon_sym_AMP,
    ACTIONS(573), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(595), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(483), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(485), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(487), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(491), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(501), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(503), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [6635] = 16,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(445), 1,
      anon_sym_DOT,
    ACTIONS(489), 1,
      anon_sym_SLASH,
    ACTIONS(493), 1,
      anon_sym_AMP_AMP,
    ACTIONS(495), 1,
      anon_sym_PIPE,
    ACTIONS(497), 1,
      anon_sym_CARET,
    ACTIONS(499), 1,
      anon_sym_AMP,
    ACTIONS(573), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(597), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(483), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(485), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(487), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(491), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(501), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(503), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [6691] = 16,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(445), 1,
      anon_sym_DOT,
    ACTIONS(489), 1,
      anon_sym_SLASH,
    ACTIONS(493), 1,
      anon_sym_AMP_AMP,
    ACTIONS(495), 1,
      anon_sym_PIPE,
    ACTIONS(497), 1,
      anon_sym_CARET,
    ACTIONS(499), 1,
      anon_sym_AMP,
    ACTIONS(573), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(599), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(483), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(485), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(487), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(491), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(501), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(503), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [6747] = 16,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(445), 1,
      anon_sym_DOT,
    ACTIONS(489), 1,
      anon_sym_SLASH,
    ACTIONS(493), 1,
      anon_sym_AMP_AMP,
    ACTIONS(495), 1,
      anon_sym_PIPE,
    ACTIONS(497), 1,
      anon_sym_CARET,
    ACTIONS(499), 1,
      anon_sym_AMP,
    ACTIONS(573), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(601), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(483), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(485), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(487), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(491), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(501), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(503), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [6803] = 16,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(445), 1,
      anon_sym_DOT,
    ACTIONS(489), 1,
      anon_sym_SLASH,
    ACTIONS(493), 1,
      anon_sym_AMP_AMP,
    ACTIONS(495), 1,
      anon_sym_PIPE,
    ACTIONS(497), 1,
      anon_sym_CARET,
    ACTIONS(499), 1,
      anon_sym_AMP,
    ACTIONS(573), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(603), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(483), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(485), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(487), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(491), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(501), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(503), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [6859] = 4,
    ACTIONS(607), 1,
      anon_sym_enable,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(151), 2,
      sym_enable_directive,
      aux_sym_source_file_repeat1,
    ACTIONS(605), 14,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_let,
      anon_sym_override,
      anon_sym_type,
      anon_sym_virtual,
      anon_sym_fn,
      anon_sym_struct,
      anon_sym_AT,
      anon_sym_var,
      aux_sym_preproc_import_token1,
      aux_sym_define_import_path_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
  [6887] = 3,
    STATE(360), 1,
      sym_texel_format,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(610), 16,
      anon_sym_rgba8unorm,
      anon_sym_rgba8snorm,
      anon_sym_rgba8uint,
      anon_sym_rgba8sint,
      anon_sym_rgba16uint,
      anon_sym_rgba16sint,
      anon_sym_rgba16float,
      anon_sym_r32uint,
      anon_sym_r32sint,
      anon_sym_r32float,
      anon_sym_rg32uint,
      anon_sym_rg32sint,
      anon_sym_rg32float,
      anon_sym_rgba32uint,
      anon_sym_rgba32sint,
      anon_sym_rgba32float,
  [6913] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(612), 16,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_let,
      anon_sym_override,
      anon_sym_type,
      anon_sym_virtual,
      anon_sym_fn,
      anon_sym_struct,
      anon_sym_AT,
      anon_sym_var,
      aux_sym_preproc_import_token1,
      aux_sym_define_import_path_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_ifdef_token3,
      aux_sym_preproc_else_token1,
  [6936] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(614), 16,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_let,
      anon_sym_override,
      anon_sym_type,
      anon_sym_virtual,
      anon_sym_fn,
      anon_sym_struct,
      anon_sym_AT,
      anon_sym_var,
      aux_sym_preproc_import_token1,
      aux_sym_define_import_path_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_ifdef_token3,
      aux_sym_preproc_else_token1,
  [6959] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(616), 16,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_let,
      anon_sym_override,
      anon_sym_type,
      anon_sym_virtual,
      anon_sym_fn,
      anon_sym_struct,
      anon_sym_AT,
      anon_sym_var,
      aux_sym_preproc_import_token1,
      aux_sym_define_import_path_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_ifdef_token3,
      aux_sym_preproc_else_token1,
  [6982] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(618), 16,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_let,
      anon_sym_override,
      anon_sym_type,
      anon_sym_virtual,
      anon_sym_fn,
      anon_sym_struct,
      anon_sym_AT,
      anon_sym_var,
      aux_sym_preproc_import_token1,
      aux_sym_define_import_path_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_ifdef_token3,
      aux_sym_preproc_else_token1,
  [7005] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(620), 16,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_let,
      anon_sym_override,
      anon_sym_type,
      anon_sym_virtual,
      anon_sym_fn,
      anon_sym_struct,
      anon_sym_AT,
      anon_sym_var,
      aux_sym_preproc_import_token1,
      aux_sym_define_import_path_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_ifdef_token3,
      aux_sym_preproc_else_token1,
  [7028] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(622), 16,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_let,
      anon_sym_override,
      anon_sym_type,
      anon_sym_virtual,
      anon_sym_fn,
      anon_sym_struct,
      anon_sym_AT,
      anon_sym_var,
      aux_sym_preproc_import_token1,
      aux_sym_define_import_path_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_ifdef_token3,
      aux_sym_preproc_else_token1,
  [7051] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(624), 16,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_let,
      anon_sym_override,
      anon_sym_type,
      anon_sym_virtual,
      anon_sym_fn,
      anon_sym_struct,
      anon_sym_AT,
      anon_sym_var,
      aux_sym_preproc_import_token1,
      aux_sym_define_import_path_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_ifdef_token3,
      aux_sym_preproc_else_token1,
  [7074] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(626), 16,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_let,
      anon_sym_override,
      anon_sym_type,
      anon_sym_virtual,
      anon_sym_fn,
      anon_sym_struct,
      anon_sym_AT,
      anon_sym_var,
      aux_sym_preproc_import_token1,
      aux_sym_define_import_path_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_ifdef_token3,
      aux_sym_preproc_else_token1,
  [7097] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(628), 16,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_let,
      anon_sym_override,
      anon_sym_type,
      anon_sym_virtual,
      anon_sym_fn,
      anon_sym_struct,
      anon_sym_AT,
      anon_sym_var,
      aux_sym_preproc_import_token1,
      aux_sym_define_import_path_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_ifdef_token3,
      aux_sym_preproc_else_token1,
  [7120] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(630), 16,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_let,
      anon_sym_override,
      anon_sym_type,
      anon_sym_virtual,
      anon_sym_fn,
      anon_sym_struct,
      anon_sym_AT,
      anon_sym_var,
      aux_sym_preproc_import_token1,
      aux_sym_define_import_path_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_ifdef_token3,
      aux_sym_preproc_else_token1,
  [7143] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(632), 16,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_let,
      anon_sym_override,
      anon_sym_type,
      anon_sym_virtual,
      anon_sym_fn,
      anon_sym_struct,
      anon_sym_AT,
      anon_sym_var,
      aux_sym_preproc_import_token1,
      aux_sym_define_import_path_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_ifdef_token3,
      aux_sym_preproc_else_token1,
  [7166] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(634), 16,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_let,
      anon_sym_override,
      anon_sym_type,
      anon_sym_virtual,
      anon_sym_fn,
      anon_sym_struct,
      anon_sym_AT,
      anon_sym_var,
      aux_sym_preproc_import_token1,
      aux_sym_define_import_path_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_ifdef_token3,
      aux_sym_preproc_else_token1,
  [7189] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(636), 16,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_let,
      anon_sym_override,
      anon_sym_type,
      anon_sym_virtual,
      anon_sym_fn,
      anon_sym_struct,
      anon_sym_AT,
      anon_sym_var,
      aux_sym_preproc_import_token1,
      aux_sym_define_import_path_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_ifdef_token3,
      aux_sym_preproc_else_token1,
  [7212] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(638), 16,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_let,
      anon_sym_override,
      anon_sym_type,
      anon_sym_virtual,
      anon_sym_fn,
      anon_sym_struct,
      anon_sym_AT,
      anon_sym_var,
      aux_sym_preproc_import_token1,
      aux_sym_define_import_path_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_ifdef_token3,
      aux_sym_preproc_else_token1,
  [7235] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(640), 16,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_let,
      anon_sym_override,
      anon_sym_type,
      anon_sym_virtual,
      anon_sym_fn,
      anon_sym_struct,
      anon_sym_AT,
      anon_sym_var,
      aux_sym_preproc_import_token1,
      aux_sym_define_import_path_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_ifdef_token3,
      aux_sym_preproc_else_token1,
  [7258] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(642), 16,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_let,
      anon_sym_override,
      anon_sym_type,
      anon_sym_virtual,
      anon_sym_fn,
      anon_sym_struct,
      anon_sym_AT,
      anon_sym_var,
      aux_sym_preproc_import_token1,
      aux_sym_define_import_path_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_ifdef_token3,
      aux_sym_preproc_else_token1,
  [7281] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(644), 16,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_let,
      anon_sym_override,
      anon_sym_type,
      anon_sym_virtual,
      anon_sym_fn,
      anon_sym_struct,
      anon_sym_AT,
      anon_sym_var,
      aux_sym_preproc_import_token1,
      aux_sym_define_import_path_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_ifdef_token3,
      aux_sym_preproc_else_token1,
  [7304] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(646), 16,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_let,
      anon_sym_override,
      anon_sym_type,
      anon_sym_virtual,
      anon_sym_fn,
      anon_sym_struct,
      anon_sym_AT,
      anon_sym_var,
      aux_sym_preproc_import_token1,
      aux_sym_define_import_path_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_ifdef_token3,
      aux_sym_preproc_else_token1,
  [7327] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(648), 16,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_let,
      anon_sym_override,
      anon_sym_type,
      anon_sym_virtual,
      anon_sym_fn,
      anon_sym_struct,
      anon_sym_AT,
      anon_sym_var,
      aux_sym_preproc_import_token1,
      aux_sym_define_import_path_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_ifdef_token3,
      aux_sym_preproc_else_token1,
  [7350] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(650), 15,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_let,
      anon_sym_override,
      anon_sym_type,
      anon_sym_virtual,
      anon_sym_fn,
      anon_sym_struct,
      anon_sym_enable,
      anon_sym_AT,
      anon_sym_var,
      aux_sym_preproc_import_token1,
      aux_sym_define_import_path_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
  [7372] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(652), 15,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT,
      sym_identifier,
      anon_sym_GT,
      aux_sym_preproc_import_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_ifdef_token3,
      aux_sym_preproc_else_token1,
  [7394] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(654), 15,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT,
      sym_identifier,
      anon_sym_GT,
      aux_sym_preproc_import_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_ifdef_token3,
      aux_sym_preproc_else_token1,
  [7416] = 5,
    ACTIONS(658), 1,
      anon_sym_LBRACK,
    ACTIONS(660), 1,
      anon_sym_DOT,
    STATE(202), 1,
      sym_postfix_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(656), 12,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [7444] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(431), 15,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT,
      sym_identifier,
      anon_sym_GT,
      aux_sym_preproc_import_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_ifdef_token3,
      aux_sym_preproc_else_token1,
  [7466] = 5,
    ACTIONS(664), 1,
      anon_sym_LBRACK,
    ACTIONS(666), 1,
      anon_sym_DOT,
    STATE(182), 1,
      sym_postfix_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(662), 12,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [7494] = 5,
    ACTIONS(658), 1,
      anon_sym_LBRACK,
    ACTIONS(660), 1,
      anon_sym_DOT,
    STATE(193), 1,
      sym_postfix_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(662), 12,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [7522] = 5,
    ACTIONS(658), 1,
      anon_sym_LBRACK,
    ACTIONS(660), 1,
      anon_sym_DOT,
    STATE(200), 1,
      sym_postfix_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(668), 12,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [7550] = 6,
    ACTIONS(431), 1,
      anon_sym_LPAREN,
    ACTIONS(658), 1,
      anon_sym_LBRACK,
    ACTIONS(660), 1,
      anon_sym_DOT,
    STATE(202), 1,
      sym_postfix_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(656), 11,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [7580] = 5,
    ACTIONS(658), 1,
      anon_sym_LBRACK,
    ACTIONS(660), 1,
      anon_sym_DOT,
    STATE(204), 1,
      sym_postfix_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(670), 12,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [7608] = 5,
    ACTIONS(658), 1,
      anon_sym_LBRACK,
    ACTIONS(660), 1,
      anon_sym_DOT,
    STATE(194), 1,
      sym_postfix_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(672), 12,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [7636] = 12,
    ACTIONS(23), 1,
      anon_sym_AT,
    ACTIONS(27), 1,
      aux_sym_preproc_import_token1,
    ACTIONS(674), 1,
      sym_identifier,
    ACTIONS(678), 1,
      aux_sym_preproc_ifdef_token3,
    ACTIONS(680), 1,
      aux_sym_preproc_else_token1,
    STATE(191), 1,
      aux_sym_preproc_ifdef_in_struct_declaration_repeat1,
    STATE(208), 1,
      sym_variable_identifier_declaration,
    STATE(408), 1,
      sym_preproc_else_in_struct_declaration,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(676), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(237), 2,
      sym_attribute,
      aux_sym_global_variable_declaration_repeat1,
    STATE(219), 3,
      sym_struct_member,
      sym_preproc_import,
      sym_preproc_ifdef_in_struct_declaration,
  [7678] = 5,
    ACTIONS(658), 1,
      anon_sym_LBRACK,
    ACTIONS(660), 1,
      anon_sym_DOT,
    STATE(199), 1,
      sym_postfix_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(682), 12,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [7706] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(684), 15,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT,
      sym_identifier,
      anon_sym_GT,
      aux_sym_preproc_import_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_ifdef_token3,
      aux_sym_preproc_else_token1,
  [7728] = 5,
    ACTIONS(664), 1,
      anon_sym_LBRACK,
    ACTIONS(666), 1,
      anon_sym_DOT,
    STATE(178), 1,
      sym_postfix_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(686), 12,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [7756] = 3,
    STATE(189), 1,
      sym_postfix_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(686), 14,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_DOT,
  [7780] = 3,
    STATE(190), 1,
      sym_postfix_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(662), 14,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_DOT,
  [7804] = 3,
    STATE(193), 1,
      sym_postfix_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(662), 14,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_DOT,
  [7828] = 3,
    STATE(194), 1,
      sym_postfix_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(672), 14,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_DOT,
  [7852] = 12,
    ACTIONS(23), 1,
      anon_sym_AT,
    ACTIONS(27), 1,
      aux_sym_preproc_import_token1,
    ACTIONS(674), 1,
      sym_identifier,
    ACTIONS(680), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(688), 1,
      aux_sym_preproc_ifdef_token3,
    STATE(192), 1,
      aux_sym_preproc_ifdef_in_struct_declaration_repeat1,
    STATE(208), 1,
      sym_variable_identifier_declaration,
    STATE(372), 1,
      sym_preproc_else_in_struct_declaration,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(676), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(237), 2,
      sym_attribute,
      aux_sym_global_variable_declaration_repeat1,
    STATE(219), 3,
      sym_struct_member,
      sym_preproc_import,
      sym_preproc_ifdef_in_struct_declaration,
  [7894] = 10,
    ACTIONS(690), 1,
      sym_identifier,
    ACTIONS(693), 1,
      anon_sym_AT,
    ACTIONS(696), 1,
      aux_sym_preproc_import_token1,
    STATE(192), 1,
      aux_sym_preproc_ifdef_in_struct_declaration_repeat1,
    STATE(208), 1,
      sym_variable_identifier_declaration,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(699), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    ACTIONS(702), 2,
      aux_sym_preproc_ifdef_token3,
      aux_sym_preproc_else_token1,
    STATE(237), 2,
      sym_attribute,
      aux_sym_global_variable_declaration_repeat1,
    STATE(219), 3,
      sym_struct_member,
      sym_preproc_import,
      sym_preproc_ifdef_in_struct_declaration,
  [7931] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(672), 14,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_DOT,
  [7952] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(704), 14,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_DOT,
  [7973] = 10,
    ACTIONS(23), 1,
      anon_sym_AT,
    ACTIONS(27), 1,
      aux_sym_preproc_import_token1,
    ACTIONS(674), 1,
      sym_identifier,
    ACTIONS(706), 1,
      aux_sym_preproc_ifdef_token3,
    STATE(196), 1,
      aux_sym_preproc_ifdef_in_struct_declaration_repeat1,
    STATE(208), 1,
      sym_variable_identifier_declaration,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(676), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(237), 2,
      sym_attribute,
      aux_sym_global_variable_declaration_repeat1,
    STATE(219), 3,
      sym_struct_member,
      sym_preproc_import,
      sym_preproc_ifdef_in_struct_declaration,
  [8009] = 10,
    ACTIONS(23), 1,
      anon_sym_AT,
    ACTIONS(27), 1,
      aux_sym_preproc_import_token1,
    ACTIONS(674), 1,
      sym_identifier,
    ACTIONS(708), 1,
      aux_sym_preproc_ifdef_token3,
    STATE(192), 1,
      aux_sym_preproc_ifdef_in_struct_declaration_repeat1,
    STATE(208), 1,
      sym_variable_identifier_declaration,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(676), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(237), 2,
      sym_attribute,
      aux_sym_global_variable_declaration_repeat1,
    STATE(219), 3,
      sym_struct_member,
      sym_preproc_import,
      sym_preproc_ifdef_in_struct_declaration,
  [8045] = 11,
    ACTIONS(23), 1,
      anon_sym_AT,
    ACTIONS(27), 1,
      aux_sym_preproc_import_token1,
    ACTIONS(674), 1,
      sym_identifier,
    STATE(203), 1,
      aux_sym__struct_declaration_content_repeat1,
    STATE(208), 1,
      sym_variable_identifier_declaration,
    STATE(308), 1,
      sym_struct_member,
    STATE(362), 1,
      sym__struct_declaration_content,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(676), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(225), 2,
      sym_preproc_import,
      sym_preproc_ifdef_in_struct_declaration,
    STATE(237), 2,
      sym_attribute,
      aux_sym_global_variable_declaration_repeat1,
  [8083] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(710), 12,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_AT,
      sym_identifier,
      aux_sym_preproc_import_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_ifdef_token3,
      aux_sym_preproc_else_token1,
  [8102] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(670), 12,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [8121] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(682), 12,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [8140] = 6,
    ACTIONS(712), 1,
      anon_sym_EQ,
    ACTIONS(716), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(718), 1,
      anon_sym_DASH_DASH,
    STATE(26), 1,
      sym_compound_assignment_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(714), 8,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [8167] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(668), 12,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [8186] = 10,
    ACTIONS(23), 1,
      anon_sym_AT,
    ACTIONS(27), 1,
      aux_sym_preproc_import_token1,
    ACTIONS(674), 1,
      sym_identifier,
    STATE(205), 1,
      aux_sym__struct_declaration_content_repeat1,
    STATE(208), 1,
      sym_variable_identifier_declaration,
    STATE(336), 1,
      sym_struct_member,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(676), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(228), 2,
      sym_preproc_import,
      sym_preproc_ifdef_in_struct_declaration,
    STATE(237), 2,
      sym_attribute,
      aux_sym_global_variable_declaration_repeat1,
  [8221] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(720), 12,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [8240] = 9,
    ACTIONS(722), 1,
      sym_identifier,
    ACTIONS(725), 1,
      anon_sym_AT,
    ACTIONS(728), 1,
      aux_sym_preproc_import_token1,
    STATE(208), 1,
      sym_variable_identifier_declaration,
    STATE(353), 1,
      sym_struct_member,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(731), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(237), 2,
      sym_attribute,
      aux_sym_global_variable_declaration_repeat1,
    STATE(205), 3,
      sym_preproc_import,
      sym_preproc_ifdef_in_struct_declaration,
      aux_sym__struct_declaration_content_repeat1,
  [8273] = 7,
    ACTIONS(39), 1,
      sym_int_literal,
    STATE(289), 1,
      sym_const_literal,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(41), 2,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token2,
    ACTIONS(734), 2,
      anon_sym_LBRACE,
      anon_sym_COLON,
    ACTIONS(736), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(93), 2,
      sym_float_literal,
      sym_bool_literal,
  [8300] = 7,
    ACTIONS(39), 1,
      sym_int_literal,
    STATE(289), 1,
      sym_const_literal,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(41), 2,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token2,
    ACTIONS(736), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(738), 2,
      anon_sym_LBRACE,
      anon_sym_COLON,
    STATE(93), 2,
      sym_float_literal,
      sym_bool_literal,
  [8327] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(740), 9,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_AT,
      sym_identifier,
      aux_sym_preproc_import_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_ifdef_token3,
      aux_sym_preproc_else_token1,
  [8343] = 9,
    ACTIONS(23), 1,
      anon_sym_AT,
    ACTIONS(674), 1,
      sym_identifier,
    ACTIONS(742), 1,
      anon_sym_RPAREN,
    STATE(224), 1,
      aux_sym_parameter_list_repeat1,
    STATE(341), 1,
      sym_parameter,
    STATE(342), 1,
      sym_variable_identifier_declaration,
    STATE(412), 1,
      sym_parameter_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(236), 2,
      sym_attribute,
      aux_sym_global_variable_declaration_repeat1,
  [8373] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(744), 9,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_AT,
      sym_identifier,
      aux_sym_preproc_import_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_ifdef_token3,
      aux_sym_preproc_else_token1,
  [8389] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(746), 9,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_AT,
      sym_identifier,
      aux_sym_preproc_import_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_ifdef_token3,
      aux_sym_preproc_else_token1,
  [8405] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(748), 9,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_AT,
      sym_identifier,
      aux_sym_preproc_import_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_ifdef_token3,
      aux_sym_preproc_else_token1,
  [8421] = 7,
    ACTIONS(39), 1,
      sym_int_literal,
    STATE(264), 1,
      sym_const_literal,
    STATE(277), 1,
      sym_case_selectors,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(41), 2,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token2,
    ACTIONS(736), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(93), 2,
      sym_float_literal,
      sym_bool_literal,
  [8447] = 9,
    ACTIONS(23), 1,
      anon_sym_AT,
    ACTIONS(674), 1,
      sym_identifier,
    ACTIONS(750), 1,
      anon_sym_RPAREN,
    STATE(224), 1,
      aux_sym_parameter_list_repeat1,
    STATE(341), 1,
      sym_parameter,
    STATE(342), 1,
      sym_variable_identifier_declaration,
    STATE(424), 1,
      sym_parameter_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(236), 2,
      sym_attribute,
      aux_sym_global_variable_declaration_repeat1,
  [8477] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(752), 9,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_AT,
      sym_identifier,
      aux_sym_preproc_import_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_ifdef_token3,
      aux_sym_preproc_else_token1,
  [8493] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(754), 9,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_AT,
      sym_identifier,
      aux_sym_preproc_import_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_ifdef_token3,
      aux_sym_preproc_else_token1,
  [8509] = 9,
    ACTIONS(23), 1,
      anon_sym_AT,
    ACTIONS(674), 1,
      sym_identifier,
    ACTIONS(756), 1,
      anon_sym_RPAREN,
    STATE(224), 1,
      aux_sym_parameter_list_repeat1,
    STATE(341), 1,
      sym_parameter,
    STATE(342), 1,
      sym_variable_identifier_declaration,
    STATE(403), 1,
      sym_parameter_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(236), 2,
      sym_attribute,
      aux_sym_global_variable_declaration_repeat1,
  [8539] = 6,
    ACTIONS(39), 1,
      sym_int_literal,
    STATE(289), 1,
      sym_const_literal,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(41), 2,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token2,
    ACTIONS(736), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(93), 2,
      sym_float_literal,
      sym_bool_literal,
  [8562] = 3,
    ACTIONS(760), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(758), 7,
      anon_sym_AT,
      sym_identifier,
      aux_sym_preproc_import_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_ifdef_token3,
      aux_sym_preproc_else_token1,
  [8579] = 7,
    ACTIONS(762), 1,
      sym_identifier,
    ACTIONS(765), 1,
      anon_sym_AT,
    STATE(220), 1,
      aux_sym_parameter_list_repeat1,
    STATE(342), 1,
      sym_variable_identifier_declaration,
    STATE(378), 1,
      sym_parameter,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(236), 2,
      sym_attribute,
      aux_sym_global_variable_declaration_repeat1,
  [8603] = 6,
    ACTIONS(768), 1,
      sym_identifier,
    ACTIONS(770), 1,
      sym_int_literal,
    STATE(222), 1,
      aux_sym_attribute_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(41), 2,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token2,
    STATE(333), 2,
      sym__literal_or_identifier,
      sym_float_literal,
  [8625] = 6,
    ACTIONS(772), 1,
      sym_identifier,
    ACTIONS(774), 1,
      sym_int_literal,
    STATE(227), 1,
      aux_sym_attribute_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(41), 2,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token2,
    STATE(340), 2,
      sym__literal_or_identifier,
      sym_float_literal,
  [8647] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(702), 7,
      anon_sym_AT,
      sym_identifier,
      aux_sym_preproc_import_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_ifdef_token3,
      aux_sym_preproc_else_token1,
  [8661] = 7,
    ACTIONS(23), 1,
      anon_sym_AT,
    ACTIONS(674), 1,
      sym_identifier,
    STATE(220), 1,
      aux_sym_parameter_list_repeat1,
    STATE(328), 1,
      sym_parameter,
    STATE(342), 1,
      sym_variable_identifier_declaration,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(236), 2,
      sym_attribute,
      aux_sym_global_variable_declaration_repeat1,
  [8685] = 4,
    ACTIONS(778), 1,
      anon_sym_COMMA,
    ACTIONS(780), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(776), 5,
      anon_sym_AT,
      sym_identifier,
      aux_sym_preproc_import_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
  [8703] = 7,
    ACTIONS(23), 1,
      anon_sym_AT,
    ACTIONS(25), 1,
      anon_sym_var,
    ACTIONS(782), 1,
      anon_sym_override,
    ACTIONS(784), 1,
      anon_sym_fn,
    STATE(307), 1,
      sym_variable_declaration,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(49), 2,
      sym_attribute,
      aux_sym_global_variable_declaration_repeat1,
  [8727] = 6,
    ACTIONS(786), 1,
      sym_identifier,
    ACTIONS(789), 1,
      sym_int_literal,
    STATE(227), 1,
      aux_sym_attribute_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(792), 2,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token2,
    STATE(363), 2,
      sym__literal_or_identifier,
      sym_float_literal,
  [8749] = 4,
    ACTIONS(795), 1,
      anon_sym_COMMA,
    ACTIONS(797), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(776), 5,
      anon_sym_AT,
      sym_identifier,
      aux_sym_preproc_import_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
  [8767] = 6,
    ACTIONS(117), 1,
      anon_sym_LPAREN,
    ACTIONS(799), 1,
      sym_identifier,
    STATE(239), 1,
      aux_sym_lhs_expression_repeat1,
    STATE(386), 1,
      sym_lhs_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(123), 2,
      anon_sym_AMP,
      anon_sym_STAR,
  [8788] = 3,
    ACTIONS(803), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(801), 5,
      anon_sym_AT,
      sym_identifier,
      aux_sym_preproc_import_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
  [8803] = 6,
    ACTIONS(23), 1,
      anon_sym_AT,
    ACTIONS(805), 1,
      sym_identifier,
    ACTIONS(807), 1,
      anon_sym_fn,
    STATE(329), 1,
      sym_variable_identifier_declaration,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(258), 2,
      sym_attribute,
      aux_sym_global_variable_declaration_repeat1,
  [8824] = 6,
    ACTIONS(117), 1,
      anon_sym_LPAREN,
    ACTIONS(799), 1,
      sym_identifier,
    STATE(239), 1,
      aux_sym_lhs_expression_repeat1,
    STATE(348), 1,
      sym_lhs_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(123), 2,
      anon_sym_AMP,
      anon_sym_STAR,
  [8845] = 3,
    STATE(357), 1,
      sym_address_space,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(809), 5,
      anon_sym_function,
      anon_sym_private,
      anon_sym_workgroup,
      anon_sym_uniform,
      anon_sym_storage,
  [8860] = 3,
    ACTIONS(797), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(801), 5,
      anon_sym_AT,
      sym_identifier,
      aux_sym_preproc_import_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
  [8875] = 3,
    STATE(317), 1,
      sym_address_space,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(809), 5,
      anon_sym_function,
      anon_sym_private,
      anon_sym_workgroup,
      anon_sym_uniform,
      anon_sym_storage,
  [8890] = 5,
    ACTIONS(23), 1,
      anon_sym_AT,
    ACTIONS(674), 1,
      sym_identifier,
    STATE(327), 1,
      sym_variable_identifier_declaration,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(49), 2,
      sym_attribute,
      aux_sym_global_variable_declaration_repeat1,
  [8908] = 5,
    ACTIONS(23), 1,
      anon_sym_AT,
    ACTIONS(674), 1,
      sym_identifier,
    STATE(210), 1,
      sym_variable_identifier_declaration,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(49), 2,
      sym_attribute,
      aux_sym_global_variable_declaration_repeat1,
  [8926] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(813), 1,
      sym_line_comment,
    ACTIONS(815), 1,
      anon_sym_LF,
    ACTIONS(817), 1,
      anon_sym_COLON_COLON,
    STATE(238), 1,
      aux_sym_import_path_repeat1,
    ACTIONS(811), 2,
      sym_identifier,
      anon_sym_as,
  [8946] = 5,
    ACTIONS(820), 1,
      sym_identifier,
    ACTIONS(822), 1,
      anon_sym_LPAREN,
    STATE(242), 1,
      aux_sym_lhs_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(824), 2,
      anon_sym_AMP,
      anon_sym_STAR,
  [8964] = 4,
    ACTIONS(828), 1,
      anon_sym_RPAREN,
    ACTIONS(830), 1,
      sym_int_literal,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(826), 3,
      sym_identifier,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token2,
  [8980] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(813), 1,
      sym_line_comment,
    ACTIONS(834), 1,
      anon_sym_LF,
    ACTIONS(836), 1,
      anon_sym_COLON_COLON,
    STATE(238), 1,
      aux_sym_import_path_repeat1,
    ACTIONS(832), 2,
      sym_identifier,
      anon_sym_as,
  [9000] = 4,
    STATE(242), 1,
      aux_sym_lhs_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(838), 2,
      anon_sym_LPAREN,
      sym_identifier,
    ACTIONS(840), 2,
      anon_sym_AMP,
      anon_sym_STAR,
  [9016] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(801), 5,
      anon_sym_AT,
      sym_identifier,
      aux_sym_preproc_import_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
  [9028] = 5,
    ACTIONS(234), 1,
      anon_sym_LBRACE,
    ACTIONS(843), 1,
      anon_sym_if,
    STATE(125), 1,
      sym_else_statement,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(124), 2,
      sym_compound_statement,
      sym_if_statement,
  [9046] = 5,
    ACTIONS(845), 1,
      anon_sym_RBRACE,
    ACTIONS(847), 1,
      anon_sym_case,
    ACTIONS(849), 1,
      anon_sym_default,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(246), 2,
      sym_switch_body,
      aux_sym_switch_statement_repeat1,
  [9064] = 5,
    ACTIONS(851), 1,
      anon_sym_RBRACE,
    ACTIONS(853), 1,
      anon_sym_case,
    ACTIONS(856), 1,
      anon_sym_default,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(246), 2,
      sym_switch_body,
      aux_sym_switch_statement_repeat1,
  [9082] = 4,
    ACTIONS(830), 1,
      sym_int_literal,
    ACTIONS(859), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(826), 3,
      sym_identifier,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token2,
  [9098] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(813), 1,
      sym_line_comment,
    ACTIONS(836), 1,
      anon_sym_COLON_COLON,
    ACTIONS(863), 1,
      anon_sym_LF,
    STATE(241), 1,
      aux_sym_import_path_repeat1,
    ACTIONS(861), 2,
      sym_identifier,
      anon_sym_as,
  [9118] = 5,
    ACTIONS(234), 1,
      anon_sym_LBRACE,
    ACTIONS(865), 1,
      anon_sym_DASH_GT,
    STATE(168), 1,
      sym_compound_statement,
    STATE(316), 1,
      sym_function_return_type_declaration,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [9135] = 5,
    ACTIONS(234), 1,
      anon_sym_LBRACE,
    ACTIONS(865), 1,
      anon_sym_DASH_GT,
    STATE(157), 1,
      sym_compound_statement,
    STATE(325), 1,
      sym_function_return_type_declaration,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [9152] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(867), 4,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_f32,
      anon_sym_f16,
  [9163] = 5,
    ACTIONS(234), 1,
      anon_sym_LBRACE,
    ACTIONS(865), 1,
      anon_sym_DASH_GT,
    STATE(159), 1,
      sym_compound_statement,
    STATE(306), 1,
      sym_function_return_type_declaration,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [9180] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(813), 1,
      sym_line_comment,
    ACTIONS(869), 1,
      sym_identifier,
    ACTIONS(871), 1,
      anon_sym_LF,
    ACTIONS(873), 1,
      anon_sym_as,
    STATE(390), 1,
      sym_alias,
  [9199] = 4,
    ACTIONS(875), 1,
      anon_sym_read,
    STATE(349), 1,
      sym_access_mode,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(877), 2,
      anon_sym_write,
      anon_sym_read_write,
  [9214] = 3,
    ACTIONS(830), 1,
      sym_int_literal,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(826), 3,
      sym_identifier,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token2,
  [9227] = 5,
    ACTIONS(234), 1,
      anon_sym_LBRACE,
    ACTIONS(865), 1,
      anon_sym_DASH_GT,
    STATE(169), 1,
      sym_compound_statement,
    STATE(298), 1,
      sym_function_return_type_declaration,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [9244] = 4,
    ACTIONS(875), 1,
      anon_sym_read,
    STATE(385), 1,
      sym_access_mode,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(877), 2,
      anon_sym_write,
      anon_sym_read_write,
  [9259] = 4,
    ACTIONS(23), 1,
      anon_sym_AT,
    ACTIONS(879), 1,
      anon_sym_fn,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(49), 2,
      sym_attribute,
      aux_sym_global_variable_declaration_repeat1,
  [9274] = 4,
    ACTIONS(847), 1,
      anon_sym_case,
    ACTIONS(849), 1,
      anon_sym_default,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(245), 2,
      sym_switch_body,
      aux_sym_switch_statement_repeat1,
  [9289] = 4,
    ACTIONS(23), 1,
      anon_sym_AT,
    ACTIONS(881), 1,
      anon_sym_fn,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(49), 2,
      sym_attribute,
      aux_sym_global_variable_declaration_repeat1,
  [9304] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(813), 1,
      sym_line_comment,
    ACTIONS(815), 1,
      anon_sym_LF,
    ACTIONS(811), 3,
      sym_identifier,
      anon_sym_COLON_COLON,
      anon_sym_as,
  [9319] = 4,
    ACTIONS(875), 1,
      anon_sym_read,
    STATE(379), 1,
      sym_access_mode,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(877), 2,
      anon_sym_write,
      anon_sym_read_write,
  [9334] = 5,
    ACTIONS(234), 1,
      anon_sym_LBRACE,
    ACTIONS(865), 1,
      anon_sym_DASH_GT,
    STATE(161), 1,
      sym_compound_statement,
    STATE(320), 1,
      sym_function_return_type_declaration,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [9351] = 4,
    ACTIONS(883), 1,
      anon_sym_COMMA,
    STATE(268), 1,
      aux_sym_case_selectors_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(885), 2,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [9366] = 4,
    ACTIONS(23), 1,
      anon_sym_AT,
    ACTIONS(784), 1,
      anon_sym_fn,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(260), 2,
      sym_attribute,
      aux_sym_global_variable_declaration_repeat1,
  [9381] = 5,
    ACTIONS(234), 1,
      anon_sym_LBRACE,
    ACTIONS(865), 1,
      anon_sym_DASH_GT,
    STATE(165), 1,
      sym_compound_statement,
    STATE(310), 1,
      sym_function_return_type_declaration,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [9398] = 5,
    ACTIONS(887), 1,
      sym_identifier,
    ACTIONS(889), 1,
      anon_sym_LT,
    STATE(321), 1,
      sym_variable_qualifier,
    STATE(322), 1,
      sym_variable_identifier_declaration,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [9415] = 4,
    ACTIONS(891), 1,
      anon_sym_COMMA,
    STATE(269), 1,
      aux_sym_case_selectors_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(734), 2,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [9430] = 4,
    ACTIONS(893), 1,
      anon_sym_COMMA,
    STATE(269), 1,
      aux_sym_case_selectors_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(896), 2,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [9445] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(898), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [9455] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(900), 3,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [9465] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(902), 3,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [9475] = 4,
    ACTIONS(904), 1,
      anon_sym_LBRACE,
    ACTIONS(906), 1,
      anon_sym_COLON,
    STATE(280), 1,
      sym_case_compound_statement,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [9489] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(908), 3,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [9499] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(910), 3,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [9509] = 4,
    ACTIONS(912), 1,
      anon_sym_SEMI,
    ACTIONS(914), 1,
      anon_sym_EQ,
    ACTIONS(916), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [9523] = 4,
    ACTIONS(904), 1,
      anon_sym_LBRACE,
    ACTIONS(918), 1,
      anon_sym_COLON,
    STATE(270), 1,
      sym_case_compound_statement,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [9537] = 4,
    ACTIONS(916), 1,
      anon_sym_COLON,
    ACTIONS(920), 1,
      anon_sym_SEMI,
    ACTIONS(922), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [9551] = 3,
    ACTIONS(916), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(924), 2,
      anon_sym_SEMI,
      anon_sym_EQ,
  [9563] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(926), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [9573] = 3,
    ACTIONS(916), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(928), 2,
      anon_sym_SEMI,
      anon_sym_EQ,
  [9585] = 3,
    ACTIONS(932), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(930), 2,
      anon_sym_AT,
      sym_identifier,
  [9597] = 4,
    ACTIONS(934), 1,
      anon_sym_LPAREN,
    ACTIONS(936), 1,
      anon_sym_LT,
    STATE(96), 1,
      sym_argument_list_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [9611] = 3,
    ACTIONS(938), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(930), 2,
      anon_sym_AT,
      sym_identifier,
  [9623] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(813), 1,
      sym_line_comment,
    ACTIONS(940), 1,
      anon_sym_COMMA,
    ACTIONS(942), 1,
      anon_sym_LF,
    STATE(296), 1,
      aux_sym_preproc_import_repeat1,
  [9639] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(944), 3,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [9649] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(946), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [9659] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(948), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [9669] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(896), 3,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [9679] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(813), 1,
      sym_line_comment,
    ACTIONS(950), 1,
      anon_sym_COMMA,
    ACTIONS(953), 1,
      anon_sym_LF,
    STATE(290), 1,
      aux_sym_preproc_import_repeat1,
  [9695] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(955), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [9705] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(957), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [9715] = 4,
    ACTIONS(863), 1,
      anon_sym_LPAREN,
    ACTIONS(959), 1,
      anon_sym_COLON_COLON,
    STATE(294), 1,
      aux_sym_import_path_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [9729] = 4,
    ACTIONS(834), 1,
      anon_sym_LPAREN,
    ACTIONS(959), 1,
      anon_sym_COLON_COLON,
    STATE(295), 1,
      aux_sym_import_path_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [9743] = 4,
    ACTIONS(815), 1,
      anon_sym_LPAREN,
    ACTIONS(961), 1,
      anon_sym_COLON_COLON,
    STATE(295), 1,
      aux_sym_import_path_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [9757] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(813), 1,
      sym_line_comment,
    ACTIONS(940), 1,
      anon_sym_COMMA,
    ACTIONS(964), 1,
      anon_sym_LF,
    STATE(290), 1,
      aux_sym_preproc_import_repeat1,
  [9773] = 3,
    ACTIONS(966), 1,
      sym_identifier,
    STATE(384), 1,
      sym_variable_identifier_declaration,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [9784] = 3,
    ACTIONS(234), 1,
      anon_sym_LBRACE,
    STATE(154), 1,
      sym_compound_statement,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [9795] = 3,
    ACTIONS(916), 1,
      anon_sym_COLON,
    ACTIONS(968), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [9806] = 3,
    ACTIONS(970), 1,
      anon_sym_COMMA,
    ACTIONS(972), 1,
      anon_sym_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [9817] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(930), 2,
      anon_sym_AT,
      sym_identifier,
  [9826] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(924), 2,
      anon_sym_SEMI,
      anon_sym_EQ,
  [9835] = 3,
    ACTIONS(974), 1,
      anon_sym_COMMA,
    ACTIONS(976), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [9846] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(978), 2,
      sym_identifier,
      sym_int_literal,
  [9855] = 3,
    ACTIONS(267), 1,
      anon_sym_RPAREN,
    ACTIONS(980), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [9866] = 3,
    ACTIONS(234), 1,
      anon_sym_LBRACE,
    STATE(164), 1,
      sym_compound_statement,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [9877] = 3,
    ACTIONS(982), 1,
      anon_sym_SEMI,
    ACTIONS(984), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [9888] = 3,
    ACTIONS(780), 1,
      anon_sym_RBRACE,
    ACTIONS(986), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [9899] = 3,
    ACTIONS(234), 1,
      anon_sym_LBRACE,
    STATE(128), 1,
      sym_compound_statement,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [9910] = 3,
    ACTIONS(234), 1,
      anon_sym_LBRACE,
    STATE(156), 1,
      sym_compound_statement,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [9921] = 3,
    ACTIONS(912), 1,
      anon_sym_SEMI,
    ACTIONS(914), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [9932] = 3,
    ACTIONS(988), 1,
      anon_sym_COMMA,
    ACTIONS(990), 1,
      anon_sym_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [9943] = 3,
    ACTIONS(992), 1,
      sym_identifier,
    STATE(442), 1,
      sym_import_path,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [9954] = 3,
    ACTIONS(994), 1,
      sym_identifier,
    STATE(404), 1,
      sym_import_path,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [9965] = 3,
    ACTIONS(904), 1,
      anon_sym_LBRACE,
    STATE(270), 1,
      sym_case_compound_statement,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [9976] = 3,
    ACTIONS(234), 1,
      anon_sym_LBRACE,
    STATE(166), 1,
      sym_compound_statement,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [9987] = 3,
    ACTIONS(996), 1,
      anon_sym_COMMA,
    ACTIONS(998), 1,
      anon_sym_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [9998] = 3,
    ACTIONS(994), 1,
      sym_identifier,
    STATE(401), 1,
      sym_import_path,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10009] = 3,
    ACTIONS(1000), 1,
      anon_sym_SEMI,
    ACTIONS(1002), 1,
      anon_sym_if,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10020] = 3,
    ACTIONS(234), 1,
      anon_sym_LBRACE,
    STATE(163), 1,
      sym_compound_statement,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10031] = 3,
    ACTIONS(1004), 1,
      sym_identifier,
    STATE(302), 1,
      sym_variable_identifier_declaration,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10042] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(928), 2,
      anon_sym_SEMI,
      anon_sym_EQ,
  [10051] = 3,
    ACTIONS(934), 1,
      anon_sym_LPAREN,
    STATE(96), 1,
      sym_argument_list_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10062] = 3,
    ACTIONS(1006), 1,
      anon_sym_SEMI,
    ACTIONS(1008), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10073] = 3,
    ACTIONS(234), 1,
      anon_sym_LBRACE,
    STATE(155), 1,
      sym_compound_statement,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10084] = 3,
    ACTIONS(904), 1,
      anon_sym_LBRACE,
    STATE(288), 1,
      sym_case_compound_statement,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10095] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1010), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [10104] = 3,
    ACTIONS(938), 1,
      anon_sym_RPAREN,
    ACTIONS(1012), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10115] = 3,
    ACTIONS(920), 1,
      anon_sym_SEMI,
    ACTIONS(922), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10126] = 3,
    ACTIONS(1014), 1,
      anon_sym_SEMI,
    ACTIONS(1016), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10137] = 3,
    ACTIONS(35), 1,
      anon_sym_LPAREN,
    STATE(111), 1,
      sym_parenthesized_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10148] = 3,
    ACTIONS(1018), 1,
      sym_identifier,
    STATE(380), 1,
      sym_variable_identifier_declaration,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10159] = 3,
    ACTIONS(1020), 1,
      anon_sym_COMMA,
    ACTIONS(1022), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10170] = 3,
    ACTIONS(916), 1,
      anon_sym_COLON,
    ACTIONS(1024), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10181] = 3,
    ACTIONS(1026), 1,
      anon_sym_LBRACE,
    STATE(367), 1,
      sym_continuing_compound_statement,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10192] = 3,
    ACTIONS(797), 1,
      anon_sym_RBRACE,
    ACTIONS(1028), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10203] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1030), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [10212] = 3,
    ACTIONS(992), 1,
      sym_identifier,
    STATE(253), 1,
      sym_import_path,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10223] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(815), 2,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
  [10232] = 3,
    ACTIONS(859), 1,
      anon_sym_RPAREN,
    ACTIONS(1032), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10243] = 3,
    ACTIONS(1034), 1,
      anon_sym_COMMA,
    ACTIONS(1036), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10254] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1038), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [10263] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(813), 1,
      sym_line_comment,
    ACTIONS(953), 1,
      anon_sym_LF,
    ACTIONS(1040), 1,
      anon_sym_COMMA,
  [10276] = 3,
    ACTIONS(1042), 1,
      sym_identifier,
    STATE(311), 1,
      sym_variable_identifier_declaration,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10287] = 2,
    ACTIONS(1044), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10295] = 2,
    ACTIONS(1046), 1,
      anon_sym_LT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10303] = 2,
    ACTIONS(1048), 1,
      anon_sym_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10311] = 2,
    ACTIONS(1050), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10319] = 2,
    ACTIONS(1052), 1,
      anon_sym_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10327] = 2,
    ACTIONS(1054), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10335] = 2,
    ACTIONS(1056), 1,
      anon_sym_LT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10343] = 2,
    ACTIONS(803), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10351] = 2,
    ACTIONS(1058), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10359] = 3,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(813), 1,
      sym_line_comment,
    ACTIONS(1060), 1,
      anon_sym_LF,
  [10369] = 2,
    ACTIONS(1062), 1,
      anon_sym_LT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10377] = 2,
    ACTIONS(1064), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10385] = 2,
    ACTIONS(1066), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10393] = 2,
    ACTIONS(972), 1,
      anon_sym_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10401] = 2,
    ACTIONS(1068), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10409] = 2,
    ACTIONS(1070), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10417] = 2,
    ACTIONS(1072), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10425] = 2,
    ACTIONS(1074), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10433] = 2,
    ACTIONS(1076), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10441] = 2,
    ACTIONS(1078), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10449] = 2,
    ACTIONS(1080), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10457] = 2,
    ACTIONS(1082), 1,
      anon_sym_LT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10465] = 2,
    ACTIONS(1084), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10473] = 2,
    ACTIONS(1086), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10481] = 2,
    ACTIONS(1088), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10489] = 2,
    ACTIONS(1090), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10497] = 2,
    ACTIONS(1092), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10505] = 2,
    ACTIONS(1094), 1,
      aux_sym_preproc_ifdef_token3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10513] = 2,
    ACTIONS(1096), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10521] = 2,
    ACTIONS(1098), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10529] = 2,
    ACTIONS(1100), 1,
      anon_sym_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10537] = 2,
    ACTIONS(936), 1,
      anon_sym_LT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10545] = 2,
    ACTIONS(1102), 1,
      aux_sym_preproc_ifdef_token3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10553] = 2,
    ACTIONS(1104), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10561] = 2,
    ACTIONS(1106), 1,
      anon_sym_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10569] = 2,
    ACTIONS(1024), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10577] = 2,
    ACTIONS(1108), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10585] = 2,
    ACTIONS(599), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10593] = 2,
    ACTIONS(1110), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10601] = 2,
    ACTIONS(968), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10609] = 2,
    ACTIONS(990), 1,
      anon_sym_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10617] = 2,
    ACTIONS(1112), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10625] = 2,
    ACTIONS(1114), 1,
      aux_sym_preproc_ifdef_token3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10633] = 2,
    ACTIONS(1116), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10641] = 2,
    ACTIONS(1118), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10649] = 3,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(813), 1,
      sym_line_comment,
    ACTIONS(1120), 1,
      anon_sym_LF,
  [10659] = 2,
    ACTIONS(1122), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10667] = 2,
    ACTIONS(1124), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10675] = 2,
    ACTIONS(287), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10683] = 2,
    ACTIONS(1126), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10691] = 2,
    ACTIONS(1128), 1,
      anon_sym_LT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10699] = 2,
    ACTIONS(131), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10707] = 2,
    ACTIONS(1130), 1,
      aux_sym_preproc_ifdef_token3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10715] = 2,
    ACTIONS(1132), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10723] = 2,
    ACTIONS(1134), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10731] = 2,
    ACTIONS(1136), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10739] = 2,
    ACTIONS(1138), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10747] = 2,
    ACTIONS(1140), 1,
      ts_builtin_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10755] = 2,
    ACTIONS(1142), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10763] = 2,
    ACTIONS(1144), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10771] = 2,
    ACTIONS(1146), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10779] = 2,
    ACTIONS(1148), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10787] = 2,
    ACTIONS(1150), 1,
      aux_sym_preproc_ifdef_token3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10795] = 2,
    ACTIONS(1152), 1,
      aux_sym_preproc_ifdef_token3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10803] = 2,
    ACTIONS(1154), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10811] = 2,
    ACTIONS(236), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10819] = 2,
    ACTIONS(1156), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10827] = 2,
    ACTIONS(1158), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10835] = 2,
    ACTIONS(1160), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10843] = 2,
    ACTIONS(1162), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10851] = 2,
    ACTIONS(133), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10859] = 2,
    ACTIONS(797), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10867] = 2,
    ACTIONS(1164), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10875] = 2,
    ACTIONS(1166), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10883] = 2,
    ACTIONS(916), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10891] = 2,
    ACTIONS(1168), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10899] = 2,
    ACTIONS(1170), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10907] = 2,
    ACTIONS(279), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10915] = 2,
    ACTIONS(1172), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10923] = 2,
    ACTIONS(1174), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10931] = 2,
    ACTIONS(1176), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10939] = 2,
    ACTIONS(1178), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10947] = 2,
    ACTIONS(712), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10955] = 2,
    ACTIONS(1180), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10963] = 2,
    ACTIONS(1182), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10971] = 2,
    ACTIONS(1184), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10979] = 2,
    ACTIONS(1186), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10987] = 2,
    ACTIONS(1188), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [10995] = 2,
    ACTIONS(1190), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [11003] = 2,
    ACTIONS(1192), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [11011] = 2,
    ACTIONS(1194), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [11019] = 2,
    ACTIONS(1196), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [11027] = 2,
    ACTIONS(1198), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [11035] = 2,
    ACTIONS(1200), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [11043] = 2,
    ACTIONS(1202), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [11051] = 2,
    ACTIONS(1204), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [11059] = 2,
    ACTIONS(1000), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [11067] = 3,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(813), 1,
      sym_line_comment,
    ACTIONS(1206), 1,
      anon_sym_LF,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(32)] = 0,
  [SMALL_STATE(33)] = 102,
  [SMALL_STATE(34)] = 191,
  [SMALL_STATE(35)] = 280,
  [SMALL_STATE(36)] = 369,
  [SMALL_STATE(37)] = 458,
  [SMALL_STATE(38)] = 520,
  [SMALL_STATE(39)] = 606,
  [SMALL_STATE(40)] = 692,
  [SMALL_STATE(41)] = 754,
  [SMALL_STATE(42)] = 837,
  [SMALL_STATE(43)] = 920,
  [SMALL_STATE(44)] = 979,
  [SMALL_STATE(45)] = 1038,
  [SMALL_STATE(46)] = 1121,
  [SMALL_STATE(47)] = 1222,
  [SMALL_STATE(48)] = 1323,
  [SMALL_STATE(49)] = 1392,
  [SMALL_STATE(50)] = 1447,
  [SMALL_STATE(51)] = 1516,
  [SMALL_STATE(52)] = 1571,
  [SMALL_STATE(53)] = 1672,
  [SMALL_STATE(54)] = 1773,
  [SMALL_STATE(55)] = 1874,
  [SMALL_STATE(56)] = 1929,
  [SMALL_STATE(57)] = 2030,
  [SMALL_STATE(58)] = 2131,
  [SMALL_STATE(59)] = 2229,
  [SMALL_STATE(60)] = 2283,
  [SMALL_STATE(61)] = 2335,
  [SMALL_STATE(62)] = 2433,
  [SMALL_STATE(63)] = 2528,
  [SMALL_STATE(64)] = 2579,
  [SMALL_STATE(65)] = 2674,
  [SMALL_STATE(66)] = 2725,
  [SMALL_STATE(67)] = 2776,
  [SMALL_STATE(68)] = 2871,
  [SMALL_STATE(69)] = 2966,
  [SMALL_STATE(70)] = 3028,
  [SMALL_STATE(71)] = 3090,
  [SMALL_STATE(72)] = 3152,
  [SMALL_STATE(73)] = 3214,
  [SMALL_STATE(74)] = 3276,
  [SMALL_STATE(75)] = 3338,
  [SMALL_STATE(76)] = 3382,
  [SMALL_STATE(77)] = 3426,
  [SMALL_STATE(78)] = 3470,
  [SMALL_STATE(79)] = 3514,
  [SMALL_STATE(80)] = 3558,
  [SMALL_STATE(81)] = 3602,
  [SMALL_STATE(82)] = 3675,
  [SMALL_STATE(83)] = 3747,
  [SMALL_STATE(84)] = 3819,
  [SMALL_STATE(85)] = 3887,
  [SMALL_STATE(86)] = 3953,
  [SMALL_STATE(87)] = 3989,
  [SMALL_STATE(88)] = 4055,
  [SMALL_STATE(89)] = 4121,
  [SMALL_STATE(90)] = 4187,
  [SMALL_STATE(91)] = 4223,
  [SMALL_STATE(92)] = 4258,
  [SMALL_STATE(93)] = 4293,
  [SMALL_STATE(94)] = 4328,
  [SMALL_STATE(95)] = 4365,
  [SMALL_STATE(96)] = 4402,
  [SMALL_STATE(97)] = 4436,
  [SMALL_STATE(98)] = 4474,
  [SMALL_STATE(99)] = 4508,
  [SMALL_STATE(100)] = 4542,
  [SMALL_STATE(101)] = 4576,
  [SMALL_STATE(102)] = 4610,
  [SMALL_STATE(103)] = 4644,
  [SMALL_STATE(104)] = 4678,
  [SMALL_STATE(105)] = 4712,
  [SMALL_STATE(106)] = 4746,
  [SMALL_STATE(107)] = 4780,
  [SMALL_STATE(108)] = 4826,
  [SMALL_STATE(109)] = 4884,
  [SMALL_STATE(110)] = 4940,
  [SMALL_STATE(111)] = 4974,
  [SMALL_STATE(112)] = 5008,
  [SMALL_STATE(113)] = 5050,
  [SMALL_STATE(114)] = 5106,
  [SMALL_STATE(115)] = 5140,
  [SMALL_STATE(116)] = 5194,
  [SMALL_STATE(117)] = 5228,
  [SMALL_STATE(118)] = 5262,
  [SMALL_STATE(119)] = 5296,
  [SMALL_STATE(120)] = 5348,
  [SMALL_STATE(121)] = 5398,
  [SMALL_STATE(122)] = 5432,
  [SMALL_STATE(123)] = 5466,
  [SMALL_STATE(124)] = 5500,
  [SMALL_STATE(125)] = 5534,
  [SMALL_STATE(126)] = 5568,
  [SMALL_STATE(127)] = 5602,
  [SMALL_STATE(128)] = 5636,
  [SMALL_STATE(129)] = 5670,
  [SMALL_STATE(130)] = 5704,
  [SMALL_STATE(131)] = 5748,
  [SMALL_STATE(132)] = 5782,
  [SMALL_STATE(133)] = 5841,
  [SMALL_STATE(134)] = 5898,
  [SMALL_STATE(135)] = 5957,
  [SMALL_STATE(136)] = 6016,
  [SMALL_STATE(137)] = 6075,
  [SMALL_STATE(138)] = 6131,
  [SMALL_STATE(139)] = 6187,
  [SMALL_STATE(140)] = 6243,
  [SMALL_STATE(141)] = 6299,
  [SMALL_STATE(142)] = 6355,
  [SMALL_STATE(143)] = 6411,
  [SMALL_STATE(144)] = 6467,
  [SMALL_STATE(145)] = 6523,
  [SMALL_STATE(146)] = 6579,
  [SMALL_STATE(147)] = 6635,
  [SMALL_STATE(148)] = 6691,
  [SMALL_STATE(149)] = 6747,
  [SMALL_STATE(150)] = 6803,
  [SMALL_STATE(151)] = 6859,
  [SMALL_STATE(152)] = 6887,
  [SMALL_STATE(153)] = 6913,
  [SMALL_STATE(154)] = 6936,
  [SMALL_STATE(155)] = 6959,
  [SMALL_STATE(156)] = 6982,
  [SMALL_STATE(157)] = 7005,
  [SMALL_STATE(158)] = 7028,
  [SMALL_STATE(159)] = 7051,
  [SMALL_STATE(160)] = 7074,
  [SMALL_STATE(161)] = 7097,
  [SMALL_STATE(162)] = 7120,
  [SMALL_STATE(163)] = 7143,
  [SMALL_STATE(164)] = 7166,
  [SMALL_STATE(165)] = 7189,
  [SMALL_STATE(166)] = 7212,
  [SMALL_STATE(167)] = 7235,
  [SMALL_STATE(168)] = 7258,
  [SMALL_STATE(169)] = 7281,
  [SMALL_STATE(170)] = 7304,
  [SMALL_STATE(171)] = 7327,
  [SMALL_STATE(172)] = 7350,
  [SMALL_STATE(173)] = 7372,
  [SMALL_STATE(174)] = 7394,
  [SMALL_STATE(175)] = 7416,
  [SMALL_STATE(176)] = 7444,
  [SMALL_STATE(177)] = 7466,
  [SMALL_STATE(178)] = 7494,
  [SMALL_STATE(179)] = 7522,
  [SMALL_STATE(180)] = 7550,
  [SMALL_STATE(181)] = 7580,
  [SMALL_STATE(182)] = 7608,
  [SMALL_STATE(183)] = 7636,
  [SMALL_STATE(184)] = 7678,
  [SMALL_STATE(185)] = 7706,
  [SMALL_STATE(186)] = 7728,
  [SMALL_STATE(187)] = 7756,
  [SMALL_STATE(188)] = 7780,
  [SMALL_STATE(189)] = 7804,
  [SMALL_STATE(190)] = 7828,
  [SMALL_STATE(191)] = 7852,
  [SMALL_STATE(192)] = 7894,
  [SMALL_STATE(193)] = 7931,
  [SMALL_STATE(194)] = 7952,
  [SMALL_STATE(195)] = 7973,
  [SMALL_STATE(196)] = 8009,
  [SMALL_STATE(197)] = 8045,
  [SMALL_STATE(198)] = 8083,
  [SMALL_STATE(199)] = 8102,
  [SMALL_STATE(200)] = 8121,
  [SMALL_STATE(201)] = 8140,
  [SMALL_STATE(202)] = 8167,
  [SMALL_STATE(203)] = 8186,
  [SMALL_STATE(204)] = 8221,
  [SMALL_STATE(205)] = 8240,
  [SMALL_STATE(206)] = 8273,
  [SMALL_STATE(207)] = 8300,
  [SMALL_STATE(208)] = 8327,
  [SMALL_STATE(209)] = 8343,
  [SMALL_STATE(210)] = 8373,
  [SMALL_STATE(211)] = 8389,
  [SMALL_STATE(212)] = 8405,
  [SMALL_STATE(213)] = 8421,
  [SMALL_STATE(214)] = 8447,
  [SMALL_STATE(215)] = 8477,
  [SMALL_STATE(216)] = 8493,
  [SMALL_STATE(217)] = 8509,
  [SMALL_STATE(218)] = 8539,
  [SMALL_STATE(219)] = 8562,
  [SMALL_STATE(220)] = 8579,
  [SMALL_STATE(221)] = 8603,
  [SMALL_STATE(222)] = 8625,
  [SMALL_STATE(223)] = 8647,
  [SMALL_STATE(224)] = 8661,
  [SMALL_STATE(225)] = 8685,
  [SMALL_STATE(226)] = 8703,
  [SMALL_STATE(227)] = 8727,
  [SMALL_STATE(228)] = 8749,
  [SMALL_STATE(229)] = 8767,
  [SMALL_STATE(230)] = 8788,
  [SMALL_STATE(231)] = 8803,
  [SMALL_STATE(232)] = 8824,
  [SMALL_STATE(233)] = 8845,
  [SMALL_STATE(234)] = 8860,
  [SMALL_STATE(235)] = 8875,
  [SMALL_STATE(236)] = 8890,
  [SMALL_STATE(237)] = 8908,
  [SMALL_STATE(238)] = 8926,
  [SMALL_STATE(239)] = 8946,
  [SMALL_STATE(240)] = 8964,
  [SMALL_STATE(241)] = 8980,
  [SMALL_STATE(242)] = 9000,
  [SMALL_STATE(243)] = 9016,
  [SMALL_STATE(244)] = 9028,
  [SMALL_STATE(245)] = 9046,
  [SMALL_STATE(246)] = 9064,
  [SMALL_STATE(247)] = 9082,
  [SMALL_STATE(248)] = 9098,
  [SMALL_STATE(249)] = 9118,
  [SMALL_STATE(250)] = 9135,
  [SMALL_STATE(251)] = 9152,
  [SMALL_STATE(252)] = 9163,
  [SMALL_STATE(253)] = 9180,
  [SMALL_STATE(254)] = 9199,
  [SMALL_STATE(255)] = 9214,
  [SMALL_STATE(256)] = 9227,
  [SMALL_STATE(257)] = 9244,
  [SMALL_STATE(258)] = 9259,
  [SMALL_STATE(259)] = 9274,
  [SMALL_STATE(260)] = 9289,
  [SMALL_STATE(261)] = 9304,
  [SMALL_STATE(262)] = 9319,
  [SMALL_STATE(263)] = 9334,
  [SMALL_STATE(264)] = 9351,
  [SMALL_STATE(265)] = 9366,
  [SMALL_STATE(266)] = 9381,
  [SMALL_STATE(267)] = 9398,
  [SMALL_STATE(268)] = 9415,
  [SMALL_STATE(269)] = 9430,
  [SMALL_STATE(270)] = 9445,
  [SMALL_STATE(271)] = 9455,
  [SMALL_STATE(272)] = 9465,
  [SMALL_STATE(273)] = 9475,
  [SMALL_STATE(274)] = 9489,
  [SMALL_STATE(275)] = 9499,
  [SMALL_STATE(276)] = 9509,
  [SMALL_STATE(277)] = 9523,
  [SMALL_STATE(278)] = 9537,
  [SMALL_STATE(279)] = 9551,
  [SMALL_STATE(280)] = 9563,
  [SMALL_STATE(281)] = 9573,
  [SMALL_STATE(282)] = 9585,
  [SMALL_STATE(283)] = 9597,
  [SMALL_STATE(284)] = 9611,
  [SMALL_STATE(285)] = 9623,
  [SMALL_STATE(286)] = 9639,
  [SMALL_STATE(287)] = 9649,
  [SMALL_STATE(288)] = 9659,
  [SMALL_STATE(289)] = 9669,
  [SMALL_STATE(290)] = 9679,
  [SMALL_STATE(291)] = 9695,
  [SMALL_STATE(292)] = 9705,
  [SMALL_STATE(293)] = 9715,
  [SMALL_STATE(294)] = 9729,
  [SMALL_STATE(295)] = 9743,
  [SMALL_STATE(296)] = 9757,
  [SMALL_STATE(297)] = 9773,
  [SMALL_STATE(298)] = 9784,
  [SMALL_STATE(299)] = 9795,
  [SMALL_STATE(300)] = 9806,
  [SMALL_STATE(301)] = 9817,
  [SMALL_STATE(302)] = 9826,
  [SMALL_STATE(303)] = 9835,
  [SMALL_STATE(304)] = 9846,
  [SMALL_STATE(305)] = 9855,
  [SMALL_STATE(306)] = 9866,
  [SMALL_STATE(307)] = 9877,
  [SMALL_STATE(308)] = 9888,
  [SMALL_STATE(309)] = 9899,
  [SMALL_STATE(310)] = 9910,
  [SMALL_STATE(311)] = 9921,
  [SMALL_STATE(312)] = 9932,
  [SMALL_STATE(313)] = 9943,
  [SMALL_STATE(314)] = 9954,
  [SMALL_STATE(315)] = 9965,
  [SMALL_STATE(316)] = 9976,
  [SMALL_STATE(317)] = 9987,
  [SMALL_STATE(318)] = 9998,
  [SMALL_STATE(319)] = 10009,
  [SMALL_STATE(320)] = 10020,
  [SMALL_STATE(321)] = 10031,
  [SMALL_STATE(322)] = 10042,
  [SMALL_STATE(323)] = 10051,
  [SMALL_STATE(324)] = 10062,
  [SMALL_STATE(325)] = 10073,
  [SMALL_STATE(326)] = 10084,
  [SMALL_STATE(327)] = 10095,
  [SMALL_STATE(328)] = 10104,
  [SMALL_STATE(329)] = 10115,
  [SMALL_STATE(330)] = 10126,
  [SMALL_STATE(331)] = 10137,
  [SMALL_STATE(332)] = 10148,
  [SMALL_STATE(333)] = 10159,
  [SMALL_STATE(334)] = 10170,
  [SMALL_STATE(335)] = 10181,
  [SMALL_STATE(336)] = 10192,
  [SMALL_STATE(337)] = 10203,
  [SMALL_STATE(338)] = 10212,
  [SMALL_STATE(339)] = 10223,
  [SMALL_STATE(340)] = 10232,
  [SMALL_STATE(341)] = 10243,
  [SMALL_STATE(342)] = 10254,
  [SMALL_STATE(343)] = 10263,
  [SMALL_STATE(344)] = 10276,
  [SMALL_STATE(345)] = 10287,
  [SMALL_STATE(346)] = 10295,
  [SMALL_STATE(347)] = 10303,
  [SMALL_STATE(348)] = 10311,
  [SMALL_STATE(349)] = 10319,
  [SMALL_STATE(350)] = 10327,
  [SMALL_STATE(351)] = 10335,
  [SMALL_STATE(352)] = 10343,
  [SMALL_STATE(353)] = 10351,
  [SMALL_STATE(354)] = 10359,
  [SMALL_STATE(355)] = 10369,
  [SMALL_STATE(356)] = 10377,
  [SMALL_STATE(357)] = 10385,
  [SMALL_STATE(358)] = 10393,
  [SMALL_STATE(359)] = 10401,
  [SMALL_STATE(360)] = 10409,
  [SMALL_STATE(361)] = 10417,
  [SMALL_STATE(362)] = 10425,
  [SMALL_STATE(363)] = 10433,
  [SMALL_STATE(364)] = 10441,
  [SMALL_STATE(365)] = 10449,
  [SMALL_STATE(366)] = 10457,
  [SMALL_STATE(367)] = 10465,
  [SMALL_STATE(368)] = 10473,
  [SMALL_STATE(369)] = 10481,
  [SMALL_STATE(370)] = 10489,
  [SMALL_STATE(371)] = 10497,
  [SMALL_STATE(372)] = 10505,
  [SMALL_STATE(373)] = 10513,
  [SMALL_STATE(374)] = 10521,
  [SMALL_STATE(375)] = 10529,
  [SMALL_STATE(376)] = 10537,
  [SMALL_STATE(377)] = 10545,
  [SMALL_STATE(378)] = 10553,
  [SMALL_STATE(379)] = 10561,
  [SMALL_STATE(380)] = 10569,
  [SMALL_STATE(381)] = 10577,
  [SMALL_STATE(382)] = 10585,
  [SMALL_STATE(383)] = 10593,
  [SMALL_STATE(384)] = 10601,
  [SMALL_STATE(385)] = 10609,
  [SMALL_STATE(386)] = 10617,
  [SMALL_STATE(387)] = 10625,
  [SMALL_STATE(388)] = 10633,
  [SMALL_STATE(389)] = 10641,
  [SMALL_STATE(390)] = 10649,
  [SMALL_STATE(391)] = 10659,
  [SMALL_STATE(392)] = 10667,
  [SMALL_STATE(393)] = 10675,
  [SMALL_STATE(394)] = 10683,
  [SMALL_STATE(395)] = 10691,
  [SMALL_STATE(396)] = 10699,
  [SMALL_STATE(397)] = 10707,
  [SMALL_STATE(398)] = 10715,
  [SMALL_STATE(399)] = 10723,
  [SMALL_STATE(400)] = 10731,
  [SMALL_STATE(401)] = 10739,
  [SMALL_STATE(402)] = 10747,
  [SMALL_STATE(403)] = 10755,
  [SMALL_STATE(404)] = 10763,
  [SMALL_STATE(405)] = 10771,
  [SMALL_STATE(406)] = 10779,
  [SMALL_STATE(407)] = 10787,
  [SMALL_STATE(408)] = 10795,
  [SMALL_STATE(409)] = 10803,
  [SMALL_STATE(410)] = 10811,
  [SMALL_STATE(411)] = 10819,
  [SMALL_STATE(412)] = 10827,
  [SMALL_STATE(413)] = 10835,
  [SMALL_STATE(414)] = 10843,
  [SMALL_STATE(415)] = 10851,
  [SMALL_STATE(416)] = 10859,
  [SMALL_STATE(417)] = 10867,
  [SMALL_STATE(418)] = 10875,
  [SMALL_STATE(419)] = 10883,
  [SMALL_STATE(420)] = 10891,
  [SMALL_STATE(421)] = 10899,
  [SMALL_STATE(422)] = 10907,
  [SMALL_STATE(423)] = 10915,
  [SMALL_STATE(424)] = 10923,
  [SMALL_STATE(425)] = 10931,
  [SMALL_STATE(426)] = 10939,
  [SMALL_STATE(427)] = 10947,
  [SMALL_STATE(428)] = 10955,
  [SMALL_STATE(429)] = 10963,
  [SMALL_STATE(430)] = 10971,
  [SMALL_STATE(431)] = 10979,
  [SMALL_STATE(432)] = 10987,
  [SMALL_STATE(433)] = 10995,
  [SMALL_STATE(434)] = 11003,
  [SMALL_STATE(435)] = 11011,
  [SMALL_STATE(436)] = 11019,
  [SMALL_STATE(437)] = 11027,
  [SMALL_STATE(438)] = 11035,
  [SMALL_STATE(439)] = 11043,
  [SMALL_STATE(440)] = 11051,
  [SMALL_STATE(441)] = 11059,
  [SMALL_STATE(442)] = 11067,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 0, 0, 0),
  [7] = {.entry = {.count = 1, .reusable = true}}, SHIFT(88),
  [9] = {.entry = {.count = 1, .reusable = true}}, SHIFT(332),
  [11] = {.entry = {.count = 1, .reusable = true}}, SHIFT(231),
  [13] = {.entry = {.count = 1, .reusable = true}}, SHIFT(350),
  [15] = {.entry = {.count = 1, .reusable = true}}, SHIFT(265),
  [17] = {.entry = {.count = 1, .reusable = true}}, SHIFT(399),
  [19] = {.entry = {.count = 1, .reusable = true}}, SHIFT(361),
  [21] = {.entry = {.count = 1, .reusable = true}}, SHIFT(440),
  [23] = {.entry = {.count = 1, .reusable = true}}, SHIFT(356),
  [25] = {.entry = {.count = 1, .reusable = true}}, SHIFT(267),
  [27] = {.entry = {.count = 1, .reusable = true}}, SHIFT(338),
  [29] = {.entry = {.count = 1, .reusable = true}}, SHIFT(313),
  [31] = {.entry = {.count = 1, .reusable = true}}, SHIFT(400),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(95),
  [35] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23),
  [37] = {.entry = {.count = 1, .reusable = true}}, SHIFT(101),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(93),
  [41] = {.entry = {.count = 1, .reusable = true}}, SHIFT(92),
  [43] = {.entry = {.count = 1, .reusable = false}}, SHIFT(91),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(176),
  [47] = {.entry = {.count = 1, .reusable = false}}, SHIFT(346),
  [49] = {.entry = {.count = 1, .reusable = false}}, SHIFT(351),
  [51] = {.entry = {.count = 1, .reusable = false}}, SHIFT(355),
  [53] = {.entry = {.count = 1, .reusable = false}}, SHIFT(366),
  [55] = {.entry = {.count = 1, .reusable = false}}, SHIFT(283),
  [57] = {.entry = {.count = 1, .reusable = false}}, SHIFT(395),
  [59] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [61] = {.entry = {.count = 1, .reusable = false}}, SHIFT(24),
  [63] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 1, 0, 0),
  [65] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_argument_list_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(95),
  [68] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_argument_list_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(23),
  [71] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_argument_list_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(93),
  [74] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_argument_list_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(92),
  [77] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_argument_list_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(91),
  [80] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_argument_list_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(176),
  [83] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_argument_list_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(346),
  [86] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_argument_list_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(351),
  [89] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_argument_list_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(355),
  [92] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_argument_list_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(366),
  [95] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_argument_list_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(283),
  [98] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_argument_list_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(395),
  [101] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_argument_list_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(24),
  [104] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_argument_list_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(24),
  [107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(34),
  [109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(35),
  [111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(180),
  [113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6),
  [115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(297),
  [117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(229),
  [119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(427),
  [121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(267),
  [123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(239),
  [125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(271),
  [127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(376),
  [129] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_header, 2, 0, 0),
  [131] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_header, 3, 0, 0),
  [133] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_header, 4, 0, 0),
  [135] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_argument_list_expression_repeat1, 2, 0, 0),
  [137] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_argument_list_expression_repeat1, 2, 0, 0),
  [139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(118),
  [141] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_const_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(176),
  [144] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_const_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(93),
  [147] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_const_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(92),
  [150] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_const_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(91),
  [153] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_const_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(346),
  [156] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_const_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(351),
  [159] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_const_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(355),
  [162] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_const_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(366),
  [165] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_const_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(376),
  [168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(131),
  [170] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compound_assignment_operator, 1, 0, 0),
  [172] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compound_assignment_operator, 1, 0, 0),
  [174] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compound_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(175),
  [177] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compound_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(297),
  [180] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compound_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(229),
  [183] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compound_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(62),
  [186] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_compound_statement_repeat1, 2, 0, 0),
  [188] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compound_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(427),
  [191] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compound_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(20),
  [194] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compound_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(21),
  [197] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_compound_statement_repeat1, 2, 0, 0),
  [199] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compound_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(436),
  [202] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compound_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(437),
  [205] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compound_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(22),
  [208] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compound_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(441),
  [211] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compound_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(423),
  [214] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compound_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(4),
  [217] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compound_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(420),
  [220] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compound_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(267),
  [223] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compound_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(239),
  [226] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compound_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(338),
  [229] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compound_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(370),
  [232] = {.entry = {.count = 1, .reusable = false}}, SHIFT(175),
  [234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(62),
  [236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(291),
  [238] = {.entry = {.count = 1, .reusable = false}}, SHIFT(20),
  [240] = {.entry = {.count = 1, .reusable = false}}, SHIFT(21),
  [242] = {.entry = {.count = 1, .reusable = false}}, SHIFT(409),
  [244] = {.entry = {.count = 1, .reusable = false}}, SHIFT(436),
  [246] = {.entry = {.count = 1, .reusable = false}}, SHIFT(437),
  [248] = {.entry = {.count = 1, .reusable = false}}, SHIFT(22),
  [250] = {.entry = {.count = 1, .reusable = false}}, SHIFT(441),
  [252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(423),
  [254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4),
  [256] = {.entry = {.count = 1, .reusable = false}}, SHIFT(420),
  [258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(370),
  [260] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_global_variable_declaration_repeat1, 2, 0, 0),
  [262] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_global_variable_declaration_repeat1, 2, 0, 0), SHIFT_REPEAT(356),
  [265] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_const_expression_repeat1, 2, 0, 0),
  [267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(275),
  [269] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_const_expression_repeat1, 2, 0, 0),
  [271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(114),
  [273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(335),
  [275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(117),
  [277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(67),
  [279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(121),
  [281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(286),
  [283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(123),
  [285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(287),
  [287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(413),
  [289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(319),
  [291] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute, 2, 0, 0),
  [293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(221),
  [295] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 2, 0, 0),
  [297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(391),
  [299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(75),
  [301] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute, 5, 0, 0),
  [303] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 5, 0, 0),
  [305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(80),
  [307] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute, 6, 0, 0),
  [309] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 6, 0, 0),
  [311] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute, 7, 0, 0),
  [313] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 7, 0, 0),
  [315] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_else_in_statement, 1, 0, 0),
  [317] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_else_in_statement, 2, 0, 0),
  [319] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compound_statement, 2, 0, 0),
  [321] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compound_statement, 2, 0, 0),
  [323] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_import, 4, 0, 4),
  [325] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_import, 4, 0, 4),
  [327] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_import, 3, 0, 1),
  [329] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_import, 3, 0, 1),
  [331] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_import, 4, 0, 1),
  [333] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_import, 4, 0, 1),
  [335] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_import, 5, 0, 1),
  [337] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_import, 5, 0, 1),
  [339] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compound_statement, 3, 0, 0),
  [341] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compound_statement, 3, 0, 0),
  [343] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 1, 0, 0),
  [345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(89),
  [347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(84),
  [349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(153),
  [351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(85),
  [353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(82),
  [355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(158),
  [357] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_source_file_repeat2, 2, 0, 0),
  [359] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat2, 2, 0, 0), SHIFT_REPEAT(84),
  [362] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat2, 2, 0, 0), SHIFT_REPEAT(332),
  [365] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat2, 2, 0, 0), SHIFT_REPEAT(231),
  [368] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat2, 2, 0, 0), SHIFT_REPEAT(350),
  [371] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat2, 2, 0, 0), SHIFT_REPEAT(265),
  [374] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat2, 2, 0, 0), SHIFT_REPEAT(399),
  [377] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat2, 2, 0, 0), SHIFT_REPEAT(361),
  [380] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat2, 2, 0, 0), SHIFT_REPEAT(356),
  [383] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat2, 2, 0, 0), SHIFT_REPEAT(267),
  [386] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat2, 2, 0, 0), SHIFT_REPEAT(338),
  [389] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat2, 2, 0, 0), SHIFT_REPEAT(313),
  [392] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat2, 2, 0, 0), SHIFT_REPEAT(400),
  [395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(87),
  [397] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_else, 1, 0, 0),
  [399] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_increment_statement, 2, 0, 0),
  [401] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_increment_statement, 2, 0, 0),
  [403] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_else, 2, 0, 0),
  [405] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 2, 0, 0),
  [407] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_decrement_statement, 2, 0, 0),
  [409] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decrement_statement, 2, 0, 0),
  [411] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bool_literal, 1, 0, 0),
  [413] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_bool_literal, 1, 0, 0),
  [415] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_float_literal, 1, 0, 0),
  [417] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_float_literal, 1, 0, 0),
  [419] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_literal, 1, 0, 0),
  [421] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_const_literal, 1, 0, 0),
  [423] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 3, 0, 22),
  [425] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 3, 0, 22),
  [427] = {.entry = {.count = 1, .reusable = false}}, SHIFT(244),
  [429] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression, 1, 0, 0),
  [431] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_declaration, 1, 0, 0),
  [433] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0),
  [435] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_constructor_or_function_call_expression, 2, 0, 0),
  [437] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_constructor_or_function_call_expression, 2, 0, 0),
  [439] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_expression, 3, 0, 10),
  [441] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_expression, 3, 0, 10),
  [443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18),
  [445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(371),
  [447] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_expression, 4, 0, 16),
  [449] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_expression, 4, 0, 16),
  [451] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list_expression, 3, 0, 0),
  [453] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list_expression, 3, 0, 0),
  [455] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_composite_value_decomposition_expression, 3, 0, 11),
  [457] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_composite_value_decomposition_expression, 3, 0, 11),
  [459] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list_expression, 2, 0, 0),
  [461] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list_expression, 2, 0, 0),
  [463] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_statement, 2, 0, 0),
  [465] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 2, 0, 0),
  [467] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_statement, 2, 0, 0),
  [469] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 2, 0, 0),
  [471] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_discard_statement, 2, 0, 0),
  [473] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_discard_statement, 2, 0, 0),
  [475] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__statement, 2, 0, 0),
  [477] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__statement, 2, 0, 0),
  [479] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 3, 0, 0),
  [481] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 3, 0, 0),
  [483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15),
  [485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16),
  [487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17),
  [489] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17),
  [491] = {.entry = {.count = 1, .reusable = false}}, SHIFT(27),
  [493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10),
  [495] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11),
  [497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12),
  [499] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13),
  [501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14),
  [503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(27),
  [505] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_expression, 2, 0, 6),
  [507] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_expression, 2, 0, 6),
  [509] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bitcast_expression, 5, 0, 0),
  [511] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_bitcast_expression, 5, 0, 0),
  [513] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_loop_statement, 3, 0, 0),
  [515] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_loop_statement, 3, 0, 0),
  [517] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 3, 0, 23),
  [519] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 3, 0, 23),
  [521] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef_in_statement, 3, 0, 2),
  [523] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_statement, 3, 0, 2),
  [525] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list_expression, 5, 0, 0),
  [527] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list_expression, 5, 0, 0),
  [529] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_loop_statement, 4, 0, 0),
  [531] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_loop_statement, 4, 0, 0),
  [533] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef_in_statement, 4, 0, 5),
  [535] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_statement, 4, 0, 5),
  [537] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef_in_statement, 4, 0, 2),
  [539] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_statement, 4, 0, 2),
  [541] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_statement, 1, 0, 0),
  [543] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_statement, 1, 0, 0),
  [545] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, 0, 25),
  [547] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, 0, 25),
  [549] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_statement, 5, 0, 0),
  [551] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_statement, 5, 0, 0),
  [553] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_loop_statement, 5, 0, 0),
  [555] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_loop_statement, 5, 0, 0),
  [557] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 5, 0, 0),
  [559] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 5, 0, 0),
  [561] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef_in_statement, 5, 0, 8),
  [563] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_statement, 5, 0, 8),
  [565] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list_expression, 4, 0, 0),
  [567] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list_expression, 4, 0, 0),
  [569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(40),
  [571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9),
  [575] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_statement, 3, 0, 10),
  [577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(37),
  [579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(177),
  [581] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_statement, 4, 0, 0),
  [583] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_statement, 3, 0, 0),
  [585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(106),
  [587] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 2, 0, 0),
  [589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(259),
  [591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(98),
  [593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(43),
  [595] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_global_constant_declaration, 5, 0, 0),
  [597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(36),
  [599] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_global_constant_declaration, 4, 0, 0),
  [601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(429),
  [603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(188),
  [605] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0),
  [607] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(440),
  [610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(359),
  [612] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef, 4, 0, 2),
  [614] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 7, 0, 18),
  [616] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 9, 0, 24),
  [618] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 8, 0, 20),
  [620] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 8, 0, 21),
  [622] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef, 3, 0, 2),
  [624] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 6, 0, 9),
  [626] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 5, 0, 2),
  [628] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 7, 0, 15),
  [630] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef, 4, 0, 5),
  [632] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 8, 0, 19),
  [634] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 7, 0, 14),
  [636] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 7, 0, 17),
  [638] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 6, 0, 12),
  [640] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declaration, 2, 0, 0),
  [642] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 5, 0, 7),
  [644] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 6, 0, 13),
  [646] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef, 5, 0, 8),
  [648] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_define_import_path, 3, 0, 1),
  [650] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enable_directive, 3, 0, 0),
  [652] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_declaration, 4, 0, 0),
  [654] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_declaration, 6, 0, 0),
  [656] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lhs_expression, 1, 0, 0),
  [658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(25),
  [660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(392),
  [662] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_postfix_expression, 3, 0, 0),
  [664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8),
  [666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(439),
  [668] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lhs_expression, 2, 0, 0),
  [670] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lhs_expression, 4, 0, 0),
  [672] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_postfix_expression, 4, 0, 0),
  [674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(419),
  [676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(434),
  [678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(212),
  [680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(195),
  [682] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lhs_expression, 3, 0, 0),
  [684] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_declaration, 8, 0, 0),
  [686] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_postfix_expression, 2, 0, 0),
  [688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(216),
  [690] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_ifdef_in_struct_declaration_repeat1, 2, 0, 0), SHIFT_REPEAT(419),
  [693] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_ifdef_in_struct_declaration_repeat1, 2, 0, 0), SHIFT_REPEAT(356),
  [696] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_ifdef_in_struct_declaration_repeat1, 2, 0, 0), SHIFT_REPEAT(338),
  [699] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_ifdef_in_struct_declaration_repeat1, 2, 0, 0), SHIFT_REPEAT(434),
  [702] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_ifdef_in_struct_declaration_repeat1, 2, 0, 0),
  [704] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_postfix_expression, 5, 0, 0),
  [706] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_else_in_struct_declaration, 1, 0, 0),
  [708] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_else_in_struct_declaration, 2, 0, 0),
  [710] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_identifier_declaration, 3, 0, 3),
  [712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(26),
  [714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(44),
  [716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(86),
  [718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(90),
  [720] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lhs_expression, 5, 0, 0),
  [722] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__struct_declaration_content_repeat1, 2, 0, 0), SHIFT_REPEAT(419),
  [725] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__struct_declaration_content_repeat1, 2, 0, 0), SHIFT_REPEAT(356),
  [728] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__struct_declaration_content_repeat1, 2, 0, 0), SHIFT_REPEAT(338),
  [731] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__struct_declaration_content_repeat1, 2, 0, 0), SHIFT_REPEAT(434),
  [734] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_selectors, 2, 0, 0),
  [736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(91),
  [738] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_selectors, 3, 0, 0),
  [740] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_member, 1, 0, 0),
  [742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(252),
  [744] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_member, 2, 0, 0),
  [746] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_struct_declaration, 5, 0, 8),
  [748] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_struct_declaration, 3, 0, 2),
  [750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(249),
  [752] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_struct_declaration, 4, 0, 5),
  [754] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_struct_declaration, 4, 0, 2),
  [756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(266),
  [758] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_ifdef_in_struct_declaration_repeat1, 1, 0, 0),
  [760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(223),
  [762] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameter_list_repeat1, 2, 0, 0), SHIFT_REPEAT(419),
  [765] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameter_list_repeat1, 2, 0, 0), SHIFT_REPEAT(356),
  [768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(333),
  [770] = {.entry = {.count = 1, .reusable = false}}, SHIFT(333),
  [772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(340),
  [774] = {.entry = {.count = 1, .reusable = false}}, SHIFT(340),
  [776] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__struct_declaration_content_repeat1, 1, 0, 0),
  [778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(416),
  [780] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__struct_declaration_content, 1, 0, 0),
  [782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(344),
  [784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(430),
  [786] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attribute_repeat1, 2, 0, 0), SHIFT_REPEAT(363),
  [789] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attribute_repeat1, 2, 0, 0), SHIFT_REPEAT(363),
  [792] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attribute_repeat1, 2, 0, 0), SHIFT_REPEAT(92),
  [795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(352),
  [797] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__struct_declaration_content, 2, 0, 0),
  [799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(175),
  [801] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__struct_declaration_content_repeat1, 2, 0, 0),
  [803] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__struct_declaration_content, 3, 0, 0),
  [805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(278),
  [807] = {.entry = {.count = 1, .reusable = false}}, SHIFT(314),
  [809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(337),
  [811] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_import_path_repeat1, 2, 0, 0),
  [813] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [815] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_import_path_repeat1, 2, 0, 0),
  [817] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_import_path_repeat1, 2, 0, 0), SHIFT_REPEAT(365),
  [820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(179),
  [822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(232),
  [824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(242),
  [826] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_attribute_repeat1, 2, 0, 0),
  [828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(66),
  [830] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_attribute_repeat1, 2, 0, 0),
  [832] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_path, 2, 0, 0),
  [834] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_path, 2, 0, 0),
  [836] = {.entry = {.count = 1, .reusable = false}}, SHIFT(365),
  [838] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_lhs_expression_repeat1, 2, 0, 0),
  [840] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_lhs_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(242),
  [843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20),
  [845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(126),
  [847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(213),
  [849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(273),
  [851] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_switch_statement_repeat1, 2, 0, 0),
  [853] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_switch_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(213),
  [856] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_switch_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(273),
  [859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(65),
  [861] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_path, 1, 0, 0),
  [863] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_path, 1, 0, 0),
  [865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(48),
  [867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(358),
  [869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(285),
  [871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(77),
  [873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(388),
  [875] = {.entry = {.count = 1, .reusable = false}}, SHIFT(347),
  [877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(347),
  [879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(318),
  [881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(431),
  [883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(206),
  [885] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_selectors, 1, 0, 0),
  [887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(281),
  [889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(235),
  [891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(207),
  [893] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_selectors_repeat1, 2, 0, 0), SHIFT_REPEAT(218),
  [896] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_case_selectors_repeat1, 2, 0, 0),
  [898] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_body, 3, 0, 0),
  [900] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_expression, 3, 0, 0),
  [902] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_expression, 4, 0, 0),
  [904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(57),
  [906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(315),
  [908] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_expression, 1, 0, 0),
  [910] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_expression, 5, 0, 0),
  [912] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_global_constant_declaration, 3, 0, 0),
  [914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(30),
  [916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(72),
  [918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(326),
  [920] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_global_constant_declaration, 2, 0, 0),
  [922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19),
  [924] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 3, 0, 0),
  [926] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_body, 2, 0, 0),
  [928] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 2, 0, 0),
  [930] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_parameter_list_repeat1, 2, 0, 0),
  [932] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_list, 3, 0, 0),
  [934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2),
  [936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(69),
  [938] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_list, 2, 0, 0),
  [940] = {.entry = {.count = 1, .reusable = false}}, SHIFT(428),
  [942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(78),
  [944] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_expression, 6, 0, 0),
  [946] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_compound_statement, 2, 0, 0),
  [948] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_body, 4, 0, 0),
  [950] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_import_repeat1, 2, 0, 0), SHIFT_REPEAT(428),
  [953] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_import_repeat1, 2, 0, 0),
  [955] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_compound_statement, 3, 0, 0),
  [957] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_compound_statement, 4, 0, 0),
  [959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(438),
  [961] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_import_path_repeat1, 2, 0, 0), SHIFT_REPEAT(438),
  [964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(79),
  [966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(299),
  [968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(29),
  [970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(304),
  [972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(173),
  [974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(51),
  [976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(272),
  [978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(385),
  [980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(55),
  [982] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_global_variable_declaration, 2, 0, 0),
  [984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(42),
  [986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(234),
  [988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(262),
  [990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(174),
  [992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(248),
  [994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(293),
  [996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(254),
  [998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(394),
  [1000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(102),
  [1002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(31),
  [1004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(279),
  [1006] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_global_variable_declaration, 1, 0, 0),
  [1008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(45),
  [1010] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 2, 0, 0),
  [1012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(282),
  [1014] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_statement, 1, 0, 0),
  [1016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(28),
  [1018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(334),
  [1020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(247),
  [1022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(63),
  [1024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(41),
  [1026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(61),
  [1028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(230),
  [1030] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_address_space, 1, 0, 0),
  [1032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(240),
  [1034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(284),
  [1036] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_list, 1, 0, 0),
  [1038] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 1, 0, 0),
  [1040] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_preproc_import_repeat1, 2, 0, 0),
  [1042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(276),
  [1044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(292),
  [1046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(70),
  [1048] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_access_mode, 1, 0, 0),
  [1050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(181),
  [1052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(364),
  [1054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(418),
  [1056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(233),
  [1058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(243),
  [1060] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alias, 2, 0, 0),
  [1062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(251),
  [1064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(59),
  [1066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(71),
  [1068] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_texel_format, 1, 0, 0),
  [1070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(257),
  [1072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(381),
  [1074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(160),
  [1076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(255),
  [1078] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_qualifier, 5, 0, 0),
  [1080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(261),
  [1082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(152),
  [1084] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continuing_statement, 2, 0, 0),
  [1086] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_global_variable_declaration, 3, 0, 0),
  [1088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(127),
  [1090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(53),
  [1092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(100),
  [1094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(211),
  [1096] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_return_type_declaration, 3, 0, 0),
  [1098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(33),
  [1100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(331),
  [1102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(129),
  [1104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(301),
  [1106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(185),
  [1108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(197),
  [1110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(172),
  [1112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(184),
  [1114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(170),
  [1116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(354),
  [1118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(60),
  [1120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(76),
  [1122] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continuing_compound_statement, 2, 0, 0),
  [1124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(186),
  [1126] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_qualifier, 3, 0, 0),
  [1128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(73),
  [1130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(122),
  [1132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(105),
  [1134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(435),
  [1136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(83),
  [1138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(217),
  [1140] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [1142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(250),
  [1144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(209),
  [1146] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_global_variable_declaration, 4, 0, 0),
  [1148] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_return_type_declaration, 2, 0, 0),
  [1150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(162),
  [1152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(215),
  [1154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(421),
  [1156] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_alias_declaration, 4, 0, 0),
  [1158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(263),
  [1160] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continuing_compound_statement, 3, 0, 0),
  [1162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(425),
  [1164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(167),
  [1166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(74),
  [1168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(104),
  [1170] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fallthrough_statement, 2, 0, 0),
  [1172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(103),
  [1174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(256),
  [1176] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continuing_compound_statement, 4, 0, 0),
  [1178] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_header, 5, 0, 0),
  [1180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(343),
  [1182] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_if_statement, 4, 0, 0),
  [1184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(404),
  [1186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(401),
  [1188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7),
  [1190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(309),
  [1192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(183),
  [1194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(214),
  [1196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(52),
  [1198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(32),
  [1200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(339),
  [1202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(187),
  [1204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(383),
  [1206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(171),
};

enum ts_external_scanner_symbol_identifiers {
  ts_external_token_block_comment = 0,
};

static const TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token_block_comment] = sym_block_comment,
};

static const bool ts_external_scanner_states[2][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token_block_comment] = true,
  },
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_wgsl_bevy_external_scanner_create(void);
void tree_sitter_wgsl_bevy_external_scanner_destroy(void *);
bool tree_sitter_wgsl_bevy_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_wgsl_bevy_external_scanner_serialize(void *, char *);
void tree_sitter_wgsl_bevy_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef TREE_SITTER_HIDE_SYMBOLS
#define TS_PUBLIC
#elif defined(_WIN32)
#define TS_PUBLIC __declspec(dllexport)
#else
#define TS_PUBLIC __attribute__((visibility("default")))
#endif

TS_PUBLIC const TSLanguage *tree_sitter_wgsl_bevy(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .external_scanner = {
      &ts_external_scanner_states[0][0],
      ts_external_scanner_symbol_map,
      tree_sitter_wgsl_bevy_external_scanner_create,
      tree_sitter_wgsl_bevy_external_scanner_destroy,
      tree_sitter_wgsl_bevy_external_scanner_scan,
      tree_sitter_wgsl_bevy_external_scanner_serialize,
      tree_sitter_wgsl_bevy_external_scanner_deserialize,
    },
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
